;==============================================================================
;NOTE: This program is written for and compiled with the Netwide Assembler,
;        optimized for size:
;      NASM -f bin -Ox USBEHCI.Asm -o USBEHCI.Com
;==============================================================================


;Brackets
;GetNumber
;No ParentIsShell

;Design as "subprogram" for SLOWDOWN to call?

;In VMWare (at least v14 on desktop), SLOWACPI with no options shows
;  ACPI version 1.0.  With an option like "2", the ACPI version shows
;  N/A and the option doesn't do anything.  Not sure if VMWare ACPI is
;  non-standard or if we're doing some thing wrong.

;OFF.BAT (SLOWACPI 0) crashes with XMGR as XMM and MS EMM386 as EMM (UMB).
;  Works OK with other XMM's, particularly MS EMM386.EXE and JEMMEx.
;  Want to use MS EMM386.EXE because it supports I/O Virtualization.
;  Still may need to do a JLM for JEMM to virtualize I/O.
;  Problem is that XMGR crashes with WRMSR instruction!

;Options to allow/disallow ODCM and maybe ACPI (but not both?)

;When showing Embedded Controller Data, option?) just show negative/positive
;  changes.  Negative changes for Batteries!  Even if showing both,
;  indicated negative/positive changes with arrows.  May need to do something
;  special arrows (on screen show low ASCII values)?


;

;TestParentShell doesn't work with DOS 3.3 (Program is listed as its
;  own Parent?)  Need to fix in all programs!

;Make sure to copy all things related to INT 15.87 from USBHOSTS!

;Make TSR to flash red when battery is running low

;Put Up/Down Arrow(s) in status message for Charging

;C2 & C3 states (for merging this program w/ BattSave): C2/C3 don't
;  exist on early computers (pre-486?), and early CPU's don't turn
;  off any power with HLT instruction either -- they just don't do
;  anything useful.  HLT still saves power, but not a lot.

;Problem with FindECInfo on Equus -- ends up in infinite loop on
;  Embedded Controller Info.  Fix It!!

;In SLOWDOWN, issue WBINVD after each slowdown loop (if 80486+)?  Is there a
;  way to verify that WBINVD will work on a particular CPU (besides 486+)?
;  Could also set MTRR type to Uncacheable?

;Do better at getting Power Info from ACPI

;With laptop plugged in but no battery, we show battery is fully charged
;  (this is wrong!)

;Handle Lid Open/Close, shut off when closed?  Allow user to select what
;  to do when lid is closed?  Test wheter at command line before closing
;  (keep track with Shell leve)?

;Auto-detect AC power, slow down automatically if on batteries, slow if
;  unplugged

;SLOWACPI 0 sometimes reboots instead of shutting off -- seems maybe related
;  to DPMS and/or EMS server being in memory, but not sure

;For Slowing down, use method with higher resolution (ACPI vs. ODCM)
;  If the same, use ODCM?

;Some computers have both ACPI & ODCM, but don't want both active at the
;  same time (may not be synchronized)!  Seems to automatically happen?
;  Ignores STOPCLK# if in ODCM?

;Integrate w/ BATTSAVE, create TSR to monitor battery status
;  Charging = Up Arrow, Discharging = Down Arrow, Neither = Horizontal Arrow
;  Percentage Charge
;  Turn Red/Flash when Battery is getting low and is Discharging
;     (Maybe use Battery Status Bit 2?)
;Coordinate screen location w/ other TSR's (CLOCK, LOCKEYS, SERIAL)?
;When battery is getting low, automatically turn on even if off
;Toggle a character when Idling
;Turn off when lid is closed if at command prompt (count INT 21 exits -- make
;  sure it works with JEMM on GPF's)
;Update battery percent every 5 seconds or so -- shouldn't be a big deal
;Get battery details from APM if available?

;Show difference between this data and last when monitoring embedded
;  controller data

;BTR/BTS required 386, WBINVD requires 486, not sure what required 586?
;  Can't use C3 unless 486+

;In All Programs: While waiting for things (esp. keystrokes),
;  issue Release Time Slice request (GetKey:)

;On Sony (and possibly others), amperage is signed (charging/discharging is
;  in high bit of data, must negate if negative to get value)

;Add support for Power/Sleep/Wakeup buttons.  Power off if at DOS prompt,
;  Sleep = ?? (Suspend USB devices?  Issue APM call of some sort?
;  Test like Power key?  Ignore?)  Wakeup = ??
;  Manage through INT 09h or INT 15.xx?

;Convert to NASM?



;In DOCS:
;FDAPM/Power do a lot of calls to APM to tell it to run at full speed (wake),
;  but we just tell it when to idle

;ODCM option needed for XMGR, at least on some computers.  ODCM uses special
;  CPU instruction WRMSR, that is only available on some CPU's and XMGR
;  crashes when it is issued.
;Also needed if user wants to use ACPI instead of APM for some reason.
;Uses ODCM rather than ACPI if it is available (and ODCM is enabled).




;DONE
;  Test80386
;  Brackets (not tested)


;
;General NASM Stuff
;These make a lot of the code compatible with A86, making porting much easier.
;A lot of this is necessary because NASM is case-sensitive, while A86 is not.
;This should be put at the top of the file.
;

  ;----------------------------------------------------------------------------
  ;Preprocessor Directives
  ;----------------------------------------------------------------------------
  ORG   100h ;Output a DOS .COM file
  CPU   586  ;Don't allow 486+ Instructions
  USE16      ;16-bit Code

  [MAP Symbols SlowACPI.Map]

  ;----------------------------------------------------------------------------
  ;The include file A86Help.Mac contains Macros and Definitions to ease
  ;  conversion from A86 to NASM as much as is possible using automated
  ;  methods.  The include file does the following:
  ;
  ;  1) Defines instruction size overrides as follows (the same as A86 uses):
  ;
  ;       B = byte
  ;       W = word
  ;       D = dword
  ;       Q = qword
  ;       T = tword
  ;       Y = yword
  ;
  ;  2) Allows "?" to be used as a data initializer, which is equivalent
  ;       to "0".  E.g., the following are equivalent:
  ;
  ;         Data1 DB ?
  ;         Data1 DB 0
  ;
  ;     I try to use a "?" to indicate that the default value is actually
  ;       unknown (to be filled in later during program initialization),
  ;       while "0" indicates that the default value is actually 0
  ;       (not "unknown").  In either case, though, the data will actually
  ;       be initialized to 0.
  ;
  ;  3) PUSH & POP will accept multiple arguments.  E.g.:
  ;
  ;       PUSH AX,BX,CX
  ;       POP  CX,BX,AX
  ;
  ;  4) MOV will accept two segment registers as inputs, and copy the
  ;       registers using the stack (a PUSH/POP combination), just like
  ;       A86 does.  If at least one of the two parameters is not a
  ;       segment register, a regular MOV is performed.  E.g.:
  ;
  ;         MOV  DS,CS
  ;
  ;     The standard MOV instruction (in either the NASM syntax, or the
  ;      CPU itself), will not accept two segment registers in a MOV.
  ;
  ;  5) INC & DEC can take a second parameter indicating the number of
  ;       times to issue the INC/DEC.  E.g.:
  ;
  ;         INC  AX,2  ;Outputs INC AX, INC AX
  ;
  ;     Note that the only time this is really useful is if the first
  ;       parameter is a word register (in 16-bit mode, or a dword
  ;       register in 32-bit mode), and if the second parameter is 2.
  ;       E.g., two successive INC AX instructions use less memory than
  ;       an ADD AX,2.  If using byte/dword registers, memory variables,
  ;       or trying to add/subtract more than 2 to a register, ADD/SUB
  ;       is more efficient than multiple INC/DEC's.
  ;
  ;  6) EVEN can be used as a synonym for NASM's align 2 directive.
  ;
  ;  7) Structures can be defined with STRUC & ENDS, instead of
  ;       struc & endstruc.
  ;
  ;In addition to the things that the include file handles "automatically",
  ;  there are still several major "issues" to address to complete the
  ;  conversion to NASM.  The include file details what the major items are.
  ;
  ;NOTE: The include file must NOT include any actual code -- just
  ;        Macros & EQUates.  We need to control the physical format
  ;        of the compiled program, which can only happen if all the
  ;        code and data is in here.
  ;----------------------------------------------------------------------------
  %include "A86Help.Mac" ;Include A86 to NASM conversion Macros

  ;----------------------------------------------------------------------------
  ;First bytes of the actual program
  ;This needs to come after the include file, or we can't use an
  ;  upper-case JMP (we would need to use lower-case jmp instead).
  ;----------------------------------------------------------------------------
  JMP Main ;Skip over TSR Code to Main Program Initialization


;
;EQUATE/STRUCTURE/MACRO DEFINITIONS
;

;
;EQUATES
;

;==============================================================================
;Miscellaneous
;==============================================================================

  ;----------------------------------------------------------------------------
  ;Special Codes
  ;----------------------------------------------------------------------------
  No  EQU  0 ;Miscellaneous Yes/No tests
  Yes EQU -1 ;      "        "  "    "


;==============================================================================
;CPU Related
;==============================================================================

  ;----------------------------------------------------------------------------
  ;Bit masks in the CPU (E)Flags Register
  ;----------------------------------------------------------------------------
  CarryFlag    EQU 0000_0001h ;Carry Flag
  ;Bit 1 always set
  ParityFlag   EQU 0000_0004h ;Parity Flag
  ;Bit 3 always clear
  AuxFlag      EQU 0000_0010h ;Auxiliary Flag
  ;Bit 5 always clear
  ZeroFlag     EQU 0000_0040h ;Zero Flag
  SignFlag     EQU 0000_0080h ;Sign Flag
  TrapFlag     EQU 0000_0100h ;Trap Flag
  IntFlag      EQU 0000_0200h ;Interrupt Flag (1 = Interrupts Enabled)
  DirFlag      EQU 0000_0400h ;Direction Flag
  OFFlag       EQU 0000_0800h ;Overflow Flag
  ;Bits 12-15 always set on 8086
  ;Bits 12-15 always clear on 80286
  IOPLMask     EQU 0000_3000h ;I/O Privilege Level (80286+)
  NestedFlag   EQU 0000_4000h ;Nested Task Flag (80286+)
  ;Bit 15 always clear on 80386+
  ResumeFlag   EQU 0001_0000h ;Resume Flag (manages Breakpoint Interrupts)
  V86Flag      EQU 0002_0000h ;1 = Virtual-8086 mode, 0 = Protected Mode
  AlignFlag    EQU 0004-0000h ;Alignment Check Flag
                              ;  (also requires AM flag set in CR0)
  VIntFlag     EQU 0008_0000h ;Virtual Interrupt Flag (also requires VME/PVF
                              ;  flags in CR4)
  VIntPendFlag EQU 0010_0000h ;Virtual Interrupt Pending Flag (set by
                              ;  software, not changed by hardware)
  CPUIDTglFlag EQU 0020_0000h ;CPUID instruction is supported by CPU if
                              ;  this flag can be toggled


  ;----------------------------------------------------------------------------
  ;CPUID-related
  ;The CPUID OpCode is called with a function number in EAX and sometimes
  ;  ECX, and returns data in EAX, EBX, ECX, and EDX.  It is essentially
  ;  read-only: you can't change anything with CPUID, only identify which
  ;  features are supported.
  ;Exactly what is returned can vary depending on several different factors,
  ;  including the manufacturer and model and version of the CPU.
  ;However, there are some quasi-standards that Intel has set regarding
  ;  certain features.  We will only concentrate here on the ones we care
  ;  about for our specific purposes.
  ;----------------------------------------------------------------------------
  CPUIDGetVendor     EQU 0000_0000h ;Get Vendor Info & largest CPUID function
    ;Rtn EAX = Largest CPUID function number supported by the Processor
    ;    EBX:EDX:ECX = Vendor Identification (12-byte ASCII String)
    ;                  "AMDisbetter!" = Early engineering samples of AMD K5
    ;                  "AuthenticAMD" = AMD
    ;                  "CentaurHauls" = Centaur
    ;                  "CyrixInstead" = Cyrix
    ;                  "GenuineIntel" = Intel
    ;                  "TransmetaCPU' = TransMeta
    ;                  "GenuineTMx86" = TransMeta
    ;                  "Geode by NSC" = National Semiconductor
    ;                  "NexGenDriven" = NexGen
    ;                  "RiseRiseRise" = Rise
    ;                  "Sis Sis Sis " = SiS
    ;                  "UMC UMC UMC " = UMC
    ;                  "VIA VIA VIA " = VIA
    ;                  "Vortex86 SoC" = Vortex
    ;                  "KVMKVMKVMKVM" = KVM
    ;                  "Microsoft Hv" = MS Hyper-V or MS Virtual PC
    ;                  "VMwareVMware" = VMware
    ;                  "XenVMMXenVMM" = Xen HVM

  CPUIDGetFeatures   EQU 0000_0001h ;Get Processor Info & Feature Bits

   ;Returned in EAX:
    CPUFtrAStepping  EQU 0000_000Fh ;Bits  0- 3 = Stepping
    CPUFtrAModel     EQU 0000_00F0h ;Bits  4- 7 = Model
    CPUFtrAFamily    EQU 0000_0F00h ;Bits  8-11 = Family
    CPUFtrAProcessor EQU 0000_3000h ;Bits 12-13 = Processor Type
                                    ;             0000h = Original OEM CPU
                                    ;             1000h = Intel Overdrive CPU
                                    ;             2000h = Dual Processor
                                    ;             3000h = Intel Reserved
    ;Bits 14-15 = Reserved
    ;EAX in its entirety is called the "Processor Signature"
    CPUFtrAXModel    EQU 000F_0000h ;Bits 16-19 = Extended Model
                                    ;             Valid if Model = 06h or 0Fh
    CPUFtrAXFamily   EQU 0FF0_0000h ;Bits 20-27 = Extended Family
                                    ;             Valid if Family = 0Fh
    ;Bits 28-31 = Reserved

   ;Returned in EBX:
    CPUFtrBBrandIdx  EQU 0000_00FFh ;Bits  0- 7 = Brand Index
    CPUFtrBCFlUSHSz  EQU 0000_FF00h ;Bits  8-15 = CFLUSH Line Size (Bytes)
    CPUFtrBMaxLogCPU EQU 00FF_0000h ;Bits 16-23 = Maximum addressable ID's for
                                    ;               logical processors in
                                    ;               physical package
    CPUFtrBInitAPIC  EQU 0FF00_0000h ;Bits 24-31 = Initial APIC ID

   ;Returned in ECX:
    CPUFtrCSSE3      EQU 0000_0001h ;Bit  0 = Streaming SIMD Extensions 3 (SSE3)
                                    ;           aka Prescott New Instructions?
    CPUFtrCPCLMULQDQ EQU 0000_0002h ;Bit  1 = PCLMULQDQ instruction support
    CPUFtrCDTES64    EQU 0000_0004h ;Bit  2 = 64-bit debug store (EDX bit 21)
    CPUFtrCMonitor   EQU 0000_0008h ;Bit  3 = MONITOR & MWAIT instructions
    CPUFtrCDS_CPL    EQU 0000_0010h ;Bit  4 = CPL qualified debug store
    CPUFtrCVMX       EQU 0000_0020h ;Bit  5 = Virtual Machine Extensions
    CPUFtrCSMX       EQU 0000_0040h ;Bit  6 = Safer Mode Extensions (LaGrande)
    CPUFtrCEST       EQU 0000_0080h ;Bit  7 = Enhanced Intel SpeedStep Technology
    CPUFtrCTM2       EQU 0000_0100h ;Bit  8 = Thermal Monitor 2
    CPUFtrCSSSE3     EQU 0000_0200h ;Bit  9 = Supplemental SSE3 instructions
    CPUFtrCL1Context EQU 0000_0400h ;Bit 10 = L1 Context ID (L1 Cache can be
                                    ;           set to adaptive or shared)
    ;Bit 11 = Reserved
    CPUFtrCFMA       EQU 0000_1000h ;Bit 12 = Fused Multiply Add estension
                                    ;           using YMM state
    CPUFtrCCMPXCHG   EQU 0000_2000h ;Bit 13 = CMPXCHG8B CMPXCHG16B instructions
    CPUFtrCxTPR      EQU 0000_4000h ;Bit 14 = Can disable sending task priority
                                    ;           messages
    CPUFtrCPDCM      EQU 0000_8000h ;Bit 15 = Performance & Debug feature
                                    ;           indication
    ;Bit 16 = Reserved
    CPUFtrCPCID      EQU 0002_0000h ;Bit 17 = Process Control Identifiers
                                    ;           (CR4 bit 17)
    CPUFtrCDCA       EQU 0004_0000h ;Bit 18 = Prefetch data from memory-mapped
                                    ;           device (Direct Cache Access)
    CPUFtrCSSE4_1    EQU 0008_0000h ;Bit 19 = SSE4.1 instructions
    CPUFtrCSSE4_2    EQU 0010_0000h ;Bit 20 = SSE4.2 instructions
    CPUFtrCx2APIC    EQU 0020_0000h ;Bit 21 = x2APIC support
    CPUFtrCMOVBE     EQU 0040_0000h ;Bit 22 = MOVBE instruction (big-endian)
    CPUFtrCPOPCNT    EQU 0080_0000h ;Bit 23 = POPCNT instruction
    CPUFtrCTSC_DedLn EQU 0100_0000h ;Bit 24 = APIC supports one-shot operation
                                    ;           using a TSC deadline value
    CPUFtrCAESNI     EQU 0200_0000h ;Bit 25 = AESNI instruction set
    CPUFtrCXSAVE     EQU 0400_0000h ;Bit 26 = XSAVE, XRESTORE, XSETBV, XGETBV,
                                    ;            and XCR0
    CPUFtrCOSXSAVE   EQU 0800_0000h ;Bit 27 = XSAVE enabled by OS
    CPUFtrCAVX       EQU 1000_0000h ;Bit 28 = Advanced Vector Extensions
    CPUFtrCF16C      EQU 2000_0000h ;Bit 29 = F16C (half-precision) FP support
                                    ;           (Reserved according to Intel)
    CPUFtrCRDRAND    EQU 4000_0000h ;Bit 30 = RDRAND support (on-chip random
                                    ;           number generator)
    CPUFtrCHypervisr EQU 8000_0000h ;Bit 31 = Running on a hypervisor (always 0
                                    ;           on a real CPU & w/ some hypers)
                                    ;           (Always 0 according to Intel)

   ;Returned in EDX:
    CPUFtrDFPU       EQU 0000_0001h ;Bit  0 = On-board x87 Floating Point Unit
    CPUFtrDVME       EQU 0000_0002h ;Bit  1 = Virtual 8086 mode enhancement
                                    ;           (CR4.VME, CR4.PVI, EFlags.VIF,
                                    ;            EFlags. VIF, etc.)
    CPUFtrDDebugX    EQU 0000_0004h ;Bit  2 = Debugging extensions
                                    ;           (CR4.DE, trap DR4 & DR5, etc.)
    CPUFtrDPSE       EQU 0000_0008h ;Bit  3 = Page Size Extension
                                    ;           (4 MB pages, CR4.PSE, etc.)
    CPUFtrDTSC       EQU 0000_0010h ;Bit  4 = Time Stamp Counter
                                    ;           (RDTSC, CR4.TSD)
    CPUFtrDRDMSR     EQU 0000_0020h ;Bit  5 = Model Specific Registers
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;            (RDMSR & WRMSR)
    CPUFtrDPAE       EQU 0000_0040h ;Bit  6 = Physical Address Extension
    CPUFtrDMCE       EQU 0000_0080h ;Bit  7 = Machine Check Exception
    CPUFtrDCMPXCHG8B EQU 0000_0100h ;Bit  8 = CMPXCHG8B instruction
    CPUFtrDAPIC      EQU 0000_0200h ;Bit  9 = On-board Advanced Programmable
                                    ;           Interrupt Controller
    ;Bit 10 = Reserved
    CPUFtrDSYSENTER  EQU 0000_0800h ;Bit 11 = SYSENTER & SYSEXIT instructions
    CPUFtrDMTRR      EQU 0000_1000h ;Bit 12 = Memory Type Range Registers
    CPUFtrDPGE       EQU 0000_2000h ;Bit 13 = Page Global Enable (CR4.PGE)
    CPUFtrDMCA       EQU 0000_4000h ;Bit 14 = Machine Check Architecture
    CPUFtrDCMOV      EQU 0000_8000h ;Bit 15 = CMOV, FCMOV, FCOMI instructions
    CPUFtrDPAT       EQU 0001_0000h ;Bit 16 = Page Attribute Table
                                    ;           (augments MTRR's)
    CPUFtrDPSE_36    EQU 0002_0000h ;Bit 17 = 36-bit Page Size Extension
    CPUFtrDPSN       EQU 0004_0000h ;Bit 18 = 96-bit Processor Serial Number
    CPUFtrDCLFLUSH   EQU 0008_0000h ;Bit 19 = CLFLUSH instruction (SSE2)
    ;bit 20 = Reserved
    CPUFtrDDebugSt   EQU 0020_0000h ;Bit 21 = Debug store (save trace of
                                    ;           executed jumps)
    CPUFtrDACPI      EQU 0040_0000h ;Bit 22 = Thermal monitor and clock control
                                    ;           MSR's for ACPI
    CPUFtrDMMX       EQU 0080_0000h ;Bit 23 = Multi Media Extensions
    CPUFtrDFXSAVE    EQU 0100_0000h ;Bit 24 = FXSAV & FXRESTOR instructions
                                    ;           (CR4.OSFXSR)
    CPUFtrDSSE       EQU 0200_0000h ;Bit 25 = SSE instructions (aka Katmai New
                                    ;           instructions)
    CPUFtrDSSE2      EQU 0400_0000h ;Bit 26 = SSE2 instructions
    CPUFtrDSelfSnoop EQU 0800_0000h ;Bit 27 = CPU cache supports self-snoop
    CPUFtrDHTT       EQU 1000_0000h ;Bit 28 = Hyper-Threading Technology
                                    ;           (multiple logical processors)
    CPUFtrDThermMon  EQU 2000_0000h ;Bit 29 = Thermal Monitor automatically
                                    ;           limits temperature (TCC)
    CPUFtrDIA64      EQU 4000_0000h ;Bit 30 = IA64 processor emulating x86
                                    ;           (Reserved according to Intel)
    CPUFtrDPBE       EQU 8000_0000h ;Bit 31 = Pending Break Enable (PBE# pin)
                                    ;           wakeup support

  CPUIDGetThermal    EQU 0000_0006h ;Get Thermal & Power Management Info

   ;Returned in EAX:
    CPUThermASensor  EQU 0000_0001h ;Bit      0 = Digital Temperature Sensor
    CPUThermATurbo   EQU 0000_0002h ;Bit      1 = Intel TurboBoost Technology
    CPUThermAARAT    EQU 0000_0004h ;Bit      2 = APIC-timer-always-running
    ;Bit 3 = Reserved
    CPUThermAPLN     EQU 0000_0010h ;Bit      4 = Power Limit Notification
                                    ;               controls
    CPUThermAECMD    EQU 0000_0020h ;Bit      5 = Extended Clock Modulation
                                    ;               Duty Cycle (16 levels)
    CPUThermAPTM     EQU 0000_0040h ;Bit      6 = Package Thermal Management
    ;Bits  7-31 = Reserved

   ;Returned in EBX:
    CPUThermBIThresh EQU 0000_000Fh ;Bits  0- 3 = Number of Interrupt Thresholds
                                    ;               in Digital Thermal Sensor
    ;Bits 4-31 = Reserved

   ;Returned in ECX:
    CPUThermCHWFdbk  EQU 0000_0001h ;Bit      0 = Hardware coordination feedback
                                    ;               capability MSR's
    ;Bits  1- 2 = Reserved
    CPUThermCPBias   EQU 0000_0008h ;Bit      3 = Performanace-energy Bias
    ;bits  4-31 = Reserved

   ;Returned in EDX:
    ;Bits  0-31 = Reserved

  CPUIDXGetMaxFunc   EQU 8000_0000h ;Get Maximum Extended Features EAX value
    ;Returns maximum COUID EAX value that can be issued in EAX
    ;  EBX, ECX, EDX = Reserved
  CPUIDXGetCPUBrand0 EQU 8000_0002h ;Get Processor Brand String 0
    ;Returns 1st 16 bytes of 48-byte Processor Brand String in EAX:EBX:ECX:EDX
    ;  String is space padded at the beginning, and null-terminated
    ;  String generally includes Manufacturer, Model, and maximum
    ;    qualified processor speed.
  CPUIDXGetCPUBrand1 EQU 8000_0003h ;Get Processor Brand String 1
    ;Returns 2nd 16 bytes of 48-byte Processor Brand String in EAX:EBX:ECX:EDX
  CPUIDXGetCPUBrand2 EQU 8000_0004h ;Get Processor Brand String 2
    ;Returns 3rd 16 bytes of 48-byte Processor Brand String in EAX:EBX:ECX:EDX

  ;----------------------------------------------------------------------------
  ;RDMSR/WRMSR-related
  ;Modern CPU's have dozens of different MSR's (Model-Specific Registers)
  ;  that monitor & control all kinds of different aspects of the CPU.  As with
  ;  the CPUID instruction, different manufacturers do things differently,
  ;  and not all CPU's even from the same manufacturer are consistent in their
  ;  use of MSR's.
  ;However, Intel has defined several MSR's to be quasi-generic in terms of
  ;  their location and meaning (Intel calls these "architectural MSRs").
  ;  So, these will be consistent at least within the Intel CPU's, and
  ;   probably by most other manufacturers as well.
  ;
  ;The RDMSR instruction reads a spcific (64-bit) MSR, and WRMSR writes.
  ;  These instructions are called with the MSR number in ECX, and EDX:EAX
  ;  contains the value.
  ;RDMSR/WRMSR support is indicated by CPUID.01h:EDX[5]
  ;----------------------------------------------------------------------------
  MSRP5MCAddr     EQU 0000_0000h ;
  MSRP5MCType     EQU 0000_0001h ;
  MSRMonFilterSz  EQU 0000_0006h ;MONITOR/MWAIT Address Range Determination
  MSRTimeStampCtr EQU 0000_0010h ;Time Stamp Counter
  MSRPlatformID   EQU 0000_0017h ;Bits  0-49 = Reserved
                                 ;Bits 50-52 = Platform ID
                                 ;Bits 53-63 = Reserved
  MSRAPICBase     EQU 0000_001Bh ;Bits  0- 7 = Reserved
                                 ;Bit      8 = BSP (Bootstrap Processor
                                 ;Bit      9 = Reserved
                                 ;Bit     10 = Enable x2APIC Mode
                                 ;Bit     11 = APIC Global Enable
                                 ;Bits 12-MaxPhyWid = APIC Base
                                 ;Bits MaxPhyWid-63 = Reserved
  MSRFtrControl   EQU 0000_003Ah ;Bit      0 = Lock (Once set, MSR cannot change)
                                 ;Bit      1 = Enable VMX inside SMX
                                 ;Bit      2 = Enable VMX outside SMX
                                 ;Bits  3- 7 = Reserved
                                 ;Bits  8-14 = SENTER Local Function Enables
                                 ;Bit     15 = SENTER Glocal Enable
                                 ;Bits 16-63 = Reserved
  MSRTSCAdjust    EQU 0000_003Bh ;Per-logical-Processor TSC Adjust
                                 ;Bits  0-63 = Logical Processor Offset
  MSRBIOSUpdtTrig EQU 0000_0079h ;BIOS Update Trigger (W)
                                 ;  Causes microcode update to be loaded to CPU
  MSRBIOSSignID   EQU 0000_008Bh ;Bits  0-31 = Reserved
                                 ;Bits 32-63 = BIOS Update Signature
                                 ;               (follows a CPUID.01h call)
  MSRSMMMonCfg    EQU 0000_009Bh ;SMM Monitor Configuration
                                 ;Bit      0 = Valid
                                 ;Bit      1 = Reserved
                                 ;bit      2 = SMI unblocking by VMXDFF
                                 ;Bits  3-11 = Reserved
                                 ;Bits 12-31 = MSEG Base
                                 ;Bits 32-63 = Reserved
  MSRSMBase       EQU 0000_009Eh ;SMRAM Base Address for Logical CPU (SMM)
  MSRPMC0         EQU 0000_00C1h ;General Performance Counter 0 PERCTR0
  MSRPMC1         EQU 0000_00C2h ;General Performance Counter 1 PERCTR1
  MSRPMC2         EQU 0000_00C3h ;General Performance Counter 2
  MSRPMC3         EQU 0000_00C4h ;General Performance Counter 3
  MSRPMC4         EQU 0000_00C5h ;General Performance Counter 4
  MSRPMC5         EQU 0000_00C6h ;General Performance Counter 5
  MSRPMC6         EQU 0000_00C7h ;General Performance Counter 6
  MSRPMC7         EQU 0000_00C8h ;General Performance Counter 7
  MSRMPerf        EQU 0000_00E7h ;Maximum Performance Clock Counter
  MSRAPerf        EQU 0000_00E8h ;Actual Performance Clock Counter
  MSRMTRRCap      EQU 0000_00FEh ;MTRR Capabilities
                                 ;Bits  0- 7 = Number of variable memory
                                 ;               ranges in CPU (usually 8,
                                 ;               starting at MSR 200h)
                                 ;Bit      8 = Fixed range MTRR support
                                 ;Bit      9 = Reserved
                                 ;Bit     10 = WC support
                                 ;Bit     11 = SMRR support
                                 ;Bits 12-63 = Reserved
  MSRSysEnterCS   EQU 0000_0174h ;Bits  0-15 = CS Selector
                                 ;Bits 16-63 = Reserved
  MSRSysEnterESP  EQU 0000_0175h ;
  MSRSysEnterEIP  EQU 0000_0176h ;
  MSRMCGCap       EQU 0000_0179h ;Global Machine Check Capability
                                 ;Bits  0- 7 = Number of Reporting Banks
                                 ;Bit      8 = MSR MCG Control Present
                                 ;Bit      9 = Extended Machine Check State
                                 ;               reginster present
                                 ;Bit     10 = Corrected MC Error Event support
                                 ;Bit     11 = Threshold-based error status
                                 ;               registers present
                                 ;Bits 12-15 = Reserved
                                 ;Bits 16-23 = Number of extended machine check
                                 ;               state registers present
                                 ;Bit     24 = Processor supports software
                                 ;               error recovery
                                 ;Bit     25 = Reserved
                                 ;Bit     26 = CPU allows platform firmware
                                 ;               invocation on errors for ACPI
                                 ;Bits 27-63 = Reserved
  MSRMCG_Status   EQU 0000_017Ah ;Global Machine Check Status
  MSRMCG_Control  EQU 0000_017Bh ;Global Machine Check Control

  ;In processors based on Intel NetBurst, MSR Addresses 180h-185h & 188h-197h
  ;  are supported and must be treated as model-specific.
  ;Starting with Intel Core Duo processors, MSR Addresses 180h-185h & 188h-197h
  ;  are reserved.

  ;180h-185h = Reserved
  MSRPerfEvtSel0  EQU 0000_0186h ;Performance Event Select Register 0
                                 ;Bits  0- 7 = Event Select (selects logic unit)
                                 ;Bits  8-15 = UMask (microarchitectural
                                 ;               condition qualifier)
                                 ;Bit     16 = USR (counts while Ring != 0)
                                 ;Bit     17 = OS (counts while Ring = 0)
                                 ;Bit     18 = Edge (enables edge detection)
                                 ;Bit     19 = PC (enables pin control)
                                 ;Bit     20 = INT (enables INT on counter OF)
                                 ;Bit     21 = AnyThread (counts across all
                                 ;               logical processors)
                                 ;Bit     22 = EN (enable performance count)
                                 ;Bit     23 = INV (invert CMASK)
                                 ;Bits 24-31 = CMASK (counter increments each
                                 ;               cycle if event count > CMASK)
                                 ;Bit  32-63 = Reserved
  MSRPerfEvtSel1  EQU 0000_0187h ;Performance Event Select Register 1

  ;In processors based on Intel NetBurst, MSR Addresses 180h-185h & 188h-197h
  ;  are supported and must be treated as model-specific.
  ;Starting with Intel Core Duo processors, MSR Addresses 180h-185h & 188h-197h
  ;  are reserved.

  MSRPerfEvtSel2  EQU 0000_0188h ;Performance Event Select Register 2
  MSRPerfEvtSel3  EQU 0000_0189h ;Performance Event Select Register 3
  ;18Ah-197h = Reserved
  MSRPerfStatus   EQU 0000_0198h ;Bits  0-15 = Current Performance State Value
                                 ;Bits 16-63 = Reserved
  MSRPerfControl  EQU 0000_0199h ;Bits  0-15 = Target Performance State Value
                                 ;Bits 16-31 = Resrved
                                 ;Bit     32 = IDA Disengage
                                 ;Bits 33-63 = Reserfed
  MSRClkModulate  EQU 0000_019Ah ;Bit      0 = Extended Duty Cycle (15 stages)
                                 ;Bits  1- 3 = Duty Cycle (0 = Undefined,
                                 ;               1 = 12.5%, ..., 7 = 87.5%)
                                 ;Bit      4 = Duty Cycle Enable
                                 ;Bits  5-63 = Reserved
  MSRThermalInt   EQU 0000_019Bh ;Thermal Interrupt Control
                                 ;Bit      0 = High Temp INT enable
                                 ;Bit      1 = Low Temp INT eanble
                                 ;Bit      2 = PROCHOT# INT enable
                                 ;Bit      3 = FORCEPR# INT enable
                                 ;Bit      4 = Critical Temp INT enable
                                 ;Bits  5- 7 = Reserved
                                 ;Bits  8-14 = Threshold #1 Value
                                 ;Bit     15 = Threshold #1 INT enable
                                 ;Bits 16-22 = Threshold #2 Value
                                 ;Bit     23 = Threshold #2 INT enable
                                 ;bit     24 = Power Limit Notification enable
                                 ;Bits 25-63 = Reserved
  MSRThermalSts   EQU 0000_019Ch ;Thermal Status Information
                                 ;Bit      0 = Thermal Status
                                 ;Bit      1 = Thermal Status Log
                                 ;Bit      2 = PROCHOT# or FORCEPR# event
                                 ;Bit      3 = PROCHOT# or FORCEPR# log
                                 ;Bit      4 = Critical Temp Status
                                 ;Bit      5 = Critical Temp Status Log
                                 ;Bit      6 = Thermal Threshold #1 Status
                                 ;Bit      7 = Thermal Threshold #1 Status Log
                                 ;Bit      8 = Thermal Threshold #2 Status
                                 ;Bit      9 = Thermal Threshold #2 Status Log
                                 ;Bit     10 - Power Limitation Status
                                 ;Bit     11 - Power Limitation Status Log
                                 ;Bits 12-15 = Reserved
                                 ;Bits 16-22 = Digital Readout
                                 ;Bits 23-26 = Reserved
                                 ;Bits 27-30 = Resolution in degrees Celsius
                                 ;Bit     31 = Reading Valid
                                 ;Bits 32-63 = Reserved
  MSRMiscEnable   EQU 0000_01A0h ;Miscellaneous Features Enable
                                 ;Bit      0 = Fast Strings Enable (default)
                                 ;Bits  1- 2 = Reserved
                                 ;Bit      3 = Automatic Thermal Ctl Ckt Enble
                                 ;               (CPU automatically slows down
                                 ;                on TCC activation)
                                 ;Bits  4- 6 = Reserved
                                 ;Bit      7 = Performance Monitoring enabled
                                 ;Bits  8-10 = Reserved
                                 ;Bit     11 = Branch Trace Storage unavailable
                                 ;Bit     12 = Precise Event Based Sampling
                                 ;               unavailable
                                 ;Bits 13-15 = Reserved
                                 ;Bit     16 = SpeedStep Technology enable
                                 ;Bit     17 = Reserved
                                 ;Bit     18 = Enable Monitor FSM
                                 ;Bits 19-21 = Reserved
                                 ;Bit     22 = Limit CPUID MaxVal to 3
                                 ;Bit     23 = xTPR Message Disable
                                 ;Bits 24-33 = Reserved
                                 ;Bit     34 = Execute Disable Bit Ftr Disable
                                 ;Bits 35-63 = Reserved
  MSREnergyPrefer EQU 0000_01B0h ;Bits  0- 3 = Power Policy Preference
                                 ;             (0 = Max Perf, 15 = Min Energy)
                                 ;Bits  4-63 = Resrved
  MSRPkgThermSts  EQU 0000_01B1h ;Package Thermal Status
                                 ;Bit      0 = Pkg Thermal Status
                                 ;Bit      1 = Pkg Thermal Status Log
                                 ;Bit      2 = Pkg PROCHOT# event
                                 ;Bit      3 = Pkg PROCHOT# log
                                 ;Bit      4 = Pkg Critical Temp Status
                                 ;Bit      5 = Pkg Critical Temp Status Log
                                 ;Bit      6 = Pkg Therm Threshold #1 Status
                                 ;Bit      7 = Pkf Therm Threshold #1 Status Log
                                 ;Bit      8 = Pkg Therm Threshold #2 Status
                                 ;Bit      9 = Pkg Therm Threshold #2 Status Log
                                 ;Bit     10 - Pkg Power Limitation Status
                                 ;Bit     11 - Pkg Power Limitation Status Log
                                 ;Bits 12-15 = Reserved
                                 ;Bits 16-22 = Pkg Digital Readout
                                 ;Bits 23-63 = Reserved
  MSRTPkgThermInt EQU 0000_01B2h ;Package Thermal Interrupt Control
                                 ;Bit      0 = Pkg High Temp INT enable
                                 ;Bit      1 = Pkg Low Temp INT eanble
                                 ;Bit      2 = Pkg PROCHOT# INT enable
                                 ;Bit      3 = Reserved
                                 ;Bit      4 = Pkg Overheat INT enable
                                 ;Bits  5- 7 = Reserved
                                 ;Bits  8-14 = Pkg Threshold #1 Value
                                 ;Bit     15 = Pkg Threshold #1 INT enable
                                 ;Bits 16-22 = Pkg Threshold #2 Value
                                 ;Bit     23 = Pkg Threshold #2 INT enable
                                 ;Bit     24 = Pkg Power Limit Notify enable
                                 ;Bits 25-63 = Reserved
  MSRDebugControl EQU 0000_01D9h ;Trace/Profile Resource Control
                                 ;Bit      0 = LBR: CPU records running trace of
                                 ;               branches taken in LBR stack
                                 ;Bit      1 = BTF: CPU treats EFLAGS .TF as
                                 ;               single-step on branches rather
                                 ;               than instructions
                                 ;Bits  2- 5 = Reserved
                                 ;Bit      6 = TR: Send Branch Trace Messages
                                 ;Bit      7 = BTS: Branch Trace Messages are
                                 ;               logged in a BTS buffer
                                 ;Bit      8 = BTINT: INT is generated when the
                                 ;               BTS buffer is full (if clear,
                                 ;               BTS is a circular buffer)
                                 ;Bit      9 = BTS_OFF_OS: BTS or BTM is
                                 ;               skipped if CPL = 0
                                 ;Bit     10 = BTS_OFF_USR: BTS or BTM is
                                 ;               skipped if CPL = 0
                                 ;Bit     11 = FREEZE_LBRS_ON_PMI: LBR stack
                                 ;              is frozen on a PMI request
                                 ;Bit     12 = FREEZE_PERFMON_ON_PMI: Each
                                 ;               Enable bit of Global Counter
                                 ;               Control MSR (3BFh) is frozen
                                 ;               on a PMI request
                                 ;Bit     13 = ENABLE_UNICORE_PMI: Logical CPU
                                 ;               can receive and generate PMI
                                 ;               on behalf of Unicore
                                 ;Bit     14 = FREEZE_WHILE_SMM: Freeze PerfMon
                                 ;               and Trace messages while in SMM
                                 ;Bits 15-63 = Reserved
  MSRSMRRPhyBase  EQU 0000_01F2h ;SMRR Base Address (Writable only in SMM)
                                 ;Bits  0- 7 = Memory Type of Address Range
                                 ;Bits  8-11 = Reserved
                                 ;Bits 12-31 = SMRR Base Physical Address
                                 ;Bits 32-63 = Reserved
  MSRSMRRPysMask  EQU 0000_01F3h ;SMRR Range Mask (Writable only in SMM)
                                 ;Bits  0-10 = Reserved
                                 ;Bit     11 = Valid (enable Range Mask)
                                 ;Bits 12-32 = SMRR Range Address Mask
                                 ;Bits 33-63 = Reserved
  MSRPlatfDCACap  EQU 0000_01F8h ;Platform Direct Cache Access Capability
  MSRCPUDCACap    EQU 0000_01F9h ;CPU supports Prefetch-Hint type
  MSRDCA0Cap      EQU 0000_01FAh ;DCA Type 0 Status & Control Register
                                 ;Bit      0 = DCA is fuse-enabled & no
                                 ;               defeatures are set
                                 ;Bits  1- 2 = Transaction
                                 ;Bits  3- 6 = DCA Type
                                 ;Bits  7-10 = DCA Queue Size
                                 ;Bits 11-12 = Reserved
                                 ;Bits 13-16 = DCA Delay - Writes have no
                                 ;               effect on Hardware
                                 ;Bits 17-23 = Reserved
                                 ;Bit     24 = SW_Block: Software DCA Block
                                 ;Bit     25 = Reserved
                                 ;Bit     26 = HW_Block: Hardware DCA Block
                                 ;Bits 27-63 = Reserved
  MSRMTRRPhyBase0 EQU 0000_0200h ;Memory Type Range Register 0 Phys Base Addr
  MSRMTRRPhyMask0 EQU 0000_0201h ;Memory Type Range Register 0 Phys Addr Mask
  MSRMTRRPhyBase1 EQU 0000_0202h ;Memory Type Range Register 1 Phys Base Addr
  MSRMTRRPhyMask1 EQU 0000_0203h ;Memory Type Range Register 1 Phys Addr Mask
  MSRMTRRPhyBase2 EQU 0000_0204h ;Memory Type Range Register 2 Phys Base Addr
  MSRMTRRPhyMask2 EQU 0000_0205h ;Memory Type Range Register 2 Phys Addr Mask
  MSRMTRRPhyBase3 EQU 0000_0206h ;Memory Type Range Register 3 Phys Base Addr
  MSRMTRRPhyMask3 EQU 0000_0207h ;Memory Type Range Register 3 Phys Addr Mask
  MSRMTRRPhyBase4 EQU 0000_0208h ;Memory Type Range Register 4 Phys Base Addr
  MSRMTRRPhyMask4 EQU 0000_0209h ;Memory Type Range Register 4 Phys Addr Mask
  MSRMTRRPhyBase5 EQU 0000_020Ah ;Memory Type Range Register 5 Phys Base Addr
  MSRMTRRPhyMask5 EQU 0000_020Bh ;Memory Type Range Register 5 Phys Addr Mask
  MSRMTRRPhyBase6 EQU 0000_020Ch ;Memory Type Range Register 6 Phys Base Addr
  MSRMTRRPhyMask6 EQU 0000_020Dh ;Memory Type Range Register 6 Phys Addr Mask
  MSRMTRRPhyBase7 EQU 0000_020Eh ;Memory Type Range Register 7 Phys Base Addr
  MSRMTRRPhyMask7 EQU 0000_020Fh ;Memory Type Range Register 7 Phys Addr Mask
  MSRMTRRPhyBase8 EQU 0000_0210h ;Memory Type Range Register 8 Phys Base Addr
  MSRMTRRPhyMask8 EQU 0000_0211h ;Memory Type Range Register 8 Phys Addr Mask
  MSRMTRRPhyBase9 EQU 0000_0212h ;Memory Type Range Register 9 Phys Base Addr
  MSRMTRRPhyMask9 EQU 0000_0213h ;Memory Type Range Register 9 Phys Addr Mask
  MSRMTRRFix64k00 EQU 0000_0250h ;MTRR Fixed Range 64k 0000h
  MSRMTRRFix16k80 EQU 0000_0258h ;MTRR Fixed Range 16k 8000h
  MSRMTRRFix16kA0 EQU 0000_0259h ;MTRR Fixed Range 16k A000h
  MSRMTRRFix4kC0  EQU 0000_0268h ;MTRR Fixed Range  4k C000h
  MSRMTRRFix4kC8  EQU 0000_0269h ;MTRR Fixed Range  4k C800h
  MSRMTRRFix4kD0  EQU 0000_026Ah ;MTRR Fixed Range  4k D000h
  MSRMTRRFix4kD8  EQU 0000_026Bh ;MTRR Fixed Range  4k D800h
  MSRMTRRFix4kE0  EQU 0000_026Ch ;MTRR Fixed Range  4k E000h
  MSRMTRRFix4kE8  EQU 0000_026Dh ;MTRR Fixed Range  4k E800h
  MSRMTRRFix4kF0  EQU 0000_026Eh ;MTRR Fixed Range  4k F000h
  MSRMTRRFix4kF8  EQU 0000_026Fh ;MTRR Fixed Range  4k F800h
  MSRPageAttrTbl  EQU 0000_0277h ;Page Attribute Table
                                 ;Bits  0- 2 = PA0 Cache Type
                                 ;               00h = Uncacheable (UC)
                                 ;               01h = Write-combining (WC)
                                 ;               02h = Reserved
                                 ;               03h = Reserved
                                 ;               04h = Write-through (WT)
                                 ;               05h = Write-protected (WP)
                                 ;               06h = Write-back (WB)
                                 ;               07h = Uncached (UC-)
                                 ;Bits  3- 7 = Resetved
                                 ;Bits  8-10 = PA1 Cache Type
                                 ;Bits 11-15 = Resetved
                                 ;Bits 16-18 = PA2 Cache Type
                                 ;Bits 19-23 = Resetved
                                 ;Bits 24-26 = PA3 Cache Type
                                 ;Bits 27-31 = Resetved
                                 ;Bits 32-34 = PA4 Cache Type
                                 ;Bits 35-39 = Resetved
                                 ;Bits 40-42 = PA5 Cache Type
                                 ;Bits 43-47 = Resetved
                                 ;Bits 48-50 = PA6 Cache Type
                                 ;Bits 51-55 = Resetved
                                 ;Bits 56-58 = PA7 Cache Type
                                 ;Bits 59-63 = Resetved
  MSR_MC00_Ctl2   EQU 0000_0280h ;Corrected Machine Check 00 Control
                                 ;  (Corrected Errors required for APICs)
                                 ;Bits  0-14 = Corrected Error Count Threshold
                                 ;Bits 15-29 = Reserver
                                 ;Bit     30 = Corrected MC Error INT Enable
                                 ;Bits 31-63 = Reserved
  MSR_MC01_Ctl2   EQU 0000_0281h ;Corrected Machine Check 01 Control
  MSR_MC02_Ctl2   EQU 0000_0282h ;Corrected Machine Check 02 Control
  MSR_MC03_Ctl2   EQU 0000_0283h ;Corrected Machine Check 03 Control
  MSR_MC04_Ctl2   EQU 0000_0284h ;Corrected Machine Check 04 Control
  MSR_MC05_Ctl2   EQU 0000_0285h ;Corrected Machine Check 05 Control
  MSR_MC06_Ctl2   EQU 0000_0286h ;Corrected Machine Check 06 Control
  MSR_MC07_Ctl2   EQU 0000_0287h ;Corrected Machine Check 07 Control
  MSR_MC08_Ctl2   EQU 0000_0288h ;Corrected Machine Check 08 Control
  MSR_MC09_Ctl2   EQU 0000_0289h ;Corrected Machine Check 09 Control
  MSR_MC10_Ctl2   EQU 0000_028Ah ;Corrected Machine Check 10 Control
  MSR_MC11_Ctl2   EQU 0000_028Bh ;Corrected Machine Check 11 Control
  MSR_MC12_Ctl2   EQU 0000_028Ch ;Corrected Machine Check 12 Control
  MSR_MC13_Ctl2   EQU 0000_028Dh ;Corrected Machine Check 13 Control
  MSR_MC14_Ctl2   EQU 0000_028Eh ;Corrected Machine Check 14 Control
  MSR_MC15_Ctl2   EQU 0000_028Fh ;Corrected Machine Check 15 Control
  MSR_MC16_Ctl2   EQU 0000_0290h ;Corrected Machine Check 16 Control
  MSR_MC17_Ctl2   EQU 0000_0291h ;Corrected Machine Check 17 Control
  MSR_MC18_Ctl2   EQU 0000_0292h ;Corrected Machine Check 18 Control
  MSR_MC19_Ctl2   EQU 0000_0293h ;Corrected Machine Check 19 Control
  MSR_MC20_Ctl2   EQU 0000_0294h ;Corrected Machine Check 20 Control
  MSR_MC21_Ctl2   EQU 0000_0295h ;Corrected Machine Check 21 Control
  MSRMTRRDefType  EQU 0000_02FFh ;MTRR Default Type
  ;                              ;Bits  0- 2 = Default Memory Type
                                 ;               00h = Uncacheable (UC)
                                 ;               01h = Write-combining (WC)
                                 ;               02h = Reserved
                                 ;               03h = Reserved
                                 ;               04h = Write-through (WT)
                                 ;               05h = Write-protected (WP)
                                 ;               06h = Write-back (WB)
                                 ;               07h = Reserved
                                 ;Bits  3- 9 = Reserved
                                 ;Bit     10 = Fixed Range MTRR Enable
                                 ;Bit     11 = MTRR Enable
                                 ;Bits 12=63 = Reserved
  MSRFixPerfCtr0  EQU 0000_0309h ;Fixed-Function Performance Counter 0
                                 ;  (Counts Instr_Retired.Any)
  MSRFixPerfCtr1  EQU 0000_030Ah ;Fixed-Function Performance Counter 1
                                 ;  (Counts CPU_CLK_Unhalted.Core)
  MSRFixPerfCtr2  EQU 0000_030Bh ;Fixed-Function Performance Counter 2
                                 ;  (Counts CPU_CLK_Unhalted.Ref)
  MSRPerf_Cap     EQU 0000_0345h ;Bits  0- 5 = LBR Format
                                 ;Bit      6 = PEBS Trap
                                 ;Bit      7 = PEBSSaveArchRegs
                                 ;Bits  8-11 = PEBS Record Format
                                 ;Bit     12 = Freeze while SMM is supported
                                 ;Bit     13 = Full width of counter writable
                                 ;               via IA32_A_PMCx
                                 ;Bits 14-63 = Reserved
  MSRFixedCtrCtl  EQU 0000_038Dh ;Fixed-Function Performance Counter Control
                                 ;Bit      0 = EN0_OS: Enable Fixed Counter 0
                                 ;               to count while CPL = 0
                                 ;Bit      1 = EN0_Usr: Enable Fixed Counter 0
                                 ;               to count while CPL > 0
                                 ;Bit      2 = AnyThread: Enable counting across
                                 ;               all logical processors on core
                                 ;Bit      3 = EN0_PMI: Enable PMI when Counter
                                 ;               0 overflows
                                 ;Bit      4 = EN1_OS: Enable Fixed Counter 1
                                 ;               to count while CPL = 0
                                 ;Bit      5 = EN1_Usr: Enable Fixed Counter 1
                                 ;               to count while CPL > 0
                                 ;Bit      6 = AnyThread: Enable counting across
                                 ;               all logical processors on core
                                 ;Bit      7 = EN1_PMI: Enable PMI when Counter
                                 ;               1 overflows
                                 ;Bit      8 = EN2_OS: Enable Fixed Counter 2
                                 ;               to count while CPL = 0
                                 ;Bit      9 = EN2_Usr: Enable Fixed Counter 2
                                 ;               to count while CPL > 0
                                 ;Bit     10 = AnyThread: Enable counting across
                                 ;               all logical processors on core
                                 ;Bit     11 = EN2_PMI: Enable PMI when Counter
                                 ;               2 overflows
                                 ;Bits 12=63 = Reserved
  MSRPerfGlblSts  EQU 0000_038Eh ;Global Performance Counter Status
                                 ;Bit      0 = Ovf_PMC0: Overflow Status of PMC0
                                 ;Bit      1 = Ovf_PMC1: Overflow Status of PMC1
                                 ;Bit      2 = Ovf_PMC2: Overflow Status of PMC2
                                 ;Bit      3 = Ovf_PMC3: Overflow Status of PMC3
                                 ;Bits  4-31 = Reserved
                                 ;Bit     32 = Ovf_FixedCtr0: Overflow Status
                                 ;               of IA32_Fixed_Ctr0
                                 ;Bit     33 = Ovf_FixedCtr1: Overflow Status
                                 ;               of IA32_Fixed_Ctr1
                                 ;Bit     34 = Ovf_FixedCtr2: Overflow Status
                                 ;               of IA32_Fixed_Ctr2
                                 ;Bits 35-60 = Reserved
                                 ;Bit     61 = Ovf_Uncore: Overflow Status of
                                 ;               Uncore Counter
                                 ;Bit     62 = OvfBuf: Overflow Status of
                                 ;               DS Save Buffer
                                 ;Bit     63 = CondChg: Status bits of this
                                 ;               register has changed
  MSRPerfGlblCtl  EQU 0000_038Fh ;Global Performance Counter Control
                                 ;Bit      0 = EN_PMC0
                                 ;Bit      1 = EN_PMC1
                                 ;Bits  2-31 = Reserved
                                 ;Bit     32 = En_Fixed_Ctr0
                                 ;Bit     33 = En_Fixed_Ctr1
                                 ;Bit     34 = En_Fixed_Ctr2
                                 ;Bits 35-63 = Reserved
  MSRPerfGOvfCtl  EQU 0000_0390h ;Global Performance Counter Overflow Control
                                 ;Bit      0 = Set 1 to Clear Ovf_PMC0
                                 ;Bit      1 = Set 1 to Clear Ovf_PMC1
                                 ;Bits  2-31 = Reserved
                                 ;Bit     32 = Set 1 to Clear Ovf_Fixed_Ctr0
                                 ;Bit     33 = Set 1 to Clear Ovf_Fixed_Ctr1
                                 ;Bit     34 = Set 1 to Clear Ovf_Fixed_Ctr2
                                 ;Bits 35-60 = Reserved
                                 ;Bit     61 = Set 1 to Clear Ovf_Uncore
                                 ;Bit     62 = Set 1 to Clear OvfBuf
                                 ;Bit     63 = Set 1 to Clear CondChg
  MSRPEBSEnable   EQU 0000_03F1h ;PEBS Control
                                 ;Bit      0 = Enable PEBS on PMC0
                                 ;Bits  1- 3 = Reserved or Model-specific
                                 ;Bits  4-31 = Reserved
                                 ;Bits 32-35 = Reserved or Model-specific
                                 ;Bits 36-63 = Reserved
  MSRMC00Control  EQU 0000_0400h ;MC00 Control
  MSRMC00Status   EQU 0000_0401h ;MC00 Status
  MSRMC00Address  EQU 0000_0402h ;MC00 Address
  MSRMC00Misc     EQU 0000_0403h ;MC00 Miscellaneous
  MSRMC01Control  EQU 0000_0404h ;MC01 Control
  MSRMC01Status   EQU 0000_0405h ;MC01 Status
  MSRMC01Address  EQU 0000_0406h ;MC01 Address
  MSRMC01Misc     EQU 0000_0407h ;MC01 Miscellaneous
  MSRMC02Control  EQU 0000_0408h ;MC02 Control
  MSRMC02Status   EQU 0000_0409h ;MC02 Status
  MSRMC02Address  EQU 0000_040Ah ;MC02 Address
  MSRMC02Misc     EQU 0000_040Bh ;MC02 Miscellaneous
  MSRMC03Control  EQU 0000_040Ch ;MC03 Control
  MSRMC03Status   EQU 0000_040Dh ;MC03 Status
  MSRMC03Address  EQU 0000_040Eh ;MC03 Address
  MSRMC03Misc     EQU 0000_040Fh ;MC03 Miscellaneous
  MSRMC04Control  EQU 0000_0410h ;MC04 Control
  MSRMC04Status   EQU 0000_0411h ;MC04 Status
  MSRMC04Address  EQU 0000_0412h ;MC04 Address
  MSRMC04Misc     EQU 0000_0413h ;MC04 Miscellaneous
  MSRMC05Control  EQU 0000_0414h ;MC05 Control
  MSRMC05Status   EQU 0000_0415h ;MC05 Status
  MSRMC05Address  EQU 0000_0416h ;MC05 Address
  MSRMC05Misc     EQU 0000_0417h ;MC05 Miscellaneous
  MSRMC06Control  EQU 0000_0418h ;MC06 Control
  MSRMC06Status   EQU 0000_0419h ;MC06 Status
  MSRMC06Address  EQU 0000_041Ah ;MC06 Address
  MSRMC06Misc     EQU 0000_041Bh ;MC06 Miscellaneous
  MSRMC07Control  EQU 0000_041Ch ;MC07 Control
  MSRMC07Status   EQU 0000_041Dh ;MC07 Status
  MSRMC07Address  EQU 0000_041Eh ;MC07 Address
  MSRMC07Misc     EQU 0000_041Fh ;MC07 Miscellaneous
  MSRMC08Control  EQU 0000_0420h ;MC08 Control
  MSRMC08Status   EQU 0000_0421h ;MC08 Status
  MSRMC08Address  EQU 0000_0422h ;MC08 Address
  MSRMC08Misc     EQU 0000_0423h ;MC08 Miscellaneous
  MSRMC09Control  EQU 0000_0424h ;MC09 Control
  MSRMC09Status   EQU 0000_0425h ;MC09 Status
  MSRMC09Address  EQU 0000_0426h ;MC09 Address
  MSRMC09Misc     EQU 0000_0427h ;MC09 Miscellaneous
  MSRMC10Control  EQU 0000_0428h ;MC10 Control
  MSRMC10Status   EQU 0000_0429h ;MC10 Status
  MSRMC10Address  EQU 0000_042Ah ;MC10 Address
  MSRMC10Misc     EQU 0000_042Bh ;MC10 Miscellaneous
  MSRMC11Control  EQU 0000_042Ch ;MC11 Control
  MSRMC11Status   EQU 0000_042Dh ;MC11 Status
  MSRMC11Address  EQU 0000_042Eh ;MC11 Address
  MSRMC11Misc     EQU 0000_042Fh ;MC11 Miscellaneous
  MSRMC12Control  EQU 0000_0430h ;MC12 Control
  MSRMC12Status   EQU 0000_0431h ;MC12 Status
  MSRMC12Address  EQU 0000_0432h ;MC12 Address
  MSRMC12Misc     EQU 0000_0433h ;MC12 Miscellaneous
  MSRMC13Control  EQU 0000_0434h ;MC13 Control
  MSRMC13Status   EQU 0000_0435h ;MC13 Status
  MSRMC13Address  EQU 0000_0436h ;MC13 Address
  MSRMC13Misc     EQU 0000_0437h ;MC13 Miscellaneous
  MSRMC14Control  EQU 0000_0438h ;MC14 Control
  MSRMC14Status   EQU 0000_0439h ;MC14 Status
  MSRMC14Address  EQU 0000_043Ah ;MC14 Address
  MSRMC14Misc     EQU 0000_043Bh ;MC14 Miscellaneous
  MSRMC15Control  EQU 0000_043Ch ;MC15 Control
  MSRMC15Status   EQU 0000_043Dh ;MC15 Status
  MSRMC15Address  EQU 0000_043Eh ;MC15 Address
  MSRMC15Misc     EQU 0000_043Fh ;MC15 Miscellaneous
  MSRMC16Control  EQU 0000_0440h ;MC16 Control
  MSRMC16Status   EQU 0000_0441h ;MC16 Status
  MSRMC16Address  EQU 0000_0442h ;MC16 Address
  MSRMC16Misc     EQU 0000_0443h ;MC16 Miscellaneous
  MSRMC17Control  EQU 0000_0444h ;MC17 Control
  MSRMC17Status   EQU 0000_0445h ;MC17 Status
  MSRMC17Address  EQU 0000_0446h ;MC17 Address
  MSRMC17Misc     EQU 0000_0447h ;MC17 Miscellaneous
  MSRMC18Control  EQU 0000_0448h ;MC18 Control
  MSRMC18Status   EQU 0000_0449h ;MC18 Status
  MSRMC18Address  EQU 0000_044Ah ;MC18 Address
  MSRMC18Misc     EQU 0000_044Bh ;MC18 Miscellaneous
  MSRMC19Control  EQU 0000_044Ch ;MC19 Control
  MSRMC19Status   EQU 0000_044Dh ;MC19 Status
  MSRMC19Address  EQU 0000_044Eh ;MC19 Address
  MSRMC19Misc     EQU 0000_044Fh ;MC19 Miscellaneous
  MSRMC20Control  EQU 0000_0450h ;MC20 Control
  MSRMC20Status   EQU 0000_0451h ;MC20 Status
  MSRMC20Address  EQU 0000_0452h ;MC20 Address
  MSRMC20Misc     EQU 0000_0453h ;MC20 Miscellaneous
  MSRMC21Control  EQU 0000_0454h ;MC21 Control
  MSRMC21Status   EQU 0000_0455h ;MC21 Status
  MSRMC21Address  EQU 0000_0456h ;MC21 Address
  MSRMC21Misc     EQU 0000_0457h ;MC21 Miscellaneous
  MSRVMXBasic     EQU 0000_0480h ;Basic VMX Capabilities
  MSRVMXPinCtls   EQU 0000_0481h ;Pin-based VM execution Controls
  MSRVMXCPUCtls   EQU 0000_0482h ;Primary Processor-based VM-execution Controls
  MSRVMXExitCtls  EQU 0000_0483h ;VM-exit Controls
  MSRVMXEntryCtls EQU 0000_0484h ;VM-entry Controls
  MSRVMXMisc      EQU 0000_0485h ;Miscellaneous VMX Capabilities
  MSRVMXCR0Fixed0 EQU 0000_0486h ;CR0 bits fixed to 0
  MSRVMXCR0Fixed1 EQU 0000_0487h ;CR0 bits fixed to 1
  MSRVMXCR4Fixed0 EQU 0000_0488h ;CR4 bits fixed to 0
  MSRVMXCR4Fixed1 EQU 0000_0489h ;CR4 bits fixed to 1
  MSRVMXVMCSEnum  EQU 0000_048Ah ;VMCS Field Enumeration
  MSRVMXCPUCtls2  EQU 0000_048Bh ;Secondary Processor-based VM-execution Ctls
  MSRVMXEPTVPIDCp EQU 0000_048Ch ;EPT & VPID
  MSRVMXTruPinCtl EQU 0000_048Dh ;Pin-based VM-execution Flex Controls
  MSRVMXTruCPUCtl EQU 0000_048Eh ;Primary Processor-based VM-execution Flex Ctls
  MSRVMXTruExtCtl EQU 0000_048Fh ;Pin-based VM-exit Flex Controls
  MSRVMXTruEntCtl EQU 0000_0490h ;Pin-based VM-entry Flex Controls
  MSR_A_PMC0      EQU 0000_04C1h ;Full-width Writable IA32_PMC0 Alias
  MSR_A_PMC1      EQU 0000_04C2h ;Full-width Writable IA32_PMC1 Alias
  MSR_A_PMC2      EQU 0000_04C3h ;Full-width Writable IA32_PMC2 Alias
  MSR_A_PMC3      EQU 0000_04C4h ;Full-width Writable IA32_PMC3 Alias
  MSR_A_PMC4      EQU 0000_04C5h ;Full-width Writable IA32_PMC4 Alias
  MSR_A_PMC5      EQU 0000_04C6h ;Full-width Writable IA32_PMC5 Alias
  MSR_A_PMC6      EQU 0000_04C7h ;Full-width Writable IA32_PMC6 Alias
  MSR_A_PMC7      EQU 0000_04C8h ;Full-width Writable IA32_PMC7 Alias
  MSRDSArea       EQU 0000_0600h ;Linear Address of Debug Store Buffer Mgmt Area
                                 ;  (Manages BTS & PEBS Buffers)
                                 ;Bits  0-63 = Valid if in IA-32e mode
                                 ;Bits  0-31 = Valid if not in IA-32e mode
  MSRTSCDeadline  EQU 0000_06E0h ;TSC Target of Local APIC's TSC Deadline Mode
  MSRx2APICID     EQU 0000_0802h ;x2APIC ID REgister
  MSRx2APICVer    EQU 0000_0803h ;x2APIC Version Register
  MSRx2APICTPR    EQU 0000_0808h ;x2APIC Task Priority Register
  MSRx2APICPPR    EQU 0000_080Ah ;x2APIC Processor Priority Register
  MSRx2APICEOI    EQU 0000_080Bh ;x2APIC EOI Register
  MSRx2APICLDR    EQU 0000_080Dh ;x2APIC Logical Destination Register
  MSRx2APICSIVR   EQU 0000_080Fh ;x2APIC Spurious Interrupt Vector Register
  MSRx2APICISR0   EQU 0000_0810h ;x2APIC In-Service Register Bits   0- 31
  MSRx2APICISR1   EQU 0000_0811h ;x2APIC In-Service Register Bits  32- 63
  MSRx2APICISR2   EQU 0000_0812h ;x2APIC In-Service Register Bits  65- 94
  MSRx2APICISR3   EQU 0000_0813h ;x2APIC In-Service Register Bits  96-127
  MSRx2APICISR4   EQU 0000_0814h ;x2APIC In-Service Register Bits 128-159
  MSRx2APICISR5   EQU 0000_0815h ;x2APIC In-Service Register Bits 160-191
  MSRx2APICISR6   EQU 0000_0816h ;x2APIC In-Service Register Bits 192-223
  MSRx2APICISR7   EQU 0000_0817h ;x2APIC In-Service Register Bits 224-255
  MSRx2APICTMR0   EQU 0000_0818h ;x2APIC Trigger Mode Register Bits   0- 31
  MSRx2APICTMR1   EQU 0000_0819h ;x2APIC Trigger Mode Register Bits  32- 63
  MSRx2APICTMR2   EQU 0000_081Ah ;x2APIC Trigger Mode Register Bits  65- 94
  MSRx2APICTMR3   EQU 0000_081Bh ;x2APIC Trigger Mode Register Bits  96-127
  MSRx2APICTMR4   EQU 0000_081Ch ;x2APIC Trigger Mode Register Bits 128-159
  MSRx2APICTMR5   EQU 0000_081Dh ;x2APIC Trigger Mode Register Bits 160-191
  MSRx2APICTMR6   EQU 0000_081Eh ;x2APIC Trigger Mode Register Bits 192-223
  MSRx2APICTMR7   EQU 0000_081Fh ;x2APIC Trigger Mode Register Bits 224-255
  MSRx2APICIRR0   EQU 0000_0820h ;x2APIC Interrupt Request Register Bits   0- 31
  MSRx2APICIRR1   EQU 0000_0821h ;x2APIC Interrupt Request Register Bits  32- 63
  MSRx2APICIRR2   EQU 0000_0822h ;x2APIC Interrupt Request Register Bits  65- 94
  MSRx2APICIRR3   EQU 0000_0823h ;x2APIC Interrupt Request Register Bits  96-127
  MSRx2APICIRR4   EQU 0000_0824h ;x2APIC Interrupt Request Register Bits 128-159
  MSRx2APICIRR5   EQU 0000_0825h ;x2APIC Interrupt Request Register Bits 160-191
  MSRx2APICIRR6   EQU 0000_0826h ;x2APIC Interrupt Request Register Bits 192-223
  MSRx2APICIRR7   EQU 0000_0827h ;x2APIC Interrupt Request Register Bits 224-255
  MSRx2APICESR    EQU 0000_0828h ;x2APIC Error Status Register
  MSRx2APICLVTCMC EQU 0000_082Fh ;x2APIC LVT Corrected Machine Check Interrupt
                                 ;  Register
  MSRx2APICICR    EQU 0000_0830h ;x2APIC Interrupt Command Register
  MSRx2APICTimer  EQU 0000_0832h ;x2APIC LVT Timer Interrupt Register
  MSRx2APICTherm  EQU 0000_0833h ;x2APIC LVT Thermal Sensor Interrupt Register
  MSRx2APICPMI    EQU 0000_0834h ;x2APIC LVT Performance Monitor Interrupt
                                 ;  Register
  MSRx2APICLINT0  EQU 0000_0835h ;x2APIC LVT LINT0 Register
  MSRx2APICLINT1  EQU 0000_0836h ;x2APIC LVT LINT1 Register
  MSRx2APICLVTErr EQU 0000_0837h ;x2APIC LVT Error Register
  MSRx2APICInitCt EQU 0000_0838h ;x2APIC Initial Count Register
  MSRx2APICCurCnt EQU 0000_0839h ;x2APIC Current Count Register
  MSRx2APICDivCnf EQU 0000_083Eh ;x2APIC Divide Configuration Register
  MSRx2APICSelfIP EQU 0000_083Fh ;x2APIC Self IPI Register
  MSRQM_EVTSel    EQU 0000_0C8Dh ;QoS Monitoring Event Select Register
                                 ;Bits  0- 7 = Event ID
                                 ;Bits  8-31 = Reserved
                                 ;Bits 32-N+31 =  Resource Monitoring ID
                                 ;Bits N+32-63: Reserved
  MSRQM_Counter   EQU 0000_0C8Eh ;QoS Monitoring Counter Register
                                 ;Bits  0-61 = Resource Monitored Data
                                 ;Bit     62 = Data Unavailable for this RMID
                                 ;Bit     63 = Error (unsupported RMID or
                                 ;               Event Type)
  MSRPQR_Assoc    EQU 0000_0C8Fh ;QoS Resource Association Register
                                 ;Bits  0-N-1: Resource Monitoring ID
                                 ;Bits  N-63 = Reserved
  ;4000_0000-4000_00FFh = Reserved (no Intel MSR's will ever be implemented
  ;                         in this range)
  MSRXFtrEnables EQU 0C000_0080h ;Extended Feature Enables (EFER)
                                 ;  Used to manage Long (64-bit) Mode
                                 ;Bit      0 = SYSCALL/SYSRET in 64-bit mode
                                 ;Bits  1- 7 = Reserved
                                 ;Bit      8 = IA-32e Mode Enable
                                 ;               (32-bit PM from Long Mode)
                                 ;Bit      9 = Reserved
                                 ;Bit     10 = IA-32e Mode Active
                                 ;Bit     11 = Execute Disable Bit Enable
                                 ;Bits 12-63 = Reserved
  MSRSTAR        EQU 0C000_0081h ;System Call Target Address
  MSRLSTAR       EQU 0C000_0082h ;IA-32e Mode System Call Target Address
  MSRFMask       EQU 0C000_0084h ;System Call Flag Mask
  MSRFSBase      EQU 0C000_0100h ;Map of BASE Address of FS
  MSRGSBase      EQU 0C000_0101h ;Map of BASE Address of GS
  MSRKernGSBase  EQU 0C000_0102h ;Swap Target of BASE Address of GS
  MSRTSCAux      EQU 0C000_0103h ;Auxiliary TSC
                                 ;Bits  0-31 = AUX: Auxiliary Signature of TSC
                                 ;Bits 32-63 = Reserved


;==============================================================================
;CONsole/Screen Related
;==============================================================================

  ;----------------------------------------------------------------------------
  ;Special ASCII Characters
  ;----------------------------------------------------------------------------
  BackSpace EQU   8 ;Backspace
  Tab       EQU   9 ;Tab
  LF        EQU  10 ;Line Feed
  FormFeed  EQU  12 ;FormFeed
  CR        EQU  13 ;Carriage Return
  EOF       EQU  26 ;End-of-File
  Quote2    EQU  34 ;Double quote
  Quote1    EQU  39 ;Single quote
  Backslash EQU  92 ;Backslash (\)
  LQuote    EQU  96 ;Left single quote (`)
  Grave     EQU  96 ;Grave Quote
  SBoxLine  EQU 196 ;Single Box Line ()
  DBoxLine  EQU 205 ;Double Box Line ()

  ;----------------------------------------------------------------------------
  ;Special Keys that can be pressed during Pause routine
  ;----------------------------------------------------------------------------
  CtrlC  EQU  3 ;Control-C Keystroke
  Escape EQU 27 ;Escape Keystroke


;==============================================================================
;DOS Related
;==============================================================================

  ;----------------------------------------------------------------------------
  ;;Minimum DOS Version required to use this program
  ;----------------------------------------------------------------------------
  MinDOSVer EQU 0300h

  ;----------------------------------------------------------------------------
  ;Default Number of Entries in the Job File Table in the PSP
  ;----------------------------------------------------------------------------
  JFTEntries EQU 20

  ;----------------------------------------------------------------------------
  ;DOS Memory Allocation Strategies
  ;----------------------------------------------------------------------------
  StrategyLowFirst     EQU 00h ;First Fit, Low Memory Only
  StrategyLowBest      EQU 01h ;Best Fit, Low Memory Only
  StrategyLowLast      EQU 02h ;Last Fit, Low Memory Only
  ;For DOS 3&4, anything >2 is Last Fit Low Memory
  ;Below are for DOS 5+ Only
  StrategyHighFirst    EQU 40h ;First Fit, High Memory Only
  StrategyHighBest     EQU 41h ;Best Fit, High Memory Only
  StrategyHighLast     EQU 42h ;Last Fit, High Memory Only
  StrategyHighLowFirst EQU 80h ;First Fit, Try High Memory then Low Memory
  StrategyHighLowBest  EQU 81h ;Best Fit, Try High Memory then Low Memory
  StrategyHighLowLast  EQU 82h ;Last Fit, Try High Memory then Low Memory

  ;----------------------------------------------------------------------------
  ;UMB Link States
  ;----------------------------------------------------------------------------
  UMBLinkNo  EQU 00h ;UMB's are not part of DOS Memory Chain
  UMBLinkYes EQU 01h ;UMB's are in DOS Memory Chain (DOS=HIGH,UMB in CONFIG.SYS)

  ;----------------------------------------------------------------------------
  ;Sizes of various DOS data structures
  ;----------------------------------------------------------------------------
  FCBSize     EQU  44 ;Size of DOS File Control Block
  CmdTailMax  EQU 128 ;Maximum size of a DOS Command Tail
  MaxPathSize EQU  64 ;Maximum Size of a DOS Path/FileName String

  ;----------------------------------------------------------------------------
  ;Special "hard-coded" DOS Device Handles.
  ;These Handles are permanently hard-coded in DOS, and are always open.
  ;There is no need to issue Find, Open, or Close calls to these
  ;  devices - you can just use them at will.
  ;However, if a program installs itself using the DOS TSR function
  ;  (INT 21.31 or INT 27h), a program must close all handles (including
  ;  these), even if the handles are never used or opened.  This is because
  ;  DOS does not close them by itself like it does with a standard program
  ;  termination (INT 20h or INT 21.4C).
  ;A program that is not a TSR, or even if it is a TSR but does not
  ;  use the DOS TSR termination process, does not need to worry about
  ;  closing these.
  ;----------------------------------------------------------------------------
  StdInHandle  EQU 0 ;Standard Input Device Handle
  StdOutHandle EQU 1 ;Standard Output Device Handle
  StdErrHandle EQU 2 ;Standard Error Device Handle
  StdAuxHandle EQU 3 ;Standard Auxiliary Device Handle (COM1 by default)
  StdPrnHandle EQU 4 ;Standard Printer Device Handle (LPT1 by default)

  ;----------------------------------------------------------------------------
  ;Values to return in AL from Critical Error Handler (INT 24h)
  ;----------------------------------------------------------------------------
  CritErrIgnore    EQU 00h ;Ignore Error and Continue Operation
  CritErrRetry     EQU 01h ;Retry Operation
  CritErrTerminate EQU 02h ;Terminate program
  CritErrFail      EQU 03h ;Fail System Call

  ;----------------------------------------------------------------------------
  ;Codes returned by INT 21h, Function 4400h (Get Device Information)
  ;----------------------------------------------------------------------------
  ;If bit 7 is Set (is a Device):
  DvcInfoIsStdIn    EQU 0001h ;STDIN
  DvcInfoIsStdOut   EQU 0002h ;STDOUT
  DvcInfoIsNUL      EQU 0004h ;NUL
  DvcInfoIsClock    EQU 0008h ;CLOCK$
  DvcInfoInt29h     EQU 0010h ;Uses Int 29h (Special Device)
  DvcInfoBinary     EQU 0020h ;Binary (Raw) Mode
  DvcInfoEOF        EQU 0040h ;EOF on Input
  DvcInfoIsDevice   EQU 0080h ;Is a Device (not a File)
  DvcInfoKEYB       EQU 0100h ;Unknown (set by DOS 6.2x KEYB program)
  DvcInfoOpenClose  EQU 0800h ;Supports Open/Close calls
  DvcInfoOutputBusy EQU 2000h ;Supports Output until Busy
  DvcInfoIOCTL      EQU 4000h ;Can process IOCTL requests (INT 21h, Func 4402h)

  ;If bit 7 is Clear (is a File):
  DvcInfoDriveMask    EQU 003Fh ;Drive number (0 = A:)
  DvcInfoNotWritten   EQU 0040h ;File has not been written (Dirty Buffer?)
  ;Bit 7 = Clear!
  DvcInfoInt24h       EQU 0100h ;Generate Int 24h on Errors (DOS 4 only)
  DvcInfoNotRemovable EQU 0800h ;Media Not Removable
  DvcInfoNoDateTime   EQU 4000h ;Don't set File Date/Time on Closing (DOS 3.0+)
  DvcInfoRemote       EQU 8000h ;File is Remote (DOS 3.0+)

  ;----------------------------------------------------------------------------
  ;DOS Extended Error Codes
  ;Most of these won't get used by us, but we still have the complete list
  ;----------------------------------------------------------------------------
  DOSXErrNone          EQU   0 ;None
  DOSXErrInvalidFunc   EQU   1 ;Invalid Function Number
  DOSXErrFileNotFound  EQU   2 ;File Not Foune
  DOSXErrPathNotFound  EQU   3 ;Path Not Found
  DOSXErrNoHandles     EQU   4 ;No Handles Available
  DOSXErrAccessDenied  EQU   5 ;Access Denied
  DOSXErrInvalidHandle EQU   6 ;Invalid Handle
  DOSXErrMCBDestroyed  EQU   7 ;Memory Control Block Destroyed
  DOSXErrInsuffMemory  EQU   8 ;Insufficient Memory
  DOSXErrInvalidMBA    EQU   9 ;Memory Block Address Invalid
  DOSXErrInvalidEnvir  EQU  10 ;Invalid Environment (>32k Length)
  DOSXErrInvalidFormat EQU  11 ;Invalid Format
  DOSXErrInvalidAccess EQU  12 ;Invalid Access Code
  DOSXErrInvalidData   EQU  13 ;Invalid Data
  ;14 = Reserved
  DOSXErrInvalidDrive  EQU  15 ;Invalid Drive
  DOSXErrRmvCurrDir    EQU  16 ;Attempted to Remove Current Directory
  DOSXErrNotSameDvc    EQU  17 ;Not Same Device
  DOSXErrNoMoreFiles   EQU  18 ;No More Files
  ;DOS 3+ Errors (INT 24h)
  DOSXErrWriteProt     EQU  19 ;Disk is Write-protected
  DOSXErrUnknownUnit   EQU  20 ;Unknown Unit
  DOSXErrDriveNotReady EQU  21 ;Drive Not Ready
  DOSXErrUnknownCmd    EQU  22 ;Unknown Command
  DOSXErrCRCError      EQU  23 ;Cyclic Redundancy Check Error
  DOSXErrBadRqLength   EQU  24 ;Bad Request Structure Length
  DOSXErrSeekError     EQU  25 ;Seek Error
  DOSXErrUnknownMedia  EQU  26 ;Unknown Media
  DOSXErrNoSector      EQU  27 ;Sector Not Found
  DOSXErrOutOfPaper    EQU  28 ;Printer Out of Paper
  DOSXErrWriteFault    EQU  29 ;Write Fault
  DOSXErrReadFault     EQU  30 ;Read Fault
  DOSXErrGeneralFail   EQU  31 ;General Failure
  DOSXErrShareViolate  EQU  32 ;Sharing Violation
  DOSXErrLockViolate   EQU  33 ;Lock Violation
  DOSXErrBadDiskChange EQU  34 ;Invalid Disk Change
  DOSXErrFCBUnavail    EQU  35 ;File Control Block Unavailable
  DOSXErrShareOverflow EQU  36 ;Sharing Buffer Overflow
  DOSXErrCodePage      EQU  37 ;Code Page Mismatch (DOS 4+)
  DOSXErrEOF           EQU  38 ;Cannot Complete File Operation (EOF) (DOS 4+)
  DOSXErrNoDiskSpace   EQU  39 ;Insufficient Disk Space (DOS 4+)
  ;40-49 = Reserved
  ;Network Errors (INT 24h)
  DOSXErrReqNoSupport  EQU  50 ;Request Not Supported
  DOSXErrNoListen      EQU  51 ;Remote Comptuer not Listening (not Responding)
  DOSXErrDupName       EQU  52 ;Duplicate Name on Network
  DOSXErrNameNotFound  EQU  53 ;Network Name Not Found
  DOSXErrNetworkBusy   EQU  54 ;Network Busy
  DOSXErrNoDevice      EQU  55 ;network Device no longer exists
  DOSXErrBIOSLimit     EQU  56 ;Network BIOS Command Limit Exceeded
  DOSXErrAdapterErr    EQU  57 ;Network Adapter Hardware Error
  DOSXErrBadResponse   EQU  58 ;Incorrect Response for Network
  DOSXErrNetworkErr    EQU  59 ;Unexpected Network Error
  DOSXErrIncompat      EQU  60 ;Incompatible Remote Adapter
  DOSXErrPrnQueueFull  EQU  61 ;Print Queue Full
  DOSXErrQueueNotFull  EQU  62 ;Queue Not Full
  DOSXErrPrnNoSpace    EQU  63 ;Not Enough Space to Print File
  DOSXErrNetNameDel    EQU  64 ;Network Name Deleted
  DOSXErrNetNoAccess   EQU  65 ;Network Access Denied
  DOSXErrNetDvcWrong   EQU  66 ;Network Device Type Incorrect
  DOSXErrNetNoName     EQU  67 ;Network Name Not Found
  DOSXErrNetNameLimit  EQU  68 ;Network Name Limit Exceeded
  DOSXErrNetBIOSLimit  EQU  69 ;Network BIOS Session Limit Exceeded
  DOSXErrNetPuase      EQU  70 ;Network Temporarily Paused
  DOSXErrReqNoAccept   EQU  71 ;Network Request Not Accepted
  DOSXErrRedirPause    EQU  72 ;Redirection Paused (Disk/Printer)
  DOSXErrNoSoftware    EQU  73 ;Network Software Not Installed
  DOSXErrAdapterClose  EQU  74 ;Unexpected Adapter Close
  ;75-79 = Reserved
  ;Done with INT 24h Errors
  DOSXErrFileExists    EQU  80 ;File Exists
  DOSXErrDuplicateFCB  EQU  81 ;Duplicated File Control Block
  DOSXErrMkDir         EQU  82 ;Cannot Make Directory
  DOSXErrInt24Fail     EQU  83 ;Fail on INT 24h
  ;Network Errors, not related to INT 24h
  DOSXErrNoStructures  EQU  84 ;Too many Redir's / Out of structures (DOS 3.3+)
  DOSXErrDupRedir      EQU  85 ;Duplicate Redirection / Already Assigned (DOS 3.3+)
  DOSXErrBadPassword   EQU  86 ;Invalid Password (DOS 3.3+)
  DOSXErrBadParameter  EQU  87 ;Invalid Parameter (DOS 3.3+)
  DOSXErrNetWriteFault EQU  88 ;Network Write Fault (DOS 3.3+)
  DOSXErrNetNoSupport  EQU  89 ;Function Not Supported / No Process Slots (DOS 4.0+)
  DOSXErrNotFrozen     EQU  90 ;(DOS 4.0+) required system component not installed / not frozen
  DOSXErrTimerServerOF EQU  91 ;(DOS 4.0+,NetWare4) timer server table overflowed
  DOSXErrDupTimerTbl   EQU  92 ;(DOS 4.0+,NetWare4) duplicate in timer service table
  DOSXErrNoItems       EQU  93 ;(DOS 4.0+,NetWare4) no items to work on
  ;94 = Reserved
  DOSXErrBadSystemCall EQU  95 ;Interrupted / Invalid System Call (DOS 4.0+)
  DOSXErrCDUnknown     EQU 100 ;Unknown Error (MSCDEX)
  DOSXErrSemaphoreOpen EQU 100 ;Open Semaphore Limit Exceeded (DOS 4.0+)
  DOSXErrCDNotReady    EQU 101 ;Not Ready (MSCDEX)
  DOSXErrSemaphoreOwn  EQU 101 ;Exclusive Semaphore Already Owned (DOS 4.0+)
  DOSXErrInvalidEMS    EQU 102 ;EMS Memory No Longer Valid (MSCDEX)
  DOSXErrSemaphoreSet  EQU 102 ;Semaphore Set When Close Attempted (DOS 4.0+)
  DOSXErrCDBadFormat   EQU 103 ;Not High Sierra or ISO-9660 Format (MSCDEX)
  DOSXErrSemaphoneExcl EQU 103 ;Too Many Exclusive Semaphore Requests (DOS 4.0+)
  DOSXErrCDDoorOpen    EQU 104 ;Door Open (MSCDEX)
  DOSXErrBadInterrupt  EQU 104 ;Operation Invalid From Interrupt Handler (DOS 4.0+)
  DOSXErrSemaphoreDied EQU 105 ;Semaphore Owner Died (DOS 4.0+)
  DOSXErrSemaphoreLmt  EQU 106 ;Semaphore Limit Exceeded (DOS 4.0+)
  DOSXErrDiskChanged   EQU 107 ;Insert Drive B: Disk Into A: / Disk Changed (DOS 4.0+)
  DOSXErrDriveLocked   EQU 108 ;Drive Locked by Another Process (DOS 4.0+)
  DOSXErrBrokenPipe    EQU 109 ;Broken Pipe (DOS 4.0+)
  DOSXErrPipeOpen      EQU 110 ;Pipe Open/Create Failed (DOS 5.0+)
  DOSXErrPipeOverflow  EQU 111 ;Pipe Buffer Overflowed (DOS 5.0+)
  DOSXErrDiskFull      EQU 112 ;Disk Full (DOS 5.0+)
  DOSXErrSearchHandles EQU 113 ;No More Search Handles (DOS 5.0+)
  DOSXErrDup2SearchHdl EQU 114 ;Invalid Target Handle for Dup2 (DOS 5.0+)
  DOSXErrVirtualAddr   EQU 115 ;Bad User Virtual Address / Protection Violation (DOS 5.0+)
  DOSXErrVioKbd        EQU 116 ;VIOKBD Request (DOS 5.0+)
  DOSXErrConsoleIO     EQU 116 ;Error on Console I/O (NetWare4)
  DOSXErrIOCtlCategory EQU 117 ;Unknown Category Code for IOCTL (DOS 5.0+)
  DOSXErrVerifyFlag    EQU 118 ;Invalid Value for Verify Flag (DOS 5.0+)
  DOSXErrIOCtlLevel4   EQU 119 ;Level Four Driver Not Found by DOS IOCTL (DOS 5.0+)
  DOSXErrBadFunction   EQU 120 ;Invalid / Unimplemented Function Number (DOS 5.0+)
  DOSXErrSemaphoreTO   EQU 121 ;Semaphore Timeout (DOS 5.0+)
  DOSXErrSmallBuffer   EQU 122 ;Buffer Too Small to Hold Return Data (DOS 5.0+)
  DOSXErrBadChar       EQU 123 ;Invalid Character or Bad File-system Name (DOS 5.0+)
  DOSXErrInfoLevel     EQU 124 ;Unimplemented Information Level (DOS 5.0+)
  DOSXErrNoVolumeLabel EQU 125 ;No Volume Label Found (DOS 5.0+)
  DOSXErrModuleHandle  EQU 126 ;Module Handle Not Found (DOS 5.0+)
  DOSXErrProcedureAddr EQU 127 ;Procedure Address Not Found (DOS 5.0+)
  DOSXErrCWaitNoChild  EQU 128 ;CWait Found No Children (DOS 5.0+)
  DOSXErrCWaitChildRun EQU 129 ;CWait Children Still Running (DOS 5.0+)
  DOSXErrDirectDiskHdl EQU 130 ;Invalid Operation for Direct Disk-access Handle (DOS 5.0+)
  DOSXErrNegOffset     EQU 131 ;Attempted Seek to Negative Offset (DOS 5.0+)
  DOSXErrSeekPipe      EQU 132 ;Attempted to Seek on Device or Pipe (DOS 5.0+)
  ;JOIN/SUBST errors
  DOSXErrAlreadyJOINs  EQU 133 ;Drive Already Has JOINed Drives (DOS 5.0+)
  DOSXErrAlreadyJOIN   EQU 134 ;Drive Already JOINed (DOS 5.0+)
  DOSXErrAlreadySUBST  EQU 135 ;Drive Already SUBSTed (DOS 5.0+)
  DOSXErrDeleteJOIN    EQU 136 ;Can Not Delete Drive Which Is Not JOINed (DOS 5.0+)
  DOSXErrDeleteSUBST   EQU 137 ;Can Not Delete Drive Which Is Not SUBSTed (DOS 5.0+)
  DOSXErrJoinJoin      EQU 138 ;Can Not JOIN to a JOINed Drive (DOS 5.0+)
  DOSXErrSubstSubst    EQU 139 ;Can Not SUBST to a SUBSTed Drive (DOS 5.0+)
  DOSXErrJoinSubst     EQU 140 ;Can Not JOIN to a SUBSTed Drive (DOS 5.0+)
  DOSXErrSubstJoin     EQU 141 ;Can Not SUBST to a JOINed Drive (DOS 5.0+)
  DOSXErrDriveBusy     EQU 142 ;Drive Busy (DOS 5.0+)
  DOSXErrJoinSubstSame EQU 143 ;Can Not JOIN/SUBST to Same Drive (DOS 5.0+)
  DOSXErrRootDir       EQU 144 ;Directory Must Not Be Root Directory (DOS 5.0+)
  DOSXErrJoinEmptyDir  EQU 145 ;Can only JOIN to Empty Directory (DOS 5.0+)
  DOSXErrPathUseSUBST  EQU 146 ;Path Already In Use for SUBST (DOS 5.0+)
  DOSXErrPathUseJOIN   EQU 147 ;Path Already In Use for JOIN (DOS 5.0+)
  DOSXErrPathUseProc   EQU 148 ;Path In Use by Another Process (DOS 5.0+)
  DOSXErrPreviousSUBST EQU 149 ;Directory Previously SUBSTituted (DOS 5.0+)
  DOSXErrSystemTrace   EQU 150 ;System Trace Error (DOS 5.0+)
  DOSXErrSemWaitEvent  EQU 151 ;Invalid Event Count for DosMuxSemWait (DOS 5.0+)
  DOSXErrMutex         EQU 152 ;Too Many Waiting on Mutex (DOS 5.0+)
  DOSXErrListFormat    EQU 153 ;Invalid List Format (DOS 5.0+)
  DOSXErrVolLblSize    EQU 154 ;Volume Label Too Large (DOS 5.0+)
  DOSXErrTCBCreate     EQU 155 ;Unable to Create Another TCB (DOS 5.0+)
  DOSXErrSignalRefused EQU 156 ;Signal Refused (DOS 5.0+)
  DOSXErrSegDiscard    EQU 157 ;Segment Discarded (DOS 5.0+)
  DOSXErrSetNotLocked  EQU 158 ;Segment Not Locked (DOS 5.0+)
  DOSXErrThreadIDAddr  EQU 159 ;Invalid Thread-ID Address (DOS 5.0+)
  DOSXErrArguments     EQU 160 ;Bad Arguments (DOS 5.0+)
  DOSXErrEnvirPtr      EQU 160 ;Bad Environment Pointer (NetWare4)
  DOSXErrPathName      EQU 161 ;Invalid Pathname Passed to EXEC (DOS 5.0+,NetWare4)
  DOSXErrSignalPending EQU 162 ;Signal Already Pending (DOS 5.0+,NetWare4)
  DOSXErrUncertMedia   EQU 163 ;Uncertain Media (DOS 5.0+)
  DOSXErrMap124A       EQU 163 ;ERROR_124 Mapping (NetWare4)
  DOSXErrThreads       EQU 164 ;Maximum Number of Threads Reached (DOS 5.0+)
  DOSXErrProcessSlots  EQU 164 ;No More Process Slots (NetWare4)
  DOSXErrMap124B       EQU 165 ;ERROR_124 Mapping (NetWare4)
  DOSXErrVolNotLock    EQU 176 ;Volume Not Locked (MS-DOS 7.0)
  DOSXErrVolLock       EQU 177 ;Volume Locked in Drive (MS-DOS 7.0)
  DOSXErrVolRemovable  EQU 178 ;Volume Not Removable (MS-DOS 7.0)
  DOSXErrLockCount     EQU 180 ;Lock Count Exceeded (MS-DOS 7.0)
  DOSXErrSegNumber     EQU 180 ;Invalid Segment Number (NetWare4)
  DOSXErrEjectRequest  EQU 181 ;Eject Request Failed (MS-DOS 7.0)


;==============================================================================
;Program-Specific
;==============================================================================

  ;----------------------------------------------------------------------------
  ;Size of our program stack (in bytes)
  ;We need a relatively large stack, since some of our code is recursive
  ;  and therefore can use quite a bit of stack space.
  ;----------------------------------------------------------------------------
  ProgStackSize EQU 512

  ;----------------------------------------------------------------------------
  ;File Buffer Related
  ;----------------------------------------------------------------------------
  DataBufferSize EQU 65536-DataBuffer ;Size of the File Buffer


;==============================================================================
;ACPI Related
;==============================================================================

  ;----------------------------------------------------------------------------
  ;Fixed Strings we need to look for in the DSDT Name Space
  ;----------------------------------------------------------------------------
  ;NameProcSect  EQU '_RP_' ;Processor Section
  NameShutDown  EQU '_S5_' ;Shut Down (Sleep State S5) Entry
  ;NameACAdapter EQU 'DACA' ;AC Adapter Device
  NamePwrSource EQU '_PSR' ;Power Source
  NameBattInfo  EQU '_BIF' ;Battery Info
  NameBattSts   EQU '_BST' ;Battery Status


  ;----------------------------------------------------------------------------
  ;ACPI Machine Language Tags
  ;----------------------------------------------------------------------------
  ;Name Prefixes
  AMLTagName      EQU   008h ;Name
  AMLTag2Names    EQU   02Eh ;Dual-Name Prefix
  AMLTagXNames    EQU   02Fh ;Multi-Name Prefix
  AMLTagRoot      EQU   05Ch ;Root (\)
  AMLTagParent    EQU   05Eh ;Parent (^)
  ;Name-related Prefixes
  AMLTagBuffer    EQU   011h ;Buffer
  ;Multi-byte Header Tags
  AMLTagMutex     EQU 0015Bh ;Mutex
  AMLTagEvent     EQU 0025Bh ;Event
  AMLTagCondRef   EQU 0125Bh ;Conditional Reference Of
  AMLTagOpRegion  EQU 0805Bh ;Operation Region
  AMLTagField     EQU 0815Bh ;Field
  AMLTagDevice    EQU 0825Bh ;Device
  AMLTagCPU       EQU 0835Bh ;CPU (Processor)
  AMLTagPwrRes    EQU 0845Bh ;Power Resource
  AMLTagThermal   EQU 0855Bh ;Thermal Zone
  AMLTagIndexFd   EQU 0865Bh ;Index Field
  AMLTagBankFd    EQU 0875Bh ;Bank Field
  ;Single-byte Header Tags
  AMLTagPkg       EQU   012h ;Package
  AMLTagMethod    EQU   014h ;Method
  ;Data Type Tags
  AMLTagByte      EQU   00Ah ;Data Byte
  AMLTagWord      EQU   00Bh ;Data Word
  AMLTagDWord     EQU   00Ch ;Data DWord
  AMLTagString    EQU   00Dh ;Data String (ASCIIZ)
  ;Multi-byte Method Code Tags
  AMLTagCrField   EQU 0135Bh ;Create Field
  AMLTagLoad      EQU 0205Bh ;Load
  AMLTagStall     EQU 0215Bh ;Stall
  AMLTagSleep     EQU 0225Bh ;Sleep
  AMLTagAcquire   EQU 0235Bh ;Acquire
  AMLTagSignal    EQU 0245Bh ;Signal
  AMLTagWait      EQU 0255Bh ;Wait
  AMLTagReset     EQU 0265Bh ;Reset
  AMLTagRelease   EQU 0275Bh ;Release
  AMLTagFromBCD   EQU 0285Bh ;FromBCD
  AMLTagToBCD     EQU 0295Bh ;ToBCD
  AMLTagUnload    EQU 02A5Bh ;Unload
  AMLTagDebug     EQU 0305Bh ;Debug
  AMLTagFatal     EQU 0315Bh ;Fatal
  ;Single-byte Method Code Tags
  AMLTagLocal0    EQU   060h ;Local0
  AMLTagLocal1    EQU   061h ;Local1
  AMLTagLocal2    EQU   062h ;Local2
  AMLTagLocal3    EQU   063h ;Local3
  AMLTagLocal4    EQU   064h ;Local4
  AMLTagLocal5    EQU   065h ;Local5
  AMLTagLocal6    EQU   066h ;Local6
  AMLTagLocal7    EQU   067h ;Local7
  AMLTagArg0      EQU   068h ;Argument0
  AMLTagArg1      EQU   069h ;Argument1
  AMLTagArg2      EQU   06Ah ;Argument2
  AMLTagArg3      EQU   06Bh ;Argument3
  AMLTagArg4      EQU   06Ch ;Argument4
  AMLTagArg5      EQU   06Dh ;Argument5
  AMLTagArg6      EQU   06Eh ;Argument6
  AMLTagStore     EQU   070h ;Store
  AMLTagADD       EQU   072h ;Add
  AMLTagConcat    EQU   073h ;Concatenate
  AMLTagSUB       EQU   074h ;Subtract
  AMLTagINC       EQU   075h ;Increment
  AMLTagDEC       EQU   076h ;Decrement
  AMLTagMUL       EQU   077h ;Multiply
  AMLTagDIV       EQU   078h ;Divide
  AMLTagSHL       EQU   079h ;Shift Left
  AMLTagSHR       EQU   07Ah ;Shift Right
  AMLTagAND       EQU   07Bh ;And
  AMLTagNAND      EQU   07Ch ;Not And
  AMLTagOR        EQU   07Dh ;Or
  AMLTagNOR       EQU   07Eh ;Not Or
  AMLTagXOR       EQU   07Fh ;Exclusive Or
  AMLTagNOT       EQU   080h ;Not

  AMLTagNotify    EQU   086h ;Notify
  AMLTagSizeOf    EQU   087h ;Size Of
  AMLTagIndex     EQU   088h ;Index
  AMLTagMatch     EQU   089h ;Match

  AMLTagLAnd      EQU   090h ;Logical And
  AMLTagLNot      EQU   092h ;Logical Not
  AMLTagLEqual    EQU   093h ;Logical Equal To
  AMLTagLGreat    EQU   094h ;Logical Greater Than
  AMLTagLLess     EQU   095h ;Logical Less Than

  AMLTagIf        EQU   0A0h ;If
  AMLTagElse      EQU   0A1h ;Else
  AMLTagNOP       EQU   0A2h ;NOP
  AMLTagReturn    EQU   0A4h ;Return
  AMLTagBreak     EQU   0A5h ;Break
  AMLTagBreakPt   EQU   0CCh ;Break Point
  AMLTagAllOnes   EQU   0FFh ;All Ones


;
;STRUCTURES
;

;==============================================================================
;DOS/CPU Related
;==============================================================================

  ;----------------------------------------------------------------------------
  ;Program Segment Prefix
  ;----------------------------------------------------------------------------
  STRUC PSPStruc
    PSPDOSExit     RESW          1 ;Int 20h Call (20CDh)
    PSPNextSegment RESW          1 ;Segment of First Byte beyond Program
    PSPCPMCall5    RESB          6 ;CPM Far Call 5
    PSPInt22Addr   RESD          1 ;Int 22h Vector (Program Termination)
    PSPInt23Addr   RESD          1 ;Int 23h Vector (Ctrl-C)
    PSPInt24Addr   RESD          1 ;Int 24h Vector (Critical Error)
    PSPParentPSP   RESW          1 ;Segment of Parent PSP
    PSPJFT         RESB JFTEntries ;Job File Table (20 File Handles)
    PSPEnvirSeg    RESW          1 ;Environment Segment for PSP
    PSPSSSPOnEntry RESD          1 ;SS:SP on Entry to last Int 21h Call
    PSPJFTSize     RESW          1 ;Number of entries in JFT (default = 20)
    PSPJFTPointer  RESD          1 ;Pointer to JFT (Default = PSP:0018h)
    PSPPreviousPSP RESD          1 ;Pointer to previous PSP (Def = FFFF:FFFF)
    PSPFiller1     RESB         18 ;Misc stuff used by SHARE, Windows, etc.
                                   ;Memory Below here available to TSR!
    PSPFiller2     RESB          2 ;Unused in DOS <= 6.00
    PSPInt21       RESW          1 ;Int 21h Call (21CDh)
    PSPRETF        RESB          1 ;RETF Call (CBh)
    PSPFiller3     RESB          9 ;Can be used to make Extended FCB from FCB1
    PSPFCB1        RESB         16 ;First File Control Block
    PSPFCB2        RESB         16 ;Second File Control Block
    PSPFiller4     RESB          4 ;Unused
    PSPCmdLineLen  RESB          1 ;Command Line Length & DTA
    PSPCmdLine     RESB        127 ;Command Line String
   ENDS
  PSPStrucSize EQU PSPStruc_size ;256 bytes

  ;----------------------------------------------------------------------------
  ;Memory Control Block
  ;----------------------------------------------------------------------------
  STRUC MCBStruc
    MCBID             RESB  1  ;Memory Control Block ID
      MCBIDValid       EQU 'M' ;Memory Block is Valid
      MCBIDLastInList  EQU 'Z' ;Memory Block is Last in List
    MCBOwnerID        RESW  1  ;PSP Segment of Owner
                               ;  0 = Owns Self
                               ;  6 = DR-DOS XMS UMB
                               ;  7 = DR-DOS Excluded Upper Memory
                               ;  8 = Belongs to DOS
                               ;FFFx = 386Max
    MCBSize           RESW  1  ;Size in Paragraphs
    MCBFiller         RESB  3  ;Filler (used by some DOS incarnations)
    MCBOwnerName      RESB  8  ;Owner Name (ASCIIZ if < 8 characters)
   ENDS
  MCBStrucSize EQU MCBStruc_size ;16 bytes (one paragraph)

  ;----------------------------------------------------------------------------
  ;Structure needed to Initialize DOS EXEC Function
  ;----------------------------------------------------------------------------
  STRUC ParamBlockStruc
    PBEnvirSegment RESW 1 ;Environment Segment to use (0 = Copy Callers Segment)
    PBCmdTailPtr   RESD 1 ;Pointer to Command Tail
    PBFCB1Offset   RESD 1 ;Pointer to File Control Block #1
    PBFCB2Offset   RESD 1 ;Pointer to File Control Block #2
    PBSSSPOnReturn RESD 1 ;Holds Childs Initial SS:SP on Return (if AL = 01)
    PBCSIPOnReturn RESD 1 ;Holds Entry Point (CS:IP) on Return (if AL = 01)
   ENDS
  ParamBlockSize EQU ParamBlockStruc_size ;Size of EXEC Parameter Block

  ;----------------------------------------------------------------------------
  ;DTA (Disk Transfer Area) after Find First Matching File (INT 21h, Func 4Eh)
  ;The first several bytes of the DTA are DOS version specific, and
  ;  we don't care about that data anyway.  We only care about the data
  ;  that is documented and the same across all versions of DOS.
  ;----------------------------------------------------------------------------
  STRUC FindFirstStruc
    FFVerSpecific     RESB 21  ;DOS Version-specific Data
    FFAttribs         RESB  1  ;File Attributes
      FAttrReadOnly    EQU 01h ;Read Only
      FAttrHidden      EQU 02h ;Hidden
      FAttrSystem      EQU 04h ;System
      FAttrVolume      EQU 08h ;Volume Label
       FAttrExecOnly   EQU 08h ;Execute-Only (Novell Netware)
      FAttrDirectory   EQU 10h ;Directory
      FAttrArchive     EQU 20h ;Archive
      FAttrUnused      EQU 40h ;Unused
                               ;DOS 3+ returns this bit set if file
                               ;  is actually a character device
                               ;DOS Window underneath Windows XP doesn't
      FAttrPending     EQU 80h ;Pending Deletion (Novell DOS, OpenDOS)
       FAttrShareable  EQU 80h ;Shareable (Novell Netware)
    FFTime            RESW  1  ;File Creation Time
     FFDate           RESW  1  ;File Creation Date
     FFSize           RESD  1  ;File Size
     FFName           RESB 13  ;ASCIIZ File Name & Extension
   ENDS

   FAttrToUse EQU FAttrHidden+FAttrSystem
     ;Attributes to use in DOS's Find First Matching File Function
     ;DOS ignores the Read-Only and and Archive bits, so they don't matter


;==============================================================================
;CPU/Memory Related
;==============================================================================

  ;----------------------------------------------------------------------------
  ;Global Descriptor Table Entry Structure for a Selector
  ;The structure is actually slightly different for different types of
  ;  GDT entries, which are defined by the GDTRights byte.
  ;The main type of GDT entry we need to deal is a Selector, which is
  ;  defined here.
  ;----------------------------------------------------------------------------
  STRUC GDTSelStruc
    GDTSegLimit      RESW  1  ;Segment Limit (bytes/pages)
    GDTAddress24     RESB  3  ;First 3 bytes of Segment Start (Linear Addr)
    GDTRights        RESB  1  ;Access rights (93h for Mem Copy Functions)
      RtSegType       EQU 0Fh ;Segment Type in bits 0-3
       ;System Segments
        STReserved0   EQU 00h ;Reserved
        STAvail16TSS  EQU 01h ;Available 16-bit TSS
        STLDT         EQU 02h ;Local Descriptor table
        STBusy16TSS   EQU 03h ;Busy 16-bit TSS
        ST16CallGate  EQU 04h ;16-bit Call Gate
        STTaskGate    EQU 05h ;Task Gate
        ST16IntGate   EQU 06h ;16-bit Interrupt Gate
        ST16TrapGate  EQU 07h ;16-bit Trap Gate
        STReserved8   EQU 08h ;Reserved
        STAvail32TSS  EQU 09h ;Available 32-bit TSS
        STReservedA   EQU 0Ah ;Reserved
        STBusy32TSS   EQU 0Bh ;Busy 32-bit TSS
        ST32CallGate  EQU 0Ch ;32-bit Call Gate
        STReservedD   EQU 0Dh ;Reserved
        ST32IntGate   EQU 0Eh ;32-bit Interrupt Gate
        ST32TrapGate  EQU 0Fh ;32-bit Trap Gate
       ;Application Segments
        STAccessed    EQU 01h ;Accessed
        STNotAccess   EQU 00h ;  Not Accessed
        STCSReadable  EQU 02h ;Readable (Code Segments)
        STCSNoRead    EQU 00h ;  Non-Readable
        STDSWritable  EQU 02h ;Writeable (Data Segments)
        STDSNoWrite   EQU 00h ;  Non-Writeable
        STCSConform   EQU 04h ;Conforming (Code Segments)
        STCSNConform  EQU 00h ;  Non-Conforming
        STDSExpDown   EQU 04h ;Expand Down (Data Segments)
        STDSExpUp     EQU 00h ;  Expand Up
        STCodeSeg     EQU 08h ;Code Segment (0 = Data Segment)
        STDataSeg     EQU 00h ;  Data Segment
        ;Bits 4-7 = Reserved/Unused?
      RtDescrTypeApp  EQU 10h ;Descriptor Type = Application
      RtDescrTypeSys  EQU 00h ;Descriptor Type = System)
      RtDescrPriv     EQU 60h ;Descriptor Privilege Level in bits 6-5
        DescrPriv0    EQU 00h ;Privilege Level 0
        DescrPriv1    EQU 20h ;Privilege Level 1
        DescrPriv2    EQU 40h ;Privilege Level 2
        DescrPriv3    EQU 60h ;Privilege Level 3
      RtSegInRAM      EQU 80h ;Segment is Present In RAM
                              ;  (not cached to disk)
    GDTXRights       RESB  1  ;Extended rights
      XRSegLim4       EQU 0Fh ;Bits 0-3 = high 4 bits of Segment Limit
      XRAvail         EQU 10h ;Available
      XRReserved      EQU 20h ;Reserved (0)
      XROpSize32      EQU 40h ;Default Operation Size = 32 bits (0 = 16 bits)
      XRGranul4K      EQU 80h ;Granularity = 4K Page (0 = byte granularity)
    GDTAddress32     RESB  1  ;High byte of 32-bit Segment Start (Linear Addr)
   ENDS

  GDTRightsData       EQU 92h  ;Rights for a Data Segment
                               ;    RtSegInRAM  + RtDescrPriv0 + RtDesrTypeApp
                               ;  + STDataSeg   + STDSWritable + STDSExpUp
                               ;  + STNotAccess
  GDTRightsCode       EQU 9Ah  ;Rights for a Code Segment
                               ;    RtSegInRAM  + RtDescrPriv0   + RtDesrTypeApp
                               ;  + STCodeSeg   + STCSNonConform + STCSReadable
                               ;  + STNotAccess
  GDTXRights32 EQU XROpSize32  ;Extended Rights for PM16 code segments
  GDTXRights16 EQU          0  ;Extended Rights for PM32 code segments
  GDTSize      EQU GDTSelStruc_size ;Size of Structure

  ;----------------------------------------------------------------------------
  ;Global Descriptor Table Entry Structure for a Call Gate
  ;  Call Gates are required when switching between Privilege Levels.
  ;  Call Gates cannot be in an IDT -- only a GDT or LDT.
  ;  When issuing a CALL (or JMP), the caller points to the Call Gate
  ;    rather than a Selector, and the Code Offset of the CALL is ignored.
  ;    The CPU instead uses the Code Offset stored in the Call Gate.
  ;  The CPU also puts the return SS, ESP, CS, and EIP on the new stack.
  ;  The stacks are defined in the TSS on a per-privilege-level basis.
  ;----------------------------------------------------------------------------
  STRUC GDTCallStruc
    GDTCallOfst15    RESW  1  ;Offset bits 00:15
    GDTCallSSelector RESW  1  ;Code Selector to use
    GDTCallDWordCnt  RESB  1  ;DWord Count (Number of DWords to copy
                              ;  between stacks)
      GDTCCntMask     EQU 1Fh ;DWord Count is only bits 0-4 (max 31 DWords)
                              ;  Bits 5-7 = 0
    GDTCallRights    RESB  1  ;16-bit or 32-Bit Call Gate
                              ;  Along with Privilege Level & InRAM flags
    GDTCallOffset31  RESW  1  ;Offset Bits 16:31
   ENDS


;==============================================================================
;BIOS Related
;==============================================================================

  ;----------------------------------------------------------------------------
  ;Structure for Copy Extended Memory Function
  ;----------------------------------------------------------------------------
  STRUC MemCopyStruc
    MCNullSegment RESB GDTSize ;Null Entry (Initialize to Zeroes))
    MCDSSegment   RESB GDTSize ;Data Segment (Initialize to Zeroes)
    MCSrcSegment  RESB GDTSize ;Source Data Segment (Copy from Here)
    MCDstSegment  RESB GDTSize ;Destination Data Segment (Copy to Here)
    MCCSSegment   RESB GDTSize ;Code Segment (Initialize to Zeroes)
    MCSSSegment   RESB GDTSize ;Stack Segment (Initialize to Zeroes)
   ENDS
  MemCopySize EQU MemCopyStruc_size ;Size of Structure


;==============================================================================
;INT 15h (Memory BIOS) Related
;==============================================================================

  ;----------------------------------------------------------------------------
  ;In the INT 15.E820 call, the size requested can either be 20 or 24
  ;  (the size of the structure).  Almost all BIOS's return 20 bytes
  ;  rather than 24, but we'll always request 24.
  ;----------------------------------------------------------------------------
  STRUC Int15_E820Struc
    E820BaseAddr        RESQ  1  ;Base Address of Memory Region
    E820Length          RESQ  1  ;Length of Memory Region (Bytes)
    E820Type            RESD  1  ;Region "Type"
      E820TypeRAM        EQU 01h ;Usable/Normal RAM
      E820TypeReserved   EQU 02h ;Reserved/Unusable (MMIO, RAM, etc.)
      E820TypeACPIReclm  EQU 03h ;ACPI Reclaimable Memory (reclaimable
                                 ;  (after ACPI has been initialized)
      E820TypeACPINVS    EQU 04h ;ACPI NVS Memory 9OS is required to save
                                 ;  this between NVS sessions
      E820TypeBad        EQU 05h ;Bad Memory
      ;Types 6-FFFF_FFFFh = Reserved
    E820XAttr           RESD  1  ;ACPI 3.0 Extended Attrributes
      E820XAValid        EQU 01h ;Entry is Valid (if 0, just ignore it)
      E820XANonVolatile  EQU 02h ;Entry is Non-volatile (possibly ROM)
      ;Types 3-FFFF_FFFFh = Reserved
  ENDS
  Int15E820Size EQU Int15_E820Struc_size ;Size of Structure (24 bytes)

  E820DXSig EQU 534D_4150h ;INT 15.E820 Signature Required in EDX ("SMAP")

  ;----------------------------------------------------------------------------
  ;Data returned by INT 15.C7 call.
  ;----------------------------------------------------------------------------
  STRUC Int15C7Struc
    I15C7Length   RESW 1 ;Length of table in bytes, excluding this word
    I15C7Local16M RESD 1 ;Local     Memory between  1M and 16M, in 1K blocks
    I15C7Local4G  RESD 1 ;Local     Memory between 16M and  4G, in 1K blocks
    I15C7Sys16M   RESD 1 ;System    Memory between  1M and 16M, in 1K blocks
    I15C7Sys4G    RESD 1 ;System    Memory between 16M and  4G, in 1K blocks
    I15C7Cache16M RESD 1 ;Cacheable Memory between  1M and 16M, in 1K blocks
    I15C7Cache4G  RESD 1 ;Cacheable Memory between 16M and  4G, in 1K blocks
    I15C7NSys16M  RESD 1 ;1K blocks before start of non-system memory
                         ;  between 1M and 16M
    I15C7NSys4G   RESD 1 ;1K blocks before start of non-system memory
                         ;  between 16M and 4G
    I15C7FreeSeg  RESW 1 ;Start Segment of largest free block in C0000-DFFFFh
    I15C7FreeSz   RESW 1 ;Size of largets free block
    I15C7Reserved RESD 1 ;Reserved
  ENDS
  I15C7Size EQU Int15C7Struc_size


;==============================================================================
;ACPI Related
;==============================================================================

  ;----------------------------------------------------------------------------
  ;ACPI Root System Description Pointer
  ;  Always aligned in memory on a 16-byte paragraph boundary
  ;  Located in first kB of XBDA, last kB of conventional memory, or
  ;    in RBDA (between E000:0000 & F000:FFE0)
  ;This is from version 5 of the ACPI Spec
  ;----------------------------------------------------------------------------
  STRUC RSDPHdrStruc     ;Structure of an RSDP
    RSDPSignature RESB 8 ;Signature String 'RSD PTR '
    RSDPChecksum1 RESB 1 ;Checksum (all bytes in first 20 bytes of
                         ;  Header MUST Add to 0)
    RSDPOEMID     RESB 6 ;OEM ID String
    RSDPRevision  RESB 1 ;Structure Revision Number (ACPI v1 = 0),
                         ;  (ACPI v5 = 2)
    RSDPRSDTAddr  RESD 1 ;Phys Addr of Root System Description Table
    ;Data below here is not included in ACPI v1
    RSDPLength    RESD 1 ;Length of the Table, including the Header
    RSDPXSDTAddr  RESQ 1 ;Phys Addr of Extended SDT (XSDT) (64-bits)
    RSDPCheckSum2 RESB 1 ;Extended Checksum (for entire table,
                         ;  including Header and both checksums)
    RSDPReserved  RESB 3 ;Reserved
   ENDS
  RSDPHdrSize EQU RSDPHdrStruc_size ;Size of ACPI Header (36 bytes)

  ;----------------------------------------------------------------------------
  ;ACPI System Description Table Header
  ;  This is the format of the first several bytes of many ACPI
  ;    Description Tables
  ;  This is a complete list of all tables supported by ACPI v5
  ;----------------------------------------------------------------------------
  STRUC ACPITblHdrStruc       ;Structure of a System Description Table Header
    ATHSignature  RESD     1  ;Table Signature
      ;ACPI-defined Signatures
      ATHSigAPIC   EQU 'APIC' ;Multiple APIC Description Table
      ATHSigBERT   EQU 'BERT' ;Boot Error Record Table
      ATHSigBGRT   EQU 'BGRT' ;Boot Graphics Resource Table
      ATHSigCPEP   EQU 'CPEP' ;Corrected Platform Error Polling Table
      ATHSigDSDT   EQU 'DSDT' ;Differentiated System Description Table
      ATHSigECDT   EQU 'ECDT' ;Embedded Controller Boot Resources Table
      ATHSigEINJ   EQU 'EINJ' ;Error Injection Table
      ATHSigERST   EQU 'ERST' ;Error Record Serialization Table
      ATHSigFACP   EQU 'FACP' ;Fixed ACPI Description Table
      ATHSigFACS   EQU 'FACS' ;Firmware ACPI Control Structure
      ATHSigFPDT   EQU 'FPDT' ;Firmware Performance Data Table
      ATHSigGTDT   EQU 'GTDT' ;Generic Timer Description Table
      ATHSigHEST   EQU 'HEST' ;Hardware Error Source Table
      ATHSigMSCT   EQU 'MSCT' ;Maximum System Characteristics Table
      ATHSigMPST   EQU 'MPST' ;Memory Power State Table
      ATHSigOEMx   EQU 'OEMx' ;All signatures starting w/ OEM are reserved
      ATHSigPMTT   EQU 'PMTT' ;Platform Memory Topology Table
      ATHSigPSDT   EQU 'PSDT' ;Persistent System Description Table
      ATHSigRASF   EQU 'RASF' ;ACPI RAS Feature Table
      ATHSigRSDT   EQU 'RSDT' ;Root System Description Table
      ATHSigSBST   EQU 'SBST' ;Smart Battery Specification Table
      ATHSigSLIT   EQU 'SLIT' ;System Locality Distance Information Table
      ATHSigSRAT   EQU 'SRAT' ;System Resource Affinity Table
      ATHSigSSDT   EQU 'SSDT' ;Secondary System Description Table
      ATHSigXSDT   EQU 'XSDT' ;Extended System Description Table
      ;ACPI-reserved Signatures
      ATHSigBOOT   EQU 'BOOT' ;Simple Boot Flag Table
      ATHSigCSRT   EQU 'CSRT' ;Core System Resource Table
      ATHSigDBG2   EQU 'DBG2' ;Debug Port Table 2
      ATHSigDBGP   EQU 'DBGP' ;Debug Port Table
      ATHSigDMAR   EQU 'DMAR' ;DMA Remapping Table
      ATHSigETDT   EQU 'ETDT' ;Event Timer Description Table (Obsolete)
      ATHSigHPET   EQU 'HPET' ;IA-PC High Precision Event Timer Table
      ATHSigIBFT   EQU 'IBFT' ;iSCSI Boot Firmware Table
      ATHSigIVRS   EQU 'IVRS' ;I/O Virtualization Reportign Structure
      ATHSigMCFG   EQU 'MCFG' ;PCI Express memory mapped configuration space
                              ;  base address Description Table
      ATHSigMCHI   EQU 'MCHI' ;Management Controller Host Interface Table
      ATHSigMSDM   EQU 'MSDM' ;Microsoft Data Management Table
      ATHSigSLIC   EQU 'SLIC' ;Microsoft Software Licensing Table Spec
      ATHSigSPCR   EQU 'SPCR' ;Serial Port Console Reflection Table
      ATHSigSPMI   EQU 'SPMI' ;Server Platform Management Interface Table
      ATHSigTCPA   EQU 'TCPA' ;Trusted Computing Platform Alliance
                              ;  Capabilities Table
      ATHSigTPM2   EQU 'TPM2' ;Trusted Platform Module 2 Table
      ATHSigUEFI   EQU 'UEFI' ;UEFI ACPI Data Table
      ATHSigWAET   EQU 'WAET' ;Windows ACPI Emulated Devices Table
      ATHSigWDAT   EQU 'WDAT' ;Watch Dog Action Table
      ATHSigWDRT   EQU 'WDRT' ;Watchdog Resource Table
      ATHSigWPBT   EQU 'WPBT' ;Windows Platform Binary Table
    ATHLength     RESD     1  ;Length of entire table (incl Header) in Bytes
    ATHRevision   RESB     1  ;Revision (ACPI Specification?)
    ATHCheckSum   RESB     1  ;All bytes in Table must sum to 0
    ATHOEMID      RESB     6  ;OEM ID String
    ATHOEMTblID   RESQ     1  ;OEM Table ID String (e.g., Mfg Model ID)
    ATHOEMRev     RESD     1  ;OEM Revision of Table
    ATHCreatorID  RESD     1  ;Vendor of Tbl Creation SW (e.g, ASI Compiler)
    ATHCreatorRev RESD     1  ;Table Creation SW Revision
   ENDS
  ACPITblHdrSize EQU ACPITblHdrStruc_size ;Size of ACPI Description Table Hdr

  ;----------------------------------------------------------------------------
  ;Root System Description Table
  ;  This Table stores the physical memory location of all the other
  ;     ACPI Description Tables
  ;  This is a Required Table
  ;----------------------------------------------------------------------------
  STRUC RSDTStruc        ;Structure of a Root System Description Table
    RSDTHeader    RESB ACPITblHdrSize ;Table Header
    RSDTPhysAddr1 RESD 1 ;Physical Address of First System Description Table
    RSDTPhysAddr2 RESD 1 ;Physical Address of Second System Description Table
    ;...
    RSDTPhysAddrN RESD 1 ;Physical Address of Last System Description Table
   ENDS

  ;----------------------------------------------------------------------------
  ;Fixed ACPI Description Table
  ;  This Table stores information vital to ACPI Operation, which is needed
  ;    by an OS when the CPU has just woken up from a low-power mode (and
  ;    the complicated ACPI Drivers have not yet been loaded).
  ;  This contains pointers to various other tables, in addition to
  ;    various I/O addresses.
  ;  This is a Required Table
  ;----------------------------------------------------------------------------
  STRUC FACPStruc                   ;Structure of a Fixed ACPI Description Table
    FACPHeader        RESB ACPITblHdrSize ;Table Header
    FACPFACSPhysAddr  RESD       1  ;Phys Addr of Firmware ACPI Control Struc
    FACPDSDTPhysAddr  RESD       1  ;Phys Addr of Differentiated System Descr Tbl
    FACPIntModel      RESB       1  ;Interrupt Model
      FACPIntDualPIC   EQU      00h ;ISA Dual PIC (IRQ 0-15), 8259, Edge-Level Ctl
      FACPIntAPIC      EQU      01h ;Multiple APIC (Described in APIC Descr Tbl)
      ;All other values reserved
      ;This field is deprecated in ACPI v2+
    FACPPrefPMProf    RESB       1  ;OEM Preferred Power Management Profile
                                    ;  0 = Unspecified
                                    ;  1 = Desktop
                                    ;  2 = Mobile
                                    ;  3 = Workstation
                                    ;  4 = Enterprise Server
                                    ;  5 = SOHO Server
                                    ;  6 = Appliance PC
                                    ;  7 = Performance Server
                                    ;  8 = Tablet
                                    ;  All other values Reserved
    FACPSCIInt        RESW       1  ;SCI Interrupt Pin (in 8259 Mode)
    FACPSMICmdIO      RESD       1  ;I/O Address of SMI Command Port
    FACPSMIOSEnable   RESB       1  ;Value to write to SMI Cmd Port to Disable SMI
                                    ;  (Enable SCI) This is also called ACPI_ENABLE
    FACPSMIOSDisable  RESB       1  ;Value to write to SMI Cmd Port to Enable SMI
    FACPSMIS4BIOSReq  RESB       1  ;Value to write to SMI Cmd Port to Enter S4BIOS
                                    ;  State.  0 here indicates no support.
    FACPPStateCnt     RESB       1  ;Value to write to SMI Cmd Port to Assume
                                    ;  processor performance state control
    FACPPM1aEvtBlk    RESD       1  ;I/O Address of Pwr Mgmt 1a Event Reg Block
    FACPPM1bEvtBlk    RESD       1  ;I/O Address of Pwr Mgmt 1b Event Reg Block
      ;PM1Evt actually consists of two separate functions, PM1Sts (Status)
      ;  and PM1En (Enable).  In addition, each can use two separate I/O
      ;  ports in a "shared" fashion.  ACPI allows a single function to be
      ;  spread across two separate I/O ports (and two separate chipsets).
      ;PM1xEvtLen (below) contains the total size for both parts (Status
      ;  and Enable), so the length of an individual part is (PM1xEvtlen/2)
      ;PM1Sts is accessed though the PM1Evt I/O Ports (PM1a & PM1b), with
      ;  length = (PM1xEvlLen/2), and must be OR'd together.
      ;PM1En is accessed though the (PM1Evt+(PM1xEvtLen/2)) I/O Ports,
      ;  with length = (PM1xEvlLen/2), and must be OR'd together.
      ;PM1xEvtLen is usually 4, so each field (Status & Enable) is usually
      ;  2 bytes.
      ;Data contained in PM1Sts is as follows:
      ;  Bit     0 = TMR_STS    Timer Carry Status bit.  Set when MSB of
      ;                           Timer toggles.  Interrupt is generated if
      ;                           TMR_EN & TMR_STS are both set.
      ;       1- 3 = Reserved
      ;          4 = BM_STS     Set when an external Bus Master requests the
      ;                           system bus.  Cleared by writing 1 to it.
      ;                           Used to indicate cache incoherency issues
      ;                           when returning from a C3 state.
      ;          5 = GBL_STS    Set when an IRQ is generated by the BIOS when
      ;                           it released the Global Lock and sees the
      ;                           Global Lock Pending bit set.
      ;       6 -7 = Reserved
      ;          8 = PWRBTN_STS (Optional) Set when Power Button is pressed.
      ;                         Not available if FACPFlags.FACPFlgPwrBtn is
      ;                           set.
      ;                         If PWRBTN_STS & PWRBTN_EN are both set, and
      ;                           the system is in S0, an IRQ is generated.
      ;                           If sleeping, a wake event is generated.
      ;                         Bit is reset by writing 1 to it.
      ;                         (Optional) if Power Buttons is held down
      ;                           for more than 4 seconds, system performs
      ;                           and unconditional shutdown.
      ;                         Bit is set if a wake event was caused by
      ;                           the Power Button.
      ;          9 = SLPBTN_STS (Optional) Set when Sleep Button is pressed.
      ;                         Not available if FACPFlags.FACPFlgSlpBtn is
      ;                           set.
      ;                         If SLPBTN_STS & SLPBTN_EN are both set, an
      ;                           IRQ is generated.  If sleeping, a wake event
      ;                           is generated.
      ;                         Bit is reset by writing 1 to it.
      ;                         Bit is set if a wake event was caused by
      ;                           the Sleep Button.
      ;         10 = RTC_STS    (Optional) Set when RTC generates an alarm
      ;                           (generates an RTC IRQ)
      ;                         If RTC_EN is set, an event is generated (SMI,
      ;                           SCI, or Resume).
      ;                         Bit is reset by writing 1 to it.
      ;                         Bit is set if a wake event was caused by
      ;                           the RTC Alarm.
      ;         11 = Ignored by OS software.
      ;      12-13 = Reserved
      ;         14 = PCIEXP_WAKE_STS Set when system wakes due to a
      ;                                PCI Express wakeup event.
      ;                              Bit is reset by writing 1 to it.
      ;         15 = WAK_STS    Set when a wake event occurs while in a
      ;                           sleeping state.
      ;                         Bit is reset by writing 1 to it.
      ;Data contained in PM1Sts is as follows:
      ;  Bit     0 = TMR_EN     Timer Carry Interrupt Enable bit.  When set,
      ;                           an IRQ is generated when TMR_STS is set.
      ;       1- 4 = Reserved
      ;          5 = GBL_EN     Global Enable Bit.  When both GBL_EN & GBL_STS
      ;                           are set, and IRQ is generated.
      ;       6 -7 = Reserved
      ;          8 = PWRBTN_EN  (Optional) When set, an event (IRQ or Wake)
      ;                           is generated when the Power Button is pressed.
      ;                         Not available if FACPFlags.FACPFlgPwrBtn is
      ;                           set.
      ;          9 = SLPBTN_EN  (Optional) When set, and event (IRQ or Wake)
      ;                           is generated when the Sleep Button is pressed.
      ;                         Not available if FACPFlags.FACPFlgSlpBtn is
      ;                           set.
      ;         10 = RTC_EN     (Optional) When set, a wake event is generated
      ;                            when the RTC_STS bit is set.
      ;                           the RTC Alarm.
      ;      11-13 = Reserved
      ;         14 = PCIEXP_WAKE_DIS When set, prevents PCI Express wake
      ;                                events from wakign the system.
      ;         15 = Reserved
    FACPPM1aCtlBlk    RESD       1  ;I/O Address of Pwr Mgmt 1a Control Reg Block
    FACPPM1bCtlBlk    RESD       1  ;I/O Address of Pwr Mgmt 1b Control Reg Block
      ;PM1Ctl is configured as a pair of I/O registers, PM1aCtl & PM1bCtl.
      ;  ACPI allows a single function to be spread across two separate
      ;  I/O ports (and two separate chipsets).
      ;To read PM1, both PM1a and PM1b I/O ports must be read, and the
      ;  results OR'd together.  Bits in the two ports will never overlap
      ;  each other.  To write PM1, the same value must be written to
      ;  both ports.
      ;Length of the field is in FACPPM1xCtlLen (usually 2)
      ;Data contained in PM1Ctl is as follows:
      ;  Bit     0 = SCI_EN   Power Management events come in through the
      ;                         SCI IRQ (OS), not the SMI Interrupt (BIOS).
      ;                       Changed only by hardware --
      ;                         software must preserve.
      ;          1 = BM_RLD   Allows Bus Master requests (from any Bus Master)
      ;                       to cause a C3 to C0 transition
      ;          2 = GBL_RLS  Setting theis bit sends an SMI event to BIOS
      ;                         OS sets this bit to indicate release of the
      ;                         Global Lock, or setting of the Global Lock
      ;                         pending bit
      ;       3- 8 = Reserved
      ;          9 = Ignored by OS software
      ;      10-12 = SLP_TYPx Sleeping State Type.  OS takes the two values
      ;                         from the \_Sx fileds and programs them
      ;                         ino the respective SLP_TYPx field.
      ;         13 = SLP_EN   Sleep Enable (write-only, returns to 0)
      ;      14-15 = Reserved
    FACPPM2CtlBlk     RESD       1  ;I/O Address of Pwr Mgmt 2 Control Reg Block
      ;Only contains one bit:
      ;  Bit       0 = ARB_DIS      ;Bus Master Arbiter Disable.  When set,
      ;                                does not allow other Bus Masters to
      ;                                access memory (prevents C3->C0 transitions
      ;                                from external Bus Master events on
      ;                                Uni-processor systems)
      ;                              Must be Clear in C0, C1, & C2 states, can be
      ;                                set for C3 on Uniprocessor systems
      ;         1- n = Reserved
    FACPPMTmrBlk      RESD       1  ;I/O Address of Pwr Mgmt Timer Ctl Reg Block
      ;Timer that counts down when system is in S0 state, stops counting
      ;  when not in S0.  Clock used is 3.579545 MHz.
      ;If FACPFlags.FACPFlgTmr32 is set, timer is 32-bits, else 24-bits
      ;  (if 24-bits, high 8 bits always return 0).
      ;Timer simply counts down from current value (whioch can be ser/reset
      ;  at any time).
      ;On overflow (transition past 0), TMR_STS (PM1 Status Bit 0) is set
      ;  and an interrupt is generated.
    FACPGPE0Blk       RESD       1  ;I/O Address of Generic Purpose Event 0 Reg Blk
    FACPGPE1Blk       RESD       1  ;I/O Address of Generic Purpose Event 1 Reg Blk
    FACPPM1xEvtLen    RESB       1  ;Bytes in I/O Space of PM1xEvtBlk (usually 4)
    FACPPM1xCtlLen    RESB       1  ;Bytes in I/O Space of PM1xCtlBlk (usually 2)
    FACPPM2CtlLen     RESB       1  ;Bytes in I/O Space of PM2CtlBlk
                                    ;  Always 1 in ACPI 1.0
    FACPPM2TmrLen     RESB       1  ;Bytes in I/O Space of PMTmrBlk (always 4?)
    FACPGPE0Len       RESB       1  ;Bytes in I/O Space of GPE0Blk (multiple of 2)
    FACPGPE1Len       RESB       1  ;Bytes in I/O Space of GPE1Blk (multiple of 2)
    FACPGPE1Base      RESB       1  ;Offset in I/O Space of GPE1Blk
    FACPCSTCtl        RESB       1  ;Value to write to SMI Cmd Port to indicate OS
                                    ;  support for _CST object and C States Changed
                                    ;  notification
    FACPC2Latency     RESW       1  ;Worst Case Latency (S) to Enter/Exit C2 State
                                    ;  >100 here indicates no support.
    FACPC3Latency     RESW       1  ;Worst Case Latency (S) to Enter/Exit C3 State
                                    ;  >1000 here indicates no support.
    FACPFlushSize     RESW       1  ;Number of Flush Strides required to Flush Cache
                                    ;  Spec Recommends using WBINVD = 1 instead
                                    ;  Ignored if WBINVD = 1
    FACPFlushStride   RESW       1  ;Cache Line Width (Bytes)
                                    ;  Ignored if WBINVD = 1
    FACPDutyOffset    RESB       1  ;Offset in P_CNT register of Duty Cycle Setting
    FACPDutyWidth     RESB       1  ;Bit-Width of Duty Cycle Setting in P_CNT Reg
                                    ;  0 here indicates no support.
    FACPDayAlarm      RESB       1  ;Offset in CMOS of Day-of-Month Alarm
                                    ;  0 here indicates no support.
    FACPMonthAlarm    RESB       1  ;Offset in CMOS of Month-of-Year Alarm
                                    ;  0 here indicates no support.
    FACPCentury       RESB       1  ;Offset in CMOS of Century Value
                                    ;  0 here indicates no support.
    FACPIACPBootArch  RESW       1  ;IA-PC Boot Architecture Flags
                                    ;  Bit  0 = Supports ISA/LPC devices
                                    ;       1 = Supports 8042 keyboard controller
                                    ;             (bits 60h-64h)
                                    ;  Bit  2 = VGA not present (must not query
                                    ;             A000h-BFFFh or ports 3B0-3BBh
                                    ;             and 3C0-3DFh)
                                    ;  Bit  3 = Message Signaled INTs not supported
                                    ;  Bit  4 = Must not enable PCIe ASPM control
                                    ;  Bit  5 = CMOS Real-time Clock not supported
                                    ;             (use Control Method Timer and
                                    ;              Alarm namespace)
                                    ;  Bits 6-15 = Reserved
    FACPReserved4     RESB       1  ;Reserved (must be 0)
    FACPFlags         RESD       1  ;Bit-level flags
      FACPFlgWBINVD    EQU    0001h ;WBINVD is correctly supported
      FACPFlgWBFlush   EQU    0002h ;WBINVD flushes caches, but does not invalidate
                                    ;If these are 0, and FlushSize/FlushStride are
                                    ;  also 0, system cannot support S1, S2, or S3
      FACPFlgC1Supt    EQU    0004h ;C1 State supported on all processors
      FACPFlgC2MP      EQU    0008h ;C2 State supported for both UniProcessor and
                                    ;  MultiProcessor systems (0 = UniProcessor Only)
      FACPFlgPwrBtn    EQU    0010h ;0 = Power Button handled as Fixed Feature
                                    ;1 = Power Button handled as Control Method
      FACPFlgSlpBtn    EQU    0020h ;0 = Sleep Button handled as Fixed Feature
                                    ;1 = Sleep Button handled as Control Method
      FACPFlgNoRTC     EQU    0040h ;RTC Wake-up Status is NOT in Fixed Reg Space
      FACPFlgRTCS4     EQU    0080h ;RTC Alarm can Wake the System from S4 State
      FACPFlgTmr32     EQU    0100h ;Timer value is 32 bits (0 = 24 bits)
      FACPFlgDocking   EQU    0200h ;System is capable of Docking (does NOT mean
                                    ;  a docking station is attached)
      FACPFlgRstReg    EQU    0400h ;Supports System Reset via FADT Reset Reg
      FACPFlgSealed    EQU    0800h ;Sealed Case, no internal expansion
      FACPFlgHeadles   EQU    1000h ;Cannot detect monitor, keyb, or mouse
      FACPFlgCPUSwSl   EQU    2000h ;Processor Native instruction must be encoded
                                    ;  after writing to SLP_TYPx register
      FACPFlgPCIExpW   EQU    4000h ;Platform supports PCIEXPWakeSts &
                                    ;  PCIExpWakeEnable
      FACPFlgUsePClk   EQU    8000h ;OS should use platform timers
      FACPFlgS4StsVl   EQU 01_0000h ;Contents of RTC_STS flag is valid after
                                     ;  waking from S4
      FACPFlgRmtPwr    EQU 02_0000h ;Compatible with remote power-on
      FACPFlgFcAPICL   EQU 04_0000h ;Local APICs must be configured for
                                    ;  cluster destination module when
                                    ;  delivering INTs in logical mode
      FACPFlgFcAPICP   EQU 08_0000h ;Local APICs must be configured for
                                    ;  physical mode
      FACPFlgNoACPI    EQU 10_0000h ;ACPI Hardware Interface is not implemented
      FACPFlgS0Best    EQU 20_0000h ;S0 has better power savings in S0 than S3
      ;Bits 22-31 = Reserved
    ;Stuff below this line was not included in ACPI v1?
    FACPResetReg      RESD       1  ;Address of Reset Register represented in
                      RESD       1  ;  Generic Address Structure Format
                      RESD       1  ;  Section 4.8.3.5 of ACPI v5 Spec
    FACPResetVal      RESB       1  ;Value to write to ResetReg Port to Reset
                                    ;  the System
    FACPReserved5     RESB       1  ;Reserved
                      RESW       1  ;  (must be 0)
    FACPXFACSPhysAddr RESQ       1  ;FACS physical address (64-bits)
                                    ;  Only valid of 32-bit address is 0, & vv
    FACPXDSDTPhysAddr RESQ       1  ;DSDT 64-bit physical address
    FACPXPM1aEvtBlk   RESQ       1  ;Ext Address of Pwr Mgmt 1a Event Reg Block
                                    ;  represented in Generic Address Structure fmt
    FACPXPM1bEvtBlk   RESQ       1  ;Ext Address of Pwr Mgmt 1b Event Reg Block
                                    ;  represented in Generic Address Structure fmt
    FACPXPM1aCtlBlk   RESQ       1  ;Ext Address of Pwr Mgmt 1a Control Reg Block
                                    ;  represented in Generic Address Structure fmt
    FACPXPM1bCtlBlk   RESQ       1  ;Ext Address of Pwr Mgmt 1b Control Reg Block
                                    ;  represented in Generic Address Structure fmt
    FACPXPM2CtlBlk    RESQ       1  ;Ext Address of Pwr Mgmt 2 Control Reg Block
                                    ;  represented in Generic Address Structure fmt
    FACPXPMTmrBlk     RESQ       1  ;Ext Address of Pwr Mgmt Timer Ctl Reg Block
                                    ;  represented in Generic Address Structure fmt
    FACPXGPE0Blk      RESQ       1  ;Ext Address of Generic Purpose Event 0 Reg Blk
                                    ;  represented in Generic Address Structure fmt
    FACPXGPE1Blk      RESQ       1  ;Ext Address of Generic Purpose Event 1 Reg Blk
                                    ;  represented in Generic Address Structure fmt
    FACPSleepCtlReg   RESQ       1  ;Address of Sleep Register
                      RESD       1  ;  represented in Generic Address Structure fmt
    FACPSleepStsReg   RESQ       1  ;Address of Sleep Status Register
                      RESD       1  ;  represented in Generic Address Structure fmt
   ENDS
  FACPStrucSize EQU FACPStruc_size ;Size of FACP Table

  ;----------------------------------------------------------------------------
  ;Firmware ACPI Control Structure
  ;----------------------------------------------------------------------------
  STRUC FACSStruc             ;Structure of a Firmware ACPI Control Structure
    FACSSignature    RESB  4  ;Table Signature 'FACS'
    FACSLength       RESD  1  ;Length of table in bytes (>= 64)
    FACSHWSignature  RESD  1  ;Hardware Signature at last Boot (used when
                              ;  waking from S4 state to test for changes)
    FACSFWWakeVect   RESD  1  ;Location for OS to store a Waking Vector
                              ;  Phys Addr called by the BIOS from Real Mode
    FACSGlobalLock   RESD  1  ;Synchronizes access to HW between OS and SMI
      FACSGLkPending  EQU 01h ;Request for Ownership is Pending
      FACSGLkOwned    EQU 02h ;Ownership is currently owned
      ;Bits 2-31 = Reserved (not necessarily 0?)
    FACSFlags        RESD  1  ;Bit-level flags
    FACSFlgS4BIOS     EQU 01h ;Platform Supports S4BIOS_REQ (BIOS saves
                              ;  memory state when going into S4 state)
    ;Bits 1-31 = Reserved (0)
    FACSReserved     RESB 40  ;Reserved (0)
   ENDS

  ;----------------------------------------------------------------------------
  ;CPUx Entry in DSDT Name Space
  ;----------------------------------------------------------------------------
  STRUC CPUxStruc
    CPUxTag      RESW 1 ;Processor Tag (AMLTagCPU)
    CPUxLength   RESB 1 ;Length of Tag (incl size) (0Bh)
    CPUxName     RESD 1 ;Name of CPU (usually CPU0, CPU1, etc.)
    CPUxID       RESB 1 ;Unique CPU ID
    CPUxIOAddr   RESD 1 ;I/O Address of P_CNT Register
                        ;  Note: To change the CPU to C2 or C3 states,
                        ;          Read from I/O registers (P_CNT+4) or
                        ;          (P_CNT+5), respectively
    CPUxPCntSize RESB 1 ;Size of Processor Control (P_CNT) register
                        ;  = 6 if Throttling & C2/C3 states supported
                        ;  = 4 if Throttling supported, but not C2/C3
                        ;  = 0 if no support
   ENDS

  ;----------------------------------------------------------------------------
  ;Package Entry in DSDT Name Space
  ;----------------------------------------------------------------------------
  STRUC PackageStruc
    PkgTag      RESB 1 ;Package Tag (AMLTagPkg)
    PkgLength   RESB 1 ;Length of Package (including this byte)
                       ;  Can actually be multiple bytes -- See ACPI Spec
    PkgElements RESB 1 ;Number of Elements in package
    PkgData     RESB 1 ;Actual Data (multiple bytes)
   ENDS

  ;----------------------------------------------------------------------------
  ;Method Entry in DSDT Name Space
  ;----------------------------------------------------------------------------
  STRUC MethodStruc
    MethTag    RESB   1  ;Method Tag (AMLTagMethod)
    MethLength RESB   1  ;Length of Method Package (including this byte)
                         ;  Can actually be multiple bytes -- See ACPI Spec
    MethName   RESD   1  ;Method Name (this is what we actually look for)
    MethFlags  RESB   1  ;Flags
      MFlgArgs  EQU  07h ;Number of Arguments passed (0-7)
      MFlgSer   EQU  08h ;Serialized (not Re-entrant)
      MFlgSync  EQU 0F0h ;Sync Level
    MethData   RESB   1  ;Method Data (multiple bytes)
   ENDS

  ;----------------------------------------------------------------------------
  ;Name Entry in DSDT Name Space
  ;----------------------------------------------------------------------------
  STRUC NameStruc
    NameTag  RESB 1 ;Name Tag (AMLTagName)
    NameName RESD 1 ;Actual Name (this is what we actually look for)
    NameData RESB 1 ;Data (multiple bytes, starts with another Tag of some sort)
   ENDS

  ;----------------------------------------------------------------------------
  ;Small Resource Entry is DSDT Name Space
  ;Used by _CRS (Current Resource Settings), _PRS (Possible Resource Settings),
  ;  and _SRS (Set Resource Settings)
  ;----------------------------------------------------------------------------
  STRUC SResourceStruc
    SResTag       RESB  1  ;Small Resource Data Type Tag
      SRTagLarge   EQU 80h ;Set if Resource is Large rather than Small
      SRTagType    EQU 78h ;Item Name/Type
                           ;00-03 = Reserved
                           ;   04 = IRQ
                           ;   05 = DMA
                           ;   06 = Start Dependent Functions
                           ;   07 = ENd Dependent Functions
                           ;   08 = I/O Port
                           ;   09 = Fixed Location I/O Port
                           ;   0A = Fixed DMA
                           ;0B-0D = Reserved
                           ;   0E = Vendor-defined
                           ;   0F = End Tag
      SRTagLength  EQU 07h ;Length in Bytes (0-7), NOT including this byte
    SResData      RESB  1  ;Actual data, varies by Name/Type
      ;IRQ (Type 04):
      ;  SResTag   = 22h or 23h (Length = 2 or 3)
      ;  Bytes 1-2 = IRQ Mask (Bit 0 = IRQ0, etc.)
      ;  Byte    3 = IRQ Information (optional)
      ;                If not included (SResTag = 22h),
      ;                  Edge-Triggered, High-True
      ;                Bit    0 = Edge Triggered (0 = Level-Triggered)
      ;                Bits 1-2 = Ignored
      ;                Bit    3 = Active-Low (0 = Active-High)
      ;                Bit    4 = Shared (multiple Devices use same IRQ)
      ;                Bit    5 = Can Wake System from Idle/Sleep State
      ;                Bits 6-7 = Reserved (must be 0)
      ;
      ;DMA (Type 05):
      ;  SResTag   = 2Ah
      ;  Byte    1 = Channel Mask (Bit 0 = Channel 0, etc.)
      ;  Byte    2 = DMA Information
      ;                Bits 0-1 = Transfer Type Preference
      ;                             00 = 8-bit only
      ;                             01 = 8- and 16-bit
      ;                             10 = 16-bit only
      ;                             11 = Reserved
      ;                Bit    2 = Bus Master Device
      ;                Bits 3-4 = Ignored
      ;                Bits 5-6 = Channel Speed Supported
      ;                             00 = Compatibility Mode
      ;                             01 = Type A DMA (described in EISA)
      ;                             10 = Type B DMA
      ;                             11 = Type F
      ;                Bit    7 = Reserved (must be 0)
      ;Start Dependent Functions (Type 05):
      ;  SResTag = 30h or 31h (Length = 0 or 1)
      ;              Each Logical Device requires its own set of resources
   ENDS


;
;MACROS
;

;  SwapDSES MACRO ;Exchange DS & ES with each other
;    PUSH DS
;    PUSH ES
;    POP  DS
;    POP  ES
;   #EM


;
;DATA
;

;==============================================================================
;Miscellaneous Strings we need to write to the screen
;==============================================================================

  ;----------------------------------------------------------------------------
  ;Help Message to write on Errors.
  ;This MUST also be the first Data at the top of the File.  If it is, the user
  ;  can simply do a "TYPE SLOWACPI.COM get the Help Screen, without even
  ;  needing to execute the Program.
  ;------------------------------------------------------------------------------
  Copyright:
    DB CR
    DB 'SLOWACPI 0.02-beta, (C) 2017, Bret E. Johnson.',CR,LF
    DB 'A program to slow down the CPU clock frequency or shut off the computer.',CR,LF
    DB LF,0

  SyntaxMsg:
    DB CR
    DB 'SYNTAX: SLOWACPI [Options]',CR,LF
    DB LF
    DB '  ?  Show this HELP screen',CR,LF
    DB '  A  Show all ALIASES for these command line Options',CR,LF
    DB '  E  Show all ErrorLevels (DOS Return Codes)',CR,LF
    DB LF
    DB '  0    Turn computer Off (the ultimate slow down)',CR,LF
    DB '  D #  Delay # seconds after flushing disk buffers (1-60, default = 2)',CR,LF
    DB LF
    DB '  #  Duty Cycle Value to Set (1-250)',CR,LF
    DB '         1 = minimum duty cycle (minimum CPU speed)',CR,LF
    DB '         If # is more than maximum allowed by hardware (usually 8 or 16),',CR,LF
    DB '           CPU runs at full speed',CR,LF
    DB LF
    DB '  O:Y|N  Use On Demand Clock Modulation (ODCM) to slow down CPU',CR,LF
    DB '             rather than ACPI (ODCM is only available on some',CR,LF
    DB '             Intel CPUs (default = Yes)',CR,LF
    DB LF
    DB '  L  Show All Embedded Controller Data (Laptops Only)',CR,LF
    DB '  C  Monitor Changes in Embedded Controller Data (Laptops Only)',CR,LF
    DB 0,EOF

  ;----------------------------------------------------------------------------
  ;Miscellaneous Strings we need to write to the screen
  ;----------------------------------------------------------------------------
  HexString:  DB '0000_0000',0
  CrLfMsg:    DB CR,LF,0
  NAMsg:      DB 'N/A',0
  YesMsg:     DB 'Yes',0
  NoMsgS:     DB ' No',0
  SingleMsg:  DB ' '
  NoMsg:      DB 0
  Space4Msg:  DB ' '
  Space3Msg:  DB ' '
  Space2Msg:  DB ' '
  SpaceMsg:   DB ' ',0
  DotMsg:     DB '.',0
  UnknownMsg: DB 'Unknown',0
  MinutesMsg: DB 'Minutes',0

  ;----------------------------------------------------------------------------
  ;Flags for WriteByteMin/WriteWordMin/etc.
  ;----------------------------------------------------------------------------
  WriteByteMinFlag   EQU 01h ;Write in Minimum Space
  WriteByteWordFlag  EQU 02h ;Writing a Word (not a Byte)
  WriteByteDWordFlag EQU 04h ;Writing a DWord (not a Byte or Word)


;==============================================================================
;Pause Related
;==============================================================================

  ;----------------------------------------------------------------------------
  ;Number of Spaces to Indent New Lines in WriteZPauseFar
  ;----------------------------------------------------------------------------
  PauseIndent DB 0

  ;----------------------------------------------------------------------------
  ;Strings and Data needed to Pause the screen
  ;----------------------------------------------------------------------------
  PauseMsg:
    DB CR,LF
    DB ' MORE   (Esc stops Pausing, Ctrl-C stops Completely, any other Continues)',CR,0
  PauseNMsg:
    DB ' MORE                                                                    ',CR,LF,0
  PauseDMsg:
    DB '                                                                               ',CR,0
  PauseRows     DW      ?  ;Number of rows per screen
  PauseHdrPtr   DD 1_0000h ;Pointer to Header Message
                           ;  High Word =  0 if Pausing has been cancelled
                           ;            = -1 if Output has been cancelled
                           ;  (start with a fake one <> 0)
  PauseHdrSize  DW      2  ;Number of lines in the Header Message
  PauseRowCount DW      2  ;Current Row Counter


;==============================================================================
;DOS Environment Related
;==============================================================================

  ;----------------------------------------------------------------------------
  ;Variables to search for our Environment Variable
  ;----------------------------------------------------------------------------
  EnvVarString  DB 'SLOWACPI='    ;Environment Variable String
  EnvVarSize   EQU $-EnvVarString ;Length of String
  EnvVarPtr     DW -1             ;Pointer to Program Environment Variable

  ;----------------------------------------------------------------------------
  ;Variables to search for an extended Command Line String
  ;This should only be valid/needed if the Command Line Size (PSP:[80h]) is 7Eh
  ;----------------------------------------------------------------------------
  CmdLineVarString  DB 'CMDLINE='         ;Environment Variable String
  CmdLineVarSize   EQU $-CmdLineVarString ;Length of String
  CmdLineVarPtr     DW -1                 ;Pointer to Program Environment Variable


;==============================================================================
;Alias Related
;==============================================================================

  ;----------------------------------------------------------------------------
  ;Strings needed to print Command Line Aliases to the screen
  ;----------------------------------------------------------------------------
  AliasHdrMsg:
    DB '                        ALIASES FOR COMMAND-LINE OPTIONS',CR,LF
    DB '',CR,LF
    DB 0

  YesNoHdrMsg:
    DB '       ALIASES FOR YES & NO',CR,LF
    DB '',CR,LF
    DB 0

  ;----------------------------------------------------------------------------
  ;Table needed to temporarily store Aliases.
  ;They are originally sorted in reverse alphabetical order.
  ;To write them in forward alphabetical order, we temporarily store
  ;  the String Pointers, in the original reverse order, in this table.
  ;  We then write the strings, starting with the last entry in this table
  ;  and moving backwards.
  ;The number of entries in this table must be AT LEAST as big as the largest
  ;  number of Aliases for a single command Option.  Most Options don't have
  ;  more than a dozen or so Aliases.
  ;----------------------------------------------------------------------------
  AliasSortTbl TIMES 50 DW ? ;Table to store Alias Strings (to reverse order)


;==============================================================================
;Program Status Related
;==============================================================================

  CPUMfgHdr:      DB 'CPU Manufacturer String: ',0
  CPUBrandHdr:    DB 'CPU Brand String       : ',0
  MemSizeMsg:     DB 'System Memory Installed: ',0

;  APMVerMsg:      DB 'APM Version             : ',0
  ACPIVerMsg:     DB 'ACPI Version           :   ',0
;  ODCMSuptMsg:    DB 'Intel ODCM Support      : ',0

;  ThtIOAddrMsg:   DB 'ACPI Duty Cycle I/O Addr: ',0
;  ThtMaskMsg:     DB 'ACPI Duty Cycle Bit Mask: ',0
  ThtCurrentMsg:  DB 'ACPI Duty Cycle Value  :   ',0

;  PM1aCtlMsg:     DB 'Pwr Mgmt Ctl 1a I/O Addr: ',0
;  PM1aOffMsg:     DB 'Value needed to Turn Off:   ',0
;  PM1bCtlMsg:     DB 'Pwr Mgmt Ctl 1b I/O Addr: ',0
;  PM1bOffMsg:     DB 'Value needed to Turn Off:   ',0

  ODCMCurrMsg:    DB 'ODCM Duty Cycle Value  :   ',0

;  ACStatusMsg:    DB 'AC Power Status         : ',0
;  BattStatusMsg:  DB 'Battery Power Status    : ',0
;  NumBattsMsg:    DB '# of Batteries Installed: ',0



  BattStateMsg:   DB 'Battery Current State  : ',0
  BattPctMsg:     DB 'Battery Charge Percent :   ',0
  BattFullTmMsg:  DB 'Approx Time to Charge  :   ',0
  BattTimeMsg:    DB 'Battery Remaining Time :   ',0

  ChargedMsg:     DB ' Charged ',0
  ChargingMsg:    DB ' Charging ',0
  DischargingMsg: DB ' Discharging ',0


  ;----------------------------------------------------------------------------
  ;String data returned by the CPUID instruction (later Pentium-class CPU's)
  ;----------------------------------------------------------------------------
  CPUMfgString   TIMES 13 DB ? ;12-byte CPUID Manufacturer ID String
  CPUBrandString TIMES 49 DB ? ;48-byte CPUID Brand String

  ;----------------------------------------------------------------------------
  ;Manufacturer string returned by Intel CPU's
  ;----------------------------------------------------------------------------
  IntelMfgString DB 'GenuineIntel'

  ;----------------------------------------------------------------------------
  ;Lookup Table for CPUID Brand Indexes (earlier Pentium-class CPU's)
  ;This table only applies to processors manufactured by Intel.
  ;  I don't know if other manufacturers use the same identification scheme
  ;    or not, and I haven't bothered looking further.
  ;The first byte is the Index Number returned in CPUID.01:BL
  ;The second DWord is the Processor Signature returned in CPUID.01:EAX
  ;  -1 indicates any Processor Signature will work, and anything other than
  ;  -1 indicates a specific Processor Signature is required
  ;These are followed by the ASCIIZ string
  ;----------------------------------------------------------------------------
CPUBrandTbl:
  DB 01h
    DD  -1
    DB 'Intel(R) Celeron(R) processor',0
  DB 02h
    DD -1
    DB 'Intel(R) Pentium(R) III processor',0
  DB 03h
    DD 0000_06B1h
    DB 'Intel(R) Celeron(R) processor',0
  DB 03h
    DD -1
    DB 'Intel(R) Pentium(R) III Xeon(R) processor',0
  DB 04h
    DD -1
    DB'Intel(R) Pentium(R) III processor',0
  DB 06h
    DD -1
    DB 'Mobile Intel(R) Pentium(R) III processor-M',0
  DB 07h
    DD -1
    DB 'Mobile Intel(R) Celeron(R) processor',0
  DB 08h
    DD -1
    DB 'Intel(R) Pentium(R) 4 processor',0
  DB 09h
    DD -1
    DB 'Intel(R) Pentium(R) 4 processor',0
  DB 0Ah
    DD -1
    DB 'Intel(R) Celeron(R) processor',0
  DB 0Bh
    DD 0000_0F13h
    DB  'Intel(R) Xeon(R) processor MP',0
  DB 0Bh
    DD -1
    DB 'Intel(R) Xeon(R) processor',0
  DB 0Ch
    DD -1
    DB 'Intel(R) Xeon(R) processor MP',0
  DB 0Eh
    DD 0000_0F13h
    DB 'Intel(R) Xeon(R) processor',0
  DB 0Eh
    DD -1
    DB 'Mobile Intel(R) Pentium(R) 4 processor-M',0
  DB 0Fh
    DD -1
    DB 'Mobile Intel(R) Celeron(R) processor',0
  DB 11h
    DD -1
    DB 'Mobile Genuine Intel(R) processor',0
  DB 12h
    DD -1
    DB 'Intel(R) Celeron(R) M processor',0
  DB 13h
    Dd -1
    DB 'Mobile Intel(R) Celeron(R) processor',0
  DB 14h
    DD -1
    DB 'Intel(R) Celeron(R) processor',0
  DB 15h
    DD -1
    DB 'Mobile Genuine Intel(R) processor',0
  DB 16h
    DD -1
    DB 'Intel(R) Pentium(R) M processor',0
  DB 17h
    DD -1
    DB 'Mobile Intel(R) Celeron(R) processor',0

  DB 0  ;End of Table


;;==============================================================================
;;Data needed to determine who our Parent Program is
;;==============================================================================
;
;  ;----------------------------------------------------------------------------
;  ;ASCIIZ Name of our Parent (the name stored in the MCB for our Parents PSP)
;  ;----------------------------------------------------------------------------
;  ParentName: DB 9 DUP (0)
;
;  ;----------------------------------------------------------------------------
;  ;Is our Parent the DOS Shell?
;  ;----------------------------------------------------------------------------
;  ParentIsShell DB No
;
;  ;----------------------------------------------------------------------------
;  ;CallBack Address that may be provided by another program
;  ;An offset of -1 (the first word) indicates an invalid address
;  ;----------------------------------------------------------------------------
;  CallBackAddr DD -1
;
;  ;----------------------------------------------------------------------------
;  ;Table of possible DOS Shell programs (COMMAND.COM or equivalents)
;  ;Must be capitalized, 8 characters max ASCIIZ (not including 0 at end)
;  ;More things could be added to this table if they are discovered;
;  ;  e.g., if FreeDOS or DR DOS or ... use a Shell Name other than COMMAND
;  ;----------------------------------------------------------------------------
;  DOSShellTbl:
;    DB 'COMMAND',0 ;Standard DOS
;    DB 'CMD',0     ;Windows NT & IBM OS/2
;    DB 'NDOS',0    ;Norton Shell (from Norton Utilities)
;    DB '4DOS',0    ;4DOS
;    DB '4NT',0     ;4NT
;    DB '4OS2',0    ;4OS2
;    DB 0           ;End of Table


;==============================================================================
;Miscellaneous Data
;==============================================================================

  ;----------------------------------------------------------------------------
  ;Miscellaneous Yes/No Flags
  ;----------------------------------------------------------------------------
  ProgFlags     DB  ?  ;Miscellaneous Yes/No Flags
    DoEnvir    EQU 01h ;Parsing/Testing Environment variable
    Help       EQU 02h ;User wants help?
    Alias      EQU 04h ;Write the Alias List to the Screen
    ErrLvl     EQU 08h ;Show ErrorLevel Table
    AllECData  EQU 10h ;Write All Embedded Controller Data
    ChgECData  EQU 20h ;Monitor/Write Changes in Embedded Controller Data
    NoODCM     EQU 40h ;Don't use ODCM (needed for XMGR, at least on some
                       ;  computers, since XMGR crashes when issuing
                       ;  WRMSR (Write Model-Specific Registers) OpCode
    NoACPI     EQU 80h ;Don't use ACPI -- Set by User?

;==============================================================================
;Memory Related
;==============================================================================
  EVEN 2

;  TestWord:     DW ? ;Needed to test if MemCopy Function even works
  MemCopyTable TIMES MemCopySize DB 0 ;Descriptor Table needed for Mem copy

  ;----------------------------------------------------------------------------
  ;Physical Address of Offset 0 of the Program in memory
  ;Needed to perform Linear -> Physical Address Translations for INT 15.87
  ;  memory transfers.
  ;If this is 0, we can't perform any memory transfers, since we do not
  ;  know our own physical address!
  ;----------------------------------------------------------------------------
  BasePhysAddr DD ? ;Physical Address of Offset 0 of Program

;==============================================================================
;INT 15h (Memory BIOS) Related
;==============================================================================
  EVEN 4

  E820Tbl  TIMES Int15E820Size DB ? ;Table for single INT 15.E820 Entry
  I15C7Tbl TIMES I15C7Size     DB ? ;Table for INT 15.C7 returned data

  MemSize DQ ? ;Size of System Memory Installed (bytes)


;==============================================================================
;ACPI Related
;==============================================================================

  ;----------------------------------------------------------------------------
  ;Date Gleaned from ACPI
  ;----------------------------------------------------------------------------
  ACPIRevision   DB  ? ;Version
  ACPIACStatus   DB -1 ;AC Line Status
;  ACPIBattStatus DB -1 ;Battery Status
;  ACPIBattFlags  DB -1 ;Battery Flags
;  ACPIBattPct    DB -1 ;Remaining Battery Life (Percent)
;  ACPIBattTime   DW -1 ;Remaining Battery Life (Time)
;  ACPINumBatts   DW -1 ;Number of Batteries currently installed

  ;----------------------------------------------------------------------------
  ;Value to change the CPU Duty Cycle to (provided by user)
  ;----------------------------------------------------------------------------
  DutyToSet   DB  -1 ;New Duty Cycle Value to Set (-1 = don't change it)
  MaxCmdDuty EQU 250 ;Maximum Duty Cycle setting we allow at the command line
                     ;  The "Real" Actual value depends on the HW, 8 or 16

  ;----------------------------------------------------------------------------
  ;Seconds to Wait after issuing Disk Flush Request before shutting down
  ;----------------------------------------------------------------------------
  FlushDelay DW 2

  ;----------------------------------------------------------------------------
  ;Messages to notify user we're shutting down
  ;----------------------------------------------------------------------------
  FlushingMsg:
    DB 'Attempting to Flush Disk Buffers & Caches...',CR,LF,0
  StoppingMsg:
    DB 'Attempting to Shut Down the Computer...',0
  StopErrMsg:
    DB CR,LF
    DB LF
    DB 'Error!  Unable to shut down the computer.',CR,LF
    DB 'You will need to turn it off the old-fashioned way, using the power switch.',0


  ;----------------------------------------------------------------------------
  ;Last actual Data Byte in Buffer
  ;----------------------------------------------------------------------------
  LastBuffByte DW DataBuffer ;Pointer to last data byte

  ;----------------------------------------------------------------------------
  ;ID String needed to locate the RSDP Header
  ;----------------------------------------------------------------------------
  EVEN 2

  RSDPHdrString:  DB 'RSD PTR '
  RSDPHdrStrSize EQU $-RSDPHdrString

  ;----------------------------------------------------------------------------
  ;Physical Addresses of various ACPI Tables we need to access
  ;----------------------------------------------------------------------------
  EVEN 2

  RSDTPhysAddr DD ? ;Phys Addr of Root System Description table
  DSDTPhysAddr DD ? ;Phys Addr of Differentiated System Description Table

  ;----------------------------------------------------------------------------
  ;Data to help us find data in the DSDT Table
  ;----------------------------------------------------------------------------
  DSDTTblSize  DD ? ;Size of DSDT Table, in bytes
  DSDTLastAddr DD ? ;Address of Last Byte of DSDT Table
  NextDSDTAddr DD ? ;DSDT Physical Address to use next time through the loop
                    ;  (0 = Start from Beginning, -1 = No more needed)

  ;----------------------------------------------------------------------------
  ;ACPI Throttling I/O Register Values
  ;----------------------------------------------------------------------------
  EVEN 2

  ThtIOAddr      DW  ?  ;I/O Address of Throttle Control Register
  ThtDutyOffset  DB  ?  ;Offset to Duty Cycle Bits
  ThtDutyWidth   DB  ?  ;Bit-width of Duty Cycle Bits (0 if not Supported)
  ThtValueMask   DW  ?  ;Bit-mask to determine the Current Throttle Setting
                        ;  ([ThtDutyOffset] & [ThtDutyWidth] converted to bitmask)
  ThtMaxValue    DB  ?  ;Bit-width converted to a number (usually 8 or 16)
  ThtEnableBit  EQU 10h ;Bit to set at [ThtIOAddr] to Enable Throttling

  ;----------------------------------------------------------------------------
  ;Power Management Control Register Values
  ;----------------------------------------------------------------------------
  EVEN 2
  PM1aCtlIOAddr DW ? ;I/O Address of Power Managment 1a Control Block
  PM1bCtlIOAddr DW ? ;I/O Address of Power Managment 1b Control Block

  PM1aS5Value: DB -1 ;Value to put in [PM1aCtl] to Soft Power Off
  PM1bS5Value: DB -1 ;Value to put in [PM1bCtl] to Soft Power Off

  ;----------------------------------------------------------------------------
  ;Processor C2/C3 Register Values
  ;----------------------------------------------------------------------------
  C2IOAddr       DW  ?  ;I/O Register to read to transfer to C2 State
                        ;  (ThtIOAddr+4)
  C3IOAddr       DW  ?  ;I/O Register to read to transfer to C2 State
                        ;  (ThtIOAddr+5)
  C2Latency      DW  ?  ;Latency to transition from C2 to C0 (s)
  C3Latency      DW  ?  ;Latency to transition from C3 to C0 (s)
  C2C3Flags      DB  ?  ;Flags
    C2C3MultiP  EQU 01h ;C2 supported in multiprocessor mode
    C2C3WBINVD  EQU 02h ;WBINVD instruction works correctly

  ;----------------------------------------------------------------------------
  ;Power Management Control Bitmap Values (Words)
  ;----------------------------------------------------------------------------
   PM1CSCIEnable   EQU 0001h ;SCI (BIOS) ACPI Control Enabled
                           ;  If 0, ACPI is controlled by SMI (OS)
   PM1CBusMaster   EQU 0002h ;Allows Bus Master Requests to transition all
                           ;  CPU's from C3 to C0
   PM1CGlobalRls   EQU 0004h ;Used during Transtion from OS (SMI) to BIOS (SCI)
   ;Bits 3-8 = Reserved (not necessarily 0)
   PM1CIgnore      EQU 0200h ;This bit is ignored by Software
   PM1CSleepType   EQU 1C00h ;Sleep Type (Code for S0-S5 Sleep Modes)
                             ;  (Not necessarily 0-5, but probably are)
     PM1CSlpTypSft EQU   10  ;Alignment Shift value for Sleep Type
   PM1CSleepEnable EQU 2000h ;Sleep Enable (forces Sleep Type to take effect)
                             ;Must be issued at same time as Sleep Type change)
   ;Bits 14-15 = Reserved (0)

;  ;----------------------------------------------------------------------------
;  ;SMI Command Register Values (Needed to Enable ACPI)
;  ;----------------------------------------------------------------------------
;  EVEN 2
;
;  SMICmdIOAddr   DW ? ;I/O Address of SMI Command Registers
;  SMIACPIEnable  DB ? ;Value to write to SMI Command Register to Enable ACPI
;                      ;  (should not be done if OS owns the ACPI BIOS)
;  SMIACPIDisable DB ? ;Value to write to SMI Command Register to Disable ACPI
;                      ;  (Transitions from OS Ownership to ACPI Ownership)

  ;----------------------------------------------------------------------------
  ;Data associated with Laptop Embedded Controller ACPI Names
  ;----------------------------------------------------------------------------
;  ECOffset DW ? ;Offset in Data Buffer of Embedded Controller Name List
;  ECEnd    DW ? ;End of Embedded Controller Name List in Data Buffer


;==============================================================================
;APM Related
;==============================================================================

  ;----------------------------------------------------------------------------
  ;Data Gleaned from APM
  ;----------------------------------------------------------------------------
  APMVersion    DW  ? ;Major.Minor (BCD)
  APMACStatus   DB -1 ;AC Line Status
  APMBattStatus DB -1 ;Battery Status
  APMBattFlags  DB -1 ;Battery Flags
  APMBattPct    DB -1 ;Remaining Battery Life (Percent)
  APMBattTime   DW -1 ;Remaining Battery Life (Time)
  APMNumBatts   DW -1 ;Number of Batteries currently installed

  ;----------------------------------------------------------------------------
  ;APM Device Codes
  ;----------------------------------------------------------------------------
  APMSysBIOS   EQU 0000h ;System BIOS
  APMAllPMDvcs EQU 0001h ;All Power-Managed Devices
  APMBattery1  EQU 8001h ;Battery #1
  APMBattery2  EQU 8002h ;Battery #2
   ;... (up to 255 possible Batteries)

  ;----------------------------------------------------------------------------
  ;APM Function Codes for INT 15h
  ;Listed here are only the ones we use -- there are several others available
  ;   that are not listed here.
  ;----------------------------------------------------------------------------
  APMInstallCk   EQU 5300h ;APM Install Check
  APMConnect     EQU 5301h ;Connect to APM BIOS
  APMDisconnect  EQU 5304h ;Disconnect from APM BIOS
  APMPwrState    EQU 5307h ;Change Power State (Suspend, StandBy, Shutdown)
    APMStandby   EQU 0001h ;Standby
    APMSuspend   EQU 0002h ;Suspend
    APMOff       EQU 0003h ;Shutdown
  APMPwrManage   EQU 5308h ;Enable/Disable Power Management
    APMPMDisable EQU 0000h ;Disable Power Managment
    APMPMEnable  EQU 0001h ;Enable Power Managment
  APMGetPower    EQU 530Ah ;Get Power Status
  APMSetVer      EQU 530Eh ;Set Driver Version

  ;----------------------------------------------------------------------------
  ;APM AC Line Status Codes
  ;----------------------------------------------------------------------------
  APMACOffLine EQU 00h ;Off-Line
  APMACOnLine  EQU 01h ;On-Line
  APMACBackup  EQU 02h ;On Backup Power
  ;03h-FEh = Reserved
  APMACUnknown EQU -1  ;Unknown

  APMACTable:
    DB APMACOffLine
       DB 'Off-Line',0
    DB APMACOnLine
       DB 'On-Line',0
    DB APMACBackup              ;v1.1+
       DB 'On Backup Power',0
    DW -1 ;End of Table

  ;----------------------------------------------------------------------------
  ;APM Battery Status Codes
  ;----------------------------------------------------------------------------
  APMBStHigh     EQU 00h ;High
  APMBStLow      EQU 01h ;Low
  APMBStCritical EQU 02h ;Critical
  APMBStCharge   EQU 03h ;Charging
  ;04h-FEh = Reserved
  APMBStUnknown  EQU -1  ;Unknown

  APMBStTable:
    DB APMBStHigh
       DB 'High',0
    DB APMBStLow
       DB 'Low',0
    DB APMBStCritical
       DB 'Critical',0
    DB APMBStCharge
       DB 'Charging',0
    DW -1 ;End of Table

  ;----------------------------------------------------------------------------
  ;APM Battery Flags Codes (v1.1+)
  ;----------------------------------------------------------------------------
  APMBFlgHigh     EQU 01h ;High
  APMBFlgLow      EQU 02h ;Low
  APMBFlgCritical EQU 04h ;Critical
  APMBFlgCharge   EQU 08h ;Charging
  APMBFlgNotPres  EQU 10h ;Selected Battery Not Present
  ;Bits 5-6 = Reserved
  APMBFlgNoBatt   EQU 80h ;No System Battery
  ;All bits set (FFh) = Unknown

  APMBFlgTable:
    DB APMBFlgHigh
       DB 'High',0
    DB APMBFlgLow
       DB 'Low',0
    DB APMBFlgCritical
       DB 'Critical',0
    DB APMBFlgCharge
       DB 'Charging',0
    DB APMBFlgNotPres
       DB 'Battery Not Present',0
    ;Bit 5 = Reserved
    ;Bit 6 = Reserved
    DB APMBFlgNoBatt
       DB 'No System Battery',0

  ;----------------------------------------------------------------------------
  ;APM Battery Remaining Codes (v1.1+)
  ;----------------------------------------------------------------------------
  APMBRemUnits     EQU 8000h ;Units (Seconds or Minutes)
    APMBRemSeconds EQU 0000h ;Seconds
    APMBRemMinutes EQU 8000h ;Minutes
  APMBRemValue     EQU 7FFFh ;Actual Value in bits 0-14
  ;All bits set (FFFFh) = Unknown


;==============================================================================
;Intel On-Demand Clock Modulation (ODCM) Related
;==============================================================================

  ;----------------------------------------------------------------------------
  ;Intel ODCM Throttling Register Values
  ;----------------------------------------------------------------------------
  EVEN 2
  ODCMNumStages DB  ?  ;0 if unsupported, else 8 or 16 (number of ODCM Stages)


;==============================================================================
;Help Screen Related
;==============================================================================

  ;----------------------------------------------------------------------------
  ;Data needed if the User has changed the name of the program from VENDOIRD
  ;----------------------------------------------------------------------------
  RealName:
    DB 'SLOWACPI',0 ;Real name of our program (MUST end in 0)
                    ;  & MUST have enough space for 8-char name
  RealNameSz DW 8   ;Size of RealName (not incl 0)


;==============================================================================
;ErrorLevel Related
;==============================================================================

  ;----------------------------------------------------------------------------
  ;ErrorLevels, and Table for ErrorLevel Description Strings
  ;----------------------------------------------------------------------------
  ErLvlOption  EQU 1 ;Bad Option on the command line
  ErLvlDOSVer  EQU 2 ;DOS Version too old
  ErLvlNo386   EQU 3 ;Not a 386+ CPU
  ErLvlDPMI    EQU 4 ;Running under DPMI
  ErLvlNoACPI  EQU 5 ;APM or ACPI is not installed
  ErLvlNoInt15 EQU 6 ;Unable to Use BIOS Int 15h to transfer data
  ErLvlNoDuty  EQU 7 ;ACPI does not support CPU Duty Cycle Throttling

  ErrLvlHdr:
    DB  CR,LF
    DB '                         ERRORLEVELS (DOS RETURN CODES)',CR,LF
    DB '  ',CR,LF
    DB '   0 No Error.',CR,LF
    DB 0

  ErrLvlTbl:
    DB ErLvlOption
       DB "Bad Command-line Option.",0
    DB ErLvlDOSVer
       DOSVerMsg:
       DB "DOS must be at least version 3.00.",0
    DB ErLvlNo386
       No386Msg:
       DB "This program requires at least an 80386 CPU.",0
;    DB ErLvlDPMI
;       DPMIMsg:
;       DB 'This program will not run in a DPMI environment (like Windows)',0
    DB ErLvlNoACPI
       NoACPIMsg:
       DB 'This program requires APM (Advanced Power Management), ',CR,LF
       DB '  ACPI (Advanced Configuration & Power Interface), or ',CR,LF
       DB '  ODCM (On-Demand Clock Modulation) on the computer.',0
    DB ErLvlNoInt15
       NoInt15Msg:
       DB "Unable to access ACPI data.",0
    DB ErLvlNoDuty
       NoDutyMsg:
       DB "The ACPI BIOS in this computer does not support CPU Duty-Cycle Throttling.",0
    DB -1,-1 ;End of Table


;==============================================================================
;Command-line (Parsing) Related
;==============================================================================

  ;----------------------------------------------------------------------------
  ;Data needed to Parse the command line for Options
  ;----------------------------------------------------------------------------
  ParseTest  DB Yes ;Testing the command for errors?
  ParseError DB  No ;Error while Parsing Command Line?

  ;----------------------------------------------------------------------------
  ;Various Parsing-related messages we may need to print to the screen
  ;----------------------------------------------------------------------------
  ParseCmdMsg:
    DB 'Error in the command-line Options for SLOWACPI:',CR,LF,0
  ParseEnvMsg:
    DB 'Error in the Environment variable "SLOWACPI":',CR,LF,0
  ParseErrMsg:
    DB '^ Error',CR,LF,LF,0
  ParseEnvMsg2:
    DB 'Reset the Environment variable (type "SET SLOWACPI=") and then',CR,LF
  ParseErrMsg2:
    DB 'Type "SLOWACPI ?" for Help.',0

  EnvMsg:
    DB 'Environment: ',0
  NoEnvironMsg:
    DB 'There is no DOS Environment.',CR,LF
    DB 'There is something WEIRD going on here!',0

  ;----------------------------------------------------------------------------
  ;Strings needed to write the Command-line error message
  ;----------------------------------------------------------------------------
  MoreLeftMsg:   DB '<<-More}  ',0
  MoreRightMsg:  DB '  {More->>',0
  MoreMsgSize   EQU $-MoreRightMsg

  ;----------------------------------------------------------------------------
  ;Command Line Options with no single-character equivalents
  ;These must be in the same numerical order that we want the
  ;  Alias Option to Sort them in!
  ;----------------------------------------------------------------------------
;  OptionAll        EQU 1 ;Do All Vendors
;  OptionPCI        EQU 2 ;Do PCI (as opposed to USB)
;  OptionUSB        EQU 3 ;Do USB (as opposed to PCI)

  ;----------------------------------------------------------------------------
  ;Command Line Options
  ;----------------------------------------------------------------------------
  SwitchList:
    DB 'Help',0
    DB  0, '?'
      ; ^              Beginning-of-List Marker
      ;    ^   ^        Code(s) to use

    DB 'WriteAllEmbeddedControllerData',0
    DB 'WriteAllECData',0
    DB 'WriteAllData',0
    DB 'WriteAllControllerData',0
    DB  0, 'L'

    DB 'WriteEmbeddedControllerDataChanges',0
    DB 'WriteECDataChanges',0
    DB 'WriteDataChanges',0
    DB 'WriteControllerDataChanges',0
    DB  0, 'C'

    DB 'OptionAliases',0
    DB 'OptionAlias',0
    DB  0, 'A'

    DB 'OnDemandClockModulation',0
    DB  0, 'O'

    DB 'ODCM',0
    DB  0, 'O'

    DB 'MonitorEmbeddedControllerData',0
    DB 'MonitorECData',0
    DB 'MonitorData',0
    DB 'MonitorControllerData',0
    DB  0, 'C'

    DB 'Hlp',0
    DB  0, '?'

    DB 'H',0
    DB  0, '?'

    DB 'ErrorLvlTbl',0
    DB 'ErrorLvlTable',0
    DB 'ErrorLvls',0
    DB 'ErrorLvl',0
    DB 'ErrorLevelTbl',0
    DB 'ErrorLevelTable',0
    DB 'ErrorLevels',0
    DB 'ErrorLevel',0
    DB  0, 'E'

    DB 'ErrLvlTbl',0
    DB 'ErrLvlTable',0
    DB 'ErrLvls',0
    DB 'ErrLvl',0
    DB 'ErrLevelTbl',0
    DB 'ErrLevelTable',0
    DB 'ErrLevels',0
    DB 'ErrLevel',0
    DB  0, 'E'

    DB 'ErLvlTbl',0
    DB 'ErLvlTable',0
    DB 'ErLvls',0
    DB 'ErLvl',0
    DB 'ErLevelTbl',0
    DB 'ErLevelTable',0
    DB 'ErLevels',0
    DB 'ErLevel',0
    DB  0, 'E'

    DB 'Dly',0
    DB  0, 'D'

    DB 'DiskFlushDly',0
    DB 'DiskFlushDelay',0
    DB  0, 'D'

    DB 'DiskDly',0
    DB 'DiskDelay',0
    DB  0, 'D'

    DB 'DiskCacheDly',0
    DB 'DiskCacheDelay',0
    DB  0, 'D'

    DB 'DiskBufferDly',0
    DB 'DiskBufferDelay',0
    DB  0, 'D'

    DB 'Delay',0
    DB  0, 'D'

    DB 'CommandLineAliases',0
    DB 'CommandLineAlias',0
    DB  0, 'A'

    DB 'CmdLineAliases',0
    DB 'CmdLineAlias',0
    DB  0, 'A'

    DB 'CacheDly',0
    DB 'CacheDelay',0
    DB  0, 'D'

    DB 'AllEmbeddedControllerData',0
    DB 'AllECData',0
    DB 'AllData',0
    DB 'AllControllerData',0
    DB  0, 'L'

    DB 'EmbeddedControllerDataChanges',0
    DB 'ECDataChanges',0
    DB 'DataChanges',0
    DB 'ControllerDataChanges',0
    DB  0, 'C'

    DB 'Aliases',0
    DB 'Alias',0
    DB  0, 'A'

    DB 0 ;End of list


  ;----------------------------------------------------------------------------
  ;Switches for Yes/No Options
  ;----------------------------------------------------------------------------
  SwitchListYesNo:
    DB 'Yes',0
    DB  0, 'Y'

    DB 'True',0
    DB 'T',0
    DB  0, 'Y'

    DB 'On',0
    DB  0, 'Y'

    DB 'Off',0
    DB  0, 'N'

    DB 'No',0
    DB  0, 'N'

    DB 'False',0
    DB 'F',0
    DB  0, 'N'

    DB 'Enabled',0
    DB 'Enable',0
    DB  0, 'Y'

    DB 'Disabled',0
    DB 'Disable',0
    DB  0, 'N'

    DB '1',0
    DB  0, 'Y'

    DB '0',0
    DB  0, 'N'

    DB  0 ;End of list


  ;----------------------------------------------------------------------------
  ;TABLE OF SUBROUTINE OFFSETS TO PROCESS THE VARIOUS COMMAND LINE OPTIONS
  ;----------------------------------------------------------------------------
  SwitchTbl:
    DB  '?'
       DW DoSwitchH    ;Help
    DB  'A'
       DW DoSwitchA    ;Command Line Aliases
    DB  'C'
       DW DoSwitchC    ;Monitor/Write Changes in Embedded Controller Data
    DB  'D'
       DW DoSwitchD    ;Disk Flush Delay
    DB  'E'
       DW DoSwitchE    ;ErrorLevel Table
    DB  'L'
       DW DoSwitchL    ;Write All Embedded Controller Data
    DB  'O'
       DW DoSwitchO    ;Use On-Demand Clock Modulation

    DB  0              ;End of Table

  ;----------------------------------------------------------------------------
  ;TABLE TO BE ABLE TO PRINT ALIASES FOR SwitchListYesNo
  ;----------------------------------------------------------------------------
  SwitchTblYesNo:
    DB 'N'  ;No
      DW -1
    DB 'Y'  ;Yes
      DW -1

    DB 0


;
;CODE
;

;------------------------------------------------------------------------------
;DO THE PROGRAM THING!
;Inputs:
;Outputs: Lots of Stuff
;Changes: Everything
;------------------------------------------------------------------------------
Main:
  CLD                    ;Go forward with string functions
  MOV  SP,DataBuffer     ;Reset Stack Pointer
  CALL ResizeMemory      ;Resize our Memory Allocation
  CALL CopyNameToMCB     ;Copy our Program name to the MCB
  CALL SetupPauseNoHdr   ;Set up the Pause
;  CALL TestParentShell   ;See if our Parent is a DOS Command Shell
;  JNZ .M10               ;If not, don't write the Copyright
  MOV  DX,Copyright      ;If so, write the
;  CALL WriteItDX         ;  Copyright message
  CALL WriteZPause       ;  Copyright message
.M10:                    ;Copyright written, if appropriate
  CALL GetRealName       ;Get the Real Program Name
  CALL GetEnvVars        ;Get the Environment Variable Pointers
  CALL ParseIt           ;Parse the command line
  CALL DoHelp            ;Print Help and Quit, if necessary
  CALL DoAliases         ;Print Aliases and Quit, if necessary
  CALL DoErrLvls         ;Print ErrorLevel Table and Quit, if necessary
  CALL TestCompatibility ;Test for compatibility, quit if Error
  CALL CalcBasePhysAddr  ;Calculate our base physical memory address
  CALL StopIt            ;Turn off the computer, if it was requested
  CALL SlowItODCM        ;Slow the Computer Down w/ ODCM, if Requested
  JNC .M20               ;If it worked, continue
  CALL SlowItACPI        ;Slow the Computer Down w/ ACPI, if Requested
.M20:                    ;
  CALL DoStatus          ;Write the Status
  CALL WriteAllECData    ;Write the Embedded Controller Data, if Requested
  CALL WriteChgECData    ;Monitor/Write changes in Embedded Controller Data
  MOV  DX,NoMsg          ;Write nothing
  XOR  AL,AL             ;AL = ErrorLevel = 0
.M90:                    ;Done with Main

;------------------------------------------------------------------------------
;PRINT MESSAGE IN DX AND QUIT WITH ERRORLEVEL IN AL
;Inputs:  AL = Errorlevel to exit program with
;         DS:[DX] = Message to Print (to ERR)
;Outputs:
;Changes: Quits program
;------------------------------------------------------------------------------
Exit:
  OR   AL,AL        ;Was there an Error?
  JZ  .X80          ;If not, jump to handle a normal termination
  CALL BeepErr      ;If error, Beep Once
  CALL WriteZErr    ;Write message to ERR
  MOV  DX,CrLfMsg   ;Write a
  CALL WriteCrLfErr ;  new line
  JMP .X90          ;Jump to quit
.X80:               ;No Error - Write to CON
;  CALL WriteItDX    ;Write the message to CON
  CALL WriteZPause  ;Write the message to CON
.X90:               ;We're done!!
  MOV  AH,4Ch       ;Service 4Ch (terminate program)
  INT  21h          ;Do it

ExitDot:
  CALL WriteZErr    ;Write the Error Message
  MOV  DX,DotMsg    ;Point at the Dot Message
  JMP  Exit         ;Quit


;------------------------------------------------------------------------------
;MAKE SURE THE MCB (MEMORY CONTROL BLOCK) CONTAINS OUR PROGRAM NAME
;Inputs:  DS = Local Data Segment
;         DS:RealName = ASCIIZ Real Name of our program
;         CLD Already Issued
;Outputs:
;Changes: Data in MCB
;NOTES:   This makes sure that the MCB (Memory Control Block) for our
;           program contains our program name.  DOS 4+ does this
;           automatically, but DOS versions 1-3 do not.  This code
;           does not verify whihc DOS version is in use, but simply
;           fills in the MCB no matter what.
;         Our program name is needed inthe MCB to make sure other programs
;           can identify that we are installed in memory.  This code should
;           be added to all TSR's, so that memory-mapping programs
;           (like MAPMEM or ISLOADED) can tell which TSR's are installed
;           in memory.  It should also be added to all programs that
;           EXEC other programs, so that the EXEC'd program can figure out
;           who called it.
;         Programs that are not TSR's and do not EXEC other programs
;           do not need this code.
;------------------------------------------------------------------------------
CopyNameToMCB:
  PUSH CX,DI,SI,ES     ;Save used registers
  MOV  CX,DS           ;Point ES:[DI]
  DEC  CX              ;  at the Owners Name
  MOV  ES,CX           ;  in the MCB
  MOV  DI,MCBOwnerName ;  of our program
  MOV  SI,RealName     ;Point DS:[SI] at our Program Name
  MOV  CX,4            ;Copy 4 words (8 bytes)

  REP  MOVSW           ;Copy our program name to the MCB
  POP  ES,SI,DI,CX     ;Restore used registers
  RET


;
;CODE TO DETERMINE WHO OUR PARENT PROGRAM IS
;

;;------------------------------------------------------------------------------
;;COPY THE CAPITALIZED NAME OF OUR PARENT PROGRAM TO A LOCAL STRING (PARENTNAME)
;;Inputs:  [ParentIsShell] = No
;;Outputs: [ParentIsShell] = Yes if Parent Program has a Shell Name
;;                           ZF = Set
;;                         = No if Parent Program does not have a Shell Name
;;                           ZF = Clear
;;Changes:
;;------------------------------------------------------------------------------
;TestParentShell:
;  PUSH AX,BX,DI,SI         ;Save used registers
;  CALL GetParentNameCaps   ;Get our Parents Capitalized Name
;  JZ  .S80                 ;If invalid, assume we're at a command-line
;  MOV  SI,DOSShellTbl      ;Point at our table of Shell Names
;.S10:                      ;Loop to here for each table entry
;  MOV  DI,ParentName       ;Point DI at our Parents Name
;  MOV  BX,SI               ;Save the current table pointer
;  CMP  B [BX],0            ;End of the Table?
;  JE  .S90                 ;If so, it's not a Command Shell
;.S20:                      ;Loop to here for each character in the string
;  MOV  AL,[BX]             ;Get the next table character
;  OR   AL,AL               ;End of the table string?
;  JZ  .S40                 ;If so, handle it
;.S30:                      ;Not end of table string
;  CMP  AL,[DI]             ;Does the character match?
;  JNE .S60                 ;If not, try the next table entry
;  INC  BX                  ;If so, increment
;  INC  DI                  ;  our Pointers
;  JMP .S20                 ;and keep testing
;.S40:                      ;End of our table string
;  CMP  B [DI],0            ;End of the Parents Name string?
;  JE  .S80                 ;If so, it's a match
;.S60:                      ;Not a match
;  CALL SkipOverStringSI    ;Point at the next table entry
;  JMP .S10                 ;Keep going until we're done
;.S80:                      ;Is a Command Shell
;  MOV  [ParentIsShell],Yes ;Store the result for later
;.S90:                      ;Done
;  CMP  [ParentIsShell],Yes ;Set the return flag
;  POP  SI,DI,BX,AX         ;Restore used registers
;  RET

;;------------------------------------------------------------------------------
;;COPY THE CAPITALIZED NAME OF OUR PARENT PROGRAM TO A LOCAL STRING (PARENTNAME)
;;Inputs:  ES = Local Data Segment
;;         CLD already issued
;;Outputs: ParentName
;;         ZF = Clear if ParentName is valid (greater than 0 length)
;;            = Set if Invalid (0-length, such as under the DOSBox program)
;;Changes:
;;------------------------------------------------------------------------------
;GetParentNameCaps:
;  PUSH AX,CX,DI,SI,DS         ;Save used registers
;  MOV  AX,[PSPParentPSP]      ;Point DS at
;  DEC  AX                     ;  the MCB of our
;  MOV  DS,AX                  ;  Parents PSP
;  MOV  SI,OFFSET MCBOwnerName ;Point DS:[SI] at the Owners name
;  MOV  DI,ParentName          ;Point ES:[DI] at our storage area
;  MOV  CX,8                   ;Copy 8 bytes
;.P10:                         ;Loop to here for each character
;  LODSB                       ;Get the next byte
;  CALL Capitalize             ;Capitalize it
;  STOSB                       ;Store it
;  LOOP .P10                   ;Keep going until we're done
;  CMP  B ES:ParentName[0],0   ;Set return flag
;  POP  DS,SI,DI,CX,AX         ;Restore used registers
;  RET


;
;CODE TO TEST THE COMPUTER FOR MINIMUM COMPATIBILITY (DOS VERSION, ETC)
;

;------------------------------------------------------------------------------
;TEST THE COMPUTER TO SEE IF IT'S COMPATIBLE (CPU, DOS VERSION, WHATEVER)
;Inputs:  InMemory
;Outputs: Quits the program if Computer is Incompatible
;         Returns if Computer is OK
;         Stores all kinds of values in memory variables
;Changes:
;------------------------------------------------------------------------------
TestCompatibility:
  PUSH AX,BX,CX,DX     ;Save used registers
  MOV  AL,ErLvlDOSVer  ;Assume incorrect
  MOV  DX,DOSVerMsg    ;  DOS Version
  CALL TestDOSVer      ;  new enough?
  JC  .C70             ;If not, error
  MOV  AL,ErLvlNo386   ;Assume CPU is
  MOV  DX,No386Msg     ;  not 386+
  CALL Test80386       ;Is the CPU at least an 80386?
  JC  .C70             ;If not, error
;  MOV  AL,ErLvlDPMI    ;Assume we're running
;  MOV  DX,DPMIMsg      ;  under DPMI
;  CALL TestDPMI        ;Are we running under DPMI?
;  JNC .C70             ;If so, error
  MOV  AL,ErLvlNoACPI  ;Assume neither APM nor ACPI
  MOV  DX,NoACPIMsg    ;  is not installed

  CMP  B [DutyToSet],0 ;Will we be attempting to shut down?
  JE  .C10             ;If so, no need to check ODCM
  CALL TestODCM        ;Test for On-Demand Clock Modulation
.C10:

  PUSHF                ;Save the
  POP  CX              ;  return flag
  CALL TestAPM         ;Is APM installed?
  PUSHF                ;Save the
  POP  BX              ;  Return flag
  CALL TestACPI        ;Is ACPI installed?
  JNZ .C90             ;If so, we're done
.C20:                  ;No ACPI, test APM
  TEST BL,CarryFlag    ;Is APM installed?
  JZ  .C90             ;If so, we're done
.C30:                  ;No APM, test ODCM
  TEST CL,CarryFlag    ;Is ODCM installed?
  JZ  .C90             ;If so, we're done
.C70:                  ;The computer is incompatible for some reason
  JMP  ExitDot         ;Quit!
.C90:                  ;The computer is compatible!
  POP  DX,CX,BX,AX     ;Restore used registers
  RET

;------------------------------------------------------------------------------
;TEST THE CURRENT DOS VERSION
;Inputs:  MinDOSVer (EQUate)
;Outputs: CF = Clear if DOS version >= MinDOSVer
;         CF = Set if DOS version < MinDOSVer
;Changes:
;------------------------------------------------------------------------------
TestDOSVer:
  PUSH AX,BX,CX     ;Save used registers
  MOV  AX,3000h     ;Service 30h (get DOS version number)
                    ;  DOS 5.0 requires AL = 00h, may change BX and CX
  INT  21h          ;Do it (Returns AL= Major, AH = Minor)
  XCHG AL,AH        ;Swap Major and Minor versions for testing
  CMP  AX,MinDOSVer ;Is the version new enough?
  JAE .D80          ;If so, it's OK
.D70:               ;DOS is older than the minimum
  STC               ;Set the "too old" flag
  JMP .D90          ;We're done
.D80:               ;DOS is >= the minimum
  CLC               ;Set the OK flag
.D90:               ;We're done
  POP  CX,BX,AX     ;Restore used registers
  RET

;------------------------------------------------------------------------------
;TEST AND SEE IF THE CPU IS AN 80386+ (CAN HANDLE 32-BIT INSTRUCTIONS)
;Inputs:
;Outputs: CF = Clear if the CPU is an 80386+
;            = Set if CPU is not an 80286-
;Changes:
;------------------------------------------------------------------------------
Test80386:
  PUSH AX,BX ;Save used registers
  PUSHF      ;Save flags
  MOV  AX,(NestedFlag+IOPLMask+IntFlag+2)
             ;AX = Flags mask for testing (Bits 12-14 + STI + Bit 1)
             ;  8086 always sets bits 12-15
             ;  80286 always clears bits 12-15
             ;  80386+ never sets bit 15
  PUSH AX    ;Store it
  POPF       ;  as the FLAGS
  PUSHF      ;Retrieve
  POP  BX    ;  the Flags
  CMP  AX,BX ;Is it an 80386+?
  JE  .E80   ;If so, handle it
.E70:        ;It's not an 80386
  POPF       ;Restore flags
  STC        ;Set the not 80386 flag
  JMP .E90   ;We're done
.E80:        ;It is an 80386
  POPF       ;Restore flags
  CLC        ;Set the 80386 flag
.E90:        ;We're done
  POP  BX,AX ;Restore used registers
  RET

;------------------------------------------------------------------------------
;TEST AND SEE IF THE CPU IS AN 80486+
;Inputs:
;Outputs: CF = Clear if the CPU is an 80486+
;            = Set if 80386-
;Changes:
;NOTE: CPU's previous to the 80486 (80386-) do not support Alignment Checking.
;------------------------------------------------------------------------------
Test80486:
  CALL Test80386     ;Is it at least an 80386?
  JC  .E95           ;If not, it can't be an 80486, either
  PUSH EAX,EBX       ;Save used registers
  PUSH CX            ;Save used registers
  MOV  CX,SP         ;Save the current stack pointer
  PUSHFD             ;Save extended flags
  AND  SP,~3         ;Align Stack Pointer at 32-bits, to avoid Alignment Fault
  PUSHFD             ;Put current EFLAGS
  POP  EAX           ;  in EAX
  MOV  EBX,EAX       ;Save EAX in EBX
  XOR  EAX,AlignFlag ;Try to change
  PUSH EAX           ;  the
  POPFD              ;  Alignment Flag
  PUSHFD             ;Put current EFLAGS
  POP  EAX           ;  in EAX
  CMP  EAX,EBX       ;Did the Alignment Flag change?
  JNE .E80           ;If so, it's an 80486
.E70:                ;It's not an 80486
  POPFD              ;Restore extended flags
  STC                ;Set return flag
  JMP .E90           ;We're done
.E80:                ;It is an 80486
  POPFD              ;Restore extended flags
  CLC                ;Set return flag
.E90:                ;Done
  MOV  SP,CX         ;Restore stack pointer
  POP  CX            ;Restore used registers
  POP  EBX,EAX       ;Restore used registers
.E95:                ;Done
  RET

;------------------------------------------------------------------------------
;TEST AND SEE IF THE CPU SUPPORTS THE CPUID INSTRUCTION
;Inputs:
;Outputs: CF = Clear if the CPU supports CPUID
;            = Set if not
;Changes:
;NOTES: The CPUID instruction was supported on later model 80486's, and
;         all Pentium-class CPU's.  Early model 80486's and all CPU's previous
;         to the 80486 (80386-) do not support CPUID.
;------------------------------------------------------------------------------
TestCPUID:
  PUSH EAX,EBX,ECX     ;Save used registers
  CALL Test80486       ;At least and 80486 CPU?
  JC  .I70             ;If not, error
  MOV ECX,CPUIDTglFlag ;ECX = BIt mask to use
  PUSHFD               ;EAX =
  POP  EAX             ;  Current Flags
  MOV  EBX,EAX         ;EBX =
  AND  EBX,ECX         ;  old CPUID Toggle Flag
  XOR  EAX,ECX         ;Try to
  PUSH EAX             ;  toggle the
  POPFD                ;  CPUID Flag
  PUSHFD               ;EAX =
  POP  EAX             ;  new CPUID
  AND  EAX,ECX         ;  Toggle Flag
  CMP  EAX,EBX         ;Did the CPUID Toggle Flag change?
  JNE .I80             ;If so, CPUID is supported
.I70:                  ;CPUID instruction is not supported
  STC                  ;Set return flag
  JMP .I90             ;Done
.I80:                  ;CPUID instruction is supported
  CLC                  ;Set return flag
.I90:                  ;Done
  POP  ECX,EBX,EAX     ;Restore used registers
  RET

;------------------------------------------------------------------------------
;TEST TO SEE IF THE COMPUTER SUPPORTS ON-DEMAND CLOCK MODULATION
;Inputs:  DS = ES = Local Data Segment
;Outputs: CF = Clear if CPU supports ODCM
;              [ODCMNumStages] = 8 or 16
;            = Set if not
;              [ODCMNumStages] = 0
;NOTES: From the documentation I can find, Intel is the only manufacturer
;         that supports ODCM.  All other manufacturers (in particular, AMD)
;         only do clock (and voltage) adjustments automatically for
;         heat & noise control, and don't allow manual adjustments.
;       At least some virtual machines claim in their CPUID & MSR data
;         to support ODCM, but they actually don't.  So, in this code
;         we actually verify the claim before just assuming it's true.
;------------------------------------------------------------------------------
TestODCM:
  PUSH EAX,EBX,ECX,EDX,DI   ;Save used registers
  TEST B [ProgFlags],NoODCM ;Does user want us to do ODCM?
  JNZ .O70                  ;If not, just quit
  CALL TestIntel            ;Intel CPU (also testes CPUID instruction)?
  JC  .O70                  ;If not, quit
  MOV  EAX,CPUIDGetVendor   ;EAX =
  CPUID                     ;  Maximum CPUID Function
  MOV  DI,AX                ;Save the maximum CPUID Function
  MOV  EAX,CPUIDGetFeatures ;Assume Get Features Function is supported
  CMP  DI,AX                ;Is it supported?
  JB  .O70                  ;If not, error
  CPUID                     ;If so, get the Features
  TEST DL,CPUFtrDRDMSR      ;CPU supports RDMSR & WRMSR?
  JZ  .O70                  ;If not, error
  TEST EDX,CPUFtrDACPI      ;CPU supports Thermal Monitoring & Clock Control?
  JZ  .O70                  ;If not, error
  MOV  B [ODCMNumStages],8  ;ODCM appears to be supported
  CMP  DI,CPUIDGetThermal   ;CPUID possibly supports Thermal MSR extensions?
  JB  .O20                  ;If not, continue
  MOV  EAX,CPUIDGetThermal  ;If so,
  CPUID                     ;  get the Thermal Extensions
  TEST AL,CPUThermAECMD     ;Does the CPU support 16 levels of ODCM?
  JZ  .O20                  ;If not, continue
  MOV  B [ODCMNumStages],16 ;Number of Stages = 16
.O20:                       ;CPU appears to support ODCM -- need to verify
  MOV  ECX,MSRClkModulate   ;Get the
  RDMSR                     ;  Clock Modulation MSR
  OR   EDX,EDX              ;Valid value in EDX?
  JNZ .O70                  ;If not, error
  TEST EAX,~1Fh             ;Valid value in EDX?
  JNZ .O70                  ;If not, error
  MOV  BH,1Eh               ;BH = Test Value to use (87.5%)
  MOV  BL,AL                ;Save current value
  MOV  AL,BH                ;Set Clock Modulation
  WRMSR                     ;  to 87.5%
  XOR  AL,AL                ;Did
  RDMSR                     ;  it
  CMP  AL,BH                ;  work?
  JNE .O70                  ;If not, error
  MOV  AL,BL                ;If so,
  WRMSR                     ;  restore original setting
  JMP .O80                  ;Done
.O70:                       ;Error
  MOV  B [ODCMNumStages],0  ;Mark as unsupported
  STC                       ;Set return flag
  JMP .O90                  ;Done
.O80:                       ;OK
  CLC                       ;Set return flag
.O90:                       ;Done
  POP  DI,EDX,ECX,EBX,EAX   ;Restore used registers
  RET


;
;CODE TO PERFORM SLOW DOWNS / SHUTDOWNS
;

;------------------------------------------------------------------------------
;TURN OFF THE COMPUTER, IF REQUESTED
;Inputs:  DS = ES = Local Data Segment
;         [DutyToSet] (0 if Shutdown was requested)
;         [PM1aS5Value], [PM1bS5Value] (-1 if not supported)
;         [PM1aCtlIOAddr], [PM1bCtlIOAddr]
;Outputs: CF = Clear if OK (Shutdown request was issued)
;            = Set if Error (Unsupported, or not requested)
;Changes: Turns the Computer Off, if Requested and Supported
;NOTES: There are two ways to Flush Disk Caches: INT 21h Function 0D00h, and
;         simulating a Ctl-Alt-Del through the keyboard BIOS.
;       Unfortunately, we can't do the second one because we want to
;         turn the computer off, not reboot it.  While it is possible that
;         simulating a Ctl-Alt-Del will just flush the caches without
;         rebooting the computer, we can't take the chance that computer will
;         get rebooted before we can shut it down.
;       Therefore, we just issue a DOS Disk Reset call and wait a couple
;         of seconds, hoping all of the disks get flushed appropriately.
;       Most Disk Caches automatically flush things after a second or two
;         of "inactivity", and also flush the caches every time a DOS
;         command-line prompt appears.  If this program is being run
;         from a command-prompt (which it probably is), the only disk
;         activity that should have occured since the last DOS prompt
;         is the reading of this executable file (no writing), so we
;         should be OK.
;------------------------------------------------------------------------------
StopIt:
  PUSH AX,BX,DX             ;Save used registers
  CMP  B [DutyToSet],0      ;Are we supposed to shut down?
  JNE .P80                  ;If not, we're done
  CALL FlushIt              ;If so, Flush the Disk Buffers
  MOV  DX,StoppingMsg       ;Tell the user
;  CALL WriteItDX            ;  we're shutting down
  CALL WriteZPause            ;  we're shutting down
  CALL StopItAPM            ;Attempt to Shut Down using APM
  JNC .P50                  ;If it worked, we're done
;  CALL GetFACPData          ;Get the Fixed ACPI Description Table Data
;                            ;  (quits if error)
  CALL GetDSDTData          ;Get the Differentiated System Descr Table Data
                            ;  (quits if error)
  MOV  DX,[PM1aCtlIOAddr]   ;DX = PM1a Control Word I/O Address
  OR   DX,DX                ;Valid?
  JZ  .P50                  ;If not, don't do any I/O!
  MOV  BX,W [PM1aS5Value]   ;Get the Values to use
  SHL  BX,(PM1CSlpTypSft-8) ;If OK, shift bits over to the correct position
  OR   BX,(PM1CSleepEnable+(PM1CSleepEnable >> 8)) ;Mask in Sleep Enable
  IN   AX,DX                ;Get the current PM1a Control Word
  AND  AH,~(PM1CSleepType >> 8) ;Mask out the Old Sleep Type
  OR   AH,BL                ;Mask in the New Sleep Type & Sleep Enable
  OUT  DX,AX                ;Send it
  MOV  DX,[PM1bCtlIOAddr]   ;Get the current
  IN   AX,DX                ;  PM1b Control Word
  AND  AH,~(PM1CSleepType >> 8) ;Mask out the Old Sleep Type
  OR   AH,BH                ;Mask in the New Sleep Type & Sleep Enable
  OUT  DX,AX                ;Send it
.P50:                       ;Computer should be shut down
  MOV  AX,2000              ;Wait for
  CALL DelayMSAX            ;  2 seconds
                            ;If it worked, we won't go any farther
  MOV  DX,StopErrMsg        ;If it didn't shut down,
  CALL WriteZErr            ;  write the Error Message
  CALL WriteCrLfErr         ;Move down
.P55:                       ;Unable to Shut Down
  CLI                       ;Disable interrupts
  HLT                       ;Stop the computer
  HLT                       ;Stop the computer
  JMP .P55                  ;Keep HLTing

.P70:                       ;Error (can't Shut Down)
  STC                       ;Set return flag
  JMP .P90                  ;Done
.P80:                       ;OK (Didn't need to / Can't do anything)
  CLC                       ;Set return flag
.P90:                       ;Done
  POP  DX,BX,AX             ;Restore used registers
  RET

;------------------------------------------------------------------------------
;FLUSH THE DISK BUFFERS AND CACHES
;Inputs:  DS = ES = Local Data Segment
;         [FlushDelay]
;Outputs: Flushes Disk Caches & Buffers, waiting afterwards if necessary
;Changes:
;------------------------------------------------------------------------------
FlushIt:
  PUSH AX,CX,DX        ;Save used registers
  MOV  DX,FlushingMsg  ;Tell the user
;  CALL WriteItDX       ;  we're Flushing
  CALL WriteZPause     ;  we're Flushing
  MOV  CX,[FlushDelay] ;CX = Flush Delay
.F10:                  ;Flush the Disk Caches & Buffers
  MOV  AX,0D00h        ;Function 0Dh (Disk Reset - Flushes Disk Caches)
  INT  21h             ;Do it
  OR   CX,CX           ;Should we delay at all?
  JZ  .F90             ;If not, don't write any Delay Numbers
.F20:                  ;Loop to here for each second of Delay
  MOV  AL,CL           ;Write the
  CALL WriteByteMin    ;  seconds left
  CMP  AL,9            ;Did we just go from 2 digits to 1?
  JNE .F25             ;If not, continue
  CALL WriteSpace      ;If so, overwrite the second digit
.F25:                  ;Previous number is erased, if appropriate
  MOV  AL,CR           ;Go to the beginning
  CALL WriteAL         ;  of the line
  MOV  AX,1000         ;Wait for
  CALL DelayMSAX       ;  one second
  LOOP .F20            ;Keep waiting until we're done
  MOV  AL,CR           ;Write
  CALL WriteAL         ;  the zero
  XOR  AL,AL           ;  seconds
  CALL WriteByteMin    ;  left
.F90:                  ;Done
  CALL WriteCrLfPause  ;Move down
  POP  DX,CX,AX        ;Restore used registers
  RET

;------------------------------------------------------------------------------
;SLOW THE CPU DOWN TO A SPECIFIED LEVEL, IF REQUESTED, USING ACPI
;Inputs:  DS = ES = Local Data Segment
;         [ThtDutyWidth] (0 if Duty Cycle Throttling is not supported)
;         [ThtDutyOffset]
;         [ThtValueMask]
;         [ThtIOAddr]
;         [ThtMaxValue]
;         [DutyToSet] = Duty Cycle Setting to Use
;                   1 = Minimum Speed (Maximum Throttle)
;               Max-1 = Almost Maximum (which is max depends on Settings)
;               Max   = Full Speed (No Throttle)
;                  -1 = Don't change it
;Outputs: CF = Clear if it worked
;            = Set if Error, or no Throttling was requested
;Changes: CPU Duty Cycle, if Requested and Supported
;------------------------------------------------------------------------------
SlowItACPI:
  PUSH AX,BX,CX,DX        ;Save used registers
  MOV  CH,[DutyToSet]     ;Get the new Value
  CMP  CH,-1              ;Do we need to change anything?
  JE  .S80                ;If not, we're done
;  CALL GetFACPData        ;Get the Fixed ACPI Description Table Data
;                          ;  (quits if error)
  CALL GetDSDTData        ;Get the Differentiated System Descr Table Data
                          ;  (quits if error)
  CMP  B [ThtDutyWidth],0 ;Can we change the Duty Cycle?
  JE  .S70                ;If not, error
  MOV  DX,[ThtIOAddr]     ;DX = I/O Address to use
  OR   DX,DX              ;Valid I/O Address?
  JZ  .S70                ;If not, error
  IN   AX,DX              ;Get current value
  AND  AX,~ThtEnableBit   ;Disable Throttling
  OUT  DX,AX              ;Do it
  CMP  CH,[ThtMaxValue]   ;Should we be running at full speed?
  JAE .S90                ;If so, we're done
  MOV  BX,[ThtValueMask]  ;Mask out
  NOT  BX                 ;  the current
  AND  AX,BX              ;  throttle setting
  XOR  BX,BX              ;Put New Throttle Value
  MOV  BL,CH              ;  in BX
  MOV  CL,[ThtDutyOffset] ;Put it in the
  SHL  BX,CL              ;  correct bit position
  OR   AX,BX              ;Send
  OUT  DX,AX              ;  it
  OR   AL,ThtEnableBit    ;Enable
  OUT  DX,AX              ;  it
  JMP .S80                ;Done
.S70:                     ;Error (can't set Duty Cycle)
  STC                     ;Set return flag
  JMP .S90                ;Done
.S80:                     ;OK (Changed Duty Cycle, or it wasn't requested)
  CLC                     ;Set return flag
.S90:                     ;Done
  POP  DX,CX,BX,AX        ;Restore used registers
  RET

;------------------------------------------------------------------------------
;SLOW THE CPU DOWN TO A SPECIFIED LEVEL, IF REQUESTED, USING ODCM
;Inputs:  DS = ES = Local Data Segment
;         [ODCMNumStages] (0 if ODCM is not supported)
;         [DutyToSet] = Duty Cycle Setting to Use
;                   1 = Minimum Speed (Maximum Throttle)
;               Max-1 = Almost Maximum (which is max depends on Settings)
;               Max   = Full Speed (No Throttle)
;                  -1 = Don't change it
;Outputs: CF = Clear if it worked or no change was requested
;            = Set if Error, or no Throttling was requested
;Changes: CPU Duty Cycle, if Requested and Supported
;------------------------------------------------------------------------------
SlowItODCM:
  PUSH EAX,BX,ECX,EDX     ;Save used registers


;jmp >C70


  MOV  BH,[DutyToSet]     ;BH = New Throttle Value
  MOV  BL,[ODCMNumStages] ;BL = Number of Possible Stages
  CMP  BH,-1              ;Did the user request a change?
  JE  .C80                ;If not, we're done
  OR   BL,BL              ;Can we even change the Duty Cycle?
  JZ  .C70                ;If not, error
  MOV  ECX,MSRClkModulate ;Get the
  RDMSR                   ;  Clock Modulation MSR
.C10:                     ;Test Full Speed
  MOV  AL,02h             ;Assume Full Speed (100%)
  CMP  BH,BL              ;Do we want Full Speed?
  JAE .C50                ;If so, continue
.C15:                     ;Not Full Speed
  CMP  BL,8               ;Can we do 16 Stages?
  JNE .C25                ;If so, jump to handle it
  SHL  BH,1               ;If not, adjust the value (can't set Bit 0)
.C25:                     ;BH contains correct Duty Cycle Value
  MOV  AL,BH              ;AL = Duty Cycle value to use
  OR   AL,10h             ;Set Enable bit
.C50:                     ;Ready to issue WRMSR command
  WRMSR                   ;Tell the CPU to change the Duty Cycle
  JMP .C80                ;Done
.C70:                     ;Error (can't set Duty Cycle)
  STC                     ;Set return flag
  JMP .C90                ;Done
.C80:                     ;OK (Changed Duty Cycle, or it wasn't requested)
  CLC                     ;Set return flag
.C90:                     ;Done
  POP  EDX,ECX,BX,EAX     ;Restore used registers
  RET


;
;CODE TO PROCESS ACPI RELATED FUNCTIONS
;

;------------------------------------------------------------------------------
;TEST AND SEE IF AN ACPI BIOS IS INSTALLED ON THIS COMPUTER
;Inputs:   DS = Local Data Segment
;          [RSDTPhysAddr] = 0
;          CLD already issued
;Outputs: ZF = Clear if OK
;              [RSDTPhysAddr] is filled in
;            = Set if Error
;              [RSDTPhysAddr] unchanged
;Changes:
;NOTES: Technically, we only need to search three areas of memory for the
;         ACPI BIOS Header: The first kB of the XBDA, the last kB of
;         conventional memory, and the Read-Only DBA between E000:0000 and
;         F000:FFE0.  We search all of memory instead, to make the code
;         smaller, and because sometimes the location of the XBDA is
;         unknown (like under some versions of Windows).
;------------------------------------------------------------------------------
TestACPI:
  PUSH EAX,BX,CX,DX,DI,SI,ES ;Save used registers
  MOV  DX,DI                 ;Save original DI
  XOR  AX,AX                 ;Start ES at the
  MOV  ES,AX                 ;  beginning of memory
.A10:                        ;Loop to here for each possible Segment
  MOV  SI,RSDPHdrString      ;DS:[SI] = String to look for
  XOR  DI,DI                 ;ES:[DI] = Where to look
  MOV  CX,(RSDPHdrStrSize/4) ;CX = Number of DWords to test
  REPE CMPSD                 ;Test the string
  JNZ .A50                   ;If no match, this isn't it
.A20:                        ;Header matches
  XOR  DI,DI                 ;Start at Beginning of Header
  XOR  AL,AL                 ;Start CheckSum test at 0
  MOV  CX,RSDPHdrSize        ;CX = Number of Bytes to CheckSum
.A30:                        ;Loop to here to get each byte of the Header
  ADD  AL,[ES:DI]            ;Add the byte value to the checksum
  INC  DI                    ;Point at the next byte
  LOOP .A30                  ;Keep going until we've got the Whole Header
  OR   AL,AL                 ;Is the CheckSum 0?
  JE  .A80                   ;If so, we've found it
.A50:                        ;This isn't the ACPI Header
  MOV  AX,ES                 ;Increment the
  INC  AX                    ;  Segment
  JZ  .A90                   ;If we've tested all memory, error
  MOV  ES,AX                 ;If OK, store the Segment
  JMP .A10                   ;Keep looking
.A80:                        ;OK (ACPI BIOS Found)
  MOV  EAX,[ES:RSDPRSDTAddr] ;Store the Physical Address of the
  MOV  [RSDTPhysAddr],EAX    ;  Root System Description Table
.A90:                        ;Done
  CMP  D [RSDTPhysAddr],0    ;Set return flag
  POP  ES,SI,DI,DX,CX,BX,EAX ;Restore used registers
  RET

;------------------------------------------------------------------------------
;GET THE DATA WE NEED FROM THE FIXED ACPI DESCRIPTION TABLE
;Inputs:  CS = DS = Local Data Segment
;         ES = Buffer Data Segment
;         [RSDTPhysAddr]
;Outputs: If OK, fills in various registers with Data
;         If Error, quits program
;Changes: Contents of DataBuffer
;------------------------------------------------------------------------------
GetFACPData:
  PUSH EAX,CX,DX,DI,SI              ;Save used registers
  CALL ClearDataBuffer              ;Fill Buffer with Zeroes
  MOV  EAX,[RSDTPhysAddr]           ;EAX = Physical Address to Copy
  MOV  DI,DataBuffer                ;ES:[DI] = Our Data Buffer
  MOV  CX,5                         ;Copy 5 words (Signature, Length, and Rev)
  CALL CopyFromPhysMem              ;Do it
  JC  .R70                          ;If error, quit
  CMP  D [ES:DI+ATHSignature],ATHSigRSDT ;If OK, does the signature match?
  JNE .R70                          ;If not, error
  MOV  CL,[ES:DI+ATHRevision]       ;If so, store the
  MOV  [ACPIRevision],CL            ;  ACPI Revision Number
  MOV  CX,W [ES:DI+ATHLength]       ;CX = Number of
  SUB  CX,RSDTPhysAddr1             ;  Table Pointer Words
  SHR  CX,1                         ;  to get
  ADD  EAX,ACPITblHdrSize           ;[EAX] = Table Pointers
  CALL CopyFromPhysMem              ;Get the Table Pointers
  JC  .R70                          ;If error, quit
  SHR  CX,1                         ;If OK, CX = Number of Table Ptr to test
  CMP  CX,8                         ;Were there more than 8 Table pointers?
  JBE .R10                          ;If not, it's OK
  MOV  CX,8                         ;If so, just get 8 (FACP is likely first)
.R10:                               ;CX contains Number of Table to get
  MOV  DX,CX                        ;Put number of Table Pointers in DX
  MOV  CX,4                         ;Get 4 words from each Table (Sig & Len)
  MOV  SI,DI                        ;[SI] = Table Pointers
  ADD  DI,(8*4)                     ;[DI] = Storage area for Tables
.R20:                               ;Loop to here to find the FACP Table
  LODSD                             ;Get the next Table Pointer (Phys Addr)
  CALL CopyFromPhysMem              ;Get the Table Signature & Length
  JC  .R70                          ;If error, quit
  CMP  D [ES:DI+ATHSignature],ATHSigFACP ;Is it the FACP Table?
  JE  .R30                          ;If so, handle it
  DEC  DX                           ;If not, decrement the counter
  JNZ .R20                          ;If not 0 yet, keep looking
  JMP .R70                          ;If 0, error
.R30:                               ;We have first 8 bytes of the FACP table
  MOV  CX,[ES:DI+ATHLength]         ;Get
  INC  CX                           ;  the
  SHR  CX,1                         ;  entire
  CALL CopyFromPhysMem              ;  FACP Table
  JC  .R70                          ;If error, quit
  MOV  EAX,[ES:DI+FACPDSDTPhysAddr] ;Store the Physical Address of the
  MOV  [DSDTPhysAddr],EAX           ;  Differentiated System Description Table
  MOV  AX,[ES:DI+FACPC2Latency]     ;Get the C2 Latency
  CMP  AX,100                       ;Valid?
  JAE .R32                          ;If not, continue
  MOV  [C2Latency],AX               ;If so, store it
.R32:                               ;C2 Latency stored, if appropriate
  MOV  AX,[ES:DI+FACPC3Latency]     ;Get the C3 Latency
  CMP  AX,1000                      ;Valid?
  JAE .R34                          ;If not, continue
  MOV  [C3Latency],AX               ;If so, store it
.R34:                               ;C3 Latency stored, if appropriate
  TEST B [FACPFlags],FACPFlgWBINVD  ;WBINVD supported correctly?
  JZ  .R36                          ;If not, continue
  OR   B [C2C3Flags],C2C3WBINVD     ;If so, set our flag
.R36:                               ;WBINVD support stored
  TEST B [FACPFlags],FACPFlgC2MP    ;C2 state suported in multiprocessor mode?
  JZ  .R38                          ;If not, continue
  OR   B [C2C3Flags],C2C3MultiP     ;If so, set our flag
.R38:                               ;Multiprocessor C2 state support stored
  MOV  AX,W [ES:DI+FACPPM1aCtlBlk]  ;Store the I/O Address of the
  MOV  [PM1aCtlIOAddr],AX           ;  Power Management 1a Control Block
  MOV  AX,W [ES:DI+FACPPM1bCtlBlk]  ;Store the I/O Address of the
  MOV  [PM1bCtlIOAddr],AX           ;  Power Management 1b Control Block
  MOV  AX,W [ES:DI+FACPDutyOffset]  ;Store the Throttle Duty Offset
  MOV  [ThtDutyOffset],AX           ;  and Throttle Duty Width
  CALL CalcThtValues                ;If so, calculate Throttle Masks
  JMP .R90                          ;Done
.R70:                               ;Error (INT 15h doesn't work)
  MOV  AL,ErLvlNoInt15              ;AL = Error Level
  MOV  DX,NoInt15Msg                ;Point at the Error Message
  JMP  ExitDot                      ;Quit
.R90:                               ;Done
  POP  SI,DI,DX,CX,EAX              ;Restore used registers
  RET

;------------------------------------------------------------------------------
;CALCULATE THROTTLE VALUES WE NEED TO USE
;Inputs:  DS = Local Data Segment
;         [ThtDutyOffset], [ThtDutyWidth]
;Outputs: [ThtMaxValue], [ThtValueMask]
;Changes:
;NOTES: This assumes the mask width is not more than 8 bits.  Every one I've
;         seen or heard about is either 3 or 4 bits, so we should be OK.
;------------------------------------------------------------------------------
CalcThtValues:
  PUSH AX,CX              ;Save used registers
.V10:                     ;Calculate & Store Maximum Value
  MOV  CL,[ThtDutyWidth]  ;CL = Number of bits in Mask
  OR   CL,CL              ;Is it valid?
  JZ  .V90                ;If not, quit
  MOV  AL,01h             ;AX = Starting bit value
  SHL  AL,CL              ;Calculate the Maximum Throttle Value
  MOV  [ThtMaxValue],AL   ;Store it
.V20:                     ;Calculate & Store Throttle Mask
  MOV  AX,0FF00h          ;Calculate
  MOV  CL,[ThtDutyWidth]  ;  the
  ROL  AX,CL              ;  width
  AND  AX,00FFh           ;  portion
  MOV  CL,[ThtDutyOffset] ;Slide it over to the
  SHL  AX,CL              ;  correct bit position
  MOV  [ThtValueMask],AX  ;Store it
.V90:                     ;Done
  POP  CX,AX              ;Restore used registers
  RET

;------------------------------------------------------------------------------
;GET THE DATA WE NEED FROM THE DIFFERENTIATED SYSTEM DESCRIPTION TABLE
;Inputs:  CS = DS = Local Data Segment
;         ES = Buffer Data Segment
;         [DSDTPhysAddr]
;         CLD already issued
;Outputs: If OK, fills in [ThtIOAddr]
;         If Error, quits program
;Changes: Contents of DataBuffer
;------------------------------------------------------------------------------
GetDSDTData:
  PUSH BP                    ;Save used registers
  MOV  BP,FindCPUxInfo       ;BP = Code to Call (Get Duty Cycle Throttling Data)
  CALL GetDSDTDataGo         ;Do it
  MOV  BP,FindPwrOffInfo     ;BP = Code to Call (Get Soft Power Off Data)
  CALL GetDSDTDataGo         ;Do it


  CALL FindBatteryInfo       ;Get data needed for Battery Status


;  MOV  BP,FindECInfo         ;BP = Code to Call (Get EC Names Pointer)
  CALL GetDSDTDataGo         ;Do it
                             ;  Do this LAST (we just store a pointer to the
                             ;    data in the DataBuffer, and do not
                             ;    convert/manipulate the data to store locally)


;  JMP >D90                   ;Done
;D70:                         ;Error (INT 15h doesn't work)
;  MOV  AL,ErLvlNoInt15       ;AL = Error Level
;  MOV  DX,NoInt15Msg         ;Point at the Error Message
;  JMP  ExitDot               ;Quit
;D75:                         ;Error (Duty Cycle Throttling not supported)
;  MOV  AL,ErLvlNoDuty        ;AL = Error Level
;  MOV  DX,NoDutyMsg          ;DX = Error Message
;  JMP  Exit                  ;Quit
.D90:                        ;Done
  POP  BP                    ;Restore used registers
  RET

GetDSDTDataGo:
.G10:                     ;Loop to here to find the correct part of the DSDT
  CALL GetNextDSDT        ;Fill the Buffer with the next part of the DSDT
  JC  .G90                ;If error, quit
  MOV  DI,DataBuffer      ;ES:DI = Data Buffer
  CALL BP                 ;If OK, call the Search Code
  JC  .G10                ;If error, try the next part of the DSDT
  MOV  D [NextDSDTAddr],0 ;Start at the beginning next time
.G90:                     ;Done
  RET

;------------------------------------------------------------------------------
;FILL THE DATA BUFFER WITH DATA FROM THE DSDT
;Inputs:  CS = DS = Local Data Segment
;         ES = Buffer Data Segment
;         [DSDTPhysAddr]
;         CLD already issued
;Outputs: CF = Clear if OK
;              Buffer filled with Data
;            = Set if Error (already downloaded all of the DSDT Data)
;              Buffer unchanged
;Changes: [DSDTTblSize]
;         [NextDSDAddr]
;NOTES: The DSDT data on at least some, if not most/all computers, is more
;         than our small Buffer can hold.  So, as we're scanning for data,
;         we may need to fill the Buffer multiple times before we find what
;         we're looking for.
;       In addition, we look for multiple pieces of information independently,
;         so we may need to fill the Buffer multiple times again for each
;         set of data.
;       The first time we fill the buffer, we do it with data from the
;         beginning of the DSDT.  We do not scan all the way to the end
;         of the buffer, but leave the last 1000 bytes alone (to try and make
;         sure all of the data for a particular item is in the Buffer
;         at the same time).
;       If the data is not found, we fill the Buffer again, but start at
;         10,000 bytes into the DSDT.  We keep doing this, increment things
;         10,000 bytes at a time, until we've scanned the entire DSDT.
;         It's a time-consuming and complicated process, but necessary because
;         of the inefficiencies of ACPI.
;------------------------------------------------------------------------------
GetNextDSDT:
  PUSH EAX,EBX,ECX,DI           ;Save used registers
  CMP  D [DSDTPhysAddr],0       ;Already have the DSDT Physical Address?
  JNE .X10                      ;If so, continue
  CALL GetFACPData              ;If not, download the FACP Data (quits if Error)
.X10:                           ;Have DSDT Physical Address
  CMP  D [DSDTTblSize],0        ;Already have the Table Size?
  JNE .X20                      ;If so, continue
  MOV  EAX,[DSDTPhysAddr]       ;EAX = Physical Address to Copy
  MOV  DI,DataBuffer            ;ES:[DI] = Our Data Buffer
  MOV  CX,4                     ;Copy 4 words (Signature & Length)
  CALL CopyFromPhysMem          ;Do it
  JC  .X70                      ;If error, quit
  CMP  D [ES:DI+ATHSignature],ATHSigDSDT ;Is the signature correct?
  JNE .X70                      ;If not, error
  MOV  EAX,[ES:DI+ATHLength]    ;Store the
  MOV  [DSDTTblSize],EAX        ;  DSDT Table Size
  ADD  EAX,[DSDTPhysAddr]       ;Store the
  DEC  EAX                      ;  Address of the Last Byte
  MOV  [DSDTLastAddr],EAX       ;  of the DSDT Table
.X20:                           ;Have the DSDT Table Size
  MOV  EAX,[NextDSDTAddr]       ;Get the Next Address to use
  CMP  EAX,-1                   ;Already done this enough times?
  JNE .X25                      ;If not, continue
  MOV  D [NextDSDTAddr],0       ;If so, start at the beginning next time
  JMP .X70                      ;Error
.X25:                           ;EAX is valid
  OR   EAX,EAX                  ;Start from the beginning?
  JNZ .X30                      ;If so, continue
  MOV  EAX,[DSDTPhysAddr]       ;If not, EAX =
  ADD  EAX,ACPITblHdrSize       ;  Next Address to use
.X30:                           ;EAX = Next Starting Address
  MOV  EBX,[DSDTLastAddr]       ;EBX =
  SUB  EBX,EAX                  ;  Number of Bytes
  INC  EBX                      ;  left in the Data
  MOV  ECX,DataBufferSize       ;ECX = Number of Possible Bytes in our Buffer
  CMP  EBX,ECX                  ;Will the remaining data fit in our buffer?
  JA  .X40                      ;If not, continue
  MOV  ECX,EBX                  ;If so, just get the number of data bytes
.X40:                           ;CX = Number of Bytes to Retrieve
  INC  CX                       ;Round up, if necessary
  SHR  CX,1                     ;Convert Number of Bytes to Number of Words
  CALL ClearDataBuffer          ;Fill Buffer with Zeroes
  MOV  DI,DataBuffer            ;ES:[DI] = Our Data Buffer
  CALL CopyFromPhysMem          ;Do it
  JC  .X70                      ;If error, quit
.X50:                           ;Done downloading the Data
  ADD  EAX,10000                ;Update the Starting Address for next time
  SHL  CX,1                     ;Have we downloaded
  CMP  CX,(DataBufferSize-1200) ;  the entire DSDT Table?
  JAE .X55                      ;If not, continue
  MOV  EAX,-1                   ;If so, mark us as done
.X55:                           ;EAX = Address to use next time
  MOV  [NextDSDTAddr],EAX       ;Store the Address to use next time
  JMP .X80                      ;Done
.X70:                           ;Error
  STC                           ;Set return flag
  JMP .X90                      ;Done
.X80:                           ;OK
  CLC                           ;Set return flag
.X90:                           ;Done
  POP  DI,ECX,EBX,EAX           ;Restore used registers
  RET

;------------------------------------------------------------------------------
;FIND THE INFORMATION WE NEED IN THE DSDT DATA REGARDING CPU THROTTLING
;Inputs:  DS = Local Segment
;         ES:DI = Buffer to Search
;         [ThtIOAddr] = 0
;         [ThtDutyWidth] (0 if Throttling not supported)
;Outputs: [ThtIOAddr] (unchanged if Throttling not supported)
;Changes:
;------------------------------------------------------------------------------
FindCPUxInfo:
  PUSH EAX,BX,DI                ;Save used registers
  MOV  AX,AMLTagCPU             ;Search for a CPU Tag
.C10:                           ;Loop to here to find a CPU Tag
  CALL FindBuffWordX            ;Search for a Tag
  JC  .C70                      ;If not found, error
  CMP  B [ES:DI+CPUxLength],0Bh ;Is it the correct Length?
  JNE .C10                      ;If not, keep looking
  MOV  BL,CPUxName              ;Is there
  CALL TestACPIName             ;  a legitiname Name?
  JC  .C10                      ;If not, keep looking
  MOV  BL,[ES:DI+CPUxPCntSize]  ;Get the P_CNT register
  OR   BL,BL                    ;Is there a P_CNT register?
  JZ  .C80                      ;If not, we're done
  MOV  AX,W [ES:DI+CPUxIOAddr]  ;If so, get the P_CNT I/O Address
  MOV  [ThtIOAddr],AX           ;Store it
  ADD  AX,4                     ;Assume C2 is supported
  CMP  BL,5                     ;Is there C2 support?
  JB  .C80                      ;If not, we're done
  MOV  [C2IOAddr],AX            ;If so, store the C2 I/O Address
  JNA .C80                      ;If C3 is not supported, we're done
  INC  AX                       ;If it is,
  MOV  [C3IOAddr],AX            ;  store the C3 I/O Address
  JMP .C80                      ;Done
.C70:                           ;Error
  STC                           ;Set return flag
  JMP .C90                      ;Done
.C80:                           ;OK
  CLC                           ;Set return flag
.C90:                           ;Done
  POP  DI,BX,EAX                ;Restore used registers
  RET

;------------------------------------------------------------------------------
;FIND THE INFORMATION WE NEED IN THE DSDT DATA REGARDING SOFT POWER OFF
;Inputs:  DS = Local Segment
;         ES:DI = Buffer to Search
;         [PM1aS5Value], [PM1bS5Value] = -1
;Outputs: CF = Clear if OK
;              [PM1aS5Value], [PM1bS5Value] stored
;            = Set if Error
;Changes:
;NOTES: According to the ACPI Spec, the S5 string is supposed to be in
;         the Root ("\_S5_"), but on at least one computer of mine
;         (a Sony Vaio Laptop), that is not the case.  Therefore, we
;         don't look for the Root character.
;       In addition, the ACPI Spec says there should be 4 bytes of data,
;         but the Sony Vaio Laptop only has three,  Therefore, we don't
;         try to verify the size of the data either.
;       The ACPI Spec says there should be four bytes of data, but does
;         not actually specify that it should be declared as four
;         individual bytes, as two words, or as one DWord.  On the few
;         computers I have that support ACPI, it is always listed as
;         individual bytes.  I have allowed for the possiblity of data
;         stored as Words or DWords, since somebody could code it that
;         way in order to save memory space (though I don't know if
;         anybody ever actually has).
;------------------------------------------------------------------------------
FindPwrOffInfo:
  PUSH EAX,DI                          ;Save used registers
  MOV  EAX,NameShutDown                ;Look for the
.P10:                                  ;Test for correct Tag
  CALL FindBuffNameX                   ;Look for the Shutdown Package Name
  JC  .P70                             ;If not found, error
  CMP  B [ES:DI+4+PkgTag],AMLTagPkg    ;Is it followed by a Package Tag?
  JNE .P10                             ;If not, keep looking
  CMP  B [ES:DI+4+PkgLength],22        ;Is the Package too big?
  JA  .P10                             ;If so, keep looking
  CMP  B [ES:DI+4+PkgElements],4       ;Are there too many Package elements?
  JA  .P70                             ;If so, error
  CMP  B [ES:DI+4+PkgData],AMLTagByte  ;Is it a Byte, Word, or DWord?
  JNE .P30                             ;If not a Byte, Handle it
.P20:                                  ;Package Data is a Byte
  MOV  AL,[ES:DI+4+PkgData+1]          ;Get the
  MOV  AH,[ES:DI+4+PkgData+3]          ;  Data values
  JMP .P40                             ;Continue
.P30:                                  ;Not Byte Data
  CMP  B [ES:DI+4+PkgData],AMLTagDWord ;Is it Word or DWord Data?
  JA  .P70                             ;If not, error
  MOV  AX,W [ES:DI+4+PkgData+1]        ;If OK, get the Data Values
.P40:                                  ;AL = PM1aCtl Value, AH = PM1bCtl Value
  MOV  W [PM1aS5Value],AX              ;Store the Values
  JMP .P80                             ;Done
.P70:                                  ;Error
  STC                                  ;Set return flag
  JMP .P90                             ;Done
.P80:                                  ;OK
  CLC                                  ;Set return flag
.P90:                                  ;Done
  POP  DI,EAX                          ;Restore used registers
  RET

;------------------------------------------------------------------------------
;FIND THE INFORMATION WE NEED IN THE DSDT DATA REGARDING THE EMBEDDED CONTROLLER
;Inputs:  DS = Local Segment
;         ES:DI = Buffer to Search
;Outputs: DS:[ECNameTbl] filled with Data
;Changes:
;NOTES: Embedded Controllers are usually only valid for laptops & tablets --
;         desktops do not have them.
;       What we do here is find the 4-character ACPI names associated
;         with the Embedded Controller with I/O addressed 62h & 66h.
;       This data area generally contains information about the batteries
;         and other power information that we are interested in for
;         our purposes.  Unfortunately, all EC's are different, so we don't
;         know exactly which offset(s) are the ones we need.  The best we
;         can do is get the names, and hopefully they will be descriptive
;         enough for the user to figure things out.
;       For my particular HP laptop, here are the ACPI Names needed
;         for the battery:
;
;           Name  _BIF Idx  Description
;           ----  --------  ------------------------------
;           BFC_         1  Design Capacity
;                        1  Last Full Charge Capacity
;           BDV_         4  Design Voltage
;           BSN_        10  Serial Number (combination of
;           BDAT        10    BSN & BDAT)

;           Name  _BST Idx  Description
;           ----  --------  ------------------------------
;           BST_         0  State
;           BPR_         1  Present Rate
;           BRC_         2  Remaining Capacity
;           BPV_         3  Present Voltage
;------------------------------------------------------------------------------


;Test both for INT & Fixed INT


FindECInfo:
  PUSH EAX,BX,CX,DX          ;Save used registers
  PUSH DI,SI,BP,DS           ;Save used registers
  MOV  DS,ES                 ;DS = Data Buffer
  MOV  SI,DI                 ;DS:SI = Buffer to Search

.F10:                        ;Loop to here to find the correct Device
  MOV  DI,SI                 ;DS:DI = Buffer to Search
  MOV  AX,AMLTagDevice       ;Look for
  CALL FindBuffWordX         ;  a Device
  JC  .F70                   ;If error, quit
  MOV  BL,2                  ;Calculate the
  CALL GetPkgLength          ;  Package Length (rtns CF, CX, DI, BP)
  JC  .F10                   ;If error, keep looking for a Device
  XOR  BL,BL                 ;Is there
  CALL TestACPIName          ;  a Device Name?
  JC  .F10                   ;If not, keep looking for a Device
  MOV  DX,BP                 ;DX = End of Device Memory Region
  MOV  SI,DI                 ;SI = Current Memory Offset

.F20:                        ;Loop to here to find correct Resources Tag
  MOV  EAX,'SRC_'            ;EAX = Resources Name to Find
  CALL FindBuffNameX         ;Look for the Name
  JC  .F70                   ;If not found, error
  CMP  DI,DX                 ;Past the end of our Device Memory Region?
  JA  .F10                   ;If so, Look for another Device
  CMP  B [DI-1],AMLTagName   ;Is it a Name?
  JNE .F20                   ;If not, keep loooking
  CMP  B [DI+4],AMLTagBuffer ;Is it for a Buffer?
  JNE .F20                   ;If not, keep looking
  MOV  BL,5                  ;Calculate the
  CALL GetPkgLength          ;  Package Length (rtns CF, CX, DI, BP)
  JC  .F20                   ;If invalid, keep looking
  CMP  B [DI],AMLTagByte     ;Is the next tag a small Buffer Size Byte Tag?
  JNE .F20                   ;If not, keep looking
  INC  DI,2                  ;If so, skip over the Byte Tag

.F30:                        ;Loop to here to verify the I/O Resources
  CMP  DI,BP                 ;Past the end of the Buffer?
  JA  .F20                   ;If so, it's not the correct Buffer
  MOV  AL,B [DI]             ;AL = Resource Data Type, AH = 0
  TEST AL,80h                ;Type 0 (Small) Resource?
  JNZ .F20                   ;If not, it can't be for us
  CMP  AL,47h                ;I/O Resource?
  JE  .F35                   ;If so, see if it's the right one
  MOVZX BX,AL                ;Copy Resource Data Type into BX
  SHR  AL,3                  ;AL = Small Item Name
  CMP  AL,0Fh                ;End Tag Descriptor?
  JE  .F20                   ;If so, it's not the correct Buffer
  AND  BL,07h                ;If not, BX = Resource Length
  ADD  DI,BX                 ;[DI] = Next Resource Item
  INC  DI                    ;Keep looking
  JMP .F30                   ;Keep scanning the Resources

.F35:                        ;I/O Resource
  CMP  D [DI+2],0062_0062h   ;I/O Port 62h?
  JE  .F40                   ;If so, continue
  CMP  D [DI+2],0066_0066h   ;I/O Port 66h?
  JNE .F10                   ;If not, it's not the correct Buffer

.F40:                        ;We've found the correct Buffer, now look
                             ;  for the Operation Region
  MOV  AX,AMLTagOpRegion     ;Look for an
  CALL FindBuffWordX         ;  Operation Region
;  JC  >F70                   ;If none found, quit
  JC  .F10                   ;If none found, look for another Device
  CMP  DI,DX                 ;Past the end of our Device Space?
;  JA  >F70                   ;If so, error
  JA  .F10                   ;If so, look for another Device
  MOV  BL,2                  ;Is there
  CALL TestACPIName          ;  a Region Name?
  JC  .F40                   ;If not, look for a real Operation Region
  CMP  B [DI+6],03h          ;Region Space = Embedded Control?
  JNE .F70                   ;If not, error
  CMP  D [DI+7],0FF0A_000Ah  ;Region Offset = 0, Region Length = 255?
  JNE .F70                   ;If not, error
  CMP  W [DI+11],AMLTagField ;Is it a Field?
  JNE .F70                   ;If not, error
  MOV  BL,13                 ;Calculate the
  CALL GetPkgLength          ;  Package Length (rtns CF, CX, DI, BP)
  JC  .F70                   ;If error, we're done
  XOR  BL,BL                 ;Is there
  CALL TestACPIName          ;  a Field Space Name?
  JC  .F70                   ;If not, error
  CMP  B [DI+4],1            ;Flags = Byte Access, No Lock, Preserve Updates?
  JNE .F70                   ;If not, error
;  LEA  AX,[DI+5]             ;If OK,
;  MOV  [ECOffset],AX         ;  store the Beginning Offset
;  MOV  [ECEnd],BP            ;  and the End Offset
  ADD  DI,5                  ;ES:DI = ACPI Field Name & Size List


;mov  DI,SonyData


  CALL InitECNameTbl         ;Copy the ACPI Name Data to our Local Table
  JC  .F70                   ;If error, quit
  CALL InitECData            ;Fill the Name Table with initial data
  JMP .F80                   ;Done
.F70:                        ;Error
 STC                         ;Set return flag
 JMP .F90                    ;Done
.F80:                        ;OK
  CLC                        ;Set return flag
.F90:                        ;Done
  POP  DS,BP,SI,DI           ;Restore used registers
  POP  DX,CX,BX,EAX          ;Restore used registers
  RET

;------------------------------------------------------------------------------
;FIND THE INFORMATION WE NEED IN THE DSDT DATA REGARDING POWER DETAILS
;Inputs:  DS = Local Segment
;         ES:DI = Buffer to Search
;         DataBuffer, cleared and filled in with DSDT Data
;         xxx = -1
;Outputs: xxx
;Changes:
;NOTES: This is EXTREMELY complicated code, due to the nature of how
;         ACPI works.  It's way more complicated than it needs to be
;         to get the job done (IMHO), but this is the state of the
;         industry.
;------------------------------------------------------------------------------
FindBatteryInfo:
  PUSH EAX,BX,DI                      ;Save used registers
;  MOV  EAX,NameACAdapter              ;Look for the
;  CALL FindBuffName0                  ;  AC Adapter Name
;  JC  >B90                            ;If not found, we're done
;B10:                                  ;Test for correct Tag
;  CMP  W [DI-3],AMLTagDevice          ;Is it a Device?
;  JE  >B20                            ;If so, go to the next stage
;B15:                                  ;Not correct Name
;  CALL FindBuffNameX                  ;If not, keep looking
;  JNC  B10                            ;If found, see if it's the right one
;  JMP >B90                            ;If not, found, we're done
;
;B20:                                  ;[DI+4] = AC Adapter Device
;  MOV  EAX,NamePwrSource              ;Look for the
;  CALL FindBuffNameX                  ;  Power Source Name
;  JC  >B90                            ;If not found, we're done
;B30:                                  ;Test for correct Tag
;  CMP  [DI-2].MethTag,AMLTagMethod    ;Is it a Method?
;  JNE >B35                            ;If not, keep looking
;  CMP  [DI-2].MethFlags,0             ;Are there 0 Arguments?
;  JNE >B35                            ;If not, keep looking
;  CMP  B [DI-2].MethData,AMLTagReturn ;Is it a Return Tag?
;  JE  >B40                            ;If so, continue
;B35:                                  ;Not correct Name
;  CALL FindBuffNameX                  ;If not, keep looking
;  JNC  B30                            ;If found, see if it's the right one
;  JMP >B90                            ;If not, found, we're done
;
;B40:                                  ;[DI-2] = Power Source Method
;  MOV  EAX,D [DI-2].MethData[1]       ;Look for the
;  CALL FindBuffName0                  ;  Return Data Name
;  JC  >B90                            ;If not found, we're done
;B50:                                  ;Test for correct Tag
;  XOR  BX,BX                          ;Assume no Root
;  CMP  B [DI-1].NameTag,AMLTagRoot    ;Is it preceded by a Root Prefix?
;  JNE >B52                            ;If not, keep testing
;  DEC  BX                             ;If so, point back at the Name Tag
;B52:                                  ;BX contains correct Offset
;  CMP  B [DI+BX-1].NameTag,AMLTagName ;Is it a Name?
;  JNE >B55                            ;If not, keep looking
;  CMP  B [DI-1].NameData,AMLTagByte   ;Is it a Data Byte?
;  JE  >B60                            ;If so, continue
;B55:                                  ;Not correct Name
;  CALL FindBuffNameX                  ;If not, keep looking
;  JNC  B50                            ;If found, see if it's the right one
;  JMP >B90                            ;If not, found, we're done
;B60:                                  ;[DI-1] = Name
;  MOV  AL,[DI-1].NameData[1]          ;If OK, store the
;  MOV  [ACPIACStatus],AL              ;  Line Status
;B90:                                  ;Done
  POP  DI,BX,EAX                      ;Restore used registers
  RET

;------------------------------------------------------------------------------
;CLEAR OUT THE DATA BUFFER (FILL IT WITH ZEROES)
;Inputs:  DS = ES = Local Data Segment
;         CLD already issued
;Outputs: Fills DataBuffer with Zeroes
;Changes:
;------------------------------------------------------------------------------
ClearDataBuffer:
  PUSH EAX,CX,DI     ;Save used registers
  XOR  EAX,EAX       ;Fill it with zeroes
  MOV  CX,(DataBufferSize/4) ;CX = Number of DWords to Write
  MOV  DI,DataBuffer ;ES:[DI] = Beginning of Buffer
  REP  STOSD         ;Fill the Buffer
  POP  DI,CX,EAX     ;Restore used registers
  RET

;;------------------------------------------------------------------------------
;;FIND THE END OF THE DATA BUFFER (THE LAST NON-ZERO BYTE)
;;Inputs:  DS = ES = Local Data Segment
;;         DataBuffer cleared and filled in with appropriate data
;;Outputs: [LastBuffByte] = Pointer to last byte of the Buffer
;;Changes:
;;------------------------------------------------------------------------------
;FindEndOfBuffer:
;  PUSHF                  ;Save flags
;  PUSH AX,CX,DI          ;Save used registers
;  XOR  AL,AL             ;Look for Zeroes
;  MOV  CX,-1             ;Maximize byte counter
;  MOV  DI,-1             ;Start at end of buffer
;  STD                    ;Go backwards
;  REPE SCASB             ;Find the first byte isn't zero
;  INC  DI                ;Point back at the last byte
;  MOV  [LastBuffByte],DI ;Store the Pointer
;  POP  DI,CX,AX          ;Restore used registers
;  POPF                   ;Restore flags
;  RET


;
;SUPPORT CODE TO FIND DATA IN THE ACPI TABLES
;

;------------------------------------------------------------------------------
;FIND A BYTE/WORD/DWORD IN THE DATA BUFFER
;Inputs:  ES = Data Buffer Segment
;         ES:[DataBuffer] cleared and filled in with appropriate data
;         EAX/AX/AL = Data to search for
;                       (may be a 4-byte String)
;         DS:[LastBuffByte]
;         If FindBuffName0, Starts search at Beginning of Buffer
;         If FindBuffNameX, Starts search at [DI+1]
;Outputs: CF = Clear if Data is found
;              [DI] = Data Pointer
;            = Set if Error (Data not Found)
;              DI = Unchanged
;Changes:
;NOTES: It is important that the Buffer was cleared out (filled with zeroes)
;         before this is called, since we look for the last non-zero byte
;         to identify the end of the actual data.
;------------------------------------------------------------------------------
FindBuffDWord0:
FindBuffName0:
  PUSH DX                ;Save used registers
  MOV  DL,4              ;Mark as a DWord
  JMP  FindBuff0         ;Do it
FindBuffDWordX:
FindBuffNameX:
  PUSH DX                ;Save used registers
  MOV  DL,4              ;Mark as a DWord
  JMP  FindBuffX         ;Do it
FindBuffWord0:
  PUSH DX                ;Save used registers
  MOV  DL,2              ;Mark as a Word
  JMP  FindBuff0         ;Do it
FindBuffWordX:
  PUSH DX                ;Save used registers
  MOV  DL,2              ;Mark as a Word
  JMP  FindBuffX         ;Do it
FindBuffByte0:
  PUSH DX                ;Save used registers
  MOV  DL,1              ;Mark as a Byte
  JMP  FindBuff0         ;Do it
FindBuffByteX:
  PUSH DX                ;Save used registers
  MOV  DL,1              ;Mark as a Byte
  JMP  FindBuffX         ;Do it

FindBuff0:
  PUSH BX                ;Save used registers
  MOV  BX,DI             ;Save original pointer
  MOV  DI,DataBuffer     ;ES:DI = Beginning of the buffer
  JMP  FindBuffX.F00     ;Do it
FindBuffX:
  PUSH BX                ;Save used registers
  MOV  BX,DI             ;Save original pointer
  CMP  DI,DataBuffer     ;At the start of the Buffer (first time through)?
  JE  .F00               ;If so, continue
  INC  DI                ;If not, Point at the next byte
;  JMP >F00               ;Do it

.F00:
;  PUSH CX                ;Save used registers
  XOR  DH,DH             ;Convert DL to a Word
;  MOV  CX,[LastBuffByte] ;[CX] =
;  SUB  CX,1000           ;  Last Possible Byte to Match
;  SUB  CX,DX             ;  Last possible
;  INC  CX                ;  Byte to Match
.F05:                    ;Loop to here for each byte in buffer
;  CMP  DI,CX             ;Are we past the end of the data?
  CMP  DI,(65536-1000)   ;Are we near the end of the Buffer?
  JA  .F70               ;If so, error
  CMP  DL,2              ;Doing Bytes, Words, or DWords?
  JA  .F40               ;If DWords, jump to handle it
  JE  .F20               ;If Words, jump to handle it
.F10:                    ;Byte
  CMP  AL,[ES:DI]        ;Is it a match?
  JMP .F50               ;Continue
.F20:                    ;Word
  CMP  AX,[ES:DI]        ;Is it a match?
  JMP .F50               ;Continue
.F40:                    ;DWord
  CMP  EAX,[ES:DI]       ;Is it a match?
;  JMP .F50               ;Continue
.F50:                    ;Data is tested
  JE  .F80               ;If so, we're done
  INC  DI                ;If not, point at the next data byte
  JMP .F05               ;Keep looking
.F70:                    ;Error (Name not Found)
  MOV  DI,BX             ;Restore original DI
  STC                    ;Set return flag
  JMP .F90               ;Done
.F80:                    ;Found the String ([DI])
  CLC                    ;Set return flag
.F90:                    ;Done
;  POP  CX                ;Restore used registers
  POP  BX                ;Restore used registers
  POP  DX                ;Restore used registers
  RET

;------------------------------------------------------------------------------
;TEST AND SEE IF THE DATA IN THE BUFFER IS AN ACPI NAME
;Inputs:  ES:DI = Buffer Contents
;            BL = Offset from Current Location of Potential Name
;                 (Name is at ES:[DI+BL]
;                 BL is a SIGNED number (can be negative)
;         CLD already issued
;Outputs: CF = Clear if OK
;            = Set if Error
;Changes:
;NOTES: Valid ACPI Names consist of capital letters, numerals, and
;         underscores, and are always exactly four characters long.
;       They cannot start with a numeral.
;       Names is ACPI can also include "paths" and strings of multiple
;         concatenated names, which we don't care about right here.
;------------------------------------------------------------------------------
TestACPIName:
  PUSH AX,CX  ;Save used registers
  PUSH SI     ;Save used registers
  MOV  SI,DI  ;ES:SI =
  MOV  AL,BL  ;  Potential
  CBW         ;  Name
  ADD  SI,AX  ;  Data
  MOV  CX,4   ;CX = Number of Characters to test
.M10:         ;Loop to here for each character
  ES   LODSB  ;Get the next character
  CMP  CX,4   ;First Character?
  JE  .M20    ;If so, it can't be a Numeral
  CMP  AL,'0' ;Numeral?
  JB  .M70    ;If not, error
  CMP  AL,'9' ;Numeral?
  JBE .M50    ;If so, continue
.M20:         ;Numerals handled, if appropriate
  CMP  AL,'A' ;Capital letter?
  JB  .M70    ;If not, error
  CMP  AL,'Z' ;Capital letter?
  JBE .M50    ;If so, continue
  CMP  AL,'_' ;Underscore?
  JNE .M70    ;If not, error
.M50:         ;Character is Valid
  LOOP .M10   ;Keep testing until we're done
  JMP .M80    ;Done
.M70:         ;Error
  STC         ;Set return flag
  JMP .M90    ;Done
.M80:         ;OK (CX & DI already calculated, SI = PkgLen Ptr)
  CLC         ;Set return flag
.M90:         ;Done
  POP  SI     ;Restore used registers
  POP  CX,AX  ;Restore used registers
  RET

;------------------------------------------------------------------------------
;GET THE LENGTH DETAILS FOR AN ACPI ENTITY
;Inputs:  ES:DI = Buffer Contents
;            BL = Offset from Current Location of Package Length
;                 (Package Length is at ES:[DI+BL]
;                 BL is a SIGNED number (can be negative)
;Outputs: CF = Clear if OK
;              CX = Package Size (usually bytes, sometimes bits)
;              DI = Pointer to next byte after the Package Length
;              BP = Pointer to last byte of Package
;            = Set if Error
;              CX, DI, BP = Unchanged
;Changes:
;NOTES: Package lengths in ACPI are variable-sized, and encoded in a special
;         fashion.  Bits 6 & 7 of the first byte contain the number of
;         bytes following the first one (0-3).
;       If there are no following bytes, bits 0-5 of the first byte are the
;         Package Length (up to 63 bytes).
;       If there are following bytes, bits 4-5 of the first byte are unused
;         and MUST be 0.  Bits 4-7 are the low nibble of the Package Length,
;         and the following (bytes) are the higher bits of the Package
;         Length.
;       The maximum Package Length is (2^28 - 1).  For our purposes, we will
;         limit the Package Length to 65535 bytes (2^16 - 1) -- we should
;         never see anything larger than that.
;------------------------------------------------------------------------------
GetPkgLength:
  PUSH AX,SI,DS      ;Save used registers
  MOV  DS,ES         ;DS = Buffer Segment
  MOV  SI,DI         ;DS:SI =
  MOV  AL,BL         ;  Package
  CBW                ;  Length
  ADD  SI,AX         ;  Data
  MOV  AL,[SI]       ;AL = First Byte of Package Length
  TEST AL,0C0h       ;More than one Byte in the Package Length?
  JNZ .L05           ;If so, jump to handle it
.L00:                ;One Byte in Package Length
  AND  AL,3Fh        ;AL = Package Length
  CMP  AL,1          ;Valid Package Length?
  JB  .L70           ;If not, error
  MOVZX CX,AL        ;CX = Package Length
  LEA  DI,[SI+1]     ;DI = Pointer to Start of Data
  JMP .L80           ;Done
.L05:                ;More than one Byte in the Length
  TEST AL,30h        ;Valid data in the first byte?
  JNZ .L70           ;If not, error
  MOV  AH,AL         ;AH =
  SHR  AH,6          ;  Number of Bytes in Package Length
  AND  AL,0Fh        ;AL = Low Nibble of Pacakge Length
  CMP  AH,2          ;Is it 1, 2, or 3?
  JA  .L70           ;If 3, it's too big for us
  JE  .L20           ;If 2, jump to handle it
.L10:                ;One byte is Package Length
  CMP  B [SI+1],0    ;Valid data?
  JE  .L70           ;If not, error
  MOVZX CX,B [SI+1]  ;CX =
  SHL  CX,4          ;  Bits 5-15 of Package Length
  OR   CL,AL         ;Mask in the Low Nibble of the Length
  LEA  DI,[SI+2]     ;DI = Pointer to Start of Data
  JMP .L80           ;Done
.L20:                ;Two bytes in Package Length
  TEST B [SI+2],0F0h ;Too big for us?
  JNZ .L70           ;If so, error
  TEST B [SI+2],0Fh  ;Valid data?
  JZ  .L70           ;If not, error
  MOV  CX,[SI+1]     ;CX =
  SHL  CX,4          ;  BIts 5-15 of Package Length
  OR   CL,AL         ;Mask in the Low Nibble of the Length
  LEA  DI,[SI+3]     ;DI = Pointer to Start of Data
  JMP .L80           ;Done
.L70:                ;Error
  STC                ;Set return flag
  JMP .L90           ;Done
.L80:                ;OK (CX & DI already calculated, SI = PkgLen Ptr)
  MOV  BP,SI         ;BP =
  ADD  BP,CX         ;  Pointer to
  DEC  BP            ;  Last Byte of Package
  CLC                ;Set return flag
.L90:                ;Done
  POP  DS,SI,AX      ;Restore used registers
  RET


;
;CODE TO PROCESS APM RELATED FUNCTIONS
;

;------------------------------------------------------------------------------
;TEST THE COMPUTER TO SEE IF IT HAS AN APM-COMPATIBLE BIOS
;Inputs:  DS = Local Data Segment
;Outputs: CF = Clear if APM BIOS is installed
;            = Set if not
;Changes: [APMVersion]
;------------------------------------------------------------------------------
TestAPM:
  PUSH AX,BX,CX        ;Save used reigsters
  MOV  AX,APMInstallCk ;Function = Install Check
  XOR  BX,BX           ;BX = 0 = Device ID for System BIOS
  STC                  ;Preset Error Flag
  INT  15h             ;Do it
  JC  .A70             ;If error, quit
  CMP  BX,'PM'         ;Correct value on return?
  JNE .A70             ;If not, error
  MOV  [APMVersion],AX ;If OK, store the Version
  JMP .A80             ;we're done
.A70:                  ;BIOS is incompatible
  STC                  ;Set error flag
  JMP .A90             ;Done
.A80:                  ;BIOS is compatible
  CLC                  ;Set OK flag
.A90:                  ;Done
  POP  CX,BX,AX        ;Restore used registers
  RET

;------------------------------------------------------------------------------
;TRY TO SHUT THE COMPUTER DOWN USING APM SERVICES
;Inputs:  DS = Local Data Segment
;Outputs: CF = Clear if OK (We are connected to the BIOS)
;            = Set if Error (We could not connect for some reason)
;Changes:
;------------------------------------------------------------------------------
StopItAPM:
  PUSH AX,BX,CX        ;Save used reigsters
  CALL ConnectAPM101   ;Try to connect to the APM BIOS
  JC  .X75             ;If unable to connect, error
  MOV  AX,APMPwrManage ;Function = Enable/Disable Power Management
  MOV  CX,APMPMEnable  ;SubFunction = Enable
  MOV  BX,APMAllPMDvcs ;BX = Device ID for all Power-managed Devices
  INT  15h             ;Do it
  JC  .X70             ;If error, quit
  MOV  AX,APMPwrState  ;Function = Set Power State
  MOV  CX,APMOff       ;SubFunction = Shut Down System
  MOV  BX,APMAllPMDvcs ;BX = Device ID for all Power-managed Devices
  INT  15h             ;Do it
                       ;We should never make it to here, since the computer
                       ;  should be turned off!
  JNC .X80             ;Done
.X70:                  ;Error - Disconnect Interface
  CALL DisconnectAPM   ;Disconnect from the APM Interface
.X75:                  ;Error
  STC                  ;Set return flag
  JMP .X90             ;Done
.X80:                  ;OK
  CALL DisconnectAPM   ;Disconnect from the APM Interface
  CLC                  ;Set return flag
.X90:                  ;Done
  POP  CX,BX,AX        ;Restore used registers
  RET

;------------------------------------------------------------------------------
;GET THE STATUS OF THE BATTERY SYSTEM USING APM SERVICES
;Inputs:  DS = Local Data Segment
;Outputs: CF = Clear if OK
;               [APMACStatus], [APMBattStatus], etc., filled in
;            = Set if Error
;Changes:
;------------------------------------------------------------------------------
GetBattery1APM:
  PUSH BP                   ;Save used registers
  MOV  BP,APMBattery1       ;Get status for Battery 1
  JMP  GetBatteryAPM.B00    ;Do it
GetBattery2APM:
  PUSH BP                   ;Save used registers
  MOV  BP,APMBattery2       ;Get status for Battery 2
  JMP  GetBatteryAPM.B00    ;Do it
GetBatteryAPM:
  PUSH BP                   ;Save used registers
  MOV  BP,APMAllPMDvcs      ;Get status for system
;  JMP >B00                  ;Do it
.B00:
  PUSH AX,BX,CX,DX,SI       ;Save used reigsters
  CALL ConnectAPM100        ;Try to connect to the APM BIOS
  JC  .B75                  ;If unable to connect, error
  MOV  AX,APMGetPower       ;Function = Get Power Status
  MOV  BX,BP                ;BX = Device ID to use
  INT  15h                  ;Do it
  JC  .B70                  ;If error, quit
  MOV  [APMBattStatus],BL   ;Store the Battery Status
  MOV  [APMACStatus],BH     ;Store the AC Line Status
  MOV  [APMBattPct],CL      ;Store Battery Life Percentage
  CMP  BP,APMAllPMDvcs      ;Is this for a specific Battery?
  JE  .B10                  ;If not, continue
  MOV  [APMNumBatts],SI     ;If so, store the number of batteries
.B10:                       ;Stored number of Batteries, if appropriate
  CMP  W [APMVersion],0101h ;Is it version 1.1+?
  JB  .B20                  ;If not, it doesn't have the Battery Flags
  MOV  [APMBattFlags],CH    ;If so, store the Flags
  MOV  [APMBattTime],DX     ;Store the Remaining Battery Time
.B20:                       ;Stored Battery Flags & Battery Time, if appropriate
  JMP .B80                  ;Done
.B70:                       ;Error - Disconnect Interface
  CALL DisconnectAPM        ;Disconnect from the APM Interface
.B75:                       ;Error
  STC                       ;Set return flag
  JMP .B90                  ;Done
.B80:                       ;OK
  CALL DisconnectAPM        ;Disconnect from the APM Interface
  CLC                       ;Set return flag
.B90:                       ;Done
  POP  SI,DX,CX,BX,AX       ;Restore used registers
  POP  BP                   ;Restore used registers
  RET


;{ Get current battery status (0 = done, $ff = error) }
;function getbattstat: Byte; assembler;
;asm
;  mov ax, APM_POWSTAT
;  mov bx, 1            { all devices }
;  mov dx, -1           { DX not set by APM 1.0 }
;  int 15h              { get power status }
;  jc @st               { an error occured }
;  mov [acbatt], bx     { save AC and battery status}
;  mov [perc], cx       { save remaining charge }
;  xchg ax, dx
;  test ax, ax
;  js @min              { time in minutes, or invalid }
;  cwd
;  mov cx, 60
;  div cx               { convert seconds to minutes }
;@min:
;  cmp ax, -1
;  je @t          { invalid value, APM 1.0, no Carry }
;  and ax, 7FFFh  { clear bit 15, no Carry }
;@t:
;  mov [remt], ax  { save remaining time }
;@st:
;  sbb al, al  { set AL on Carry (error flag) }
;end;
;
;{ Print battery status }
;procedure printstate;
;var
;  m: Integer;
;begin
;  Writeln(' APM version........ ', hi(apmver), '.', lo(apmver));

;  Write(' AC line status..... ');
;  case hi(acbatt) of
;    0: Writeln('OFF');
;    1: Writeln('ON');
;  $ff: Writeln('BACKUP');
;  else Writeln('UNKNOWN');
;  end;

;  Write(' Battery status..... ');
;  case lo(acbatt) of
;    0: Writeln('HIGH');
;    1: Writeln('LOW');
;    2: Writeln('CRITICAL');
;    3: Writeln('CHARGING');
;  else Writeln('UNKNOWN');
;  end;

;  Write(' Remaining charge... ');
;  if (lo(perc) <= 100) then
;    Writeln(lo(perc), '%')
;  else
;    Writeln('UNKNOWN');
;  if (remt <> -1) then

;  begin
;    m := remt mod 60;
;    Writeln(' Remaining time..... ',
;            remt div 60, ' h ',         { hours }
;            m div 10, m mod 10, ' m');  { minutes always with leading zero }
;  end;
;end;

;------------------------------------------------------------------------------
;CONNECT TO THE APM-COMPATIBLE BIOS
;Inputs:  DS = Local Data Segment
;         [APMVersion]
;Outputs: CF = Clear if OK (We are connected to the BIOS)
;            = Set if Error (We could not connect for some reason)
;Changes:
;------------------------------------------------------------------------------
ConnectAPM102:
  PUSH DX                ;Save used registers
  MOV  DX,0102h          ;Look for/Set version 1.2
  JMP  ConnectAPM100.C00 ;Do it
ConnectAPM101:
  PUSH DX                ;Save used registers
  MOV  DX,0101h          ;Look for/Set version 1.1
  JMP  ConnectAPM100.C00 ;Do it
ConnectAPM100:
  PUSH DX                ;Save used registers
  MOV  DX,0100h          ;Look for/Set version 1.0
;  JMP >C00               ;Do it
.C00:
  PUSH AX,BX,CX          ;Save used reigsters
  CALL TestAPM           ;Is APM even installed?
  JC  .C70               ;If not, error
  MOV  AX,APMConnect     ;Function = Connect Real Mode Interface
  XOR  BX,BX             ;BX = 0 = Device ID for System BIOS
  INT  15h               ;Do it
  JC  .C70               ;If error, quit
  CMP  DX,[APMVersion]   ;Is the APM Version new enough for us to use?
  JA  .C70               ;If not, error
  MOV  AX,APMSetVer      ;Function = Set Driver Version Compatibility
  MOV  CX,[APMVersion]   ;CX = Version Number to set (set to Maximum)
  CMP  CX,0102h          ;Is the version higher thatn 1.2?
  JBE .C20               ;If so, it's OK - we can handle it
  MOV  CX,0102h          ;If not, just set to version 1.2
.C20:                    ;Cx contains correct version to set
  XOR  BX,BX             ;BX = 0 = Device ID for System BIOS
  INT  15h               ;Do it
  JNC .C80               ;If it worked, we're done
.C70:                    ;Error
  STC                    ;Set return flag
  JMP .C90               ;Done
.C80:                    ;OK
  CLC                    ;Set return flag
.C90:                    ;Done
  POP  CX,BX,AX          ;Restore used registers
  POP  DX                ;Restore used registers
  RET

;------------------------------------------------------------------------------
;DISCONNECT FROM THE APM BIOS
;Inputs:  DS = Local Data Segment
;Outputs: CF = Clear if OK (We are disconnected)
;            = Set if Error (We could not disconnect for some reason)
;Changes:
;------------------------------------------------------------------------------
DisconnectAPM:
  PUSH AX,BX,CX         ;Save used reigsters
  MOV  AX,APMDisconnect ;Function = Dissconnect Interface
  XOR  BX,BX            ;BX = 0 = Device ID for System BIOS
  INT  15h              ;Do it (Returns CF)
  POP  CX,BX,AX         ;Restore used registers
  RET


;
;CODE TO COPY DATA TO/FROM EXTENDED MEMORY FROM/TO OUR DATA AREA
;

;------------------------------------------------------------------------------
;COPY DATA TO/FROM A PHYSICAL ADDRESS FROM/TO TO A SEGMENT:OFFSET ADDRESS
;Inputs:  DS = ES = Data Area to use
;         EAX     = Physical Memory Address
;         ES:[DI] = Segment:Offset Memory Address
;         CX      = Number of Words to Copy (note WORDS, not Bytes)
;Outputs: CF = Clear if OK
;              Data is copied
;            = Set if Error
;Changes: MemCopyTable
;NOTES: This uses the System BIOS "Copy Extended Memory" function
;         (INT 15h, Function 87h) to perform the Copy.  It works under
;         all Protected Mode Memory Managers that I have tried
;         (DPMI, VCPI, and "regular"), so can provide a straightforward
;         way to do things.  It works much faster under a memory manager
;         than it does with the BIOS, because under a memory
;         manager the CPU is already in protected (V86) mode, while when
;         using the BIOS the CPU must switch to protected mode, perform the
;         copy, and then switch back to real mode again.
;       The value in CX is a WORD count, not a Byte count, and can be
;         anything between 0 (no data transfer) to 32,768 (transfer a full
;         64k segment).  Data does not need to be word-aligned.
;       The data format used by INT 15h.87h is in the form of a set of
;         Global Descriptor Table (GDT) entries, but some of the data in
;         the entries is ignored.  Specifically, with the memory managers,
;         the granularity (GDTXRights.XRGranul4K) is ignored and the
;         code always assumes that the granularity is one byte.
;       In contrast, with at least some BIOS's, almost all of the data
;         in the GDT is completely ignored, including the granularity
;         AND the segment limits.  In fact, the segment limits can be
;         set to 0 in these BIOS's and the call transfers the data
;         successfully.  The only datum that seems to be used are the
;         two memory addresses.
;------------------------------------------------------------------------------
CopyFromPhysMem:
  PUSH BX,DX             ;Save used registers
  MOV  BX,MCSrcSegment   ;Source Segment = Physical
  MOV  DX,MCDstSegment   ;Destination Segment = Segment:Offset
  JMP  CopyToPhysMem.P00 ;Do it
CopyToPhysMem:
  PUSH BX,DX             ;Save used registers
  MOV  BX,MCDstSegment   ;Destination Segment = Physical
  MOV  DX,MCSrcSegment   ;Source Segment = Segment:Offset
;  JMP >P00               ;Do it
.P00:
  PUSH EAX,EDI,SI         ;Save used registers
  CALL InitMemCopyTable   ;Initialize the Descriptor Table
  MOV  SI,MemCopyTable    ;Point ES:[SI] at the Descriptor Table
  CALL CopyEAX2GDTAddr    ;Store the Linear Address
  PUSH ES                 ;EAX =
  PUSH DI                 ;  Segment:Offset
  POP  EAX                ;  Address
  CALL SegOff2PhysAddrEAX ;Convert it to a Physical Address (EAX)
  JC  .P70                ;If error, quit
  MOV  BX,DX              ;Store the
  CALL CopyEAX2GDTAddr    ;  Segment:Offset Address
  MOV  AH,87h             ;AH = Function = 87h (Copy Extended Memory)
                          ;CX = # of Words to Copy (Max 8000h)
                          ;ES:[SI] = Memory Copy Descriptor Table
  STC                     ;Preset Error Flag
  CLI                     ;Disable interrupts
  INT  15h                ;Do it (Returns CF & AH)
  STI                     ;Enable interrupts
  OR   AH,AH              ;Did it work?
  JZ  .P80                ;If so, we're done
.P70:                     ;Error
  STC                     ;Set error flag
  JMP .P90                ;Done
.P80:                     ;OK
  CLC                     ;Set OK flag
.P90:                     ;Done
  POP  SI,EDI,EAX         ;Restore used registers
  POP  DX,BX              ;Restore used registers
  RET

;------------------------------------------------------------------------------
;STORE A 32-BIT LINEAR ADDRESS INTO A GDT ENTRY
;Inputs:  EAX  = Linear Address to Store
;         [SI] = GDT Table to Store it in
;          BX  = Offset of GDT Entry in Table to use
;Outputs: Stores EAX in the GDT Entry appropriately
;Changes:
;NOTES: A 32-bit GDT entry stores the low 3 bytes in the address in one place
;         and the high byte in another, so a simple MOV instruction won't work.
;------------------------------------------------------------------------------
CopyEAX2GDTAddr:
  PUSH EAX                       ;Save used registers
  MOV  [SI+BX+GDTAddress24],AX   ;Store
  SHR  EAX,16                    ;  the
  MOV  [SI+BX+GDTAddress24+2],AL ;  Physical
  MOV  [SI+BX+GDTAddress32],AH   ;  Address
  POP  EAX                       ;Restore used registers
  RET

;------------------------------------------------------------------------------
;INITIALIZE DESCRIPTOR TABLE
;Inputs:  DS = ES = Local Data Segment
;         CLD already issued
;Outputs: Initializes MemCopyTable values
;Changes:
;NOTES: This initializes all values in the Memory Copy Descriptor Table except
;         the Linear Memory Addresses.  After calling this subroutine, the
;         Caller simply needs to fill in the Memory Addresses and issue
;         the BIOS Call.
;       This sets the segment limits that are needed to guarantee full
;         transfer of a 64K Segment, even if it is not properly aligned.
;       Even though we set the Extended Rights to indicate that the
;         granularity is a 4K page, JEMM and EMM386 ignore this and assume
;         the granularity is 1 byte.  The BIOS does not ignore the
;         granularity bit, though.
;------------------------------------------------------------------------------
InitMemCopyTable:
  PUSH AX,BX,CX,DI,SI                    ;Save used registers
  MOV  DI,MemCopyTable                   ;ES:[DI] = Descriptor Table
  MOV  BX,DI                             ;[BX] = Descriptor Table
  MOV  CX,(MemCopySize/2)                ;CX = Number of Words to Write
  XOR  AX,AX                             ;Write Zeroes
  REP  STOSW                             ;Set Table to all zeroes
  MOV  SI,MCSrcSegment                   ;SI = Source Offset
  MOV  DI,MCDstSegment                   ;DI = Destination Offset
  MOV  W [SI+BX+GDTSegLimit],-1          ;Setup Segment Limits (big enough
  MOV  W [DI+BX+GDTSegLimit],-1          ;  for entire 64k Segment)
  MOV  B [SI+BX+GDTRights],GDTRightsData ;Setup
  MOV  B [DI+BX+GDTRights],GDTRightsData ;  Basic Rights
  MOV  B [SI+BX+GDTXRights],GDTXRights32 ;Setup Extended Rights & High Nibble
  MOV  B [DI+BX+GDTXRights],GDTXRights32 ;  of 20-bit Segment Limit
  POP  SI,DI,CX,BX,AX                    ;Restore used registers
  RET


;
;CODE TO CONVERT SEGMENT:OFFSET ADDRESSES TO PHYSICAL ADDRESSES
;

;
;Code to Convert Segment:Offset Addresses to Physical Addresses
;If the Address is "foreign" (from another program), these routines will
;  use VCPI calls to determine the physical address.  If local to our
;  program, we calculated the Programs Base Physical Address on installation
;  and just need to do a simple addition.
;

;------------------------------------------------------------------------------
;CONVERT A SEGMENT:OFFSET (EAX) TO A 32-BIT PHYSICAL ADDRESS
;Inputs:  EAX   = Segment:Offset to convert
;Outputs: CF = Clear if OK
;              EAX = Segment:Offset converted to a Physical address
;            = Set if Error
;              EAX = Unchanged
;Changes:
;NOTES: This will make a call to the VCPI-compliant Memory Manager
;         (e.g.,EMM386) if one is loaded.  This will allow us to determine
;         the physical address even if the physical address is in a UMB.
;------------------------------------------------------------------------------
SegOff2PhysAddrEAX:
  PUSH EBX,ECX,EDX  ;Save used registers
  PUSH EBP          ;Save used registers
  MOV  EBP,EAX      ;Save original EAX
  XOR  ECX,ECX      ;Convert
  XOR  EBX,EBX      ;  Segment:Offset
  PUSH EAX          ;  to
  POP  BX           ;  a
  POP  CX           ;  Linear
  SHL  ECX,4        ;  Address
  ADD  ECX,EBX      ;  (ECX)
  MOV  EBX,ECX      ;Save it in EBX
  CALL TestRealMode ;Is the CPU in Real Mode?
  JNC .S80          ;If so, we're done
  CALL TestMTask    ;Are we running underneath a multi-tasker (Windows)?
  JZ  .S70          ;If so, we can't use VCPI to determine our address
  CALL TestVCPI     ;Are we running under VCPI?
  JC  .S70          ;If not, we can't determine our physical address
  SHR  ECX,12       ;CX = Page Number of Segment
  MOV  AX,0DE06h    ;Function DE06h (convert Page to Physical Address)
  INT  67h          ;Do it (Returns EDX = Physical Address)
  OR   AH,AH        ;Did it work?
  JNZ .S90          ;If not, quit
  SHL  ECX,12       ;Subtract out original
  SUB  EBX,ECX      ;  (Linear) Page Offset
  ADD  EBX,EDX      ;Add small offset to the Page Offset
  JMP .S80          ;Done
.S70:               ;Error
  MOV  EAX,EBP      ;Restore original EAX
  STC               ;Set return flag
  JMP .S90          ;Done
.S80:               ;EAX is valid
  MOV  EAX,EBX      ;Put result in EAX for the return
  CLC               ;Set return flag
.S90:               ;Done
  POP  EBP          ;Restore used registers
  POP  EDX,ECX,EBX  ;Restore used registers
  RET

;------------------------------------------------------------------------------
;SEE IF THE COMPUTER IS IN REAL MODE
;Inputs:
;Outputs: CF = Clear if in Real Mode
;            = Set if in Protected Mode
;Changes:
;------------------------------------------------------------------------------
TestRealMode:
  PUSH AX   ;Save used registers
  SMSW AX   ;Get the Machine Status Word
  SHR  AX,1 ;Set the return flag
  POP  AX   ;Restore used registers
  RET

;------------------------------------------------------------------------------
;TEST AND SEE IF WE ARE RUNNING UNDER A MULTI-TASKER (e.g., WINDOWS)
;Inputs:
;Outputs: ZF = Set if we are underneath a multi-tasker
;            = Clear if not
;Changes:
;NOTES: This call works with several different MultiTaskers besides
;         Windows DPMI, so it's an excellent test for what we need.
;       The main reason for this test is that the VCPI test that follows it
;         crashes the computer under some versions Windows.
;------------------------------------------------------------------------------
TestMTask:
  PUSH AX       ;Save used registers
  MOV  AX,1680h ;Function 1680h (Release current Virtual Machine Time Slice)
  INT  2Fh      ;Do it
  OR   AL,AL    ;Did it work?
  POP  AX       ;Restore used registers
  RET

;------------------------------------------------------------------------------
;SEE IF A VCPI-COMPLIANT MEMORY MANAGER IS INSTALLED
;Inputs:
;Outputs: CF = Clear if VCPI is installed
;            = Set if not
;Changes:
;------------------------------------------------------------------------------
TestVCPI:
  PUSH AX,BX     ;Save used registers
  MOV  AL,67h    ;Does Int 67h
  CALL TestInt   ;  even exist?
  JZ  .V70       ;If not, we can't have VCPI
  MOV  AX,0DE00h ;Function DE00h (VCPI Installation check)
  INT  67h       ;Do it (Also returns BX = Version)
  OR   AH,AH     ;Did it work?
  JZ  .V80       ;If so, we're done
.V70:            ;Error
  STC            ;Set the error flag
  JMP .V90       ;We're done
.V80:            ;It's OK
  CLC            ;Set the OK flag
.V90:            ;We're done
  POP  BX,AX     ;Restore used registers
  RET

;------------------------------------------------------------------------------
;TEST AND SEE IF AN INTERRUPT VECTOR HAS A VALID ADDRESS (other than 0)
;Inputs:  AL = Interrupt number to test
;Outputs: ZF = Set if invalid address (all zeroes)
;            = Clear if valid address (anything other than zeroes)
;Changes:
;------------------------------------------------------------------------------
TestInt:
  PUSH AX,BX,ES ;Save used registers
  MOV  AH,35h   ;Function 35h (get Interrupt Vector), AL = Int # to get
  INT  21h      ;Do it (returns ES:BX)
  MOV  AX,ES    ;Put the segment in AX so we can test it
  OR   AX,AX    ;Is the segment valid (set the return flag)?
  POP  ES,BX,AX ;Restore used registers
  RET


;
;CODE TO DETERMINE THE PHYSICAL MEMORY ADDRESS OF OUR PROGRAM
;

;------------------------------------------------------------------------------
;CALCULATE THE PHYSICAL ADDRESS OF OUR TSR IN MEMORY
;Inputs:  DS = Local Data Segment
;Outputs: [BasePhysAddr]
;Changes:
;------------------------------------------------------------------------------
CalcBasePhysAddr:
  PUSH EAX                ;Save used registers
  XOR  AX,AX              ;Use Offset 0 (beginning of Program)
  PUSH DS                 ;Put
  PUSH AX                 ;  ES:0000h
  POP  EAX                ;  in EAX
  CALL SegOff2PhysAddrEAX ;Calculate the Physical Address (returns EAX)
  MOV  [BasePhysAddr],EAX ;Store it
  POP  EAX                ;Restore used registers
  RET

;;------------------------------------------------------------------------------
;;CONVERT A SEGMENT:OFFSET (in EAX) TO A 32-BIT PHYSICAL ADDRESS
;;Inputs:  EAX = Segment:Offset to convert
;;Outputs: ZF  = Clear if OK
;;               EAX = Segment:Offset converted to a Physical Address
;;             = Set if Error (could not determine Physical Address)
;;               EAX = 0
;;Changes:
;;Notes: This will make a call to the VCPI-compliant Memory Manager
;;         (e.g.,EMM386) if one is loaded.  This will allow us to determine the
;;         Physical Address even if we are loaded in High Memory (a UMB).
;;       If under VCPI, this assumes that our program is in a contiguous
;;         physical address space, which it normally is under VCPI.
;;------------------------------------------------------------------------------
;SegOff2PhysAddrEAX:
;  PUSH EBX,ECX,EDX  ;Save used registers
;  XOR  ECX,ECX      ;Convert
;  XOR  EBX,EBX      ;  Segment:Offset
;  PUSH EAX          ;  to
;  POP  BX           ;  a
;  POP  CX           ;  Linear
;  SHL  ECX,4        ;  Address
;  ADD  ECX,EBX      ;  (ECX)
;  MOV  EBX,ECX      ;Save it in EBX
;  CALL TestRealMode ;Is the CPU in Real Mode?
;  JNC >S90          ;If so, we're done
;  CALL TestVCPI     ;If Protected Mode, is the Memory Manager VCPI-compliant?
;  JC  >S70          ;If not, error
;  SHR  ECX,12       ;CX = Page Number of Segment
;  MOV  AX,0DE06h    ;Function DE06h (convert Page to Physical Address)
;  INT  67h          ;Do it (Returns EDX = Physical Address)
;  OR   AH,AH        ;Did it work?
;  JNZ >S70          ;If not, error
;  SHL  ECX,12       ;Subtract out original
;  SUB  EBX,ECX      ;  (Linear) Page Offset
;  ADD  EBX,EDX      ;Add small offset to the Page Offset
;  JMP >S90          ;Done
;S70:                ;Error
;  XOR  EBX,EBX      ;Set error flag
;S90:                ;Done
;  MOV  EAX,EBX      ;Put result in EAX for the return
;  OR   EAX,EAX      ;Set return flag
;  POP  EDX,ECX,EBX  ;Restore used registers
;  RET
;
;;------------------------------------------------------------------------------
;;TEST TO SEE IF THE CPU IS IN REAL MODE
;;Inputs:  CPU already tested for 80286+
;;Outputs: CF = Clear if Real Mode
;;            = Set if Protected (V86) Mode
;;Changes:
;;------------------------------------------------------------------------------
;TestRealMode:
;  PUSH AX   ;Save used registers
;  SMSW AX   ;Get the Machine Status Word
;  ROR  AX,1 ;Set return flag
;  POP  AX   ;Restore used registers
;  RET
;
;;------------------------------------------------------------------------------
;;TEST AND SEE IF VCPI IS INSTALLED (VIRTUAL CONTROL PROGRAM INTERFACE)
;;Inputs:
;;Outputs: CF = Clear if installed
;;            = Set if not installed
;;Changes:
;;------------------------------------------------------------------------------
;TestVCPI:
;  PUSH AX,BX     ;Save used registers
;  MOV  AL,67h    ;Is Int 67h
;  CALL TestInt   ;  even installed?
;  JZ  >V70       ;If not, VCPI can't be installed
;  CALL TestMTask ;Are we running undera multitasker?
;  JZ  >V70       ;If so, assume VCPI can't be installed
;  MOV  AX,0DE00h ;Function DE00h (VCPI Install Check)
;  INT  67h       ;Do it (also returns BX = version)
;  OR   AH,AH     ;Is it installed?
;  JZ  >V80       ;If so, we're done
;V70:             ;VCPI is not installed
;  STC            ;Set the not installed flag
;  JMP >V90       ;We're done
;V80:             ;VCPI is installed
;  CLC            ;Set the installed flag
;V90:             ;We're done
;  POP  BX,AX     ;Restore used registers
;  RET
;
;;------------------------------------------------------------------------------
;;TEST AND SEE IF AN INTERRUPT VECTOR HAS A VALID ADDRESS (other than 0)
;;Inputs:  AL = Interrupt number to test
;;Outputs: ZF = Set if invalid address (all zeroes)
;;            = Clear if valid address (anything other than zeroes)
;;Changes:
;;------------------------------------------------------------------------------
;TestInt:
;  PUSH AX,BX,ES ;Save used registers
;  MOV  AH,35h   ;Function 35h (get Interrupt Vector), AL = Int # to get
;  INT  21h      ;Do it (returns ES:BX)
;  MOV  AX,ES    ;Put the segment in AX so we can test it
;  OR   AX,AX    ;Is the segment valid (set the return flag)?
;  POP  ES,BX,AX ;Restore used registers
;  RET
;
;;------------------------------------------------------------------------------
;;TEST AND SEE IF WE ARE IN A VIRTUAL MACHINE UNDERNEATH A MULTITASKER
;;Inputs:
;;Outputs: ZF = Set if we are under a MultiTasker
;;            = Clear if not
;;Changes:
;;NOTES: This call works with several different MultiTaskers besides
;;         Windows (DPMI), so it's an excellent test for what we need.
;;       If in a "DOS Box" under any sort of multi-tasker, especially
;;         MS-Windows, we can't safely determine our own physical
;;         address since multitaskers do not provide a function that
;;         allows it.
;;------------------------------------------------------------------------------
;TestMTask:
;  PUSH AX       ;Save used registers
;  MOV  AX,1680h ;Function 1680h (Release current Virtual Machine Time Slice)
;  INT  2Fh      ;Do it
;  OR   AL,AL    ;Did it work?
;  POP  AX       ;Restore used registers
;  RET


;
;CODE TO PARSE THE COMMAND LINE FOR SWITCHES, AND PRINT ERRORS.
;

;------------------------------------------------------------------------------
;PARSE THE COMMAND LINE FOR SWITCHES
;Inputs:
;Outputs: All kinds of stuff!
;Changes:
;------------------------------------------------------------------------------
ParseIt:
  CALL FixCmdLineCR      ;Replace CR at end of Command Line with a 0
  MOV  B [ParseTest],Yes ;Test input strings for errors
  CALL ParseThings       ;Do all input strings
  MOV  B [ParseTest],No  ;Parse string for real
  CALL ParseThings       ;Do all input strings
P90:
  RET

ParseThings:
  PUSH SI                     ;Save used registers
  MOV  SI,[EnvVarPtr]         ;[SI] = Our Environment Variable
  CMP  SI,-1                  ;Is there an Environment Variable to parse?
  JE  .P30                    ;If no, skip it
  OR   B [ProgFlags],DoEnvir  ;Mark as doing the Environment
  CMP  B [ParseTest],Yes      ;Just doing the Test Run?
  JE  .P20                    ;If so, don't write the variable contents yet
  MOV  DX,EnvMsg              ;Write the first part of the
  CALL WriteZPause            ;  environment message to the screen
  CALL WriteEnvCon            ;Write the environment variable contents
  CALL WriteCrLfPause2        ;Move down
.P20:                         ;Do the Environment Variable
  CALL ParseCmdLine           ;Parse the Environment (quits if Error)
.P30:                         ;Do StdIn
  AND  B [ProgFlags],~DoEnvir ;Mark as doing Command Line
  MOV  SI,81h                 ;Assume "real" Command Line
  CMP  W [CmdLineVarPtr],-1   ;Have a CMDLINE Environment variable?
  JE  .P50                    ;If not, just do regular command line
  MOV  SI,[CmdLineVarPtr]     ;If so, point at the variable
.P50:                         ;Pointed at Command Line Tail
  CALL ParseCmdLine           ;Parse Command Line
  POP  SI                     ;Restore used registers
  RET

;------------------------------------------------------------------------------
;PARSE THE COMMAND LINE FOR SWITCHES
;Inputs:  [ParseTest]
;         [SI] = Option String to Parse
;Outputs:
;Changes: SI
;------------------------------------------------------------------------------
ParseCmdLine:
  PUSH AX             ;Save used registers
.P10:                 ;Look for the next switch
  CALL IsSpaceOrEOX   ;Look for a valid character
  JZ  .P90            ;If EOL, we're done
  CMP  AL,'/'         ;Is it a slash?
  JE  .P15            ;If so, jump to handle it
  CMP  AL,'-'         ;Is it a dash?
  JE  .P15            ;If so, jump to handle it
  DEC  SI             ;If not, point back at the first character
  JMP .P20            ;Continue
.P15:                 ;It's a slash or a dash
  CALL IsSpaceOrEOL   ;Look for a valid switch character
  JZ  .P70            ;If no character, there's an error
.P20:                 ;Handle the Slashes and Dashes, if there
  CALL GetDecimal     ;If so, see if it's a Number
  JC  .P30            ;If not, try other possibilities
;  OR   AX,AX          ;Is it too small?
;  JZ  >P70            ;If so, error
  CMP  AX,MaxCmdDuty  ;Is it too big?
  JA  .P70            ;If so, Error
  MOV  [DutyToSet],AL ;If OK, store it
  JMP .P50            ;Done with this switch
.P30:                 ;Look for the switch
  CALL GetSwitch      ;See if it matches one of our switches
  JZ  .P70            ;If not, error
.P50:                 ;Got a valid switch
  JMP .P10            ;Keep looking for more switches
.P70:                 ;Error - tell the user where it was
  CALL WriteCmdErr    ;Display the error for the user
  MOV  AL,ErLvlOption ;ErrorLevel = Bad Option on command line
  MOV  DX,NoMsg       ;Point at an empty message
  JMP  Exit           ;Print error message and quit
.P90:                 ;We're done
  POP  AX             ;Restore used registers
  RET

;------------------------------------------------------------------------------
;GET THE SWITCH CHARACTERS, AND DO WHATEVER IT IS THEY'RE ASKING
;Inputs:  DS:[SI] = Command line pointer
;Outputs: Lots of stuff!!!
;         [ParseError]
;         ZF = Set if Error
;            = Clear if OK
;Changes:
;------------------------------------------------------------------------------
GetSwitch:
  PUSH AX,BX,DI,BP        ;Save used registers
  MOV  BX,SwitchList      ;Point at the list of switch code words
  CALL GetCode            ;See if its a match
  JNC .S10                ;If so, jump to test it
  CALL GetNextChar        ;If not, it's a single character
  CALL Capitalize         ;Capitalize it
.S10:                     ;We have a Switch to test!
  MOV  BX,SwitchTbl       ;Point at the Table of Offsets
.S20:                     ;Loop to here for each table entry
  MOV  AH,[BX]            ;Get the switch from our table?
  OR   AH,AH              ;Is it the end of the table?
  JZ  .S70                ;If so, there's an error
  CMP  AL,AH              ;If a valid entry, is it a match?
  JE  .S30                ;If so, jump to handle it
  ADD  BX,3               ;If not, point at the next table entry
  JMP .S20                ;And keep looking
.S30:                     ;It's a match from the table
  MOV  DI,ProgFlags       ;[DI] = [ProgFlags]
  MOV  AH,[ParseTest]     ;Pass the "Testing" flag
  OR   AH,AH              ;Set the ZF for Testing
  CALL W [BX+1]           ;Do the Switch stuff
  JMP .S90                ;And quit
.S70:                     ;There's an error
  MOV  B [ParseError],Yes ;Mark the error flag
.S90:                     ;We're done
  CMP  B [ParseError],Yes ;Set/Clear the error flag
  POP  BP,DI,BX,AX        ;Restore used registers
  RET

;------------------------------------------------------------------------------
;Display Help (Syntax) Message
;Inputs:   DS  = Local Data Segment
;          ES  = TSR Data Area
;         [DI] = [ProgFlags]
;         [SI] = Command Line Pointer
;          AH  = [ParseTest], ZF Set if [ParseTest] = No
;------------------------------------------------------------------------------
DoSwitchH:
  OR   B [DI],Help ;Set the appropriate Flag
  RET

;------------------------------------------------------------------------------
;Display ErrorLevel Table
;Inputs:   DS  = Local Data Segment
;          ES  = TSR Data Area
;         [DI] = [ProgFlags]
;         [SI] = Command Line Pointer
;          AH  = [ParseTest], ZF Set if [ParseTest] = No
;------------------------------------------------------------------------------
DoSwitchE:
  OR   B [DI],ErrLvl ;Set the appropriate Flag
  RET

;------------------------------------------------------------------------------
;Display list of Command-line (Option) Aliases
;Inputs:   DS  = Local Data Segment
;          ES  = TSR Data Area
;         [DI] = [ProgFlags]
;         [SI] = Command Line Pointer
;          AH  = [ParseTest], ZF Set if [ParseTest] = No
;------------------------------------------------------------------------------
DoSwitchA:
  OR   B [DI],Alias ;Set the appropriate Flag
  RET

;------------------------------------------------------------------------------
;Write All Embedded Controller Data
;Inputs:   DS  = Local Data Segment
;          ES  = TSR Data Area
;         [DI] = [ProgFlags]
;         [SI] = Command Line Pointer
;          AH  = [ParseTest], ZF Set if [ParseTest] = No
;------------------------------------------------------------------------------
DoSwitchL:
  OR   B [DI],AllECData ;Set the appropriate Flag
  RET

;------------------------------------------------------------------------------
;Monitor/Write Changes in Embedded Controller Data
;Inputs:   DS  = Local Data Segment
;          ES  = TSR Data Area
;         [DI] = [ProgFlags]
;         [SI] = Command Line Pointer
;          AH  = [ParseTest], ZF Set if [ParseTest] = No
;------------------------------------------------------------------------------
DoSwitchC:
  OR   B [DI],ChgECData ;Set the appropriate Flag
  RET

;------------------------------------------------------------------------------
;Use Intel On-Demand Clock Modulation (ODCM)
;Inputs:   DS  = Local Data Segment
;          ES  = TSR Data Area
;         [DI] = [ProgFlags]
;         [SI] = Command Line Pointer
;          AH  = [ParseTest], ZF Set if [ParseTest] = No
;------------------------------------------------------------------------------
DoSwitchO:
  PUSH AX                   ;Save used registers
  MOV  AL,NoACPI            ;Bit mask to use
  CALL DoSwitchWithYNPrgRvs ;Do it
  POP  AX                   ;Restore used registers
  RET

;------------------------------------------------------------------------------
;Set Disk Flush Delay
;Inputs:   DS  = Local Data Segment
;          ES  = TSR Data Area
;         [DI] = [ProgFlags]
;         [SI] = Command Line Pointer
;          AH  = [ParseTest], ZF Set if [ParseTest] = No
;------------------------------------------------------------------------------
DoSwitchD:
  PUSH AX,DX              ;Save used registers
  CALL SkipColonEquals    ;Skip the Colon or Equals (if there)
  CALL GetDecimal         ;Get the Delay value
  JC  .D70                ;If no number, error
  CMP  AX,60              ;Is it too big?
  JA  .D70                ;If so, error
.D10:                     ;Got a valid Delay Value (AX)
  CMP  B [ParseTest],Yes  ;Is this just the test run?
  JE  .D90                ;If so, we're done
.D20:                     ;Store the new Delay Value
  MOV  [FlushDelay],AX    ;Store it
  JMP .D90                ;Done
.D70:                     ;Error
  MOV  B [ParseError],Yes ;Mark as an error
.D90:                     ;Done
  POP  DX,AX              ;Restore used registers
  RET


;
;SUPPORT ROUTINES FOR PROCESSING GENERAL COMMAND-LINE SWITCHES
;

;------------------------------------------------------------------------------
;HANDLE A SWITCH WITH A YES/NO OPTION
;Inputs:  DS = Local Segment
;         ES = TSR Segment
;         If using EMS, we have the EMS Context
;         [DPMSDSel]
;         SI = Command Line Pointer
;         AL = Bit mask to Set/Unset
;         AH = [ParseTest] status
;Outputs: Sets/Unsets bit in TSR:[EMSFlags] or Local:[ProgFlags] as needed
;Changes:
;NOTES: If we are changing the resident (TSR) part of the program
;         (TSR:[EMSFlags]), we do not actually change anything unless
;         [ParseTest] is set to No.  If we are changing the transient
;         part of the program (Local:[ProgFlags]), we change it no matter
;         what [ParseTest] is set to.
;       Forward and Reverse refer to Forward and Reverse Logic.  With
;         Forward Logic, if the user says Yes, we set the particular bit
;         to 1.  With Reverse Logic, when the user says Yes, we set
;         to bit to 0.
;------------------------------------------------------------------------------
;DoSwitchWithYNTsrRvs:
;  PUSH CX                 ;Save used registers
;  MOV  CL,-1              ;Mark as Reverse Logic
;  JMP  DoSwWithYN         ;Jump to do ES:[EMSFlags]
;DoSwitchWithYNTsrFwd:
;  PUSH CX                 ;Save used registers
;  XOR  CL,CL              ;Mark as Forward Logic
;  JMP  DoSwWithYN         ;Jump to do ES:[EMSFlags]
DoSwitchWithYNPrgRvs:
  PUSH CX                 ;Save used registers
  MOV  CL,-1              ;Mark as Reverse Logic
  JMP  DoSwWithYN.Y001    ;Jump to do DS:[ProgFlags]
DoSwitchWithYNPrgFwd:
  PUSH CX                 ;Save used registers
  XOR  CL,CL              ;Mark as Forward Logic
;  JMP  DoSwWithYN.Y001    ;Jump to do DS:[ProgFlags]
DoSwWithYN:
;  PUSH BX                 ;Save used registers
;  MOV  BX,EMSFlags        ;[BX] = [EMSFlags]
;  JMP .Y00                ;Do it
.Y001:                    ;DS:[ProgFlags]
  PUSH BX                 ;Save used registers
  MOV  BX,ProgFlags       ;[BX] = [ProgFlags]
;  JMP .Y00                ;Do it
.Y00:
  PUSH AX                 ;Save used registers
  MOV  CH,AL              ;Save Bit Mask to set
  CALL GetYesNo4Switch    ;Get the Yes/No parameter (AL)
  JC  .Y70                ;If error, handle it
  OR   AL,AL              ;Is it Yes?
  JNZ .Y20                ;If so, jump to handle it
.Y10:                     ;No
  OR   CL,CL              ;Is it Forward Logic?
  JZ  .Y40                ;If so, jump to handle it
  JMP .Y50                ;If not, jump to handle Reverse Logic
.Y20:                     ;Yes
  OR   CL,CL              ;Is it Forward Logic?
  JZ  .Y50                ;If so, jump to handle it
.Y40:                     ;Unset the Bit
  NOT  CH                 ;Need to Unset
;  CMP  BX,LastEMSByte     ;Is it for [ProgFlags]?
;  JAE .Y45                ;If so, jump to handle it
;.Y42:                     ;Unset ES:[EMSFlags]
;  OR   AH,AH              ;Just a Test Run?
;  JNZ .Y90                ;If so, quit
;  CALL AndByteInEMSBXCH   ;Unset the appropriate EMS flag
;  JMP .Y90                ;Done
;.Y45:                     ;Unset DS:[ProgFlags]
  AND  [BX],CH            ;Unset the appropriate flag
  JMP .Y90                ;Done
.Y50:                     ;Set the Bit
;  CMP  BX,LastEMSByte     ;Is it for [ProgFlags]?
;  JAE .Y55                ;If so, jump to handle it
;.Y52:                     ;Set ES:[EMSFlags]
;  OR   AH,AH              ;Just a Test Run?
;  JNZ .Y90                ;If so, quit
;  CALL OrByteInEMSBXCH    ;Set the appropriate EMS flag
;  JMP .Y90                ;Done
;.Y55:                     ;Set DS:[ProgFlags]
  OR   [BX],CH            ;Set the appropriate flag
  JMP .Y90                ;Done
.Y70:                     ;Error
  MOV  B [ParseError],Yes ;Mark as an Error
.Y90:                     ;Done
  POP  AX                 ;Restore used registers
  POP  BX                 ;Restore used registers
  POP  CX                 ;Restore used registers
  RET

;------------------------------------------------------------------------------
;GET A YES/NO OPTION FOR A COMMAND-LINE SWITCH
;Inputs:  [SI] = Command Line Pointer
;Outputs: CF = Clear if OK
;              ZF = Set if No
;                   AL = 0 (No)
;                 = Clear if Yes
;                   AL = -1 (Yes)
;            = Set if Error
;              AL = 0
;Changes:
;------------------------------------------------------------------------------
GetYesNo4Switch:
  PUSH BX,CX              ;Save used registers
  MOV  CH,AH              ;Save original AH
  CALL SkipColonEquals    ;Skip Colon/Equals (if there)
  MOV  BX,SwitchListYesNo ;[BX] = List of Code Words
  CALL GetCode            ;See if its a match
  JNC .Y20                ;If so, jump to test it
  CALL GetNextChar        ;If not, get a single character
  JZ  .Y70                ;If end-of-line, error
  CALL Capitalize         ;Capitalize it
.Y20:                     ;Got a character
  CMP  AL,'Y'             ;Is it Yes?
  JE  .Y40                ;If so, handle it
  CMP  AL,'N'             ;Is it No?
  JNE .Y70                ;If not, error
.Y30:                     ;No
  XOR  AL,AL              ;If so, make it No
  JMP .Y80                ;Done
.Y40:                     ;Yes
  MOV  AL,Yes             ;Mark it as a Yes
  JMP .Y80                ;Done
.Y70:                     ;Error
  XOR  AL,AL              ;Set AL to 0
  STC                     ;Set Error Flag
  JMP .Y90                ;Done
.Y80:                     ;OK
  OR   AL,AL              ;Set Zero Flag for Return
  CLC                     ;Set OK Flag
.Y90:                     ;Done
  MOV  AH,CH              ;Restore original AH
  POP  CX,BX              ;Restore used registers
  RET

;------------------------------------------------------------------------------
;REPLACE THE CARRIAGE RETURN AT THE END OF THE CMD LINE TAIL WITH A 0
;Inputs:  CS = DS = PSP Segment
;Outputs:
;Changes: Last Byte of Command Tail
;------------------------------------------------------------------------------
FixCmdLineCR:
  PUSH AX,CX,DI,ES   ;Save used registers
  MOV  AL,CR         ;Look for a CR
  MOV  CX,7Fh        ;Maximize Byte Counter
  MOV  ES,DS         ;Point ES:[DI]
  MOV  DI,81h        ;  at the Command Line Tail
  REPNE SCASB        ;Look for the CR
  MOV  B [ES:DI-1],0 ;Replace the CR with a 0
  POP  ES,DI,CX,AX   ;Restore used registers
  RET

;------------------------------------------------------------------------------
;GET THE NEXT CHARACTER FROM THE ENVIRONMENT OR COMMAND LINE
;Inputs:  [SI] = Pointer (Command Line, Environment, or File Data Pointer)
;Outputs: AL = The next character
;         ZF = Set if End-Of-Line (Character = ASCII 0)
;            = Clear if "real" character
;Changes: SI
;------------------------------------------------------------------------------
GetNextChar:
  PUSH DS                    ;Save used registers
  TEST B [ProgFlags],DoEnvir ;Are we doing the Program Environment Variable?
  JNZ .N10                   ;If so, handle it
  CMP  W [CmdLineVarPtr],-1  ;Need to use the CMDLINE Environment variable?
  JE  .N90                   ;If not, just do the "real" command line
.N10:                        ;Get next character from the Environment
  MOV  DS,[PSPEnvirSeg]      ;Point at the Environment Segment
.N90:                        ;DS:[SI] points at the next character
  LODSB                      ;Get the character from the "real" command line
  OR   AL,AL                 ;Set ZF if EOL
  POP  DS                    ;Restore used registers
  RET

;------------------------------------------------------------------------------
;SKIP OVER SPACES TO FIND THE NEXT LEGITIMATE CHARACTER, TESTING FOR EOL
;Inputs:  DS:[SI] = Command Line Pointer
;Outputs: ZF = Set if EOL
;               AL  = Unchanged
;              [SI] = End-of-Line Character
;            = Clear if not EOL
;               AL  = First non-space character
;              [SI] = Character AFTER the next non-space character
;Changes:
;------------------------------------------------------------------------------
IsSpaceOrEOX:
  CALL IsSpaceOrEOL ;Skip over the spaces
  JZ  .X90          ;If end-of-line, we're done
  CALL GetNextChar  ;If not, get the next character
  OR   AL,AL        ;Set return flag
.X90:               ;Done
  RET

;------------------------------------------------------------------------------
;SKIP OVER SPACES TO FIND LEGITIMATE CHARACTERS, AND TEST FOR EOL
;Inputs:  DS:[SI] = Command Line Pointer
;Outputs: ZF = Set if EOL
;            = Clear if legitimate character
;              [SI] = The Next non-Space Character
;Changes:
;------------------------------------------------------------------------------
IsSpaceOrEOL:
  PUSH AX          ;Save used registers
.L10:              ;Loop to here to skip over spaces
  CALL GetNextChar ;Get the next character
  CMP  AL,' '      ;Is it a space?
  JE  .L10         ;If so, get the next character
  CMP  AL,Tab      ;Is it a Tab?
  JE  .L10         ;If so, get the next character
  DEC  SI          ;If not, point back at the character
  OR   AL,AL       ;Set EOL flag
  POP  AX          ;Restore used registers
  RET

;------------------------------------------------------------------------------
;SKIP OVER A COLON OR EQUALS, IF THERE
;Inputs:  DS:[SI] = Command Line Pointer
;Outputs: CF = Clear if Colon or Equals was found (and skipped)
;              [SI] = First non-Space Character after the Colon/Equals
;            = Set if No Colon or Equals was found
;              [SI] = First non-Space Character after where we were looking
;Changes:
;------------------------------------------------------------------------------
SkipColonEquals:
  PUSH AX           ;Save used registers
  CALL IsSpaceOrEOX ;Skip over the Spaces
  JZ  .Q75          ;If End-of-Line, nothing to get
  CMP  AL,':'       ;Is it a Colon?
  JE  .Q80          ;If so, we're done
  CMP  AL,'='       ;Is it an equals?
  JE  .Q80          ;If so, we're done
.Q70:               ;No Colon/Equals Found
  DEC  SI           ;Point back at the character
.Q75:               ;[SI] correct
  STC               ;Set return flag
  JMP .Q90          ;Done
.Q80:               ;Colon/Equals Found
  CALL IsSpaceOrEOL ;Go to the next character
  CLC               ;Set return flag
.Q90:               ;Done
  POP  AX           ;Restore used registers
  RET

;------------------------------------------------------------------------------
;CONVERT A CODE WORD FROM THE COMMAND LINE TO A BYTE FROM THE LOOKUP TABLE
;Inputs:  [SI] = Command Line Pointer
;         [BX] = List to Test
;Outputs: CF = Clear if a match was found
;              AL = Entry from Table
;              [SI] = Next character after the Code Match
;         CF = Set if no match found (error)
;              AL = Unchanged
;              SI = Unchanged
;Changes: SI if valid match found
;------------------------------------------------------------------------------
GetCode:
  PUSH BX,DX         ;Save used registers
  MOV  DX,AX         ;Save AX in case there's no match
.C10:                ;Loop to here for each list of words
  CMP  B [BX],0      ;Are we at the end of our table?
  JE  .C80           ;If so, we couldn't find a match
  XOR  AH,AH         ;Assume it's a match
  PUSH SI            ;Save our command line pointer for a second
.C20:                ;Loop to here for each character in a word
  CALL GetNextChar   ;Get the next character
  CALL Capitalize    ;Capitalize it
  CALL CmpALBXNoCase ;Is it a match?
  JZ  .C30           ;If so, handle it
  INC  AH            ;If not, mark us as no match
.C30:                ;The character is tested
  INC  BX            ;Point at the next character in our test word
  CMP  B [BX],0      ;Are we at the end of the word?
  JNE .C20           ;If not, keep going until we're done
  INC  BX            ;Point at the next word or code list
  OR   AH,AH         ;Was it a match?
  JZ  .C50           ;If so, jump to handle it
  POP  SI            ;If not, restore our command line pointer
  CMP  B [BX],0      ;Is this the end of our word list?
  JNE .C10           ;If not, just test the next word
  INC  BX,2          ;If so, skip over the codes
  JMP .C10           ;Keep going until we're done with our list
.C50:                ;We've found a match!
  POP  AX            ;Lose our original command line pointer
  DEC  BX            ;Point back at the end-of-word marker
.C60:                ;Loop to here to find the end-of-list
  MOV  AX,[BX]       ;Get the next two characters in our list
  INC  BX            ;Point at the next character for next time
  OR   AX,AX         ;Is this the start of our code list?
  JNE .C60           ;If not, keep looking
  INC  BX            ;If so, point at the character we're looking for
  MOV  DL,[BX]       ;Get the character from the table
  CLC                ;Mark our OK flag
  JMP .C90           ;And we're done
.C80:                ;No match found
  STC                ;Mark us as no match
.C90:                ;We're done
  MOV  AX,DX         ;Set AX to the correct value
  POP  DX,BX         ;Restore used registers
  RET

CmpALBXNoCase:
  PUSH AX         ;Save used registers
  CALL Capitalize ;Capitalize AL
  MOV  AH,AL      ;Store it in AH
  MOV  AL,[BX]    ;Get [BX]
  CALL Capitalize ;Capitalize it
  CMP  AL,AH      ;Compare AL & [BX]
  POP  AX         ;Restore used registers
  RET


;
;CODE THE TELL THE USER WHERE THE COMMAND LINE ERROR OCCURRED
;

;------------------------------------------------------------------------------
;WRITE THE COMMAND LINE OR ENVIRONMENT ERROR INFORMATION TO THE SCREEN
;Inputs:  [SI] = Command line Pointer (if Command Line)
;              = StdIn Buffer Pointer (if StdIn String)
;              = Environment Pointer (if Environment Variable)
;         DoEnvir, DoStdIn
;Outputs:
;Changes: Writes information to screen
;------------------------------------------------------------------------------
WriteCmdErr:
  PUSH AX,BX,CX,DX        ;Save used registers
  PUSH DI,SI,BP           ;Save used registers
  CALL FindBadChar        ;Find the actual bad character in the string (SI)
  CALL SetupCmdErrStrings ;Set up the String Pointers and Sizes
                          ;DI:[AX] = Command Line String
                          ;DS:[BX] = Program name at beginning of String
                          ;    CX  = Size of BX String
                          ;DS:[DX] = Header String
                          ;DS:[BP] = Footer String
  CALL WriteZErr          ;Write the Header
  CALL WriteCrLfErr       ;Move down
  SUB  SI,AX              ;Calculate the number
  ADD  CX,SI              ;  of spaces
  DEC  CX                 ;  to write
  CALL WriteCmdString     ;Write the Command-line String (may modify CX)
  CALL WriteCrLfErr       ;Move down
  MOV  B [SingleMsg],' '  ;Want to write spaces
  MOV  DX,SingleMsg       ;Point at the string
.E60:                     ;Loop to here to write each space (number in CX)
  CALL WriteZErr          ;Write the space
  LOOP .E60               ;Keep writing them until we're done
  MOV  DX,ParseErrMsg     ;Write the Pointer Part
  CALL WriteZErr          ;  of the Error Message
  MOV  DX,BP              ;Write the last part
  CALL WriteZErr          ;  of the message
  POP  BP,SI,DI           ;Restore used registers
  POP  DX,CX,BX,AX        ;Restore used registers

  RET

;------------------------------------------------------------------------------
;GO BACKWARDS IN AN ERRORED OPTION STRING TO INDICATE TO USER WHERE ERROR WAS
;Inputs:  SI = Option String Pointer (Environment, StdIn, or Command Line)
;                where error was found
;Outputs: SI = Options String Pointer, adjusted to point at a "Real" character
;Changes:
;------------------------------------------------------------------------------
FindBadChar:
  PUSH AX          ;Save used registers
  DEC  SI          ;Go back 1 character to start
.B10:              ;Loop to here to find a legitimate character
  CALL GetNextChar ;Get the character
  JZ  .B40         ;If end-of-line, keep going back
  CMP  AL,' '      ;Is it a space?
  JNE .B90         ;If not, we're done
.B40:              ;Need to keep going back
  SUB  SI,2        ;Go back to the previous character
  JMP .B10         ;Keep looking
.B90:              ;Done
  POP  AX          ;Restore used registers
  RET

;------------------------------------------------------------------------------
;SET UP THE STRING POINTERS AND SIZES TO BE ABLE TO WRITE THE COMMAND ERROR
;Inputs:  DS = Local Data Segment
;Outputs: DI:[AX] = Command-line String to write
;         DS:[DX] = First Error Message (Header) to write
;         DS:[BX] = Second message to write (first part of Command string)
;             CX  = Number of Bytes to add to String Size
;         DS:[BP] = Third message to write (Footer)
;Changes:
;------------------------------------------------------------------------------
SetupCmdErrStrings:
  TEST B [ProgFlags],DoEnvir  ;Working with the Environment?
  JNZ .S40                    ;If so, handle it
.S10:                         ;Command Line
  MOV  AX,81h                 ;DI:[AX] =
  MOV  DI,DS                  ;  Command-line Tail
  MOV  BX,RealName            ;DS:[BX] = Program Name
  MOV  CX,[RealNameSz]        ;CX = Size of [BX] String
  CMP  W [CmdLineVarPtr],-1   ;Real Command Line?
  JE  .S30                    ;If so, continue
.S20:                         ;CMDLINE Environment Variable
  MOV  DI,[PSPEnvirSeg]       ;DI:[AX] =
  MOV  AX,[CmdLineVarPtr]     ;  CMDLINE
  SUB  AX,CmdLineVarSize      ;  Environment Variable
.S30:                         ;Have Command-line parameters set up
  MOV  DX,ParseCmdMsg         ;DS:[DX] = Header String
  MOV  BP,ParseErrMsg2        ;DS:[BP] = Footer String
  JMP .S90                    ;Done
.S40:                         ;Environment
  MOV  DI,[PSPEnvirSeg]       ;DI:[AX] =
  MOV  AX,[EnvVarPtr]         ;  SLOWACPI
  SUB  AX,EnvVarSize          ;  Environment Variable
  MOV  BX,NoMsg               ;DS:[BX] = Second message to write
  XOR  CX,CX                  ;CX = Size of [BX] String
  MOV  DX,ParseEnvMsg         ;DS:[DX] = Header String
  MOV  BP,ParseEnvMsg2        ;DS:[BP] = Footer String
.S90:                         ;Done
  RET

;------------------------------------------------------------------------------
;WRITE THE CONTENTS OF THE COMMAND STRING, WITH MORE MESSAGES AS NEEDED
;Inputs:  CS = DS = Local Data Segment
;         DS:[BX] = First String to write (may not be needed!)
;         DI:[AX] = Second String (main part) to write
;             CX  = Number of Spaces to write at beginning (if normal)
;Outputs: CX = Adjusted number of spaces to write
;Changes:
;------------------------------------------------------------------------------
WriteCmdString:
  PUSH AX,BX,DX,DI,SI      ;Save used registers
  PUSH BP,DS,ES            ;Save used registers
  MOV  BP,CX               ;Save the original Space Counter in BP
  MOV  ES,DI               ;Save the second string Pointer
  MOV  SI,AX               ;  in ES:[SI]
  MOV  DX,BX               ;Save the length
  CALL CalcStrSizeDX       ;  of the first string
  MOV  DI,CX               ;  in DI
  MOV  DS,ES               ;Save the length
  CALL CalcStrSizeSI       ;  of the second string
  MOV  AX,CX               ;  in AX
  CMP  BP,70               ;Are there too many spaces to fit on one line?
  JBE .G20                 ;If not, continue
.G10:                      ;Need to lop off the beginning
  SUB  BP,DI               ;We will not be
  XOR  DI,DI               ;  writing the
  MOV  BX,NoMsg            ;  first string
  CMP  BP,70               ;Are there still too many spaces to fit?
  JBE .G20                 ;If not, continue
  MOV  BX,MoreLeftMsg      ;Point at the More Message
  ADD  BP,MoreMsgSize      ;Compensate number of spaces for More Message
  MOV  DI,60               ;We want the number of spaces to be 60
  SUB  DI,BP               ;Calculate how far into the Second string
  NEG  DI                  ;  we need to start to accomplish that
  MOV  BP,59               ;BP = New Number of Spaces
  ADD  SI,DI               ;  where we need to start writing
  SUB  AX,DI               ;  of second string
  MOV  DI,MoreMsgSize      ;DI = Size of new first string (More Message)
.G20:                      ;Beginning of line is accounted for
  MOV  DS,CS               ;Write the
  MOV  DX,BX               ;  first
  CALL WriteZErr           ;  string
  MOV  DS,ES               ;Point DS:[DX] at the
  MOV  DX,SI               ;  second string
  ADD  DI,AX               ;Calculate total length of both strings
  CMP  DI,79               ;Will it fit on one line?
  JBE .G40                 ;If so, continue
  MOV  BX,(80-MoreMsgSize) ;Calculate how many characters
  SUB  BX,DI               ;  of the second string
  ADD  BX,AX               ;  we need to write
  MOV  AL,[SI+BX]          ;Save the old character in the string
  MOV  B [SI+BX],0         ;Convert it to an end-of-string character
  CALL WriteZErr           ;Write the truncated string
  MOV  [SI+BX],AL          ;Restore the original character of the string
  MOV  DS,CS               ;Write the
  MOV  DX,MoreRightMsg     ;  More Message
.G40:                      ;Write last message
  CALL WriteZErr           ;Write it
.G90:                      ;Done
  MOV  CX,BP               ;Return CX = number of spaces to write
  POP  ES,DS,BP            ;Restore used registers
  POP  SI,DI,DX,BX,AX      ;Restore used registers
  RET

;------------------------------------------------------------------------------
;WRITE THE ENVIRONMENT VARIABLE CONTENTS TO THE SCREEN
;Inputs:  [EnvVarPointer] (-1 if no Environment variable exists)
;Outputs:
;Changes: Writes to CON or ERR
;------------------------------------------------------------------------------
WriteEnvCon:
  CMP  W [EnvVarPtr],-1 ;Is there even an Environment variable to write?
  JE  .W90              ;If not, we're done
  PUSH DX,DS            ;Save used registers
  MOV  DX,[EnvVarPtr]   ;Point at the
  SUB  DX,EnvVarSize    ;  beginning of the Variable
  MOV  DS,[PSPEnvirSeg] ;Point at the Environment Segment
  CALL WriteZPause      ;Write it
  POP  DS,DX            ;Restore used registers
.W90:                   ;We're done
  RET


;
;MISCELLANEOUS COMMAND-LINE RELATED STUFF
;

;------------------------------------------------------------------------------
;GET OUR REAL PROGRAM NAME
;Inputs:
;Outputs: RealName, [RealNameSz]
;Changes:
;------------------------------------------------------------------------------
GetRealName:
  PUSH AX,CX,DI,SI        ;Save used registers
  PUSH DS,ES              ;Save used registers
  MOV  DS,[PSPEnvirSeg]   ;Point DS and ES
  MOV  ES,DS              ;  at the environment segment
  XOR  DI,DI              ;Point at the beginning of Environment variable list
  MOV  CX,-1              ;Max out the count limiter
  XOR  AX,AX              ;Need to look for a double 0
.N10:                     ;Loop to here to skip over environment variables
  REPNE SCASB             ;Look for the end of this environment variable
  CMP  B [DI],0           ;Is it the end of the variable list (double zero)?
  JNE .N10                ;If not, keep skipping over environment variables
  CMP  W [DI+1],0         ;If so, is there at least one string after the env?
  JE  .N90                ;If not, we're done
  LEA  SI,[DI+3]          ;If so, point DS:[SI] at the True Name
  MOV  ES,CS              ;Point ES (for ES:[DI]) at our local data
.N20:                     ;Loop to here to skip over drive/path info
  MOV  DI,RealName        ;Point at the beginning of our data area
  XOR  CX,CX              ;Start the length counter at 0
.N30:                     ;Loop to here for each character in the name
  LODSB                   ;Get the next character of the name
  CMP  AL,'.'             ;Is it a dot?
  JE  .N40                ;If so, we may have the name
  CMP  AL,Backslash       ;Is it a path separator?
  JE  .N20                ;If so, start looking for the name again
  CALL Capitalize         ;If part of a name, capitalize the character
  STOSB                   ;Store it in our data area
  INC  CX                 ;Increment the size counter
  JMP .N30                ;And keep looking for more characters
.N40:                     ;We may have the name
  LODSB                   ;Get the next character of the name
  OR   AL,AL              ;End of the name?
  JZ  .N50                ;If so, it really was our program name
  CMP  AL,Backslash       ;Was it a Directory with a dotted name?
  JE  .N20                ;If so, keep looking for a file name
  JMP .N40                ;If not, keep looking for the end of the name
.N50:                     ;Have the name
  XOR  AL,AL              ;Store
  STOSB                   ;  a 0
  MOV  [CS:RealNameSz],CX ;Store the Size
.N90:                     ;We're done
  POP  ES,DS              ;Restore used registers
  POP  SI,DI,CX,AX        ;Restore used registers
  RET

;------------------------------------------------------------------------------
;GET THE POINTERS TO THE ENVIRONMENT VARIABLES WE NEED
;Inputs:  CS = DS = Local Data Segment (also PSP Data Area)
;Outputs: Various Environment Pointers
;Changes:
;------------------------------------------------------------------------------
GetEnvVars:
  PUSH BX,CX,SI             ;Save used registers
.V20:                       ;Get Program Variable
  MOV  SI,EnvVarString      ;Get
  MOV  BX,EnvVarPtr         ;  our
  MOV  CX,EnvVarSize        ;  Program Variable
  CALL GetEnvVarPtr         ;  Pointer
.V50:                       ;Get CMDLINE string
;  CMP  [ParentIsShell],Yes  ;Were we called from the command line?
;  JNE .V90                  ;If not, CMDLINE is for our Parent, not us
  CMP  B [80h],7Eh          ;Is command line size maxed out?
  JB  .V90                  ;If not, don't worry about CMDLINE Env Var
  MOV  SI,CmdLineVarString  ;Get
  MOV  BX,CmdLineVarPtr     ;  the
  MOV  CX,CmdLineVarSize    ;  CMDLINE
  CALL GetEnvVarPtr         ;  Pointer
  CALL AdjustCmdLine        ;Compensate CMDLINE Pointer for Program Name
.V90:                       ;Done
  POP  SI,CX,BX             ;Restore used registers
  RET

;------------------------------------------------------------------------------
;GET THE POINTER TO AN ENVIRONMENT VARIABLE
;Inputs:   CS = DS = Local Data Segment (also contains PSP)
;         [BX] = Where to store the Pointer at
;          CX  = Length of String
;         [SI] = Environment Variable String to Look for (ends in =)
;Outputs: ZF = Set if Error (Variable not found)
;               [BX] = -1
;             = Clear if OK (variable was found)
;               [BX] = Pointer to String (in Environment Segment, NOT PSP!!)
;Changes:
;------------------------------------------------------------------------------
GetEnvVarPtr:
  PUSH AX,CX,SI,BP      ;Save used registers
  PUSH DS,ES            ;Save used registers
  MOV  W [BX],-1        ;Default = -1 (does not exist)
  MOV  ES,[PSPEnvirSeg] ;ES:[DI] =
  XOR  DI,DI            ;  Environment Variable List
  MOV  DX,CX            ;Save the Size
  MOV  BP,SI            ;Save the original Pointer
  XOR  AL,AL            ;Need to look for 0's
.V10:                   ;Loop to here for each Environment variable
  MOV  CX,DX            ;CX = Number of bytes to test
  MOV  SI,BP            ;DS:[SI] = String to Test for
  REPE CMPSB            ;Is it a match?
  JZ  .V30              ;If so, continue
  MOV  CX,-1            ;Max out the count limiter
  REPNE SCASB           ;Look for the end of this environment variable
  CMP  [ES:DI],AL       ;End of Environment?
  JNE .V10              ;If not, keep looking
  JMP .V90              ;If so, no variable
.V30:                   ;Found it!
  MOV  [BX],DI          ;Store the Pointer
.V90:                   ;Done
  CMP  W [BX],-1        ;Set return flag
  POP  ES,DS            ;Restore used registers
  POP  BP,SI,CX,AX      ;Restore used registers
  RET

;------------------------------------------------------------------------------
;ADJUST THE CMDLINE ENVIRONMENT VARIABLE POINT TO POINT AT THE COMMAND TAIL
;Inputs:  DS = Local Data Segment (and PSP Segment)
;         [CmdLineVarPtr] (-1 if does not exist)
;           Unadjusted for Program Path/Name
;Outputs: [CmdLineVarPtr]
;           Adjusted (Program Path/Name skipped over to leave Command Tail)
;Changes:
;NOTES: The CMDLINE environment variable, which is only set by SOME
;         versions of DOS, contains the entire contents of the command
;         line.  The "entire contents" includes our executable file name
;         (including the path, if it was provided), but does not include
;         the redirection and/or piping parameters.
;       This routine skips over the executable file name part and simply
;         points at the command tail (the "Options" part of the command line).
;       The CMDLINE variable is used by some versions of DOS (such as 4DOS/NDOS
;         and DOS 95) to allow the command-line to be longer than the 126
;         characters normally allowed by DOS.
;------------------------------------------------------------------------------
AdjustCmdLine:
  PUSH AX,DX,SI,DS      ;Save used registers
  MOV  SI,[CmdLineVarPtr] ;[SI] = CMDLINE environment variable contents
  CMP  SI,-1            ;Anything there?
  JE  .J90              ;If not, no need for changes
  MOV  DL,"/"           ;Assume Get SwitchChar function is unsupported
  MOV  AX,3700h         ;Function 3700h (Get DOS SwitchChar)
  INT  21h              ;Do it (returns DL)
  MOV  DS,[PSPEnvirSeg] ;DS:[SI] = CMDLINE contents
.J10:                   ;Loop to here to skip initial spaces & tabs
  LODSB                 ;Get the next character
  CMP  AL,' '           ;Space?
  JE  .J10              ;If so, keep skipping
  CMP  AL,Tab           ;Tab?
  JE  .J10              ;If so, keep skipping
.J20:                   ;Skipped initial Tabs & Spaces
  DEC  SI               ;Point back at the first character
  XOR  AH,AH            ;Assume no quotes
  CMP  AL,Quote2        ;Double Quote (part of LFN Path & File Name)?
  JNE .J30              ;If not, continue
  MOV  AH,AL            ;If so, mark as a quote
  INC  SI               ;Update the Pointer
.J30:                   ;Loop to here for each character
  LODSB                 ;Get next character
  OR   AH,AH            ;Are we looking for a Quoted Path/File Name?
  JZ  .J40              ;If not, continue
.J35:                   ;Looking for the Closing Quote
  CMP  AL,AH            ;Is it the Closing Quote?
  JNE .J50              ;If not, keep looking
  JMP .J85              ;If so, we're done
.J40:                   ;Not a Quoted Path/File Name
  OR   AL,AL            ;End of variable?
  JE  .J80              ;If so, handle it
  CMP  AL,' '           ;Space?
  JE  .J80              ;If so, we're done
  CMP  AL,Tab           ;Tab?
  JE  .J80              ;If so, we're done
  CMP  AL,'/'           ;Slash?
  JE  .J80              ;If so, we're done
  CMP  AL,DL            ;SwitchChar?
  JE  .J80              ;If so, we're done
.J50:                   ;Not end-of-name
  JMP .J30              ;Keep looking
.J80:                   ;[SI-1] = CMDLINE Pointer
  DEC  SI               ;Point at beginning of string
.J85:                   ;[SI] = New CMDLINE Pointer
  MOV  [CS:CmdLineVarPtr],SI ;Store it
.J90:                   ;Done
  POP  DS,SI,DX,AX      ;Restore used registers
  RET


;
;CODE TO LOOK FOR A CALL BACK ADDRESS ON THE COMMAND-LINE
;

;;------------------------------------------------------------------------------
;;GET THE CALL BACK ADDRESS FROM THE COMMAND-LINE, IF THERE
;;Inputs:  [SI] = Command-Line Pointer
;;         [CallBackAddr] = -1
;;Outputs: CF = Clear if OK (got a valid Address, or no address provided)
;;                [CallBackAddr] = Address (converted to a number) if
;;                                   ParentShell = No
;;            = Set if Error (invalid address format)
;;                [CallBackAddr] = -1 in Offset if none or invalid address,
;;                                   or anything follows the address
;;Changes: SI
;;------------------------------------------------------------------------------
;GetCallBackAddr:
;  PUSH AX                  ;Save used registers
;  CALL IsSpaceOrEOL        ;Skip over the spaces
;  JZ  .C80                 ;If end-of-line, everything's OK
;;  CMP  [ParentIsShell],Yes ;Are we being run from the command-line?
;;  JE  >C70                 ;If so, the user needs help
;  CALL GetHex              ;Get the Segment (must be in Hex)
;  JC  .C70                 ;If invalid, error
;  MOV  [CallBackAddr+2],AX ;If OK, store the Segment
;  CALL IsSpaceOrEOX        ;Skip spaces
;  JZ  .C70                 ;If end-of-line, error
;  CMP  AL,':'              ;Is the next character a Colon?
;  JNE .C70                 ;If not, error
;  CALL IsSpaceOrEOL        ;Skip spaces
;  JZ  .C70                 ;If end-of-line, error
;  CALL GetHex              ;Get the Offset (must be in Hex)
;  JC  .C70                 ;If invalid, error
;  MOV  [CallBackAddr],AX   ;If OK, store the Offset
;  CALL IsSpaceOrEOL        ;Skip spaces
;  JZ  .C80                 ;If end-of-line, it's OK
;.C70:                      ;Error
;  MOV  W [CallBackAddr],-1 ;Make sure address is invalid
;  STC                      ;Set error flag
;  JMP .C90                 ;Done
;.C80:                      ;OK
;  CLC                      ;Set OK flag
;.C90:                      ;Done
;  POP  AX                  ;Restore used registers
;  RET


;
;CODE TO GET A NUMBER FROM A STRING (HEX OR DECIMAL)
;

;------------------------------------------------------------------------------
;GET A NUMBER FROM A STRING (CAN BE DECIMAL OR HEX)
;Inputs:  [SI] = String Pointer
;Outputs: CF = Clear if we got a valid number
;              AX = Number
;            = Set if Error (no number found)
;              AX = 0
;Changes: SI points at next byte after the number
;NOTES: A Hex String must start with '0x' and/or end in 'H'!
;------------------------------------------------------------------------------
GetNumber:
  CALL IsSpaceOrEOL ;Skip past spaces
  JZ  .N70          ;If End-of-Line, Error
  CALL TestForHex   ;Is it a Hex Number?
  JC  .N20          ;If not, try a decimal
  CALL Test0xPrefix ;Skip over the 0x (C-style) prefix, if there
  CALL GetHex       ;If so, get it
  JNC .N80          ;If OK, we're done
  JMP .N70          ;If not, Error
.N20:               ;Not Hex
  CALL GetDecimal   ;Try a Decimal
  JNC .N80          ;If OK, we're done
.N70:               ;Error
  DEC  SI           ;Point back at the first character
  STC               ;Set Error Flag
  JMP .N90          ;Done
.N80:               ;OK
  CLC               ;Set OK Flag
.N90:               ;Done
  RET

;------------------------------------------------------------------------------
;TEST AN ASCII STRING TO SEE IF IT IS A HEX STRING (ENDS IN H)
;Inputs:  [SI] = String to test
;Outputs: CF = Clear if it is a Hex String
;            = Set if Error (not a Hex String)
;Changes:
;NOTES: A valid Hex String will contain numerals 0-9, A-F, and Underscores,
;         and will end in an H.  It cannot contain spaces.
;------------------------------------------------------------------------------
TestForHex:
  PUSH AX,SI        ;Save used registers
  CALL Test0xPrefix ;Test for the 0x (C-style) prefix (changes SI)
  JNC .H80          ;If so, it's Hex
  CALL GetNextChar  ;Get the
  DEC  SI           ;  first character
  CALL IsHexNumber  ;A valid Hex Number?
  JC  .H70          ;If not, Error
.H40:               ;Loop to here for each character
  CALL GetNextChar  ;Get the next character
  CALL IsHexNumber  ;A valid Hex Number?
  JNC .H40          ;If so, keep looking
  CMP  AL,'_'       ;An Underscore?
  JE  .H40          ;If so, keep looking
  CALL IsHexEnd     ;End of the Hex Number?
  JZ  .H80          ;If so, we're done
.H70:               ;Not Hex
  STC               ;Set error Flag
  JMP .H90          ;Done
.H80:               ;Is Hex
  CLC               ;Set OK Flag
.H90:               ;Done
  POP  SI,AX        ;Restore used registers
  RET

;------------------------------------------------------------------------------
;TEST FOR A 0x (C-STYLE) HEX PREFIX
;Inputs:  [SI] = String to test
;Outputs: CF = Set if not a 0x Prefix
;              SI unchanged
;            = Clear if not a 0x Prefix
;              [SI] = Character after the 0x
;Changes:
;------------------------------------------------------------------------------
Test0xPrefix:
  PUSH AX,BX       ;Save used registers
  MOV  BX,SI       ;Save original Pointer
  CALL GetNextChar ;Get the next character
  CMP  AL,'0'      ;Is it a 0?
  JNE .X70         ;If not, it's not a Prefix
.X20:              ;Loop to here to skip over all zeroes
  CALL GetNextChar ;Get the next charcter
  CMP  AL,'0'      ;Is it another 0?
  JE  .X20         ;If so, keep skipping the zeroes
  CALL Capitalize  ;If not, capitalize it
  CMP  AL,'X'      ;Is it an X?
  JNE .X70         ;If not, it's not a 0x Prefix
  CALL GetNextChar ;Get the next charcter
  CALL IsHexNumber ;Is it a Hex Number?
  JNC .X80         ;If so, it's a 0x Prefix
.X70:              ;Not a 0x Prefix
  MOV  SI,BX       ;Restore original pointer
  STC              ;Set return flag
  JMP .X90         ;Done
.X80:              ;Is a 0x Prefix
  DEC  SI          ;Point back at the first hex number
  CLC              ;Set return flag
.X90:              ;Done
  POP  BX,AX       ;Restore used registers
  RET

;------------------------------------------------------------------------------
;GET THE NEXT SERIES OF HEX CHARACTERS, AND CONVERT THEM TO A NUMBER
;Inputs:  [SI] = Command Line Pointer
;Outputs: CF = Clear if OK
;              AX = Character string converted to a number, ?? if not
;            = Set if Error
;              AX = Unchanged
;Changes:
;NOTES: The string can either have an H at the end or not, and this code
;         will work.
;------------------------------------------------------------------------------
GetHex:
  PUSH BX,CX,DX     ;Save used registers
  MOV  DX,AX        ;Save original AX
  XOR  BX,BX        ;Start with zero
  MOV  CX,4         ;CL = bits to shift by, CH = Character Counter
  XOR  AH,AH        ;Set High byte to 0
.D10:               ;Loop to here for each character
  CALL GetNextChar  ;Get the next character
  CALL IsHexNumber  ;A valid Hex Number?
  JNC .D20          ;If so, continue
  CMP  AL,'_'       ;If no, is it an Underscore?
  JE  .D45          ;If so, keep looking
  JMP .D50          ;If not, we're done
.D20:               ;Valid Hex Number
  INC  CH           ;Increment the character counter
  SHL  BX,CL        ;Make room for the New Nibble
  JNC .D40          ;If we're not too big yet, keep going
  DEC  SI           ;If too big, Point back at bad character
  JMP .D70          ;Error
.D40:               ;OK to add in new Nibble
  ADD  BX,AX        ;Add in the new Nibble
.D45:               ;Done with this character
  JMP .D10          ;Jump to get next character
.D50:               ;Done getting string
  DEC  SI           ;Point back at the bad character
  OR   CH,CH        ;Any valid characters at all?
  JZ  .D70          ;If not, error
  CALL GetNextChar  ;Is the next character
  CALL IsHexEnd     ;  an H?
  JZ  .D80          ;If so, we're done
  DEC  SI           ;If not, point back at the non-H
  JMP .D80          ;Done
.D70:               ;There was an error
  MOV  AX,DX        ;Restore original AX
  STC               ;Mark the error flag
  JMP .D90          ;And quit
.D80:               ;We have a good number
  MOV  AX,BX        ;Put the value where it belongs
  CLC               ;Mark the OK flag
.D90:               ;We're done
  POP  DX,CX,BX     ;Restore used registers
  RET

;------------------------------------------------------------------------------
;GET THE NEXT SERIES OF NUMERIC CHARACTERS, AND CONVERT THEM TO A NUMBER
;Inputs:  [SI] = Command Line Pointer
;Outputs: AX = decimal character string converted to a number, ?? if not
;         CF = Clear if AX is OK
;              SI points at the next character after the number
;            = Set if no decimal found
;              SI = Unchanged
;Changes:
;------------------------------------------------------------------------------
GetDecimal:
  PUSH BX,CX,DX     ;Save used registers
  XOR  AX,AX        ;Start with zero
  XOR  BX,BX        ;  "    "    "   - accumulator
  MOV  CX,10        ;CX = multiplier & digit limit comparer
  CALL IsSpaceOrEOX ;Skip past the spaces
  JZ  .D70          ;If End-Of-Line, there's an error
  SUB  AL,'0'       ;If not, convert it to a number
  CMP  AL,9         ;Is it really a number?
  JA  .D70          ;If not, there's an error
  DEC  SI           ;If so, step back to the number
.D10:               ;Loop to here for each character
  CALL GetNextChar  ;Get the next character
  SUB  AL,'0'       ;Change it to 0-9 range
  XOR  AH,AH        ;Extend byte to word
  CMP  AX,CX        ;Is it a digit?
  JAE .D80          ;If not, we're done
  CMP  BX,6553      ;Is our number getting too big?
  JB  .D20          ;If not, jump to store it
  CMP  AL,5         ;If so, will this number make it too big?
  JA  .D70          ;If so, there's an error
.D20:               ;Add the digit to our number
  XCHG AX,BX        ;Swap accumulation into AX, new digit into BX
  MUL  CX           ;Multiply the previous accumulation by 10
  ADD  BX,AX        ;Add in the new digit
  JMP .D10          ;Jump to get next character
.D70:               ;Error
  DEC  SI           ;Point back at the number
  STC               ;Mark the error flag
  JMP .D90          ;And quit
.D80:               ;We have a good number
  DEC  SI           ;Point back at the non-number
  MOV  AX,BX        ;Put the value where it belongs
  CLC               ;Mark the OK flag
.D90:               ;We're done
  POP  DX,CX,BX     ;Restore used registers
  RET

;------------------------------------------------------------------------------
;TEST AN ASCII CHARACTER TO SEE IF IT IS A HEX NUMERAL (BETWEEN 0 AND F)
;Inputs:  AL = ASCII Character to Test
;Outputs: CF = Clear if it is a Number
;              AL = ASCII Code converted to a real Number
;            = Set if Error (not a Number)
;              AL = Unchanged
;Changes:
;------------------------------------------------------------------------------
IsHexNumber:
  PUSH BX          ;Save used registers
  MOV  BL,AL       ;Save the character in case we need to restore it
  CALL IsNumber    ;A Decimal Number?
  JNC .H85         ;If so, we're done
  CALL Capitalize  ;If not, Capitalize it
  CMP  AL,'A'      ;A Hex Number?
  JB  .H70         ;If not, Error
  CMP  AL,'F'      ;A Hex Number?
  JBE .H80         ;If so, handle it
.H70:              ;Not a Number
  MOV  AL,BL       ;Restore original character
  STC              ;Set Error Flag
  JMP .H90         ;Done
.H80:              ;A Number > 9
  SUB  AL,('A'-10) ;Convert it to a real number
  JMP .H90         ;Done
.H85:              ;OK (is a Number)
  CLC              ;Set OK Flag
.H90:              ;Done
  POP  BX          ;Restore used registers
  RET

;------------------------------------------------------------------------------
;TEST AN ASCII CHARACTER TO SEE IF IT IS A NUMERAL (BETWEEN 0 AND 9)
;Inputs:  AL = ASCII Character to Test
;Outputs: CF = Clear if it is a Number
;              AL = ASCII Code converted to a real Number
;            = Set if Error (not a Number)
;              AL = Unchanged
;Changes:
;------------------------------------------------------------------------------
IsNumber:
  CMP  AL,'0' ;A Number?
  JB  .N70    ;If not, Error
  CMP  AL,'9' ;A Number?
  JBE .N80    ;If so, handle it
.N70:         ;Not a Number
  STC         ;Set Error Flag
  JMP .N90    ;Done
.N80:         ;A number
  SUB  AL,'0' ;Convert it to a real number
  CLC         ;Set OK Flag
.N90:         ;Done
  RET

;------------------------------------------------------------------------------
;TEST AN ASCII CHARACTER TO SEE IF IT IS A PARTICULAR CHARACTER
;Inputs:  AL = ASCII Character to Test
;Outputs: ZF = Set if it is the appropriate character
;            = Clear if not
;Changes:
;------------------------------------------------------------------------------
IsHexEnd:
  PUSH AX         ;Save used registers
  CALL Capitalize ;Capitalize the Character
  CMP  AL,'H'     ;See if it matches
  POP  AX         ;Restore used registers
  RET

;------------------------------------------------------------------------------
;BEEP THE SPEAKER
;Inputs:
;Outputs: Beeps the speaker
;Changes:
;------------------------------------------------------------------------------
BeepErr:
  PUSH AX,BX    ;Save used registers
  XOR  BX,BX    ;BH = Video page = 0
  MOV  AX,0E07h ;AH = 0Eh = Function = Write TTY
                ;AL = 07h = Character to write = BEL
  INT  10h      ;Do it
  POP  BX,AX    ;Restore used registers
  RET

;------------------------------------------------------------------------------
;CAPITALIZE A CHARACTER (Byte)
;Inputs:  AL = character to be capitalized
;Outputs: AL = capitalized character
;Changes:
;------------------------------------------------------------------------------
Capitalize:
  CMP  AL,'a'     ;Is it less than 'a'?
  JB  .C90        ;If so, quit
  CMP  AL,'z'     ;Is it more than 'z'?
  JA  .C90        ;If so, quit
  SUB  AL,'a'-'A' ;If between 'a' and 'z', capitalize it
.C90:
  RET


;
;CODE TO WRITE SPECIAL MESSAGES TO THE SCREEN (HELP, STATUS, ETC.)
;

;
;Write Program Help Message
;

;------------------------------------------------------------------------------
;PRINT THE SYNTAX HELP MESSAGE AND QUIT
;Inputs:  DS:[SI] = Current command line pointer
;Outputs: Writes Help Message to the screen
;Changes: Quits program
;------------------------------------------------------------------------------
DoHelp:
  TEST B [ProgFlags],Help ;Does the user want help?
  JNZ .H00                ;If so, do it
  RET

.H00:
  MOV  DX,SyntaxMsg ;Point at the Help Message
  XOR  AL,AL        ;ErrorLevel = 0
  JMP  Exit         ;Quit


;
;Write Command-Line Aliases
;

;------------------------------------------------------------------------------
;PRINT THE COMMAND LINE ALIASES AND QUIT
;Inputs:  DS:[SI] = Current command line pointer
;Outputs: Writes Aliases to the screen
;Changes: Quits program
;------------------------------------------------------------------------------
DoAliases:
  TEST B [ProgFlags],Alias ;Does user want to see the Aliases?
  JZ  .A95                ;If not, we're done

  PUSH BX,DX,SI           ;Save used registers
  CALL WriteCrLfPause     ;Move down
  MOV  DX,AliasHdrMsg     ;Set up
  CALL SetupPause         ;  the Header
  MOV  SI,SwitchList      ;SI = Alias Table
  MOV  BX,'?'+('Z' << 8)  ;BL = Min Value, BH = Max Value to look for
  CALL DoAliasesGoNoNum   ;Write the Aliases
;  MOV  BX,1+(31 << 8)     ;BL = Min Value, BH = Max Value to look for
;  CALL DoAliasesGoNoNum   ;Write the Aliases
  CALL WriteCrLfPause2    ;Move down

  MOV  DX,YesNoHdrMsg     ;Set up
  CALL SetupPause         ;  the Header
  MOV  SI,SwitchListYesNo ;SI = Alias Table
  MOV  BX,'N'+('Y' << 8)  ;BL = Min Value, BH = Max Value to look for
  CALL DoAliasesGoNoNum   ;Write the Aliases

.A90:                     ;Done
  POP  SI,DX,BX           ;Restore used registers
  MOV  DX,NoMsg           ;Don't write anything
  XOR  AL,AL              ;ErrorLevel = 0
  JMP  Exit               ;Quit

.A95:                     ;No need to write Aliases
  RET

;------------------------------------------------------------------------------
;WRITE THE LIST OF SWITCH CHARACTERS TO THE SCREEN
;Inputs:  DS = Local Data Segment
;         ES = TSR Data Area
;         BL = Minimum Value to look for in the Table
;         DH = Maximum Value to look for in the Table
;         SI = Switch List ("Code Word") Table
;Outputs: Writes List of Switch Characters to the Screen
;Changes:
;NOTES:   Sets CH =  0 if we write Blocks for Switches < " "
;                 = -1 if we write numbers for the all Switches (0-255)
;                 = -2 if we subtract 128 from the numbers (128-255)
;------------------------------------------------------------------------------
;DoAliasesGoNum80h:
;  PUSH CX               ;Save used registers
;  MOV  CH,2             ;Mark as writing Numbers, needing to subtract 128
;  JMP >G00              ;Continue
DoAliasesGoNum:
  PUSH CX                   ;Save used registers
  MOV  CH,1                 ;Mark as writing Numbers, not needing to modify
  JMP  DoAliasesGoNoNum.G00 ;Continue
DoAliasesGoNoNum:
  PUSH CX               ;Save used registers
  XOR  CH,CH            ;Mark as not writing Numbers
;  JMP >G00              ;Continue
.G00:
  PUSH AX,DI            ;Save used registers
  MOV  DI,AliasSortTbl  ;Point at the Alias Sort Table
  MOV  AL,BL            ;Start with the Lower Limit
.G10:                   ;Loop to here for each Alias
  CALL GetAliasPointers ;Get the Alias Pointers
  JZ  .G60              ;If none for this entry, go to the next one
.G20:                   ;Have at least one valid Alias
  CALL WriteCrLfPause   ;If valid, move down
  OR   CH,CH            ;Writing Single characters?
  JNZ .G40              ;If not, handle full numbers
  MOV  CL,78            ;Write this many characters per line
  CMP  AL,' '           ;Is there a valid single-character equivalent?
  JB  .G30              ;If not, don't write it
  CALL WriteAL          ;If so, write it
  JMP .G50              ;Continue
.G30:                   ;Not a writable character
  CALL WriteBlock       ;Write a Block Character
  JMP .G50              ;Continue
.G40:                   ;Need to write Numbers
  MOV  CL,76            ;Write this many characters per line
  PUSH AX               ;Save the number for a second
  CMP  CH,2             ;Do we need to modify the Number?
  JNE .G45              ;If not, continue
  AND  AL,~80h          ;Subtract 128 from it
.G45:                   ;Write the Number
  CALL ByteToString     ;Write the Switch as a Number
  POP  AX               ;Restore the Number
.G50:                   ;Done writing single character
  CALL WriteAliases     ;Write the Alias List
.G60:                   ;Done with this Code
  CMP  AL,BH            ;Have we done the whole list yet?
  JE  .G90              ;If so, we're done
  INC  AL               ;If not, go to the next possibility
  JMP .G10              ;Keep going until we're done
.G90:                   ;Done
  POP  DI,AX            ;Restore used registers
  POP  CX               ;Restore used registers
  RET

;------------------------------------------------------------------------------
;GET STRING POINTERS FOR ALL ALIASES FOR A SINGLE CHARACTER OPTION
;Inputs:   DS  = Local Data Segment
;          ES  = TSR Data Area
;          AL  = Switch Table entry to look for (not 0)
;         [SI] = Switch Table to look through, sorted backwards
;         [DI] = Alias Sort Table
;Outputs:  ZF = Clear if OK
;               [DI] = Filled with String Pointers, sorted backwards
;                      Last Entry is always a 0
;             = Set if no matches found
;                      First Entry is 0
;Changes:
;------------------------------------------------------------------------------
GetAliasPointers:
  PUSH AX,BX,CX,DX      ;Save used registers
  PUSH DI,SI            ;Save used registers
  MOV  CX,DI            ;Sve original pointer
.P10:                   ;Loop to here for each Table Entry
  MOV  DX,SI            ;Save beginning Alias Pointer
.P20:                   ;Loop to here to find the end of an Alias List Entry
  CMP  B [SI],0         ;End of Alias List?
  JE  .P30              ;If so, handle it
  CALL SkipOverStringSI ;If not, skip over the string
  JMP .P20              ;Keep looking
.P30:                   ;End of Alias List Entry
  MOV  BX,SI            ;Save End-of-Entry Pointer
  CMP  AL,[SI+1]        ;Is this entry a match?
  JNE .P50              ;If not, go to the next one
  MOV  SI,DX            ;Point at Alias String
.P40:                   ;Loop to here for each Alias String
  CMP  B [SI],0         ;End of the entry?
  JE  .P50              ;If so, we're done
  MOV  [DI],SI          ;If not, store it in the sort table
  INC  DI,2             ;Update the Table Pointer
  CALL SkipOverStringSI ;Skip over the string
  JMP .P40              ;Keep going until we have all of the strings
.P50:                   ;Done with this entry
  MOV  SI,BX            ;Get End-of-Entry Pointer
  INC  SI,2             ;Skip over End-of-Entry stuff
  CMP  B [SI],0         ;End of Table?
  JNE .P10              ;If not, keep looking
.P90:                   ;Done
  MOV  W [DI],0         ;Make sure last entry is a 0
  CMP  CX,DI            ;Set return flag
  POP  SI,DI            ;Restore used registers
  POP  DX,CX,BX,AX      ;Restore used registers
  RET

;------------------------------------------------------------------------------
;WRITE ALL ALIAS STRINGS FOR A SINGLE CHARACTER OPTION
;Inputs:   DS  = Local Data Segment
;          ES  = TSR Data Area
;         [DI] = Alias String Pointer Table (Sorted backwards)
;                  Last Entry is a 0
;          CL  = Number of characters left available to write on first line
;                 (76 if Writing Numbers, 78 if Writing Characters)
;         CLD already issued
;Outputs:
;Changes:
;------------------------------------------------------------------------------
WriteAliases:
  PUSHA               ;Save all registers
  PUSH ES             ;Save used registers
  MOV  ES,DS          ;Point ES at the Local Data Segment
  MOV  BL,CL          ;BL = Character Countdown Measurer
  MOV  BH,CL          ;BH = Original Counter
  MOV  DX,DI          ;Save start-of-table Pointer
  MOV  CX,-1          ;Maximize counter
  XOR  AX,AX          ;Find the last
  REPNE SCASW         ;  entry in
  SUB  DI,4           ;  the Table
.W10:                 ;Loop to here for each Alias String
  CMP  DI,DX          ;Are we done writing?
  JB  .W90            ;If so, quit
  MOV  SI,[DI]        ;Get the next string
  DEC  DI,2           ;Update the table pointer
  CALL CalcStrSizeSI  ;See how long the string is
  OR   BL,BL          ;Is the character counter down to 0?
  JZ  .W20            ;If so, we need to reset it
  CMP  CL,BL          ;Is this string too long to fit on this line?
  JB  .W40            ;If not, go ahead and write it
.W20:                 ;Need to start a new line
  CALL WriteCrLfPause ;Start a new line
  PUSH CX             ;Save String Size for a second
  MOV  CL,79          ;Calculate how many
  SUB  CL,BH          ;  spaces to write
  CALL WriteSpaces    ;Write the spaces
  POP  CX             ;Restore String Size
  MOV  BL,BH          ;Reset the character counter
.W40:                 ;Write the Alias String
  SUB  BL,CL          ;Update the
  DEC  BL             ;  character counter
  CALL WriteSpace     ;Write a Space
  CALL WriteZPauseSI  ;Write the string
  JMP .W10            ;Keep writing
.W90:                 ;Done
  CALL WriteCrLfPause ;Move down
  POP  ES             ;Restore used registers
  POPA                ;Restore all registers
  RET


;
;Write the ErrorLevel Table
;

;------------------------------------------------------------------------------
;WRITE ERRORLEVEL TABLE TO THE SCREEN AND QUIT
;Inputs:  CS = DS = Local Data Segment
;Outputs: Writes ErrorLevel Table to the Screen
;Changes: Quits Program
;         Several registers
;------------------------------------------------------------------------------
DoErrLvls:
  TEST B [ProgFlags],ErrLvl ;Does the user want to see the ErrorLevels?
  JNZ .V00                  ;If so, do it
  RET

.V00:
  MOV  DX,ErrLvlHdr         ;Write the
  CALL SetupPause           ;  Table Header
  MOV  AL,1                 ;Start with ErrorLevel 1
.V10:                       ;Loop to here for each table entry
  MOV  BX,ErrLvlTbl         ;Table to search
  CALL SearchByte2StringTbl ;Valid ErrorLevel?
  JC  .V50                  ;If not, keep looking
  CALL WriteSpace           ;Move Over
  CALL ByteToString         ;If valid, write the Number
  CALL WriteSpace           ;Write a space
  MOV  DX,BX                ;Write the
  CALL WriteZPause          ;  Description String
  CALL WriteCrLfPause       ;Move down
.V50:                       ;Done with this entry
  INC  AL                   ;Increment ErrorLevel
  JNZ .V10                  ;If not rolled over yet, keep looking
.V90:                       ;Done
  MOV  DX,NoMsg             ;Don't write anything
  XOR  AL,AL                ;ErrorLevel = 0
  JMP  Exit                 ;Quit


;
;Write CPU Duty Cycle Status
;

;------------------------------------------------------------------------------
;WRITE THE CURRENT STATUS TO THE SCREEN
;Inputs:  ES = TSR Data Area
;         Status (Flag)
;Outputs: Writes a bunch of stuff to the screen if Status Flag is True
;Changes:
;------------------------------------------------------------------------------
DoStatus:
  PUSH AX,DX              ;Save used registers
.S02:                     ;Write CPUID Strings
  CALL WriteCPUStrings    ;Write CPU ID Strings
  CALL WriteMemSize       ;Write Memory Size
.S05:                     ;Write APM version
;  MOV  DX,APMVerMsg
;  CALL WriteItDX
;  MOV  AX,[APMVersion]
;  OR   AX,AX
;  JNZ >S06
;  CALL WriteNA
;  JMP >S07
;S06:
;  XCHG AL,AH
;  CALL WriteByteMin
;  CALL WriteDot
;  XCHG AL,AH
;  CALL WriteByteMin
;S07:
;  CALL WriteCrLfPause
.S10:                     ;Write ACPI version
  MOV  DX,ACPIVerMsg
;  CALL WriteItDX
  CALL WriteZPause
  CMP  D [RSDTPhysAddr],0
  JE  .S12
  CMP  B [ACPIRevision],0
  JNE .S12
  CALL GetFACPData
  CALL GetDSDTData
.S11:
  MOV  AL,[ACPIRevision]
;  CALL ByteToString
  CALL WriteByteMin
  MOV  AL,'.'
  CALL WriteAL
  MOV  AL,'0'
  CALL WriteAL
  JMP .S13
.S12:
  CALL WriteNA
.S13:
;  CALL WriteCrLfPause
;S15:                      ;Write ODCM Support Status
;  MOV  DX,ODCMSuptMsg
;  CALL WriteItDX
;  MOV  DX,NoMsgS
;  CMP  [ODCMNumStages],0
;  JE  >S16
;  MOV  DX,YesMsg
;S16:
;  CALL WriteItDX
;S20:                      ;Write ACPI Throttling Details
  CMP  B [ACPIRevision],0
  JE  .S30
  CALL WriteSeparator     ;New Section
;  MOV  DX,ThtIOAddrMsg    ;Write I/O Address
;  CALL WriteItDX
;  MOV  AX,[ThtIOAddr]
;  CALL WriteWordHex
;  CALL WriteCrLfPause
;  MOV  DX,ThtMaskMsg      ;Write Duty Cycle Bit Mask
;  CALL WriteItDX
;  MOV  AX,[ThtValueMask]
;  CALL WriteWordHex
;  CALL WriteCrLfPause
  MOV  DX,ThtCurrentMsg   ;Write Current Duty Cycle Setting
;  CALL WriteItDX
  CALL WriteZPause
  CALL WriteDutyCycleACPI
;  CALL WriteSeparator     ;New Section
;  MOV  DX,PM1aCtlMsg      ;Write PM1a I/O Address
;  CALL WriteItDX
;  MOV  AX,[PM1aCtlIOAddr]
;  CALL WriteWordHex
;  CALL WriteCrLfPause
;  MOV  DX,PM1aOffMsg      ;Write PM1a S5 Value
;  CALL WriteItDX
;  MOV  AX,[PM1aS5Value]
;  CALL WriteByteHex
;  CALL WriteCrLfPause
;  MOV  DX,PM1bCtlMsg      ;Write PM1b I/O Address
;  CALL WriteItDX
;  MOV  AX,[PM1bCtlIOAddr]
;  CALL WriteWordHex
;  CALL WriteCrLfPause
;  MOV  DX,PM1bOffMsg      ;Write PM1b S5 Value
;  CALL WriteItDX
;  MOV  AX,[PM1bS5Value]
;  CALL WriteByteHex
;  JMP >S60
.S30:                     ;Write ODCM Throttling Details
  CMP  B [ODCMNumStages],0
  JE  .S60
;  CALL WriteSeparator     ;New Section
  CALL WriteCrLfPause      ;Move down
  MOV  DX,ODCMCurrMsg
;  CALL WriteItDX
  CALL WriteZPause
  CALL WriteDutyCycleODCM
;  CMP  [APMVersion],0
;  JNE >S60
;  CMP  B [ACPIRevision],0
;  JNE >S60
;  CALL WriteCrLfPause
.S60:                     ;Write Battery Status
;  CMP  [APMVersion],0
;  JE  >S65
;  CALL GetBatteryAPM
;  JC  >S65
;  CALL WriteSeparator     ;New Section
;  CALL WriteBattAPM       ;Write Battery Status using APM
;  JMP >S90
;S65:
  CMP  B [ACPIRevision],0
  JE  .S90
  CALL WriteSeparator     ;New Section
  CALL WriteBattACPI      ;Write Battery Status using ACPI
.S90:                     ;Done
  POP  DX,AX              ;Restore used registers
  RET

;------------------------------------------------------------------------------
;WRITE THE CPUID STRINGS
;Inputs:  DS = ES = Local Data Segment
;         CLD already issued
;Outputs: To Screen
;Changes: [CPUMfgString], [CPUBrandString]
;------------------------------------------------------------------------------
WriteCPUStrings:
  PUSH AX,DX,SI           ;Save used registers
  XOR  AX,AX              ;AL = Strings Written Counter
  CALL GetCPUIDStrings    ;Get the Strings
.C10:                     ;CPUID Manufacturer String
  MOV  SI,CPUMfgString    ;DS:SI = Potential String to Write
  CMP  B [SI],0           ;Did we get a manufacturer string?
  JE  .C90                ;If not, we're done
  INC  AX                 ;If so, increment our counter
  MOV  DX,CPUMfgHdr       ;Write
;  CALL WriteItDX          ;  the
  CALL WriteZPause        ;  the
;  CALL WriteItSI          ;  Data
  CALL WriteZPauseSI      ;  Data
.C20:                     ;CPUID Brand String
  MOV  SI,CPUBrandString  ;DS:SI = Potential String to Write
  CMP  B [SI],0           ;Did we get a brand string?
  JNE .C40                ;If so, continue
.C30:                     ;CPUID Brand Index
  CALL FindCPUBrand       ;Valid Brand Index (rtns CF, SI)?
  JC  .C50                ;If not, w're done
.C40:                     ;DS:SI = Brand String to write
  INC  AX                 ;If so, increment our counter
  CALL WriteCrLfPause     ;Move down
  MOV  DX,CPUBrandHdr     ;Write
  CALL WriteZPause        ;  the
  CALL WriteZPauseSI      ;  Data
.C50:                     ;Done with Brand String
  MOV  DX,WriteSeparator  ;Assume no Brand String
  DEC  AX                 ;Did we write a Brand String?
  JZ  .C55                ;If not, continue
  MOV  DX,WriteSeparator2 ;Need a longer separator
.C55:                     ;DX = Code to Call
  CALL DX                 ;Write the appropriate separator string
.C90:                     ;Done
  POP  SI,DX,AX           ;Restore used registers
  RET

;------------------------------------------------------------------------------
;GET THE CPUID STRINGS FROM THE CPU
;Inputs:  DS = ES = Local Data Segment
;         CLD already issued
;Outputs: [CPUMfgString], [CPUBrandString]
;Changes:
;------------------------------------------------------------------------------
GetCPUIDStrings:
  PUSH EAX,EBX,ECX,EDX,DI     ;Save used registers
  CALL TestCPUID              ;Processor supports CPUID instruction?
  JC  .G90                    ;If not, we're done
  CALL GetCPUMfgString        ;Download the Manufactureer String
  JC  .G90                    ;If error, quit
  MOV  EAX,CPUIDXGetMaxFunc   ;Get the
  CPUID                       ;  Maximum Extended CPUID Feature supported
  CMP  EAX,CPUIDXGetCPUBrand2 ;Is the CPU Brand String supported?
  JB  .G90                    ;If not, we're done
  MOV  DI,CPUBrandString      ;ES:DI = Where to store the data
  MOV  EAX,CPUIDXGetCPUBrand0 ;Get the first
  CPUID                       ;  CPU Brand String
  CALL CopyCPUIDString        ;Store it in our buffer
  MOV  EAX,CPUIDXGetCPUBrand1 ;Get the second
  CPUID                       ;  CPU Brand String
  CALL CopyCPUIDString        ;Store it in our buffer
  MOV  EAX,CPUIDXGetCPUBrand2 ;Get the third
  CPUID                       ;  CPU Brand String
  CALL CopyCPUIDString        ;Store it in our buffer
.G90:                         ;Done
  POP  DI,EDX,ECX,EBX,EAX     ;Restore used registers
  RET

CopyCPUIDString:
  PUSH EAX     ;Save used registers
  STOSD        ;Store
  MOV  EAX,EBX ;  the
  STOSD        ;  string
  MOV  EAX,ECX ;  in
  STOSD        ;  our
  MOV  EAX,EDX ;  local
  STOSD        ;  buffer
  POP  EAX     ;Restore used registers
  RET

;------------------------------------------------------------------------------
;DETERMINE THE BRAND STRING FROM THE BRAND INDEX
;Inputs:  EAX = Processor Signature
;          BL = Brand Index
;Outputs: CF = Clear if Entry Found
;              SI = Processor Brand String
;            = Set if Not Found
;              SI = Unchanged
;         CLD already issued
;Changes:
;------------------------------------------------------------------------------
FindCPUBrand:
  PUSH DI                   ;Save used registers
  PUSH EAX,EBX,ECX,EDX,EBP  ;Save used registers
  MOV  DI,SI                ;Save original DX
  CALL TestCPUID            ;Processor supports CPUID instruction?
  JC  .F70                  ;If not, error
  CALL TestIntel            ;Is the CPU manufactured by Intel?
  JC  .F70                  ;If not, we can't use our Brand Index Table
  MOV  EAX,CPUIDGetVendor   ;Get the
  CPUID                     ;  Maximum CPUID Function Number
  CMP  EAX,CPUIDGetFeatures ;Valid for use to use?
  JB  .F70                  ;If not, error
  MOV  EAX,CPUIDGetFeatures ;Get the CPU
  CPUID                     ;  Features
  MOV  EBP,EAX              ;EBP = Processor Signature
                            ; BL = Brand Index
  MOV  SI,CPUBrandTbl       ;DS:SI = Table to search
.F10:                       ;Loop to here for each Table Entry
  LODSB                     ;AL = Brand Index from Table
  OR   AL,AL                ;End of Table?
  JZ  .F70                  ;If so, error
  CMP  AL,BL                ;The one we're looking for?
  JNE .F50                  ;If not, skip it
  LODSD                     ;EAX = Processor Signature
  CMP  EAX,-1               ;Match any Processor Signature?
  JE  .F80                  ;If so, we're done
  CMP  EAX,EBP              ;The one we're looking for?
  JE  .F80                  ;If so, we're done
  JMP .F55                  ;If not, keep looking
.F50:                       ;Brand Inded does not match
  ADD  SI,4                 ;Skip over the Processor Signature in the Table
.F55:                       ;Processor Signature does not match
  CALL SkipOverStringSI     ;Skip over the Brand String
  JMP .F10                  ;Keep looking
.F70:                       ;Error
  STC                       ;Set return flag
  JMP .F90                  ;Done
.F80:                       ;OK
  MOV  DI,SI                ;DI = Value to return in SI
  CLC                       ;Set return flag
.F90:                       ;Done
  POP  EBP,EDX,ECX,EBX,EAX  ;Restore used registers
  MOV  SI,DI                ;Set return SI
  POP  DI                   ;Restore used registers
  RET

;------------------------------------------------------------------------------
;TEST AND SEE IF THE CPU IS MANUFACTURED BY INTEL
;Inputs:  DS = ES = Local Data Segment
;Outputs: CF = Clear if CPU is manufactured by Intel
;            = Set if not Intel, or unknown
;         CLD already issued
;Changes:
;------------------------------------------------------------------------------
TestIntel:
  PUSH CX,DI,SI          ;Save used registers
  CALL GetCPUMfgString   ;Download the manufacturer string
  JC  .I70               ;If error, quit
  MOV  SI,CPUMfgString   ;DS:SI = Downloaded string
  MOV  DI,IntelMfgString ;ES:DI = Test String
  MOV  CX,3              ;Test 3 DWords (12 bytes)
  REPE CMPSD             ;Compare the strings
  JZ  .I80               ;If they match, we're done
.I70:                    ;Error
  STC                    ;Set return flag
  JMP .I90               ;Done
.I80:                    ;OK
  CLC                    ;Set return flag
.I90:                    ;Done
  POP  SI,DI,CX          ;Restore used registers
  RET

;------------------------------------------------------------------------------
;DOWNLOAD THE PROCESSOR MANUFACTURER STRING FROM THE CPU
;Inputs:  DS = ES = Local Data Segment
;Outputs: CF = Clear if OK
;              [CPUMfgString] filled in
;            = Set if Error
;              [CPUMfgString] unchanged
;         CLD already issued
;Changes:
;------------------------------------------------------------------------------
GetCPUMfgString:
  PUSH EAX,EBX,ECX,EDX,DI ;Save used registers
  MOV  DI,CPUMfgString    ;ES:DI = Where to store the data
  CMP  B [DI],0           ;Did we already do this?
  JNE .M80                ;If so, just quit
  CALL TestCPUID          ;Processor supports CPUID instruction?
  JC  .M70                ;If not, we're done
  MOV  EAX,CPUIDGetVendor ;Get the
  CPUID                   ;  Manufacturer String
  MOV  EAX,EBX            ;Store
  STOSD                   ;  string
  MOV  EAX,EDX            ;  in
  STOSD                   ;  our
  MOV  EAX,ECX            ;  local
  STOSD                   ;  buffer
  JMP .M80                ;Done
.M70:                     ;Error
  STC                     ;Set return flag
  JMP .M90                ;Done
.M80:                     ;OK
  CLC                     ;Set return flag
.M90:                     ;Done
  POP  DI,EDX,ECX,EBX,EAX ;Restore used registers
  RET

  SizePrefixes DB 'kMGTPEZY' ;kilo, Mega, Giga, Tera, Peta, Exa, Zetta, Yotta

;------------------------------------------------------------------------------
;GET AND WRITE THE SYSTEM MEMORY SIZE
;Inputs:  DS = ES = Local Data Segment
;Outputs: To Screen
;Changes:
;------------------------------------------------------------------------------
WriteMemSize:
  PUSH EAX,ECX,EDX,SI    ;Save used registers
  CALL GetMemSize        ;Get the Memory Size ([MemSize])
  JC  .Z90               ;If erro, quit
  CLD                    ;Go forward with string functions
  MOV  DX,MemSizeMsg     ;Write
  CALL WriteZPause       ;  the Header
  MOV  EDX,[MemSize+4]   ;EDX:EAX =
  MOV  EAX,[MemSize+0]   ;  Memory Size
  MOV  SI,SizePrefixes   ;DS:[SI] = Prefixes (start with k)
  MOV  ECX,1024          ;Divide by 1k
  OR   EDX,EDX           ;>4 MB?
  JZ  .Z05               ;If not, continue
  INC  SI,2              ;DS:[SI] = Prefixes (start with M rather than k)
  MOV  ECX,(1024*1024*1024) ;Divide by 1G
.Z05:                    ;ECX & SI set correctly
  DIV  ECX               ;  by 1 Mi
  MOV  ECX,1024          ;Divide by 1024 (1 ki) from now on
.Z10:                    ;Loop to here to find the correct value
  CMP  EAX,999           ;Need to divide again?
  JBE .Z20               ;If not, we're done
  INC  SI                ;Go to the next Prefix
  XOR  EDX,EDX           ;Divide again
  DIV  ECX               ;  by 1024
  JMP .Z10               ;Keep going until we're done
.Z20:                    ;Partial size
  CMP  AX,10             ;Less than 10?
  JAE .Z22               ;If not, handle it
  CALL Write2Spaces      ;If so, move over
  JMP .Z30               ;Continue
.Z22:                    ;More than 9
  CMP  AX,100            ;Less than 100?
  JAE .Z30               ;If not, continue
  CALL WriteSpace        ;If so, move over
.Z30:                    ;Correctr Spacing is Done
  CALL WriteWordMin      ;Write the whole part
  CALL WriteDot          ;Write a Dot
  MOV  EAX,EDX           ;Calculate
  XOR  EDX,EDX           ;  the
  DIV  ECX               ;  decimal portion
  SHR  ECX,1             ;Do we need to
  CMP  EDX,ECX           ;  round up?
  JB  .Z35               ;If not, we're done
  INC  EAX               ;If so, round up
.Z35:                    ;EAX = Decimal portion
  CALL WriteByteMin      ;Write the decimal portion
  CALL WriteSpace        ;Move over
  MOV  DL,[SI]           ;Write
  MOV  [SingleMsg],DL    ;  the
  MOV  DX,SingleMsg      ;  Prefix
  CALL WriteZPause
  MOV  B [SingleMsg],'B' ;Write
  CALL WriteZPause       ;  the "B"
  CALL WriteSeparator    ;Write the separator line
.Z90:                    ;Done
  POP  SI,EDX,ECX,EAX    ;Restore used registers
  RET

;------------------------------------------------------------------------------
;WRITE THE CURRENT DUTY CYCLE SETTING (BOTH AS A FRACTION AND A PERCENTAGE)
;Inputs:  DS = ES = Local Data Segment
;         ThtXX Values filled in
;Outputs: To Screen
;Changes:
;------------------------------------------------------------------------------
WriteDutyCycleODCM:
  PUSH EAX,ECX,EDX        ;Save used registers
  MOV  ECX,MSRClkModulate ;Get the
  RDMSR                   ;  Clock Modulation MSR
  MOV  AH,[ODCMNumStages] ;AH = Number of Possible Stages
  TEST AL,10h             ;Modulation Enabled?
  JNZ .D20                ;If so, get the Current Value
.D10:                     ;Use Maximum Value
  MOV  AL,AH              ;Use Maximum Value
  JMP .D50                ;Continue
.D20:                     ;Get actual value
  AND  AL,0Fh             ;Mask out unwanted bits
  CMP  AH,8               ;8 Stages or 16 Stages?
  JNE .D50                ;If 16, continue
  SHR  AL,1               ;If 8, adjust the Current Value
.D50:                     ;AL = Current Duty Cycle
  CALL WriteDutyCycle     ;Write it
  POP  EDX,ECX,EAX        ;Restore used registers
  RET

WriteDutyCycleACPI:
  PUSH AX,CX,DX           ;Save used registers
  MOV  DX,[ThtIOAddr]     ;Get the current
  IN   AX,DX              ;  Duty Cycle Value
  TEST AL,ThtEnableBit    ;Is Throttling Enabled?
  JNZ .P20                ;If so, get the Actual Value
.P10:                     ;Throttling Disabled
  MOV  AL,[ThtMaxValue]   ;Just use the Maximum value
  JMP .P30                ;Continue
.P20:                     ;Throttling Enabled
  AND  AX,[ThtValueMask]  ;Get the
  MOV  CL,[ThtDutyOffset] ;  Current Throttle
  SHR  AX,CL              ;  Value
.P30:                     ;AL = Current Duty Cycle
  MOV  AH,[ThtMaxValue]   ;AH = Maximum Throttle Value
  CALL WriteDutyCycle     ;Write it
  POP  DX,CX,AX           ;Restore used registers
  RET

WriteDutyCycle:
  PUSH AX,CX        ;Save used registers
  MOV  CH,AH        ;Save max value in CH
  CALL WriteByteMin ;Write the
  CALL WriteSlash   ;  Current
  MOV  CL,AL        ;  Throttle Value
  MOV  AL,CH        ;  as a
  CALL WriteByteMin ;  fraction
  CALL WriteSpace   ;Move over
  CALL WriteLParen  ;Start Parentheses
  MOV  AL,CL        ;Convert the
  MOV  CL,100       ;  Value to the Numerator
  MUL  CL           ;  of a Percent
  MOV  CL,CH        ;Get the Denominator
  OR   CL,CL        ;Is it 0?
  JNZ .Y50          ;If not, continue
.Y40:               ;Denominator is 0
  MOV  AL,100       ;Set Percentage to 100
  JMP .Y60          ;Jump to write it
.Y50:               ;Have a valid denominator
  DIV  CL           ;Calculate the Percent
  SHR  CL,1         ;Round
  CMP  AH,CL        ;  up
  JB  .Y60          ;  if
  INC  AL           ;  necessary
.Y60:               ;AL = Percentage
  CALL WriteByteMin ;Write the Percentage
  CALL WritePercent ;Write the Percent Sign
  CALL WriteRParen  ;Close Parentheses
  POP  CX,AX        ;Restore used registers
  RET

;;------------------------------------------------------------------------------
;;WRITE THE BATTERY STATUS USING APM CALLS
;;Inputs:  DS = ES = Local Data Segment
;;         APM Nattery Data already downloaded
;;Outputs: Writes Battery Data to the Screen
;;Changes:
;;------------------------------------------------------------------------------
;WriteBattAPM:
;  PUSH AX,BX,CX,DX         ;Save used registers
;
;  MOV  DX,ACStatusMsg      ;Write AC Power Status
;  CALL WriteItDX
;  MOV  AL,[APMACStatus]
;  MOV  BX,APMACTable
;  CALL WriteByte2String
;
;  MOV  DX,BattStatusMsg    ;Write Battery Status
;  CALL WriteItDX
;  MOV  BX,APMBFlgTable     ;This is actually a bit-map: can have multiple values?
;  MOV  AL,[APMBattFlags]
;  CMP  AL,-1
;  JNE >B10
;  MOV  AL,[APMBattStatus]
;  MOV  BX,APMBStTable
;B10:
;  CALL WriteByte2String
;
;  MOV  AL,[APMBattPct]     ;Write Battery Charge Percent
;  CMP  AL,-1
;  JE  >B20
;  MOV  DX,BattPctMsg
;  CALL WriteItDX
;  CALL WriteByteMin
;  CALL WritePercent
;  CALL WriteCrLfPause
;
;B20:
;  MOV  AX,[APMBattTime]    ;Write Battery Charge Time
;  CMP  AX,-1
;  JE  >B30
;  MOV  DX,BattTimeMsg
;  CALL WriteItDX
;  OR   AX,AX
;  JS  >B25
;  CWD
;  MOV  BX,60
;  DIV  BX
;  SHR  BX,1
;  CMP  DX,BX
;  JB  >B25
;  INC  AX
;B25:
;  AND  AH,((NOT APMBRemUnits) SHR 8)
;  CALL WriteWordMin
;  CALL WriteSpace
;  CALL WriteMinutes
;  CALL WriteCrLfPause
;
;B30:
;  MOV  AL,B [APMNumBatts][0] ;Write number of Batteries
;  CMP  AL,-1
;  JE  >B90
;  MOV  DX,NumBattsMsg
;  CALL WriteItDX
;  CALL ByteToString
;
;B90:                       ;Done
;  POP  DX,CX,BX,AX         ;Restore used registers
;  RET

;------------------------------------------------------------------------------
;WRITE A SEPARATOR LINE FOR THE STATUS
;Inputs:  DS = ES = Local Data Segment
;Outputs: Writes a Spearator Line
;Changes:
;------------------------------------------------------------------------------
WriteSeparator2:
  PUSH CX                 ;Save used registers
  MOV  CX,72              ;CX = Number of characters to Write
  JMP  WriteSeparator.S00 ;Do it
WriteSeparator:
  PUSH CX             ;Save used registers
  MOV  CX,40          ;CX = Number of characters to Write
;  JMP >S00            ;Do it
.S00:
  PUSH AX             ;Save used registers
  CALL WriteCrLfPause ;Move down
  MOV  AL,''         ;Write single dashes
.S10:                 ;Loop to here for each character
  CALL WriteAL        ;Write the character
  LOOP .S10           ;Keep writing until we're done
  CALL WriteCrLfPause ;Move down
  POP  AX             ;Restore used registers
  POP  CX             ;Restore used registers
  RET





  ;Embedded Controller
  ;Usually only in laptops -- controls/monitors things like Wireless Network,
  ;  BlueTooth, Batteries, Lids, etc.
  ;Only contains 256 bytes of data (somewhat similar in concept to the CMOS)
  ;Data can take a long time to transfer to/from the Embedded Controller,
  ;  so we must monitor the Status Port to monitor the transfer of data
  ;The BIOS will also do things with the data in the background (generally
  ;  using the non-maskable System Management Interrupt (SMI), so we need
  ;  to be careful about how we handle this


  ECCmdStsPort      DW 66h ;Command & Status Port
                           ;  It's possible to use a port other than 66h,
                           ;    though it's rarely done
    ;----------------------------------------------
    ;Values that can be written to the Command Port
    ;----------------------------------------------
    ECCmdRead      EQU 80h ;Read Data
    ECCmdWrite     EQU 81h ;Write Data
    ECCmdBurstOn   EQU 82h ;Enable Burst Mode
                           ;  Tells Controller that we will be sending a
                           ;    lot of data very quickly, and need its
                           ;    dedicated attention for awhile
    ECCmdBurstOff  EQU 83h ;Disable Burst Mode
    ECCmdQuery     EQU 84h ;Used to respond to an SCI (Interrupt) event
                           ;  Returns a value between 0 & 255 to indicate
                           ;    the reason for the Interrupt
    ;-----------------------------------------
    ;Values that are read from the Status Port
    ;-----------------------------------------
    ECStsOutFull   EQU 01h ;Output Buffer Full (Data Waiting for Host)
    ECStsInFull    EQU 02h ;Input Buffer Full (Data Waiting for Controller)
    ;Bit 2 = Reserved/Ignore
    ECStsCmd       EQU 08h ;Byte in Data Buffer is a Command (not Data)
                           ;  (Only used by Controller)
    ECStsBurst     EQU 10h ;Controller is in Burst Mode
                           ;  (0 = Controller is in "normal" interrupt-driven
                           ;    mode)
    ECStsSCIEvent  EQU 20h ;SCI Event is Pending (need to issue SCI Query)
    SCStsSMIEvent  EQU 40h ;SMI Event is Pending (BIOS needs to Query)
    ;Bit 7 = Reserved/Ignore
  ECAdrDtaPort      DW 62h ;Address & Data Port (always Command Port - 4)
    ;After writing to Command Port, Write the Data Offset value requested
    ;  (0-255) to this port, then read/write the actual data from this
    ;  same port.
    ;Ensure the InFull/OutFull bytes are correct before actually doing
    ;  anything!


  ECDataBuff TIMES 256 DB ? ;256 bytes of EC Data


  NumECEntries EQU 256 ;Number of Embedded Controller Name Entries

  ;----------------------------------------------------------------------------
  ;Embedded Controller (Laptop) Name Structure
  ;  Data in the Embedded Controller is accessed as individual bytes, even
  ;    when it is Word or DWord data.  DWord data is not very common,
  ;    so we just stored words and use multiple table entries (with the
  ;    same name) if it is a DWord.
  ;  Many field in the Controller are Bytes or bit-maps.
  ;----------------------------------------------------------------------------
  STRUC ECNameStruc
    ECNmName    RESD 1 ;ACPI Name of Field Element
                       ;  If an element is more than 16 bytes, we use
                       ;    multiple entries with the same name.  We can
                       ;    tell if multiple entries are used from the
                       ;    Size Field.
    ECNmData    RESW 1 ;Actual data from Embedded Controller
    ECNmBitMask RESB 1 ;AND this value with the EC Data Byte, then SHR
                       ;  with the SftMask value to determine the actual
                       ;  Field contents (invalid if NumBits >= 8)
                       ;If NumBits > 16, this is the third byte of data
    ECNmSftMask RESB 1 ;SHR the EC Data Byte this many bits after ANDing
                       ;  it with the BitMask to determine the actual
                       ;  Field contents (invalid if NumBits >= 8)
                       ;If NumBits > 16, this is the fourth byte of data
                       ;Unused if NumBits >= 8.
    ECNmOffset  RESB 1 ;Byte Offset of Data in Embedded Controller Space
    ECNmNumBits RESB 1 ;Number of bits in the Field
   ENDS
  ECNameSize EQU ECNameStruc_size ;10 Bytes

  ECNameTbl TIMES (NumECEntries*ECNameSize) DB 0 ;Embedded Controller
                                                 ;  Name Table
  ECNameEnd EQU $ ;End of EC Name Table




  ECHdrString:
    DB CR,LF
    DB LF
    DB '    CURRENT LAPTOP EMBEDDED CONTROLLER DATA',CR,LF
    DB '',CR,LF,0

  ECHdrString2:
    DB '            Data             Current Data',CR,LF
    DB 'ACPI Byte  Length Bit  ',CR,LF
    DB 'Name Index (bits) Mask    Hex        Decimal',CR,LF
    DB '     ',CR,LF
    DB 0

  ECHdrString3:
    DB CR,LF
    DB LF
    DB '         MONITORING CHANGES IN LAPTOP EMBEDDED CONTROLLER DATA',CR,LF
    DB '',CR,LF,0

  ECHdrString4:
    DB '            Data             Current Data             Previous Data',CR,LF
    DB 'ACPI Byte  Length Bit   ',CR,LF
    DB 'Name Index (bits) Mask    Hex        Decimal       Hex        Decimal',CR,LF
    DB '       ',CR,LF
    DB 0


  IgnoreNameTbl:  TIMES 32 DD 0
  IncludeNameTbl: TIMES 32 DD 0


  BStateName:   DD '_TSB' ;ACPI Name of Battery State Register
                          ;  Bit 0 = Discharging
                          ;      1 = Charging
                          ;      2 = Critical
  BPRateName:   DD '_RPB' ;ACPI Name of Battery Present Rate Register
                          ;  mA or mW, direction as defined in BState
  BRemCapName:  DD '_CRB' ;ACPI Name of Battery Remaining Capacity Register
                          ;  mAh or mWh
  BFullCapName: DD '_CFB' ;ACPI Name of Battery Last Full Charge
                          ;  Capacity Register
                          ;  mAh or mWh



;------------------------------------------------------------------------------
;WRITE THE BATTERY STATUS USING ACPI CALLS
;Inputs:  DS = ES = Local Data Segment
;         ACPI Battery Data already downloaded
;Outputs: Writes Battery Data to the Screen
;Changes:
;------------------------------------------------------------------------------
WriteBattACPI:
  PUSH EAX,EBX,ECX,EDX    ;Save used registers
  PUSH DI,ESI             ;Save used registers
  CMP  B [ECNameTbl],0    ;Any Battery Info to Write?
  JE  .B90                ;If not, quit
;  CALL WriteCrLfPause    ;If so, move down
  MOV  EBX,[BStateName]   ;Get the
  CALL GetNameData        ;  Battery State
  JC  .B90                ;If none, quit
  MOV  DX,BattStateMsg    ;If OK,
  CALL WriteZPause        ;  write the description
  MOV  DX,DischargingMsg  ;Assume
  MOV  DI,BattTimeMsg     ;  Discharging
  MOV  SI,BRemCapName     ;
  TEST AL,1               ;Discharging?
  JNZ .B10                ;If so, continue
  MOV  DX,ChargingMsg     ;Assume
  MOV  DI,BattFullTmMsg   ;  Charging
  MOV  SI,BFullCapName    ;
  TEST AL,2               ;Charging?
  JNZ .B10                ;If so, continue
  MOV  DX,ChargedMsg      ;If not,
  XOR  DI,DI              ;  it's Charged
;  JMP >B10                ;Continue
;.B902                     ;To avoid
;  JMP >B901               ;  JMP > 128
.B10:                     ;DX = Battery State Message to Write
  CALL WriteZPause        ;Write the Battery State Message
  CALL WriteCrLfPause     ;Move down
  OR   DI,DI              ;Is it Fully Charged?
  JZ  .B90                ;If not, we're done
  MOV  EBX,[BFullCapName] ;Get the
  CALL GetNameData        ;  Full Capacity
  JC  .B90                ;If error, quit
  MOV  ECX,EAX            ;Store it in ECX
  MOV  EBX,[BRemCapName]  ;Get the
  CALL GetNameData        ;  Remaining Capacity
  JC  .B90                ;If error, quit
  XOR  EDX,EDX            ;Calculate
  PUSH ECX                ;  the
  MOV  ECX,100            ;  Charge
  MUL  ECX                ;  Percent
  POP  ECX                ;  (don't
  DIV  ECX                ;  round up!)
  MOV  DX,BattPctMsg      ;Write the
  CALL WriteZPause        ;  Description
  CALL WriteByteMin       ;Write the Percent Charge
  MOV  AL,'%'             ;Write a
  CALL WriteAL            ;  Percent Sign
  CALL WriteCrLfPause     ;Move down
  MOV  EBX,[BPRateName]   ;Get the
  CALL GetNameData        ;  Present Rate of Charge/Discharge
  JC  .B90                ;If error, quit
;  JNC >B20                ;If OK, continue
;.B901                     ;To
;  JMP >B90                ;  avoid
;.B20:                     ;  JMP > 128
  MOV  ECX,EAX            ;Store it in ECX
  MOV  EBX,[SI]           ;Get the
  CALL GetNameData        ;  Full/Remaining Capacity, as appropriate
  JC  .B90                ;If error, quit
  CMP  SI,BFullCapName    ;Charging?
  JNE .B25                ;If not, continue
  MOV  ESI,EAX            ;If so, save Full Charge Capacity
  MOV  EBX,[BRemCapName]  ;Get the
  CALL GetNameData        ;  Remaining Capacity
  JC  .B90                ;If error, quit
  XCHG ESI,EAX            ;Calculate the
  SUB  EAX,ESI            ;  capacity needed to charge
.B25:                     ;EAX contains correct value
  MOV  DX,DI              ;Write the
  CALL WriteZPause        ;  Description
  XOR  EDX,EDX            ;Calculate the
  DIV  ECX                ;  remaining mWh / mAh
  CALL WriteByteMin       ;Write the Hours
  MOV  AL,':'             ;Write
  CALL WriteAL            ;  a Colon
  PUSH ECX                ;Convert
  MOV  EAX,EDX            ;  decimal
  MOV  ECX,60             ;  hours
  MUL  ECX                ;  to
  POP  ECX                ;  minutes
  DIV  ECX                ;  (don't round up)
  CMP  AL,10              ;Is it at least 10 minutes?
  JAE .B30                ;If so, continue
  MOV  AH,AL              ;If not,
  MOV  AL,'0'             ;  write
  CALL WriteAL            ;  a
  MOV  AL,AH              ;  zero
.B30:                     ;Write the Minutes
  CALL WriteByteMin       ;Write the Minutes
  CALL WriteCrLfPause     ;Move down
.B90:                     ;Done
  POP  ESI,DI             ;Restore used registers
  POP  EDX,ECX,EBX,EAX    ;Restore used registers
  RET


;Inputs:  ES = Local Data Segment
;         [ECDataBuff]
;         CLD already issued
;Outputs: CF = Clear if OK
;              [ECDataBuff] filled with data
;            = Set if Error
;              [ECDataBuff] partially filled with data
;Changes:


GetAllECData:
  PUSH AX,BX,DI      ;Save used registers
  XOR  BL,BL         ;Start with EC Offset 0
  MOV  DI,ECDataBuff ;ES:DI = Where to store the Data
.A10:                ;Loop to here to get the Data
  CALL ReadECByte    ;Read the next Byte of Data
  JC  .A70           ;If error, quit
  STOSB              ;Save it in the buffer
  INC  AH            ;Increment the Offset
  JNZ .A10           ;If not done yet, keep getting the data
  JMP .A80           ;Done
.A70:                ;Error
  STC                ;Set return flag
  JMP .A90           ;Done
.A80:                ;OK
  CLC                ;Set return flag
.A90:                ;Done
  POP  DI,BX,AX      ;Restore used registers
  RET


;;Sony laptop Embedded Controller Names
;
;SonyData:
;  DB 000h, 040h, 00Ch, 053h, 04Dh, 050h, 052h, 008h, 053h, 04Dh, 053h, 054h
;  DB 008h, 053h, 04Dh, 041h, 044h, 008h, 053h, 04Dh, 043h, 04Dh, 008h, 053h
;  DB 04Dh, 044h, 030h, 048h, 010h, 053h, 04Dh, 041h, 041h, 008h, 000h, 018h
;  DB 000h, 007h, 053h, 034h, 046h, 047h, 001h, 000h, 008h, 000h, 004h, 042h
;  DB 041h, 04Eh, 04Bh, 004h, 000h, 010h, 04Dh, 042h, 043h, 054h, 010h, 052h
;  DB 043h, 041h, 050h, 010h, 04Dh, 042h, 056h, 054h, 010h, 000h, 040h, 005h
;  DB 048h, 04Bh, 044h, 041h, 010h, 043h, 054h, 04Dh, 050h, 008h, 000h, 038h
;  DB 000h, 003h, 053h, 034h, 057h, 04Bh, 001h, 000h, 001h, 053h, 033h, 04Ch
;  DB 044h, 001h, 053h, 034h, 04Ch, 044h, 001h, 000h, 001h, 000h, 001h, 050h
;  DB 04Eh, 044h, 043h, 001h, 000h, 00Eh, 042h, 041h, 054h, 044h, 010h, 000h
;  DB 048h, 005h, 04Dh, 044h, 046h, 047h, 008h, 000h, 048h, 01Dh, 04Ch, 044h
;  DB 053h, 054h, 001h, 000h, 004h, 050h, 04Eh, 044h, 053h, 001h, 000h, 042h
;  DB 014h, 053h, 042h, 043h, 04Dh, 008h, 053h, 042h, 044h, 04Ch, 010h, 053h
;  DB 042h, 045h, 058h, 001h
;  DB 0FFh


;------------------------------------------------------------------------------
;INITIALIZE THE EMBEDDED CONTROLLER NAME TABLE WITH DETAILS
;Inputs:  CS = DS = Local Data Segment
;         ES = Buffer Data Segment
;         ES:DI = Start of ACPI Name Space for our Fields
;Outputs: CF = Clear if OK
;              [ECNameTbl] filled with information
;            = Set if Error
;Changes:
;------------------------------------------------------------------------------
InitECNameTbl:
  PUSH EAX,BX,CX,DX          ;Save used registers
  PUSH DI,SI,BP              ;Save used registers
  XOR  DX,DX                 ;DX = Running Bit Offset Counter
  MOV  SI,ECNameTbl          ;DS:SI = Where to store data
.I10:                        ;Loop to here for each Name
  MOV  EAX,[ES:DI]           ;EAX = Name
  XOR  BL,BL                 ;ES:[DI+BL] = ACPI Name
  CALL TestACPIName          ;Valid ACPI Name?
  MOV  BL,4                  ;Assume a Valid Name
  JNC .I20                   ;If a valid Name, continue
  MOV  BL,1                  ;Assume Null Name
  OR   AL,AL                 ;Null Name?
  JNZ .I60                   ;If not, we're done
.I20:                        ;BL = Correct Value
  CALL GetPkgLength          ;Get the Nubmer of Bits in the Data
                             ;  (Returns CF, CX, BP, updates DI)
  JC  .I60                   ;If error, we're done
  MOV  BP,DX                 ;BP = Current Bit Counter
  ADD  DX,CX                 ;Update Bit Counter for next time
  JC  .I70                   ;If overflow, error
  CMP  DX,(256*8)            ;Too many bits in the data?
  JAE .I70                   ;If so, error
  OR   AL,AL                 ;Null Name?
  JZ  .I10                   ;If so, keep looking for more data
.I30:                        ;Is a valid name
  CMP  CX,32                 ;Is it longer than a DWord?
  JA  .I10                   ;If so, skip it
  CMP  CL,8                  ;Is it a Bit-map?
  JB  .I31                   ;If so, continue
  TEST BP,7                  ;If not, is it byte-aligned?
  JZ  .I32                   ;If so, continue
  JMP .I10                   ;Skip it
.I31:                        ;Bit-mapped data
  PUSH DX,BP                 ;Save used registers
  DEC  DX                    ;Does the
  AND  BP,100h               ;  Bit-mapped Data
  AND  DX,100h               ;  cross a
  CMP  DX,BP                 ;  Byte boudnary?
  POP  BP,DX                 ;Restore used registers
  JNE .I10                   ;If so, skip it
.I32:                        ;Data appears to be OK
  MOV  [SI+ECNmName],EAX     ;If OK, store the Name
  MOV  [SI+ECNmNumBits],CL   ;  and the number of bits
  MOV  BX,BP                 ;BX = Bit Counter
  SHR  BP,3                  ;Store the
  OR   W [SI+ECNmOffset],BP  ;  Byte Offset
  CMP  CL,8                  ;Is it a Bit-map?
  JAE .I50                   ;If not, we're done with this entry
  AND  BX,7                  ;Mask out bytes, leave bits
  XOR  AX,AX                 ;Start bit mask at 0
.I33:                        ;Loop to here to calculate bit mask
  BTS  AX,BX                 ;Mask in the next bit in the mask
  INC  BX                    ;Increment the Bit Number
  LOOP .I33                  ;Keep going until we're done
  MOV  B [SI+ECNmBitMask],AL ;Store the Bit Mask
  XOR  BX,BX                 ;Start Shift Mask at 0
.I36:                        ;Loop to here to calcualte the Shift Mask
  SHR  AL,1                  ;Shift over the Bit Mask
  JC  .I40                   ;If "overflow", we've got our shift mask
  INC  BX                    ;If not, increment the Shift Mask
  JMP .I36                   ;Keep going until we "overflow"
.I40:                        ;BL = Shift Mask
  MOV  B [SI+ECNmSftMask],BL ;Store the Shift Mask
.I50:                        ;Filled in this Table entry
  ADD  SI,ECNameSize         ;Point at the next Table entry
  CMP  SI,ECNameEnd          ;Any more room left in the Table?
  JB  .I10                   ;If so, keep looking
.I60:                        ;Done getting Names
  CMP  SI,ECNameTbl          ;Did we get any data at all?
  JNE .I80                   ;If so, quit
.I70:                        ;Error
  MOV  B [ECNameTbl],0       ;Mark the Table as invalid
  STC                        ;Set return flag
  JMP .I90                   ;Done
.I80:                        ;OK
  CLC                        ;Set return flag
.I90:                        ;Done
  POP  BP,SI,DI              ;Restore used registers
  POP  DX,CX,BX,EAX          ;Restore used registers
  RET

;------------------------------------------------------------------------------
;INITIALIZE THE EMBEDDED CONTROLLER NAME TABLE WITH CURRENT DATA
;Inputs:  CS = DS = Local Data Segment
;         ES = Buffer Data Segment
;         [ECNameTable] = Name Table, filled in with appropriate info
;Outputs: [ECNameTbl] filled with Current Data
;Changes:
;------------------------------------------------------------------------------
InitECData:
  PUSH SI             ;Save used registers
  MOV  SI,ECNameTbl   ;DS:SI = Table of Names
.G10:                 ;Loop to here for each Table Entry
  CMP  B [SI],0       ;Valid Table Entry?
  JE  .G90            ;If not, we're done
  CALL GetECEntryData ;Get the Data for this Table Entry
  ADD  SI,ECNameSize  ;Point at the next Table entry
  CMP  SI,ECNameEnd   ;Done with the Table?
  JB  .G10            ;If not, keep going
.G90:                 ;Done
  POP  SI             ;Restore used registers
  RET

;------------------------------------------------------------------------------
;GET THE DATA FOR AN INDIVIDUAL EMBEDDED CONTROLLER NAME TABLE ENTRY
;Inputs:  CS = DS = Local Data Segment
;         DS:SI = Embedded Controller Name Table entry to get
;         [ECNameTable] = Name Table, filled in with appropriate info
;Outputs: EC Name Table entry updated with Current Data
;Changes:
;------------------------------------------------------------------------------
GetECEntryData:
  PUSH EAX,BX,CX,SI,BP     ;Save used registers
  MOV  CL,[SI+ECNmNumBits] ;AL = Number of Bits
  MOV  BP,ReadECByte       ;Assume a Byte
  CMP  CL,16               ;Do we want a Byte?
  JB  .Y20                 ;If so, continue
  MOV  BP,ReadECWord       ;If not, assume a Word
  JE  .Y20                 ;If we want a word, continue
  MOV  BP,ReadECDWord      ;If not, we must want a DWord
.Y20:                      ;BP = Code to Call
  XOR  EAX,EAX             ;Start Data at 0
  MOV  BL,[SI+ECNmOffset]  ;BL = Offset of Data to get
  CALL BP                  ;Read the Data (AL/AX/EAX)
  JC  .Y90                 ;If error, quit
  CMP  CL,8                ;Is it a Byte, WOrd, or DWord?
  JB  .Y30                 ;If not, continue
  MOV  [SI+ECNmData],EAX   ;If so, store it
  JMP .Y90                 ;Done with this Table Entry
.Y30:                      ;Is bit-mapped Data
  MOV  CL,[SI+ECNmSftMask] ;CL = SHift Mask
  AND  AL,[SI+ECNmBitMask] ;Mask out the unwanted bits
  SHR  AL,CL               ;Move data over to the correct position
  MOV  [SI+ECNmData],AX    ;Store it
.Y90:                      ;Done
  POP  BP,SI,CX,BX,EAX     ;Restore used registers
  RET

;------------------------------------------------------------------------------
;GET THE CURRENT DATA FOR A SPECIFIC EMBEDDED CONTROLLER ACPI NAME
;Inputs:  CS  = DS = Local Data Segment
;         EBX = Embedded Controller ACPI Name to Look For
;         [ECNameTbl] filled with current data
;Outputs: CF = Clear if OK
;              EAX = Data asociated with the ACPI Name
;            = Set if Error
;              EAX = Undefined
;Changes:
;------------------------------------------------------------------------------
GetNameData:
  PUSH CX,SI                 ;Save used registers
  OR   BL,BL                 ;Valid name?
  JZ  .D70                   ;If not, error
  MOV  SI,ECNameTbl          ;DS:SI = Table to Search
  MOV  CX,256                ;CX = Number of Table Entries
.D10:                        ;Loop to here to find the matching Entry
  CMP  EBX,[SI+ECNmName]     ;The entry we're looking for?
  JNE .D50                   ;If not, skip this one
  CMP  B [SI+ECNmNumBits],32 ;Is it a DWord?
  JE  .D30                   ;If so, jump to handle it
  XOR  EAX,EAX               ;Set high word of EAX to 0
  MOV  AX,[SI+ECNmData]      ;Get the Low Word of Data
  JMP .D80                   ;Done
.D30:                        ;Is a DWord
  MOV  EAX,D [SI+ECNmData]   ;Get the DWord Data
  JMP .D80                   ;Done
.D50:                        ;Not the correct Entry
  ADD  SI,ECNameSize         ;Point at the enxt Table Entry
  LOOP .D10                  ;Keep looking
.D70:                        ;Error (Ignore this Entry)
  STC                        ;Set the return flag
  JMP .D90                   ;Done
.D80:                        ;OK (do not ignore)
  CLC                        ;Set return flag
.D90:                        ;Done
  POP  SI,CX                 ;Restore used registers
  RET

;------------------------------------------------------------------------------
;WRITE CHANGES IN THE EMBEDDED CONTROLLER NAME TABLE DATA TO THE SCREEN
;Inputs:  DS = Local Data Segment
;         [ECNameTbl] filled with data
;         CLD already issued
;Outputs: To Screen
;         Updates contents of [ECNameTbl] in "real time" until a keystroke
;           is pressed
;Changes:
;------------------------------------------------------------------------------
WriteChgECData:
  PUSH AX,EBX,DX,SI        ;Save used registers


mov  D [IgnoreNameTbl+0],'DCMP'
mov  D [IgnoreNameTbl+4],'_VPB'
mov  D [IgnoreNameTbl+8],'CDRF'


;Write Include/Ignore Names


  TEST B [ProgFlags],ChgECData ;Need to do this?
  JZ  .U90                 ;If not, quit
  CMP  B [ECNameTbl],0     ;Anything in the Table?
  JE  .U70                 ;If not, Error
  MOV  DX,ECHdrString3     ;Write the
  CALL WriteZPause         ;  first part of the Header
  MOV  DX,ECHdrString4     ;Write the
  CALL SetupPause          ;  second part of the Header
.U10:                      ;Loop to here to start the table search again
  MOV  SI,ECNameTbl        ;DS:SI = Embedded Controller Name Table
.U20:                      ;Loop to here for each Table entry
;  CALL GetKey              ;User pressed a keystroke?
;  JNZ >U90                 ;If so, we're done
  CALL TestNameIgnore      ;Should we ignore this Entry?
  JC  .U30                 ;If so, skip it
  MOV  EBX,D [SI+ECNmData] ;EBX = Current Data
  CALL GetECEntryData      ;Get the current data
  CMP  EBX,D [SI+ECNmData] ;Has it changed?
  JE  .U30                 ;If not, continue
  CALL WriteECEntryChg     ;If so, write the data to the screen
  CALL WriteCrLfPause      ;Move down
.U30:                      ;Data is written, if appropriate
  ADD  SI,ECNameSize       ;Point at the next Table entry
  CMP  B [SI+ECNmName],0   ;End of Table?
  JE  .U50                 ;If so, handle it
  CMP  SI,ECNameEnd        ;End of Table?
  JB  .U20                 ;If not, keep looking
.U50:                      ;At end of Table
  CALL GetKey              ;User pressed a keystroke?
  JZ  .U10                 ;If not, keep looking
  MOV  DX,NoMsg            ;Write nothing
  XOR  AL,AL               ;AL = ErrorLevel = 0
  JMP  Exit                ;Quit
.U70:                      ;Error

;Display appropriate error message and quit

.U90:                      ;Done
  POP  SI,DX,EBX,AX        ;Restore used registers
  RET

;------------------------------------------------------------------------------
;TEST AN EMBEDDED CONTROLLER NAME ENTRY TO SEE IF IT SHOULD BE IGNORED
;Inputs:  CS = DS = Local Data Segment
;         SI = Embedded Controller Name Table
;         [IgnoreNameTbl] filled with ACPI Names to Ignore
;         CLD already issued
;Outputs: CF = Clear if OK (Data should NOT be ignored)
;            = Set if Error (Data Should be ignored)
;Changes:
;------------------------------------------------------------------------------
TestNameInclude:


;Do this!!


TestNameIgnore:
  PUSH EAX,EBX,CX,SI     ;Save used registers
  MOV  EBX,[SI+ECNmName] ;EBX = Name to find
  MOV  CX,16             ;CX = Number of Entries in the Ignore Name Table
  MOV  SI,IgnoreNameTbl  ;DS:SI = Table of Names to Ignore
.I10:                    ;Loop to here for each Table Entry
  LODSD                  ;Get the next Ignore Table entry
  CMP  EAX,EBX           ;Does it match?
  JE  .I70               ;If so, we should ignore it
  LOOP .I10              ;If not, keep looking
  JMP .I80               ;Don't ignore the name
.I70:                    ;Error (Ignore this Entry)
  STC                    ;Set the return flag
  JMP .I90               ;Done
.I80:                    ;OK (do not ignore)
  CLC                    ;Set return flag
.I90:                    ;Done
  POP  SI,CX,EBX,EAX     ;Restore used registers
  RET

;------------------------------------------------------------------------------
;WRITE THE CONTENTS OF THE ENTIRE EMBEDDED CONTROLLER NAME TABLE TO THE SCREEN
;Inputs:  DS = Local Data Segment
;         [ECNameTbl] filled with data
;         CLD already issued
;Outputs: To Screen
;Changes:
;------------------------------------------------------------------------------
WriteAllECData:
  PUSH DX,SI             ;Save used registers
  TEST B [ProgFlags],AllECData ;Need to do this?
  JZ  .L90               ;If not, quit
  MOV  SI,ECNameTbl      ;DS:SI = Embedded Controller Name Table
  CMP  B [SI],0          ;Anything in the Table?
  JE  .L70               ;If not, Error
  MOV  DX,ECHdrString    ;Write the
  CALL WriteZPause       ;  first part of the Header
  MOV  DX,ECHdrString2   ;Write the
  CALL SetupPause        ;  second part of the Header
.L10:                    ;Loop to here for each Table entry
  CMP  B [SI+ECNmName],0 ;End of Table?
  JE  .L90               ;If so, we're done
  CALL WriteECEntry      ;If not, write the Data
  CALL WriteCrLfPause    ;Move down
  ADD  SI,ECNameSize     ;Point at the next Table entry
  CMP  SI,ECNameEnd      ;Done with the Table?
  JB  .L10               ;If not, keep going
;  JMP >L90               ;Done
  MOV  DX,NoMsg          ;Write nothing
  XOR  AL,AL             ;AL = ErrorLevel = 0
  JMP  Exit              ;Quit
.L70:                    ;Error


;Display appropriate error message and quit


.L90:                    ;Done
  POP  SI,DX             ;Restore used registers
  RET

;------------------------------------------------------------------------------
;WRITE THE CONTENTS OF A SINGLE EMBEDDED CONTROLLER NAME ENTRY TO THE SCREEN
;Inputs:  CS  = DS = Local Data Segment
;         DS:SI = Embedded Controller Name Table entry to write
;         If WriteECEntryChg,
;           EBX = Old Contents of [SI+ECNmData], including Bit-map data
;Outputs: To Screen
;Changes:
;------------------------------------------------------------------------------
WriteECEntryChg:
  PUSH DX                    ;Save used registers
  MOV  DX,0001h              ;Mark as writing a Change
  JMP  WriteECEntry.Y00      ;Do it
WriteECEntry:
  PUSH DX                    ;Save used registers
  XOR  DX,DX                 ;Mark as writing Current data
;  JMP >Y00                   ;Do it
.Y00:
  PUSH EAX,CX,SI             ;Save used registers
  MOV  EAX,[SI+ECNmName]     ;Get the Field Name
  OR   AL,AL                 ;Valid Name?
  JZ  .Y90                   ;If so, we're done
  CALL WriteACPIName         ;If OK, write the Field Name
  XOR  EAX,EAX               ;All Bytes = 0
  CALL Write3Spaces          ;Move over
  MOV  AL,[SI+ECNmOffset]    ;Write the
  CALL WriteByteHex          ;  Byte
  CALL WriteHexEnd           ;  Index
  CALL WriteSpace            ;Move over
  MOV  AL,[SI+ECNmNumBits]   ;Write the
  CALL WordToString          ;  Data Length
  CALL Write2Spaces          ;Move over
  CMP  AL,8                  ;Bit-mapped?
  JAE .Y25                   ;If not, continue
.Y20:                        ;Bit-mapped
  MOV  AL,[SI+ECNmBitMask]   ;Write the
  CALL WriteByteHex          ;  Bit
  CALL WriteHexEnd           ;  Mask
  JMP .Y30                   ;Continue
.Y25:                        ;Not bit-mapped
  CALL WriteNA               ;Write "N/A"
.Y30:                        ;Done writing Bit-mask
  CALL WriteSpace            ;Move over
  CMP  B [SI+ECNmNumBits],16 ;Bit-mapped, Byte, Word, or DWord?
  JB  .Y32                   ;If Byte or Bit-map, jump to handle it
  JE  .Y34                   ;If a Word, jump to handle it
  JMP .Y36                   ;If not, it must be a DWord
.Y32:                        ;Data is a Byte
  MOV  CL,7                  ;Move
  CALL WriteSpaces           ;  over
  MOV  AL,B [SI+ECNmData]    ;Get and
  CALL WriteByteHex          ;  write the
  CALL WriteHexEnd           ;  Hex Data
  JMP .Y40                   ;Continue
.Y34:                        ;Data is a Word
  MOV  CL,5                  ;Move
  CALL WriteSpaces           ;  over
  MOV  AX,W [SI+ECNmData]    ;Get and
  CALL WriteWordHex          ;  write the
  CALL WriteHexEnd           ;  Hex Data
  JMP .Y40                   ;Continue
.Y36:                        ;Data is a DWord
  MOV  EAX,D [SI+ECNmData]   ;Get and
  CALL WriteDWordHex         ;  write the
  CALL WriteHexEnd           ;  Hex Data
.Y40:                        ;Hex Data is written
  CALL WriteSpace            ;Move over
  CALL DWordToString         ;Write the Decimal Data
  OR   DL,DL                 ;Writing changes?
  JZ  .Y90                   ;If not, we're done
  XCHG EBX,D [SI+ECNmData]   ;If so, swap old and new data
  OR   DH,DH                 ;Did we already write the change?
  JNZ .Y90                   ;If so, we're done
  INC  DH                    ;If not, mark it as writing now
  JMP .Y30                   ;Do it
.Y90:                        ;Done
  POP  SI,CX,EAX             ;Restore used registers
  POP  DX                    ;Restore used registers
  RET

;------------------------------------------------------------------------------
;WRITE AN ACPI NAME TO THE SCREEN
;Inputs:   CS = DS = Local Data Segment
;         EAX = ACPI Name to write (4 characters)
;Outputs: CF = Clear if OK (was not a Null Name)
;              Name is written to screen
;            = Set if Error (was a Null Name)
;              Nothing is written
;------------------------------------------------------------------------------
WriteACPIName:
  PUSH CX      ;Save used registers
  OR   AL,AL   ;Null Name?
  MOV  CX,4    ;Write 4 characters
.N10:          ;Loop to here for each character
  CALL WriteAL ;Write the next character
  ROR  EAX,8   ;AL = Next Character to write
  LOOP .N10    ;Keep going until we're done
.N70:          ;Error
  STC          ;Set return flag
  JMP .N90     ;Done
.N80:          ;OK
  CLC          ;Set return flag
.N90:          ;Done
  POP  CX      ;Restore used registers
  RET

;------------------------------------------------------------------------------
;READ A DATA WORD OR DWORD FROM THE EMBEDDED CONTROLLER OF A LAPTOP
;Inputs:  BL = Data Offset of Data to Get/Send
;         If Write, AX/EAX = Data to Send
;Outputs: CF = Clear if OK
;              If Read:
;                AX/EAX = Data from the Controller
;              If Write:
;                AX/EAX = Unchanged
;            = Set if Error
;                AX/EAX = Unchanged
;         Interrupts Enabled
;Changes: Sends/Receives Data to/from the Embedded Controller
;NOTES: The Embedded Controller is only accessible a byte at a time, so we
;         can't read a WOrd or DWord with one instruction.
;       We read the (2 or 4) bytes one at a time, and concatentate them
;         together to form the final product.
;       We read all of the data with interrupts disabled, to try and ensure
;         the total data is valid.
;------------------------------------------------------------------------------
ReadECDWord:
  PUSH CX              ;Save used registers
  MOV  CX,0004h        ;CH = 0 = Read, CL = 4 = DWord
  JMP  WriteECWord.L00 ;Do it
WriteECDWord:
  PUSH CX              ;Save used registers
  MOV  CX,0104h        ;CH = 1 = Write, CL = 4 = DWord
  JMP  WriteECWord.L00 ;Do it
ReadECWord:
  PUSH CX              ;Save used registers
  MOV  CX,0002h        ;CH = 0 = Read, CL = 2 = Word
  JMP  WriteECWord.L00 ;Do it
WriteECWord:
  PUSH CX              ;Save used registers
  MOV  CX,0102h        ;CH = 1 = Write, CL = 2 = Word
;  JMP >L00             ;Do it
.L00:
  PUSH BX,EDX,EBP  ;Save used registers
  MOV  BH,CL       ;Save size data
  MOV  EDX,EAX     ;EDX = Original EAX
  MOV  EBP,EAX     ;EBP = Original EAX
  OR   CH,CH       ;Read or Write?
  CLI              ;Disable interrupts
  JNZ .L40         ;If Write, jump to handle it
.L10:              ;Read
  XOR  CH,CH       ;CX = Number of Bytes to Write
  XOR  DX,DX       ;Assume Word
  CMP  CL,2        ;Word or DWord?
  JE  .L12         ;If Word, continue
  XOR  EDX,EDX     ;If not, reset entire DWord
.L12:              ;EDX is initialized
  CALL ReadECByte  ;Read the next byte
  JC  .L18         ;If error, handle it
  OR   DL,AL       ;Mask it into our output
  ROR  EDX,8       ;Rotate the Output Data
  INC  BL          ;Update the Data Offset
  LOOP .L12        ;Keep going until we're done
  CMP  BH,4        ;Word or DWord?
  JE  .L80         ;If a DWord, we're done
  ROR  EDX,16      ;If a Word, put things in the correct position
  JMP .L80         ;Done
.L18:              ;Error while reading data
  MOV  EDX,EBP     ;EDX = Original EAX
  JMP .L70         ;Error
.L40:              ;Write
  XOR  CH,CH       ;CX = Number of Bytes to Write
.L45:              ;Loop to here to write each byte
  CALL WriteECByte ;Write the next byte
  JC  .L90         ;If error, quit
  ROR  EAX,8       ;Put next byte in AL
  INC  BL          ;Update the Offset
  LOOP .L45        ;Keep going until we're done
  JMP .L80         ;Done
.L70:              ;Error
  STC              ;Set return flag
  JMP .L90         ;Done
.L80:              ;OK
  CLC              ;Set return flag
.L90:              ;Done
  STI              ;Enable interrupts
  MOV  EAX,EDX     ;Set EAX for the return
  POP  EBP,EDX,BX  ;Restore used registers
  POP  CX          ;Restore used registers
  RET

;------------------------------------------------------------------------------
;READ/WRITE A DATA BYTE FROM THE EMBEDDED CONTROLLER OF A LAPTOP
;Inputs:  BL = Data Offset of Data to Get/Send
;         If Write, AL = Data to Send
;Outputs: CF = Clear if OK
;              If Read:
;                AL = Data from the Controller
;              If Write:
;                AL = Unchanged
;            = Set if Error
;                AL = Unchanged
;Changes: Sends/Receives Data to/from the Embedded Controller
;------------------------------------------------------------------------------
ReadECByte:
  PUSH BX                ;Save used registers
  XOR  BH,BH             ;Mark as a Read
  JMP  WriteECByte.C00   ;Do it
WriteECByte:
  PUSH BX                ;Save used registers
  MOV  BH,1              ;Mark as a Write
;  JMP >C00               ;Do it
.C00:
  PUSH DX,BP             ;Save used registers
  PUSHF                  ;Save flags
  CLI                    ;Disable interrupts
  MOV  BP,AX             ;Save original AX
  CALL WaitECInEmpty     ;Wait for Input Buffer to Clear (rtns AH)
  JC  .C70               ;If it never does, error
  MOV  DX,[ECCmdStsPort] ;DX = I/O Port to use
  MOV  AL,ECCmdRead      ;Assume Read
  OR   BH,BH             ;Is it a Read?
  JZ  .C10               ;If so, continue
  MOV  AL,ECCmdWrite     ;If not, it's Write
.C10:                    ;AL = Command to send
  OUT  DX,AL             ;Issue the command to the Controller
  CALL WaitECInEmpty     ;Wait for the Controller to accept our Cmd (rtns AH)
  JC  .C70               ;If it never does, error
  MOV  DX,[ECAdrDtaPort] ;Tell the Controller
  MOV  AL,BL             ;  what Offset Value
  OUT  DX,AL             ;  to use
  CALL WaitECInEmpty     ;Wait for the Controller to accept our Data (rtns AH)
  JC  .C70               ;If it never does, error
  OR   BH,BH             ;Read or Write?
  JNZ .C30               ;If Write, jump to handle it
.C20:                    ;Read
  CALL WaitECOutFull     ;Wait for our Data to appear (rtns AH)
  JC  .C70               ;If it never does, error
  IN   AL,DX             ;Get the Data
  AND  BP,0FF00h         ;Put the data
  XOR  AH,AH             ;  into the low byte
  OR   BP,AX             ;  of BP
  CALL WaitECOutEmpty    ;Wait for the Controller to acknowledge (rtns AH)
  JC  .C70               ;If it never does, error
  JMP .C80               ;Done
.C30:                    ;Write
  MOV  AL,BL             ;Send
  OUT  DX,AL             ;  our Data
  CALL WaitECInEmpty     ;Wait for the Controller to accept our Data (rtns AH)
  JNC .C80               ;If it's accepted, we're done
.C70:                    ;Error
  POPF                   ;Restore flags
  STC                    ;Set return flag
  JMP .C90               ;Done
.C80:                    ;OK
  POPF                   ;Restore flags
  CLC                    ;Set return flag
.C90:                    ;Done
  MOV  AX,BP             ;Set AX for the return
  POP  BP,DX             ;Restore used registers
  POP  BX                ;Restore used registers
  RET

;;------------------------------------------------------------------------------
;;MAKE SURE THE EMBEDDED CONTROLLER IS SET UP FOR US TO GET DATA
;;Inputs:  DS = Local Data Segment
;;         [ECCmdStsPort], [ECAdrDtaPort]
;;         CLI already issued
;;Outputs: CF = Clear if OK (Controller is set up for us to get data)
;;            = Set if Error
;;Changes:
;;NOTES: At least on my HP laptop, the Controller is alread set up in
;;         burst mode and the Output Buffer Full flag always seems
;;         to be set.
;;       We'll make sure Burst mode is enabled, and SCI Query is issued
;;         if required.  We'll ignore the Output Buffer Full status.
;;------------------------------------------------------------------------------
;PrepareEC:
;  PUSH AX,DX             ;Save used registers
;  CALL WaitECInEmpty     ;Wait for the Input Buffer to Clear (rtns AH)
;  JC  >P70               ;If it never does, error
;  TEST AH,ECStsOutFull   ;Output Buffer have anything in it?
;  JZ  >P10               ;If not, continue
;  MOV  DX,[ECAdrDtaPort] ;DX = I/O Port to use
;  IN   AL,DX             ;Get the Data (we don't care what it is)
;  CALL WaitECOutEmpty    ;Wait for the Controller to acknowledge (rtns AH)
;  JC  >P70               ;If it never does, error
;P10:                     ;Test Burst Mode
;  MOV  DX,[ECCmdStsPort] ;DX = I/O Port to use
;  TEST AH,ECStsBurst     ;In Burst Mode?
;  JNZ >P20               ;If so, no need to Enable Burst Mode
;  MOV  AL,ECCmdBurstOn   ;Tell the Controller
;  OUT  DX,AL             ;  to Enable Burst Mode
;  CALL WaitECInEmpty     ;Wait for the Controller to accept our Cmd (rtns AH)
;  JC  >P70               ;If it never does, error
;  CALL WaitECBurstOn     ;Wait for Burst Mode to be Enabled (rtns AH)
;  JC  >P70               ;If it never does, error
;P20:                     ;Test SCI Event
;  TEST AH,ECStsSCIEvent  ;SCI Event notification?
;  JZ  >P80               ;If not, we're done
;  MOV  AL,ECCmdQuery     ;If so,
;  OUT  DX,AL             ;  issue the Query Command
;  CALL WaitECInEmpty     ;Wait for the Controller to accept our Cmd (rtns AH)
;  JC  >P70               ;If it never does, error
;  MOV  DX,[ECAdrDtaPort] ;DX = I/O Port to use
;  CALL WaitECOutFull     ;Wait for our Data to appear (rtns AH)
;  JC  >P70               ;If it never does, error
;  IN   AL,DX             ;Get the Data (we don't care what it is)
;  CALL WaitECOutEmpty    ;Wait for the Controller to acknowledge (rtns AH)
;  JNC >P80               ;If it does, we're done
;P70:                     ;Error
;  STC                    ;Set return flag
;  JMP >P90               ;Done
;P80:                     ;OK
;  CLC                    ;Set return flag
;P90:                     ;Done
;  POP  DX,AX             ;Restore used registers
;  RET

;------------------------------------------------------------------------------
;WAIT FOR THE EMBEDDED CONTROLLER TO BE IN A SPECIFIC STATE
;Inputs:  DS = Local Data Segment
;         [ECCmdStsByte]
;Outputs: AH = Current Status
;         CF = Clear if OK (Controller has correct Status)
;            = Set if Error
;Changes:
;------------------------------------------------------------------------------
;WaitECInFull:
;  PUSH BX                 ;Save used registers
;  MOV  BX,ECStsInFull     ;BH = XOR Value, BL = TEST Value
;  JMP >W00                ;Continue
WaitECInEmpty:
  PUSH BX                 ;Save used registers
  MOV  BX,(ECStsInFull << 8)+ECStsInFull ;BH = XOR Value, BL = TEST Value
  JMP  WaitECOutEmpty.W00 ;Continue
WaitECOutFull:
  PUSH BX                 ;Save used registers
  MOV  BX,ECStsOutFull    ;BH = XOR Value, BL = TEST Value
  JMP  WaitECOutEmpty.W00 ;Continue
WaitECOutEmpty:
  PUSH BX                 ;Save used registers
  MOV  BX,(ECStsOutFull << 8)+ECStsOutFull ;BH = XOR Value, BL = TEST Value
;  JMP >W00                ;Continue
;WaitECBurstOn:
;  PUSH BX                 ;Save used registers
;  MOV  BX,ECStsBurst      ;BH = XOR Value, BL = TEST Value
;  JMP >W00                ;Continue
.W00:
  PUSH CX,DX,DI          ;Save used registers
  MOV  DX,[ECCmdStsPort] ;DX = I/O Port to use
  MOV  DI,AX             ;Save original AX
  MOV  CX,5000           ;Don't wait forever!
;  MOV  CX,-1             ;Don't wait forever!
.W10:                    ;Loop to here to wait for correct status
  IN   AL,DX             ;Get the Current Status
  MOV  AH,AL             ;AH = Current Status
  XOR  AL,BH             ;Toggle the bit, if appropriate
  TEST AL,BL             ;Correct status bit set?
  JNZ .W80               ;If so, we're done
  CALL Delay1US          ;If not, wait for one microsecond
  LOOP .W10              ;Try again
.W70:                    ;Error
  STC                    ;Set return flag
  JMP .W90               ;Done
.W80:                    ;OK
  CLC                    ;Set return flag
.W90:                    ;Done
  MOV  BX,DI             ;BX = Original AX
  POP  DI,DX,CX          ;Restore used registers
  MOV  AL,BL             ;Restore original AL
  POP  BX                ;Restore used registers
  RET

;------------------------------------------------------------------------------
;DELAY FOR APPROXIMATELY ONE MICROSECOND
;Inputs:
;Outputs:
;Changes:
;------------------------------------------------------------------------------
Delay1US:
  PUSHF          ;Save flags
  PUSH AX        ;Save used registers
  MOV  AX,1      ;Delay for
  CALL DelayUSAX ;  one microsecond
  POP  AX        ;Restore used registers
  POPF           ;Save flags
  RET


;
;CODE TO DETERMINE THE AMOUTN OF SYSTEM MEMORY
;

;------------------------------------------------------------------------------
;DETERMINE THE AMOUNT OF MEMORY INSTALLED ON THE SYSTEM
;Inputs:  CS = DS = ES = Local Data Area
;Outputs: CF = Clear if OK
;              [MemSize] contains System Memory Installed (Bytes)
;            = Set if Error
;              [MemSize] Undefined
;Changes: Various Table Values (E820Tbl, etc.)
;NOTES: This tests for memory in various ways.  Newer systems generally
;         support INT 15.E820, which supports 64-bit memory sizes
;         (more than the 4GB supported by 32-bit processors).  If that
;         doesn't work, the system is probably pretty old and we need to
;         use other methods that are limited to smaller sizes.
;------------------------------------------------------------------------------
GetMemSize:
  PUSH EAX,BX         ;Save used registers
  MOV  BX,MemSize     ;DS:[BX] = Memory Size Storage Area
  XOR  EAX,EAX        ;Need to store zeroes
;  MOV  [BX+0],EAX     ;Initialize
;  MOV  [BX+4],EAX     ;  to zeroes
;  CALL GetMemSizeE820 ;Get the Memory size using INT 15.E820
;  JNC .Z90            ;If it worked, we're done
  MOV  [BX+0],EAX     ;Initialize
  MOV  [BX+4],EAX     ;  to zeroes
  CALL GetMemSizeC7   ;Get the Memory size using INT 15.C7
  JNC .Z90            ;If it worked, we're done
  MOV  [BX+0],EAX     ;Initialize
  MOV  [BX+4],EAX     ;  to zeroes
  CALL GetMemSizeE801 ;Get the Memory size using INT 15.E801
  JNC .Z90            ;If it worked, we're done
  MOV  [BX+0],EAX     ;Initialize
  MOV  [BX+4],EAX     ;  to zeroes
  CALL GetMemSize88   ;Get the Memory size using INT 15.88
.Z90:                 ;Done
  POP  BX,EAX         ;Restore used registers
  RET

;------------------------------------------------------------------------------
;DETERMINE THE AMOUNT OF MEMORY INSTALLED ON THE SYSTEM USING INT 15.E820
;Inputs:  CS = DS = ES = Local Data Area
;         [MemSize] Initialized to 0
;Outputs: CF = Clear if OK
;              [MemSize] contains System Memory Installed (Bytes)
;            = Set if Error
;              [MemSize] Undefined
;Changes: [E820Tbl]
;NOTES: INT 15.E820 has been installed in all BIOS's since abut 2002, and
;         many BIOS's even before that.  It is the only BIOS function that
;         can test for memory above 4GB (the limt for 32-bit processors
;         that don't use Physical Address Extensions (PAE).
;       According to Ralf Brown's Interrupt List (RBIL), if this call
;         doesn't work we should use other INT 15h functions.
;       We're don't actually need to memory map -- we're just looking for
;         the entry with the highest ending memory address.  Therefore,
;         we don't actually need a whole table of entries.  We just need
;         one table entry, along with a place to store the highest value
;         we've read so far.  New data will just overwrite the odl data.
;       According to documents, the various returned values are not
;         necessarily sequential, and some of the regions may actually
;         overlap with each other.  If we were actually trying to use
;         the data for something (like HIMEM or EMM386 or JEMM needs to do)
;         we would need to stroe the data and do the sorting/filtering/
;         combining to sort through all of the details.  The entry we're
;         looking for will most likely be the last one, but it doesn't
;         necessarily need to be.
;------------------------------------------------------------------------------
GetMemSizeE820:
  PUSH EAX,EBX,EDX,DI   ;Save used registers
  XOR  EBX,EBX          ;Initialze EBX to 0
  MOV  DI,E820Tbl       ;ES:DI = Table to store things in
  CALL GetMemSizeE820_2 ;Get the Data
  JC  .Z70              ;If error, we're done
  OR   EBX,EBX          ;EBX = 0 (list is worthless)?
  JZ  .Z70              ;If so, error
  JMP .Z30              ;If OK, handle it
.Z10:                   ;Loop to here to find all entries
  CALL GetMemSizeE820_2 ;Get the next table entry
;  JNC .Z30              ;If OK, continue
;  OR   BX,BX            ;End-of-list?
;  JZ  .Z80              ;If so, we're done
.Z30:                   ;Got some valid data

;  mov  EAX,[ES:DI+E820BaseAddr+4]
;  call WriteDWordHex
;  call WriteUnderscore
;  mov  EAX,[ES:DI+E820BaseAddr+0]
;  call WriteDWordHex
;  call WriteHexEnd
;  call Write2Spaces
;  mov  EAX,[ES:DI+E820Length+4]
;  call WriteDWordHex
;  call WriteUnderscore
;  mov  EAX,[ES:DI+E820Length+0]
;  call WriteDWordHex
;  call WriteHexEnd
;  call Write2Spaces
;  mov  EAX,[ES:DI+E820Type]
;  call WriteDWordHex


;  MOV  EAX,[ES:DI+E820Length+0] ;
;  ADD  [MemSize+0],EAX          ;
;  MOV  EAX,[ES:DI+E820Length+4] ;
;  ADC  [MemSize+4],EAX          ;

  MOV  EAX,[ES:DI+E820BaseAddr+0] ;EDX:EAX =
  MOV  EDX,[ES:DI+E820BaseAddr+4] ;  Base Address
  ADD  EAX,[ES:DI+E820Length+0]   ;Add in
  ADC  EDX,[ES:DI+E820Length+4]   ;  the Length


;  call Write2Spaces
;  push EAX
;  mov  EAX,EDX
;  call WriteDWordHex
;  call WriteUnderscore
;  pop  EAX
;  call WriteDWordHex
;  call WriteHexEnd
;  call WriteCrLfPause


  CMP  EDX,[MemSize+4]  ;New Size more than the previous size?
  JA  .Z35              ;If so, we need to replace the old size
  CMP  EAX,[MemSize+0]  ;More than the previous Size?
  JBE .Z40              ;If not, leave the old size alone
.Z35:                   ;New size is more than old size
  MOV  [MemSize+4],EDX  ;Store the
  MOV  [MemSize+0],EAX  ;  New Size
.Z40:                   ;Done storing size, if appropriate
  OR   EBX,EBX          ;Was this the last Entry?
  JNZ .Z10              ;If not, keep getting data
  JMP .Z80              ;Done
.Z70:                   ;Error
  STC                   ;Set return flag
  JMP .Z90              ;Done
.Z80:                   ;OK

;  call WriteCrLfPause
;  mov  EAX,[MemSize+4]
;  call WriteDWordHex
;  call WriteUnderscore
;  mov  EAX,[MemSize+0]
;  call WriteDWordHex
;  call WriteHexEnd

  CLC                   ;Set return flag
.Z90:                   ;Done
  POP  DI,EDX,EBX,EAX   ;Restore used registers
  RET

;------------------------------------------------------------------------------
;Inputs:  ES:DI = Storage Area (E820Tbl)
;         EBX = Index to Use
;Outputs: CF = Clear if it worked
;                E820Tbl contains the entry
;                EBX = Incremented by 1
;            = Set if it didn't work, or the entry is invalid for some
;                reason (tests everything except the value in EBX)
;Changes: [E820Tbl], EBX
;------------------------------------------------------------------------------
GetMemSizeE820_2:
  PUSH EAX,ECX,EDX       ;Save used registers
  MOV  EAX,0000_E820h    ; AX = Function Number
                         ;      Some BIOS's require the high word of EAX to
                         ;        be 0, even though it isn't required by
                         ;        the spec
  MOV  ECX,Int15E820Size ;ECX = Number of Bytes we want to receive
  MOV  EDX,E820DXSig     ;EDX = "SMAP"
  MOV  D [ES:DI+E820XAttr],E820XAValid ;Pre-mark as a Valid Entry
  STC                    ;Preset error flag
  INT  15h               ;Do it
  JC  .W70               ;If error, quit (CF set on first call if unsupported)
  CMP  EAX,E820DXSig     ;EAX = "SMAP" if call was successful
  JNE .W70               ;If not, error
  JCXZ .W70              ;If returned length = 0, error
  CMP  CL,Int15E820Size  ;Received extended bytes?
  JNE .W30               ;If not, no need to test Validity Flag
  TEST B [ES:DI+E820XAttr],E820XAValid ;Valid Entry?
  JZ  .W70               ;If not, error
.W30:                    ;Tested for Validity Flag, if appropriate
  MOV  EAX,[ES:DI+E820Length+0] ;Length
  OR   EAX,[ES:DI+E820Length+4] ;  >0?
  JNZ .W80               ;If so, it's OK
.W70:                    ;Error
  STC                    ;Set return flag
  JMP .W90               ;Done
.W80:                    ;OK
  CLC                    ;Set return flag
.W90:                    ;Done
  POP  EDX,ECX,EAX       ;Restore used registers
  RET

;------------------------------------------------------------------------------
;DETERMINE THE AMOUNT OF MEMORY INSTALLED ON THE SYSTEM USING INT 15.C7
;Inputs:  CS = DS = ES = Local Data Area
;         [MemSize] Initialized to 0
;Outputs: CF = Clear if OK
;              [MemSize] contains System Memory Installed (Bytes)
;            = Set if Error
;              [MemSize] Undefined
;Changes: [I15C7Tbl]
;NOTES: INT 15.C7 is supported by many older machines, but in my limited
;         testing doesn't seem to be supported on machines that support
;         INT 15.E820.  INT 15.E820 is the one we really want to use anyway,
;         and is the one we try first, so that would seem to be OK.
;       RBIL doesn't mention this call as a backup to INT 15.E820, but
;         one of the backups it mentions is INT 15.88 which mentions this
;         as sort of a backup (to get data beyond 16M).
;       We can use INT 15.C0 as a precursor to INT 15.C7 to see if it's
;         supported or not, since one of the flags returned by INT 15.C0
;         indicates whether or not this function is supported.  Unfortunately,
;         on some systems INT 15.C0 indicates this function is supported
;         even when it isn't, so there's really no point in testing with
;         INT 15.C0.  INT 15.C0 is definitely useful for some things, but
;         not this.  So, we'll just do the call and not worry about the
;         INT 15.C0 pre-test.
;------------------------------------------------------------------------------
GetMemSizeC7:
  PUSH EAX,EDX,SI,DI        ;Save used registers
  MOV  SI,I15C7Tbl          ;DS:[SI] = Data Storage Area
  MOV  AH,0C7h              ;Function C7h (Return Memory-Map Information)
  STC                       ;Preset Error Flag
  INT  15h                  ;Do it
  JC  .V70                  ;If error, quit
  MOV  DI,MemSize           ;[DI] = MemSize storage area
.V10:                       ;Add in 1M-16M value
  MOV  D [DI],(1024*1024)   ;Starting memory size = 1M
  MOV  EAX,[SI+I15C7Sys16M] ;EAX =
  MOV  EDX,1024             ;  Size of memory
  MUL  EDX                  ;  between 1M and 16M
  ADD  [DI+0],EAX           ;Add it to
  ADC  [DI+4],EDX           ;  our running total
.V20:                       ;Add in 16M-4G value
  MOV  EAX,[SI+I15C7Sys4G]  ;EAX =
  MOV  EDX,1024             ;  Size of memory
  MUL  EDX                  ;  between 16M and 4G
  ADD  [DI+0],EAX           ;Add it to
  ADC  [DI+4],EDX           ;  our running total
  JMP .V80                  ;Done
.V70:                       ;Error
  STC                       ;Set return flag
  JMP .V90                  ;Done
.V80:                       ;OK
  CLC                       ;Set return flag
.V90:                       ;Done
  POP  DI,SI,EDX,EAX        ;Restore used registers
  RET

;------------------------------------------------------------------------------
;DETERMINE THE AMOUNT OF MEMORY INSTALLED ON THE SYSTEM USING INT 15.E801
;Inputs:  CS = DS = ES = Local Data Area
;         [MemSize] Initialized to 0
;Outputs: CF = Clear if OK
;              [MemSize] contains System Memory Installed (Bytes)
;            = Set if Error
;              [MemSize] Undefined
;Changes: [E820Tbl]
;NOTES: INT 15.E801 in RBIL is called the Phoenix BIOS 4.0 method, but works
;         with many BIOS's.  It returns:
;           AX = Extended Memory between 1M and 16M in kB (Max = 15kB)
;           BX = Extended Memory above 16M in 64 kB blocks
;           CX = Configured Memory between 1M and 16M in kB (Max = 15k = 3C00h)
;           DX = Configured Memory above 16M in 64kB blocks
;       Some BIOS's always return AX = BX = 0 (so require used of CX & DX),
;           and others always return CX = DX = 0 (so require use of AX & BX)
;------------------------------------------------------------------------------
GetMemSizeE801:
  PUSH EAX,BX,CX,EDX      ;Save used registers
  MOV  AX,0E801h          ;Function E801h (Get Mem Size for >64MB installations)
  STC                     ;Preset Error Flag
  INT  15h                ;Do it
  JC  .E70                ;If error, quit
.E10:                     ;Got the Data
  OR   CX,CX              ;CX = 0?
  JNZ .E12                ;If not, continue
  OR   DX,DX              ;DX = 0?
  JNZ .E12                ;If not, continue
  MOV  CX,AX              ;If so, use AX & BX
  MOV  DX,BX              ;  instead of CX & DX
.E12:                     ;CX & DX OK
  OR   DX,DX              ;Less than 16M?
  JZ  .E40                ;If so, jump to handle it
.E20:                     ;> 16MB installed
  MOVZX EAX,DX            ;Multiply
  MOV  EDX,65536          ;  returned size
  MUL  EDX                ;  by 64kB
  ADD  EAX,(16*1024*1024) ;Add 16MB
  ADC  EDX,0              ;  to the Total
  MOV  [MemSize+0],EAX    ;Store
  MOV  [MemSize+4],EDX    ;  it
  JMP .E80                ;Done
.E40:                     ;Less than 16 MB installed (DX = 0)
  MOVZX EAX,CX            ;Multiply
  MOV  EDX,1024           ;  returned size
  MUL  EDX                ;  by 1kB
  ADD  EAX,(1024*1024)    ;Add 1MB to the total
  MOV  [MemSize+0],EAX    ;Store it
  JMP .E80                ;Done
.E70:                     ;Error
  STC                     ;Set return flag
  JMP .E90                ;Done
.E80:                     ;OK
  CLC                     ;Set return flag
.E90:                     ;Done
  POP  EDX,CX,BX,EAX      ;Restore used registers
  RET

;------------------------------------------------------------------------------
;DETERMINE THE AMOUNT OF MEMORY INSTALLED ON THE SYSTEM USING INT 15.88
;Inputs:  CS = DS = ES = Local Data Area
;         [MemSize] Initialized to 0
;Outputs: CF = Clear if OK
;              [MemSize] contains System Memory Installed (Bytes)
;            = Set if Error
;              [MemSize] Undefined
;Changes:
;NOTES: INT 15.88 in RBIL is called the Get Extended Memory Size (286+).
;       The value returned in AX by this call is the amount of memory
;         in kB that is above 1MB.
;       Memory Managers sometimes trap this call and return a "fake"
;         amount of memory (smaller than what it really is) and then use
;         the rest of the memory for internal purposes.  As a result, the
;         returned by this function may not necessariy be accurate, at least
;         least if there is a memory manager installed.
;       Some BIOS's do not return CF clear like they're supposed to, so
;         we can't depend solely on CF for the test to see if it worked
;         or not.  So, we'll also need to check the value in AX.
;------------------------------------------------------------------------------
GetMemSize88:
  PUSH EAX,CX,EDX      ;Save used registers
  XOR  EAX,EAX         ;Initialize high word of EAX to 0
  MOV  CX,8800h        ;Function 88h
  MOV  AX,CX           ;  (Get Extended Memory Size)
                       ;  AL = 0 for a Test Value
  STC                  ;Preset Error Flag
  INT  15h             ;Do it
  JC  .Y30             ;If error, jump to handle it
.Y10:                  ;Carry clear
  OR   AX,AX           ;Returned 0?
  JNZ .Y12             ;If not, continue
  MOV  EAX,0001_0000h  ;If so, max it out
  JMP .Y50             ;Continue
.Y12:                  ;AX not 0
  CMP  AX,CX           ;Did AX change?
  JNE .Y50             ;If so, assume it's OK
  MOV  CX,88FFh        ;Function 88h
  MOV  AX,CX           ;  (Get Extended Memory Size)
                       ;  AL = -1 for a Test Value
  STC                  ;Preset Error Flag
  INT  15h             ;Do it
  JC  .Y30             ;If error, jump to handle it
.Y15:                  ;Carry clear
  CMP  AX,CX           ;Did AX change?
  JNE .Y50             ;If so, assume it's OK
  JMP .Y70             ;If not, error
.Y30:                  ;Returned with CF set
  CMP  AX,CX           ;Did AX change?
  JE  .Y70             ;If not, error
  CMP  AH,80h          ;Error?
  JE  .Y70             ;If so, quit
  CMP  AH,86h          ;Error?
  JE  .Y70             ;If so, quit
.Y50:                  ;AX = Correct Value
  MOV  EDX,1024        ;Multiply by
  MUL  EDX             ;  1k
  ADD  EAX,(1024*1024) ;Add in
  ADC  EDX,0           ;  1M
  MOV  [MemSize+0],EAX ;Store
  MOV  [MemSize+4],EDX ;  it
  JMP .Y80             ;Done
.Y70:                  ;Error
  STC                  ;Set return flag
  JMP .Y90             ;Done
.Y80:                  ;OK
  CLC                  ;Set return flag
.Y90:                  ;Done
  POP  EDX,CX,EAX      ;Restore used registers
  RET


;
;CODE TO SEARCH THROUGH STRING-RELATED TABLES
;

;------------------------------------------------------------------------------
;WRITE A VALUE FROM A BYTE-TO-STRING LOOKUP TABLE
;Inputs:  DS:[BX] = Table to search
;         AL      = Byte to search for
;         CLD already issued
;Outputs: String from Table is written, floowed by a new line
;         If string is not found, "Unknown" is written
;Changes:
;------------------------------------------------------------------------------
WriteByte2String:
  PUSH BX,DX                ;Save used registers
  MOV  DX,UnknownMsg        ;Assume we won't find a match
  CALL SearchByte2StringTbl ;Search for a match
  JC  .W20                  ;If none, write Unknown
  MOV  DX,BX                ;If found, point [DX] at the String
.W20:                       ;[DX] = String to Write
;  CALL WriteItDX            ;Write the String
  CALL WriteZPause          ;Write the String
;  CALL WriteCrLfPause       ;Move down
  CALL WriteCrLfPause       ;Move down
  POP  DX,BX                ;Restore used registers
  RET

;------------------------------------------------------------------------------
;SEARCH A BYTE-TO-STRING LOOKUP TABLE FOR A MATCHING ENTRY
;Inputs:  DS:[BX] = Table to search
;         AL      = Byte to search for
;         CLD already issued
;Outputs: CF = Clear if a byte match as found in table
;              BX = Pointer to the String
;            = Set if no match found in table
;              BX = unchanged
;Changes:
;NOTES: Last Entry in Table (end-of-table marker) = DW -1
;------------------------------------------------------------------------------
SearchByte2StringTbl:
  PUSH AX,SI            ;Save used registers
  CLD                   ;Go forward with string functions
  MOV  SI,BX            ;Put pointer in SI
  MOV  AH,AL            ;Put byte to check in AH
.S10:                   ;Loop to here for each table entry
  LODSB                 ;Get the next table entry
  CMP  AL,-1            ;Is it possibly the end of the table?
  JNE .S20              ;If not, continue
  CMP  B [SI],-1        ;Is it actually the end of the table?
  JE  .S70              ;If so, there's no match
.S20:                   ;Not end of table
  CMP  AL,AH            ;Is it a match?
  JE  .S80              ;If so, handle it!
  CALL SkipOverStringSI ;If not, skip over the string
  JMP .S10              ;And keep looking
.S70:                   ;No entry found
  STC                   ;Set the not found flag
  JMP .S90              ;Quit
.S80:                   ;Entry found [SI]
  MOV  BX,SI            ;Point BX at the String
  CLC                   ;Set the found flag
.S90:                   ;Done
  POP  SI,AX            ;Restore used registers
  RET

;------------------------------------------------------------------------------
;SKIP TO THE END OF AN ASCIIZ STRING
;Inputs:  DS:[SI] = ASCIIZ String to Skip Over
;Outputs: [SI]    = Next Byte After String
;Changes:
;------------------------------------------------------------------------------
SkipOverStringSI:
  PUSH CX,DX         ;Save used registers
  MOV  DX,SI         ;Calculate the size
  CALL CalcStrSizeDX ;  of the string (CX, does not include the Zero)
  INC  CX            ;Compensate for the Zero
  ADD  SI,CX         ;Add it to the Pointer
  POP  DX,CX         ;Restore used registers
  RET

;------------------------------------------------------------------------------
;CALCULATE THE LENGTH OF AN ASCIIZ STRING
;Inputs:  DS:[SI] = ASCIIZ String to wrok with
;Outputs: CX = Length of String
;         ZF = Set if string is 0 length
;            = Clear if not
;Changes:
;------------------------------------------------------------------------------
CalcStrSizeSI:
  PUSH DX            ;Save used registers
  MOV  DX,SI         ;Calculate the
  CALL CalcStrSizeDX ;  length of the string
  POP  DX            ;Restore used registers
  RET

;------------------------------------------------------------------------------
;WRITE AN ASCIIZ STRING, POINTED AT BY SI, TO PAUSE
;Inputs:  DS:[SI] = ASCIIZ String to Write
;Outputs: To Screen (CON)
;Changes:
;------------------------------------------------------------------------------
WriteZPauseSI:
  PUSH DX          ;Save used registers
  MOV  DX,SI       ;Write the
  CALL WriteZPause ;  string
  POP  DX          ;Restore used registers
  RET


;
;CODE TO WRITE OUR OUTPUT, EITHER TO PAUSE OR TO THE USER-PROVIDED ADDRESS
;

;------------------------------------------------------------------------------
;WRITE OUR OUTPUT TO PAUSE, OR TO THE PROVIDED CALL-BACK ADDRESS

;         [CallBackAddr] (-1 in Offset if invalid)
;Outputs: Either to Pause, or to the Call-Back address
;Changes:
;------------------------------------------------------------------------------
;WriteItDX:
;  CMP  W [CallBackAddr][0],-1 ;Is there a valid call-back address?
;  JE  .W50                    ;If not, write to Pause
;;  CMP  [ParentIsShell],Yes    ;Double-check whether we are at a command-line
;;                              ;  (we shouldn't need to do this, but will anyway)
;;  JE  >W50                    ;If so, write to Pause
;  PUSH AX,BX,CX,DX,DI,SI      ;Save
;  PUSH BP,DS,ES               ;  all registers
;  CALL D [CallBackAddr]       ;If not, call the provided code address
;  POP  ES,DS,BP               ;Restore
;  POP  SI,DI,DX,CX,BX,AX      ;  all registers
;  JMP .W90                    ;Done
;.W50:                         ;Write to Pause
;  CALL WriteZPause            ;Write to Pause
;.W90:                         ;Done
;  RET


;
;CODE NEEDED TO SET UP AND DO SCREEN PAUSES
;

;------------------------------------------------------------------------------
;SETUP PARAMETERS FOR DOING A SCREEN PAUSE (FOR PRINTING A LARGE TABLE)
;Inputs:  DS = Local Data Segment
;         DS:[DX] = ASCIIZ Header to Print at top of each screen
;                   Last character of the Header MUST be an LF
;                   If SetupPauseNoHdr, we "inject" NoMsg as the Header
;Outputs: Pauses the screen with a MORE message every time it gets full
;NOTES:   If a Screen Header is really large (almost taking up the whole
;           screen itself, with little room for data), this procedure
;           may not work correctly.  This procedure does not validate
;           the size of the Header -- it simply assumes that it is a
;           "reasonable" size compared to the size of the screen.  Most
;           anything that needs a Screen Header (a long data table) will
;           only have a few lines of Header, so this should be OK as a
;           general purpose procedure.
;         After this Setup is complete (which should be near the beginning
;           of MAIN, before anything is sent to the screen), WriteZPause
;           must be called for ALL screen writing to CON:, not WriteZCon!
;         The Pausing occurs in "real time", meaning we can send things
;           to the Pause routine a byte, line, or several screens at a
;           time for processing.  Because we do it in "real time",
;           we can end up with extra MORE's and screen Headers appearing
;           on screen than are actually needed.  During a screen
;           transition (or a transition to a new Header) whether we
;           actually need to write anything or not depends on if there
;           is actually any real data coming afterward (in time), which
;           of course we don't know (since it hasn't happened yet).
;           So, we must assume there is more data to come and process the
;           MORE's and Screen Headers accordingly.  This only causes problems
;           (in the form of extraneous MORE's and Screen Headers)
;           when things happen near the bottom of the screen.
;           DOS's MORE utiltiy (and other programs of similar ilk) do not
;           process in "real time", but rather store things in a Temporary
;           File and then process the file.
;------------------------------------------------------------------------------
SetupPauseNoHdr:
  PUSH DX         ;Save used registers
  MOV  DX,NoMsg   ;Point at 0-length Message
  CALL SetupPause ;Setup the Pause
  POP  DX         ;Restore used registers
  RET

SetupPause:
  PUSH AX,BX,CX,DI,SI       ;Save used registers
  MOV  SI,PauseHdrPtr       ;[SI] = [PauseHdrPtr]
  CMP  W [SI],-1            ;Has the user already cancelled us?
  JE  .S90                  ;If so, just quit
  CMP  W [SI],0             ;Has the user stopped pausing already?
  JE  .S85                  ;If so, just write the header
  CALL TestRedir            ;Is our output redirected?
  JNC .S10                  ;If not, setup our Headers
  MOV  W [SI],0             ;Mark as Redirected or Pausing Stopped/Disabled
  JMP .S85                  ;Jump to write the Header and Quit
.S10:                       ;Output not redirected
  CALL GetScreenRows        ;Store the number of rows
  MOV  [PauseRows],AX       ;  on the screen
  CALL CountZLinesCX        ;Calculate the number of lines
  INC  CX,2                 ;  in the new Header
  MOV  DI,[PauseRowCount]   ;Get the Current Row count
  ADD  DI,CX                ;Add the size of the new header
  SUB  DI,3                 ;Adjust for Headers
  DEC  AX                   ;Will writing the new Header
  CMP  DI,AX                ;  cause a Pause event?
  JB  .S50                  ;If not, handle it
.S20:                       ;New Header is too big to fit on screen
  MOV  W [SI],NoMsg         ;Point Header for second page at nothing
  MOV  W [PauseHdrSize],2   ;Set Pause Header Size
  PUSH CX                   ;Save New Header Size
  SUB  AX,[PauseRowCount]   ;Calculate how many rows to fill up the screen
  MOV  CX,AX                ;Put number of rows in CX
  INC  CX                   ;Adjust it
.S30:                       ;Loop to here to fill up the screen
  CALL WriteCrLfPause       ;Write a new line
  LOOP .S30                 ;Keep going until we're done
  POP  CX                   ;Restore New Header Size
  CMP  W [SI],-1            ;Did the user cancel during the header transition?
  JE  .S90                  ;If so, we're done
  CMP  W [SI],0             ;Did the user stop Pausing during the transition?
  JE  .S85                  ;If so, just write the Header
.S50:                       ;Need to adjust current Row Count
  SUB  W [PauseRowCount],2  ;Adjust things for the previous Header
.S80:                       ;Store new Header Info
  MOV  [SI],DX              ;Store the Header Address
  MOV  [PauseHdrSize],CX    ;Store the Header Size
  ADD  [PauseRowCount],CX   ;Add the Header Size to the Row Count
  MOV  AX,[PauseRows]       ;Compensate if
  CMP  AX,[PauseRowCount]   ;  the new header
  JAE .S85                  ;  put us past
  DEC  AX                   ;  the end
  MOV  [PauseRowCount],AX   ;  of hte screen
.S85:                       ;Write Header
  CALL WriteZCon            ;Write the Header
.S90:                       ;We're done
  POP  SI,DI,CX,BX,AX       ;Restore used registers
  RET

;------------------------------------------------------------------------------
;CHECK TO SEE IF STDOUT HAS BEEN REDIRECTED
;Inputs:
;Outputs: CF = Clear if STDOUT is normal (usually the screen)
;            = Set if STDOUT been redirected
;Changes:
;------------------------------------------------------------------------------
TestRedir:
  PUSH AX,BX,DX        ;Save used registers
  MOV  AX,4400h        ;Function 4400h (Get Device Info)
  MOV  BX,StdOutHandle ;Device = STDOUT
  INT  21h             ;Do it (returns DX, changes AX)
  JC  .R80             ;If error, assume not Redirected
  AND  DL,(DvcInfoIsDevice+DvcInfoIsStdOut) ;Mask out unwanted bits
  CMP  DL,(DvcInfoIsDevice+DvcInfoIsStdOut) ;Is it still the STDOUT Device?
  JE  .R80             ;If so, it's not Redirected
.R70:                  ;STDOUT has been Redirected
  STC                  ;Set the Redirected flag
  JMP .R90             ;Done
.R80:                  ;STDOUT is not Redirected
  CLC                  ;Set the Not-Redirected flag
.R90:                  ;Done
  POP  DX,BX,AX        ;Restore used registers
  RET

;------------------------------------------------------------------------------
;GET THE NUMBER OF VIDEO ROWS ON THE SCREEN
;Inputs:
;Outputs: AX = Number of text rows on the screen
;                (usually 25, 43, or 50)
;Changes:
;------------------------------------------------------------------------------
GetScreenRows:
  PUSH BX,CX,DS  ;Save used registers
  MOV  AX,40h    ;Point ES to
  MOV  DS,AX     ;  BIOS data area
  MOV  AH,12h    ;Function 12h (EGA Alternate Select)
  MOV  BX,0FF10h ;Subfunction (BL) 10h (Return EGA information)
                 ;  Preset unrealistic return value (BH)
  INT  10h       ;Do it (returns AX, BX, CX)
  CMP  BL,10h    ;Is the function supported (EGA or better)?
  JE  .R50       ;If not, jump to handle MDA/CGA
  CMP  BH,0FFh   ;Is the return value valid?
  JE  .R50       ;If not, jump to handle MDA/CGA
  TEST B [87h],8 ;If so, is bit 3 of the EGA information byte set?
  JNZ .R50       ;If so, EGA is not the active display
  XOR  AX,AX     ;Get # of
  MOV  AL,[84h]  ;  rows - 1
  JMP .R90       ;We're done
.R50:            ;Video card is less than EGA (MDA or CGA)
  MOV  AX,24     ;Number of rows must be 25
.R90:            ;We're done
  INC  AX        ;Bump the number of rows by 1
  POP  DS,CX,BX  ;Restore used registers
  RET

;------------------------------------------------------------------------------
;WRITE ASCIIZ STRING(s) TO THE SCREEN, PAUSING WHEN IF NECESSARY
;Inputs:  DS:[DX] = String to write
;         [PauseRows], [PauseHdrPtr], [PauseHdrSize], [PauseRowCount]
;         CS = Local Data Segment
;Outputs: [PauseRowCount]
;Changes: Pauses the screen and waits for user input, if necessary
;NOTES: This should be called instead of WriteZCon every time something
;         is written during the Pausing.
;       A string can be written by WriteZCon during the pausing, as long
;         as the string does not contain a Line Feed.  Any line containing
;         a Line Feed must come through here or the Line Count will get
;         screwed up!
;------------------------------------------------------------------------------
WriteZPause:
  PUSH AX,BX,CX,DX            ;Save used registers
  MOV  AX,[CS:PauseHdrPtr]    ;AX = Header Pointer
  CMP  AX,-1                  ;Has the Output been cancelled by the user?
  JE  .P90                    ;If so, don't write anything at all
  OR   AX,AX                  ;Is STDOUT Redirected?
  JZ  .P80                    ;If so, just write it with no Pausing
  CALL CountZLinesCX          ;Count how many Lines are in the string
  MOV  AX,[CS:PauseRowCount]  ;Add the new lines
  ADD  AX,CX                  ;  to the current lines
  CMP  AX,[CS:PauseRows]      ;Will we be at or past the end of the screen?
  JB  .P70                    ;If not, just write it
  JE  .P20                    ;If at the end of the screen, handle it
  SUB  AX,[CS:PauseRows]      ;If not, find
  SUB  CX,AX                  ;  the end of the String
  CALL FindEndOfLines         ;  we need to write ([BX])
  MOV  AL,[BX]                ;Save the character that's there now
  MOV  B [BX],0               ;Replace it with a 0
  CALL WriteZPause            ;Write it (will Pause correctly)
  MOV  [BX],AL                ;Restore original character
  MOV  DX,BX                  ;Use the new string pointer
  CALL WriteZPause            ;Write it (Pausing if necessary)
  JMP .P90                    ;Done
.P20:                         ;At end of screen
  CALL WriteZCon              ;Write the String
  CALL HandlePause            ;Handle the Pause (may change Pointers/Counters)
  JMP .P90                    ;We're done for now
.P70:                         ;Store new Row Count
  MOV  [CS:PauseRowCount],AX  ;Save the new Row Count
.P80:                         ;Write the String
  CALL WriteZCon              ;Write the string
.P90:                         ;Done
  POP  DX,CX,BX,AX            ;Restore used registers
  RET

;------------------------------------------------------------------------------
;WRITE THE PAUSE LINE, AND WAIT FOR A KEYSTROKE
;Inputs:  CS = Local Data Segment
;         [PauseRows], [PauseHdrPtr], [PauseHdrSize], [PauseRowCount]
;Outputs: [PauseRowCount], [PauseHdrPtr]
;Changes: Pauses the screen and waits for user input, if necessary
;------------------------------------------------------------------------------
HandlePause:
  PUSH AX,BX,DX,DS          ;Save String Segment
  MOV  DS,CS                ;Point DS at our Data Segment
  MOV  BX,PauseHdrPtr       ;[BX] = Pause Header
  MOV  DX,PauseMsg          ;Write the
  CALL WriteZCon            ;  Enter a Keystroke message
  CALL FlushKbdBuff         ;Clear the keyboard buffer
.L10:                       ;Loop to here to wait for a keystroke
  CALL GetKey               ;Is there a key in the keystroke buffer?


  JZ  .L10                  ;If not, keep waiting until there is
  MOV  DX,PauseDMsg         ;Delete the
  CALL WriteZCon            ;  MORE Message
  CMP  AL,CtrlC             ;Was the keystroke a Control-C?
  JE  .L40                  ;If so, jump to handle it
  CMP  AL,Escape            ;Was the keystroke an Escape?
  JNE .L20                  ;If not, just keep going
  MOV  W [BX],0             ;If so, mark us as redirected (stop Pausing)
  JMP .L90                  ;And quit
.L20:                       ;Continue with the Pause
  MOV  DX,PauseNMsg         ;Write the
  CALL WriteZCon            ;  MORE Replacement Line
  MOV  DX,[BX]              ;Point DX at the Header
  CALL WriteZCon            ;Write it
  MOV  AX,[PauseHdrSize]    ;Reset the Row Count
  MOV  [PauseRowCount],AX   ;Store the new Row Count
  JMP .L90                  ;We're done for now
.L40:                       ;Ctrl-C (stop altogether)
  MOV  W [BX],-1            ;Mark as stopped
.L90:                       ;Done
  POP  DS,DX,BX,AX          ;Restore used registers
  RET

;------------------------------------------------------------------------------
;CALCULATE THE NUMBER OF LINES IN AN ASCIIZ STRING (COUNT CR/LF COMBINATIONS)
;Inputs:  DS:[DX] = Pointer to String to measure
;         CLD already issued
;Outputs: CX = Number of LF's in the String (may be 0)
;         ZF = Set if CX = 0
;            = Clear if CX > 0
;Changes:
;------------------------------------------------------------------------------
CountZLinesCX:
  PUSH AX,SI ;Save used registers
  MOV  SI,DX ;Put the pointer in DI
  XOR  CX,CX ;Initialize Lines Counter
.Z10:        ;Loop to here for each character
  LODSB      ;Get the next character
  OR   AL,AL ;Is it the end of the string?
  JZ  .Z90   ;If so, we're done
  CMP  AL,LF ;Is it a Line Feed?
  JNE .Z10   ;If not, it's not a new line
  INC  CX    ;If so, Increment the Line Counter
  JMP .Z10   ;Keep looking
.Z90:        ;We're done
  OR   CX,CX ;Set return flag
  POP  SI,AX ;Restore used registers
  RET

;------------------------------------------------------------------------------
;FIND THE POINTER AFTER THE FIRST SEVERAL LINES OF A STRING
;Inputs:  DS:[DX] = String to use
;         CX = Number of lines to "skip"
;         CLD already issued
;Outputs: DS:[BX] = "New" String Pointer (after the last line written)
;Changes:
;NOTES: This assumes that the string actually has MORE than the number of
;         lines in AX (it does not look for the end of an ASCIIZ string).
;------------------------------------------------------------------------------
FindEndOfLines:
  PUSH AX,CX  ;Save used registers
  PUSH DI,ES  ;Save used registers
  MOV  BX,CX  ;BX = Line Counter
  MOV  ES,DS  ;Point ES:[DI] at
  MOV  DI,DX  ;  the string
  MOV  AL,LF  ;Look for Line Feeds
  MOV  CX,-1  ;Maximize counter
.L10:         ;Loop to here for each new line
  REPNE SCASB ;Look for the end-of-line character
  DEC  BX     ;Decrement the Line Counter
  JNZ .L10    ;If not 0 yet, keep looking
  MOV  BX,DI  ;Store the new string beginning
.L90:         ;Done
  POP  ES,DI  ;Restore used registers
  POP  CX,AX  ;Restore used registers
  RET

;------------------------------------------------------------------------------
;FLUSH KEYBOARD BUFFER
;Inputs:
;Outputs:
;Changes: Flushes the Keyboard Buffer
;------------------------------------------------------------------------------
FlushKbdBuff:
  PUSH AX     ;Save used registers
.F10:         ;Loop to here for each key
  CALL GetKey ;Get a key from the keyboard buffer
  JNZ .F10    ;If there was one, get another
  POP  AX     ;Restore used registers
  RET

;------------------------------------------------------------------------------
;READ KEYBOARD CHARACTER
;Inputs :
;Outputs: AH = Keyboard scan code
;         AL = ASCII value of keypress (or 0 if extended ASCII)
;         AX = 0 if no key is waiting
;Changes: ZF = Set if no key in buffer (and AX = 0)
;            = Clear if a key was found (AX = key)
;------------------------------------------------------------------------------
GetKey:
  MOV  AH,1     ;Service 1 (Keystroke waiting?)
  INT  16h      ;Do It
  JNZ .K20      ;If so, jump to get the keystroke
  MOV  AL,2Fh   ;Is there an
  CALL TestInt  ;  INT 2Fh Handler?
  JZ  .K70      ;If not, we're done
  MOV  AX,1680h ;If so, Function 1680h (Multitasker Release Time Slice)
                ;  Also monitored by APM-type power managers
  INT  2Fh      ;Do it
  JMP .K70      ;Done
.K20:           ;A key is waiting
  XOR  AH,AH    ;If a key is waiting, service 0 (Get keystroke)
  INT  16h      ;Do It
  JMP .K90      ;We're done
.K70:           ;No Key Waiting
  XOR  AX,AX    ;Make sure AX = 0
.K90:           ;Done
  OR   AX,AX    ;Set the found/not found flag
  RET

;------------------------------------------------------------------------------
;WRITE A CR/LF TO THE CONSOLE WITH A PAUSE
;Inputs:
;Outputs: To Screen, Updates Pause Counters
;Changes:
;------------------------------------------------------------------------------
WriteCrLfPause:
  PUSH DX          ;Save used registers
  MOV  DX,CrLfMsg  ;Write a Cr/Lf to
  CALL WriteZPause ;  the Pause Device
  POP  DX          ;Restore used registers
  RET

WriteCrLfPause2:
  CALL WriteCrLfPause ;Move down
  CALL WriteCrLfPause ;  2 lines
  RET

WriteCrLfErr:
  PUSH DX         ;Save used registers
  MOV  DX,CrLfMsg ;Write a Cr/Lf to
  CALL WriteZErr  ;  the ERR Device
  POP  DX         ;Restore used registers
  RET


;
;CODE TO WRITE THINGS TO THE SCREEN
;

;------------------------------------------------------------------------------
;CONVERT BYTE, WORD, OR DWORD TO HEX CHARACTER STRING, AND WRITE IT
;Inputs:  AL/AX = Nibble/Byte/Word to be written
;         CLD must be set already!
;Outputs: Writes to the Screen
;Changes: HexString
;------------------------------------------------------------------------------
WriteNibbleHex:
  PUSH BX             ;Save used registers
  MOV  BX,8           ;Need to start of offset 8 in string
  JMP  WriteHex0      ;Jump to do it
WriteByteHex:
  PUSH BX             ;Save used registers
  MOV  BX,7           ;Need to start of offset 7 in string
  JMP  WriteHex0      ;Jump to do it
WriteWordHex:
  PUSH BX             ;Save used registers
  MOV  BX,5           ;Need to start of offset 5 in string
  JMP  WriteHex0      ;Jump to do it
WriteDWordHex:
  PUSH BX             ;Save used registers
  XOR  BX,BX          ;Need to start of offset 0 in string
;  JMP  WriteHex0      ;Jump to do it
WriteHex0:            ;Start converting the strings
  PUSH DX,DI          ;Save used registers
  MOV  DI,HexString   ;Point DS:[DI] at HexString
  MOV  DX,DI          ;Point DS:[DX] at HexString
  ROR  EAX,16         ;Convert the High Word
  CALL Word2HexString ;  to a String
  INC  DI             ;Skip over the Underscore
  ROR  EAX,16         ;Convert the Low Word
  CALL Word2HexString ;  to a String
  ADD  DX,BX          ;Point DX at the beginning of where we write
;  CALL WriteItDX      ;Write it
  CALL WriteZPause    ;Write it
  POP  DI,DX          ;Restore used registers
  POP  BX             ;Restore used registers
  RET

;------------------------------------------------------------------------------
;CONVERT A BYTE OR WORD TO A HEXADECIMAL STRING (2 OR 4 CHARACTERS)
;Inputs:  AX = Word to Convert to a Hex String
;         DS = Local Data Segment
;         DS;[DI] = Where to store the result
;         CLD already issued
;Outputs: DS:[DI]
;Changes: DI
;------------------------------------------------------------------------------
Word2HexString:
  PUSH AX,BX,ES         ;Save used registers
  MOV  BX,AX            ;Save original Word
  MOV  ES,DS            ;Point ES:[DI] at
  CALL Word2HexString00 ;Convert it
  POP  ES,BX,AX         ;Restore used registers
  RET

Word2HexString00:
  MOV  AL,BH            ;Convert High Byte
  CALL Word2HexString10 ;  to ASCII
  MOV  AL,BL            ;Work with Low Byte
Word2HexString10:       ;Convert Byte to ASCII
  AAM  10h              ;Separate Low & High Nibbles
  XCHG AH,AL            ;Put High Nibble in AL
  CALL Word2HexString20 ;Convert High Nibble to ASCII
  XCHG AH,AL            ;Work with Low Nibble
Word2HexString20:       ;Convert Nibble to ASCII
  ADD  AL,90h           ;Convert BCD
  DAA                   ;  to Decimal
  ADC  AL,40h           ;Convert Decimal
  DAA                   ;  to ASCII
  STOSB                 ;Store the Nibble
  RET

;Byte2HexString:
;  PUSH AX,ES            ;Save used registers
;  MOV  ES,DS            ;Point ES:[DI] at the String
;  CALL Word2HexString10 ;Convert it
;  POP  ES,AX            ;Restore used registers
;  RET

;------------------------------------------------------------------------------
;WRITE A BYTE/WORD/TRIBYTE/DWORD TO THE SCREEN AS A DECIMAL
;Inputs:  AL/AX/EAX = Byte/Word/DWord to Write
;Outputs:
;Changes:
;NOTES: If ByteToString, WordToString, or DWordToString, fills front
;         of string with spaces, and includes commas.
;       If WriteByteMin, WriteWordMin, or WriteDWordMin, does NOT
;         include spaces at front, and does NOT include comma separators.
;------------------------------------------------------------------------------
WriteByteMin:
  PUSH EAX,BX                ;Save used registers
  XOR  AH,AH                 ;Make sure high byte is 0
  JMP WriteMin0              ;Continue
WriteWordMin:
  PUSH EAX,BX                ;Save used registers
;  JMP WriteMin0              ;Continue
WriteMin0:
  AND  EAX,0000_FFFFh        ;Make sure High Word is 0
;  JMP >D00                   ;Continue
;WriteTriByteMin:
;  PUSH EAX,BX                ;Save used registers
;  AND  EAX,00FF_FFFFh        ;Make sure high byte is 0
;  JMP >D00                   ;Continue
;WriteDWordMin:
;  PUSH EAX,BX                ;Save used registers
;D00:
  MOV  BH,WriteByteMinFlag   ;Mark as doing minimum
  JMP  BWD2String00          ;Do it

ByteToString:
  PUSH EAX,BX                ;Save used registers
  XOR  AH,AH                 ;Make sure high byte is 0
  XOR  BX,BX                 ;BH = No Minimum, Byte
  JMP  BW2String0           ;Continue
WordToString:
  PUSH EAX,BX                ;Save used registers
  MOV  BH,WriteByteWordFlag  ;BH = No Minimum, Word
;  JMP  BW2String00           ;Continue
BW2String0:
  AND  EAX,0000_FFFFh        ;Make sure High Word is 0
  JMP  BWD2String00          ;Continue
DWordToString:
  PUSH EAX,BX                ;Save used registers
  MOV  BH,WriteByteDWordFlag ;BH = No Minimum, DWord
;  JMP  BWD2String00          ;Continue

BWD2String00:
;.D01:
;.W00:                        ;Do a word or a byte
  PUSH ECX,EDX,SI            ;Save used registers
  MOV  SI,SingleMsg          ;Point at the single character message
  XOR  BL,BL                 ;Test for first non-zero character is false
  MOV  ECX,1000000000        ;First divisor is 1,000,000,000
.W20:                        ;Loop to here for each character
  XOR  EDX,EDX               ;High word of Dividend = 0
  DIV  ECX                   ;Divide EDX:EAX by current divisor
  OR   EAX,EAX               ;Is this a non-zero character?
  JNZ .W30                   ;If so, we need to write it
  OR   BL,BL                 ;Has there already been a non-zero character?
  JNZ .W30                   ;If so, we need to write it
  CMP  ECX,1                 ;Is this the last character?
  JE  .W30                   ;If so, we need to write it
  TEST BH,WriteByteMinFlag   ;Are we doing a minimum?
  JNZ .W40                   ;If not, don't write anything
  MOV  AL,' '                ;Assume a space
  TEST BH,WriteByteDWordFlag ;Writing a DWord?
  JNZ .W35                   ;If so, write the space
  TEST BH,WriteByteWordFlag  ;Doing a Word?
  JZ  .W25                   ;If not, handle a Byte
  CMP  ECX,10000             ;If so, doing the ten-thousands character?
  JBE .W35                   ;If so, write the space
  JMP .W40                   ;If not, don't write anything
.W25:                        ;Doing a Byte
  CMP  ECX,100               ;Doing the hundreds character?
  JBE .W35                   ;If so, write the space
  JMP .W40                   ;If not, don't write anything
.W30:                        ;We need to write this character
  INC  BL                    ;Test for first non-zero character is true
  ADD  AL,'0'                ;Convert the Number to ASCII
.W35:                        ;Write the character
  MOV  [SI],AL               ;Write the
  CALL WriteZPauseSI         ;  character
  CMP  AL,' '                ;Should we write a comma or a space?
  JE  .W36                   ;If a space, continue
  MOV  AL,','                ;If not, mark as a comma
.W36:                        ;AL contains space or Comma
  MOV  [SI],AL               ;Store it in the String
  CMP  ECX,1000000000        ;Need to write the space or comma?
  JE  .W38                   ;If so, jump to write it
  CMP  ECX,1000000           ;Need to write the space or comma?
  JE  .W38                   ;If so, jump to write it
  CMP  ECX,1000              ;Need to write the space or comma?
  JNE .W40                   ;If not, continue
.W38:                        ;Need to write a Space or Comma Separator
  CALL WriteZPauseSI         ;Write the space or Comma
.W40:                        ;Done writing the Character
  CMP  ECX,1                 ;Was this the last division to do?
  JE  .W90                   ;If so, we're done
  MOV  EAX,EDX               ;If not, start next loop with remainder of division
  PUSH EAX                   ;Save register for a second
  XOR  EDX,EDX               ;So dividend won't be messed up
  MOV  EAX,ECX               ;Want to divide divisor in ECX
  MOV  ECX,10                ;Want to divide by 10
  DIV  ECX                   ;Divide it
  MOV  ECX,EAX               ;Store it back in ECX
  POP  EAX                   ;Restore register
  JMP .W20                   ;And do it again
.W90:                        ;We're done
  POP  SI,EDX,ECX            ;Restore used registers
  POP  BX,EAX                ;Restore used registers
  RET

;;------------------------------------------------------------------------------
;;WRITE A BYTE OR WORD TO THE SCREEN AS A DECIMAL (EXTRA SPACES INCLUDED)
;;Inputs:  AL/AX = Byte/Word to Write
;;Outputs:
;;Changes:
;;------------------------------------------------------------------------------
;WriteByteMin:
;  PUSH AX,BX        ;Save used registers
;  XOR  AH,AH        ;Make sure high byte is 0
;  MOV  BH,1         ;Mark as doing minimum
;  JMP >W00          ;Do it
;WriteWordMin:
;  PUSH AX,BX        ;Save used registers
;  MOV  BH,1         ;Mark as doing minimum
;  JMP >W00          ;Do it
;ByteToString:
;  PUSH AX,BX        ;Save the original word & BP
;  XOR  AH,AH        ;Make sure high byte is 0
;  XOR  BH,BH        ;BH = No Minimum, Byte
;  JMP >W00          ;Jump to start the loop
;WordToString:
;  PUSH AX,BX        ;Save the original word
;  MOV  BH,2         ;BP = No Minimum, Word
;W00:                ;Do a word or a byte
;  PUSH CX,DX,SI     ;Save used registers
;  MOV  SI,SingleMsg ;Point at the single character message
;  XOR  BL,BL        ;Test for first non-zero character is false
;  MOV  CX,10000     ;First divisor is 10,000
;W20:                ;Loop to here for each character
;  XOR  DX,DX        ;High word of Dividend = 0
;  DIV  CX           ;Divide DX:AX by current divisor
;  OR   AX,AX        ;Is this a non-zero character?
;  JNZ >W30          ;If so, we need to write it
;  OR   BL,BL        ;Has there already been a non-zero character?
;  JNZ >W30          ;If so, we need to write it
;  CMP  CX,1         ;Is this the last character?
;  JE  >W30          ;If so, we need to write it
;  TEST BH,1         ;Are we doing a minimum?
;  JNZ >W40          ;If not, don't write anything
;  MOV  AL,' '       ;Assume a space
;  TEST BH,2         ;Doing a word?
;  JNZ >W35          ;If so, write the space
;  CMP  CX,100       ;If not, doing the hundreds character?
;  JBE >W35          ;If so, write the space
;  JMP >W40          ;If not, don't write anything
;W30:                ;We need to write this character
;  INC  BL           ;Test for first non-zero character is true
;  ADD  AL,'0'       ;Convert the Number to ASCII
;W35:                ;Write the character
;  MOV  [SI],AL      ;Write the
;  CALL WriteItSI    ;  character
;W40:                ;Skip this character - just make it a space
;  CMP  CX,1         ;Was this the last division to do?
;  JE  >W90          ;If so, we're done
;  MOV  AX,DX        ;If not, start next loop with remainder of division
;  PUSH AX           ;Save register for a second
;  XOR  DX,DX        ;So dividend won't be messed up
;  MOV  AX,CX        ;Want to divide divisor in CX
;  MOV  CX,10        ;Want to divide by 10
;  DIV  CX           ;Divide it
;  MOV  CX,AX        ;Store it back in CX
;  POP  AX           ;Restore register
;  JMP  W20          ;And do it again
;W90:                ;We're done
;  POP  SI,DX,CX     ;Restore used registers
;  POP  BX,AX        ;Restore original word & BP
;  RET

;------------------------------------------------------------------------------
;WRITE AN ASCIIZ STRING, POINTED AT BY SI, TO CON
;Inputs:  DS:[SI] = ASCIIZ String to Write
;Outputs: To Screen (CON)
;Changes:
;------------------------------------------------------------------------------
WriteItSI:
  PUSH DX          ;Save used registers
  MOV  DX,SI       ;Write the
;  CALL WriteItDX   ;  string
  CALL WriteZPause ;  string
  POP  DX          ;Restore used registers
  RET

;------------------------------------------------------------------------------
;WRITE ASCIIZ STRING TO CON OR TO ERR
;Inputs:  DS:[DX] = Pointer to string
;         CS = Local Data Segment
;Outputs: Writes the string to CON or ERR
;Changes:
;------------------------------------------------------------------------------
WriteZCon:             ;Write to CON
  CMP  D [CS:PauseHdrPtr],-1 ;Should we write anything?
  JE   WriteZErr.Z90   ;If not, just quit
  PUSH BX              ;Save used register
  MOV  BX,StdOutHandle ;Write to STDOUT
  JMP  WriteZErr.Z00   ;Jump to do it
WriteZErr:             ;Write to ERR
  PUSH BX              ;Save used register
  MOV  BX,StdErrHandle ;Write to STDERR
.Z00:
  PUSH AX,CX           ;Save used registers
  CALL CalcStrSizeDX   ;Calculate the size of the string (returns CX)
  JZ  .Z80             ;If nothing to write, just quit
  MOV  AH,40h          ;Function 40h (Write to Device)
  INT  21h             ;Do it
.Z80:                  ;We're done
  POP  CX,AX           ;Restore used registers
  POP  BX              ;Restore used register
.Z90:                  ;We're done
  RET

;------------------------------------------------------------------------------
;CALCULATE THE LENGTH OF AN ASCIIZ STRING
;Inputs:  DS:[DX] = Pointer to the string
;Outputs: CX = Length of the string
;         ZF = Set if string is 0 length
;            = Clear if not
;Changes:
;------------------------------------------------------------------------------
CalcStrSizeDX:
  PUSH AX,DI  ;Save used registers
  PUSH ES     ;Save used registers
  MOV  ES,DS  ;Point ES:[DI]
  MOV  DI,DX  ; at the string
  XOR  AL,AL  ;Look for a 0
  MOV  CX,-1  ;Start with max count for REPNE
  REPNE SCASB ;Find the end of the string
  NOT  CX     ;Calculate the size
  DEC  CX     ;  of the string (sets ZF)
  POP  ES     ;Restore used registers
  POP  DI,AX  ;Restore used registers
  RET

;------------------------------------------------------------------------------
;WRITE A SPECIFIC CHARACTER OR SET OF CHARACTERS TO THE SCREEN
;Inputs:
;Outputs: To screen
;Changes:
;------------------------------------------------------------------------------
WriteAL:
  PUSH DX               ;Save used registers
  MOV  DL,AL            ;Write what's in AL
  JMP  WriteUnknown.C00 ;Do it
WriteBlock:
  PUSH DX               ;Save used registers
  MOV  DL,''           ;Write a Block Character
  JMP  WriteUnknown.C00 ;Do it
WriteDot:
  PUSH DX               ;Save used registers
  MOV  DX,DotMsg        ;Point at the string
  JMP  WriteUnknown.C10 ;Do it
WriteEquals:
  PUSH DX               ;Save used registers
  MOV  DL,'='           ;Write an Equals
  JMP  WriteUnknown.C00 ;Do it
WriteHexEnd:
  PUSH DX               ;Save used registers
  MOV  DX,'h'           ;Write an "h"
  JMP  WriteUnknown.C00 ;Do it
WriteMinutes:
  PUSH DX               ;Save used registers
  MOV  DX,MinutesMsg    ;Point at the string
  JMP  WriteUnknown.C10 ;Do it
WriteNA:
  PUSH DX               ;Save used registers
  MOV  DX,NAMsg         ;Point at Message
  JMP  WriteUnknown.C10 ;Do it
WriteLParen:
  PUSH DX               ;Save used registers
  MOV  DL,'('           ;Write a Left Parentheses
  JMP  WriteUnknown.C00 ;Do it
WriteRParen:
  PUSH DX               ;Save used registers
  MOV  DL,')'           ;Write a Right Parentheses
  JMP  WriteUnknown.C00 ;Do it
WritePercent:
  PUSH DX               ;Save used registers
  MOV  DL,'%'           ;Write a Percent Sign
  JMP  WriteUnknown.C00 ;Do it
WriteSlash:
  PUSH DX               ;Save used registers
  MOV  DL,'/'           ;Write a Slash
  JMP  WriteUnknown.C00 ;Do it
WriteUnderscore:
  PUSH DX               ;Save used registers
  MOV  DL,'_'           ;Write a Slash
  JMP  WriteUnknown.C00 ;Do it
WriteSpace:
  PUSH DX               ;Save used registers
  MOV  DX,SpaceMsg      ;Point at Message
  JMP  WriteUnknown.C10 ;Do it
Write2Spaces:
  PUSH DX               ;Save used registers
  MOV  DX,Space2Msg     ;Point at Message
  JMP  WriteUnknown.C10 ;Do it
Write3Spaces:
  PUSH DX               ;Save used registers
  MOV  DX,Space3Msg     ;Point at Message
  JMP  WriteUnknown.C10 ;Do it
Write4Spaces:
  PUSH DX               ;Save used registers
  MOV  DX,Space4Msg     ;Point at Message
  JMP  WriteUnknown.C10 ;Do it
WriteUnknown:
  PUSH DX               ;Save used registers
  MOV  DX,UnknownMsg    ;Point at Message
  JMP  WriteUnknown.C10 ;Do it
.C00:
  MOV  [SingleMsg],DL   ;Put the character in the Single Character String
  MOV  DX,SingleMsg     ;Point at Single Character String
.C10:                   ;DX is pointed at String
  CALL WriteZPause      ;Write the String
  POP  DX               ;Restore used registers
  RET

;------------------------------------------------------------------------------
;WRITE SOME SPACES TO THE SCREEN
;Inputs:  CL = Number of spaces to write
;         SpaceMsg
;Outputs: To the screen
;Changes:
;------------------------------------------------------------------------------
;WriteSpacesErr:
;  PUSH AX          ;Save used registers
;  MOV  AL,-1       ;Mark as ERR
;  JMP >S00         ;Do it
WriteSpaces:
  PUSH AX          ;Save used registers
  XOR  AL,AL       ;Mark as CON
;  JMP >S00         ;Do it
;S00:
  PUSH CX,DX       ;Save used registers
  OR   CL,CL       ;Should we write 0 spaces?
  JZ  .S90         ;If so, we're done
  XOR  CH,CH       ;If OK, change it to a word
  MOV  DX,SpaceMsg ;Point at the message
  OR   AL,AL       ;Write to CON?
  JNZ .S30         ;If not, Handle ERR
.S10:              ;Loop to here for each space
  CALL WriteZPause ;Write the space
  LOOP .S10        ;Keep going until we're done
  JMP .S90         ;Done
.S30:              ;Write to Err
  CALL WriteZErr   ;Write the space
  LOOP .S10        ;Keep going until we're done
.S90:              ;We're done
  POP  DX,CX       ;Restore used registers
  POP  AX          ;Restore used registers
  RET


;
;CODE TO DELAY FOR A CERTAIN NUMBER OF MILLISECONDS
;

;------------------------------------------------------------------------------
;DELAY FOR A GIVEN NUMBER OF MILLISECONDS
;Inputs:  AX = number of milliseconds to wait (0-65,535)
;Outputs:
;Changes:
;------------------------------------------------------------------------------
DelayMSAX:
  PUSH AX,BX,DX  ;Save used registers
  OR   AX,AX     ;Is there anything to do?
  JZ  .D90       ;If not, just quit
  MOV  DX,1000   ;Convert
  MUL  DX        ;  to
  MOV  BX,AX     ;  microseconds (DX:BX)
.D10:            ;Loop to here for each 65535 uS
  OR   DX,DX     ;Counted down high word yet?
  JZ  .D30       ;If so, handle it
  DEC  DX        ;Decrement high word
  MOV  AX,-1     ;Maximum microseconds
  JMP .D50       ;Do it
.D30:            ;Counted down high word
  OR   BX,BX     ;Anything to do?
  JZ  .D90       ;If not, we're done
  MOV  AX,BX     ;Get Low Word
  XOR  BX,BX     ;Make sure it's zero next time
.D50:            ;AX = Microseconds to wait
  CALL DelayUSAX ;Delay the number of microseconds specified
  JMP .D10       ;See if we need to wait some more
.D90:            ;We're done
  POP  DX,BX,AX  ;Restore used registers
  RET

;------------------------------------------------------------------------------
;DELAY FOR A GIVEN NUMBER OF MICROSECONDS
;Inputs:  AX = number of microseconds to wait (0-65,535)
;Outputs:
;Changes:
;   NOTE: Delays will be slightly longer than what's asked for, never shorter.
;         Accuracy decreases with small delays or slow computers!
;------------------------------------------------------------------------------
DelayUSAX:
  PUSH AX,BX           ;Save used registers
  OR   AX,AX           ;Is there anything to do?
  JZ  .D90             ;If not, just quit
  MOV  BX,AX           ;Put it in BX
  MOV  AX,(0FFFFh/3)+1 ;Maximum time for each sub-delay
.D10:                  ;Loop to here for each sub-delay
  CMP  BX,AX           ;Is it more than the maximum?
  JA  .D40             ;If so, just do the sub-delay
  MOV  AX,BX           ;If not, just do the remainder that's left
.D40:                  ;Do the delay
  CALL DoDelayUS       ;Do the US Delay
  SUB  BX,AX           ;SUbtract out how long we just waited
  JNZ .D10             ;If not 0 yet, do the sub-delay again
.D90:                  ;We're done
  POP  BX,AX           ;Restore used registers
  RET

DoDelayUS:
  PUSH AX,BX,CX,DX ;Save used registers
  PUSHF            ;Save Flags
  SHL  AX,1        ;Multiply by 2
  MOV  BX,11932    ;Compensate for the fact
  MUL  BX          ;  that the clock frequency
  MOV  BX,10000    ;  is actually
  DIV  BX          ;  1.19318 MHz
  MOV  DX,AX       ;Save it
  CLI              ;Disable interrupts
  CALL GetTimer    ;Get the starting timer tick counter
  MOV  CX,AX       ;Save it
.D20:              ;Keep looping to here until we've waited long enough
  MOV  BX,CX       ;Get the starting timer tick counter
  CALL GetTimer    ;Get the current timer tick counter
  SUB  BX,AX       ;Calculate the elapsed time
  CMP  BX,DX       ;Has it been long enough?
  JB  .D20         ;If not, keep waiting
.D90:              ;We're done
  POPF             ;Restore Flags
  POP  DX,CX,BX,AX ;Restore used registers
  RET

;------------------------------------------------------------------------------
;GET CURRENT TIMER COUNTER FROM PORT 40h (THE CLOCK INTERRUPT)
;Inputs:
;Outputs: AX = Current timer counter word
;Changes:
;------------------------------------------------------------------------------
GetTimer:
  MOV  AL,06h ;Bits 7:6 =  00 = Timer 0
              ;Bits 5:4 =  00 = Latch Counter
              ;Bits 3:1 = 011 = Mode 3 (Square Wave)
              ;Bit    0 =   0 = Binary Counter (16 bits)
  OUT  43h,AL ;Tell the PIT what wer'e going to do
  IN   AL,40h ;Get LSB of timer counter
  MOV  AH,AL  ;Save it
  IN   AL,40h ;Get MSB of timer counter
  XCHG AH,AL  ;Put things in the right order
  RET


;
;SPACE AND CODE TO PROCESS OUR PROGRAM STACK
;  This code and must be physically at the END of the Program,
;    but must be one of the FIRST procedures called by the Program.
;  In addition, the Stack Pointer (SP) must be set properly
;    (to LastProgByte) BEFORE this code is called.
;

;------------------------------------------------------------------------------
;RESIZE OUR MEMORY ALLOCATION TO THE MINIMUM SIZE NEEDED
;Inputs:  SP = LastProgByte - 2
;         ES = Local Segment
;Outputs: Rellocates Memory to the minimum size required to run the program
;Changes:
;------------------------------------------------------------------------------
ResizeMemory:
  PUSH AX,BX  ;Save used registers
  MOV  AH,4Ah ;Function 4Ah (Resize Memory Block pointed at by ES)
  MOV  BX,(65535 >> 4)+1 ;BX = Number of Paragraphs to Resize to
  INT  21h    ;Do it
  POP  BX,AX  ;Restore used registers
  RET

  EVEN 16
  TIMES (ProgStackSize/8) DB 'PrgStack' ;Set up a Program Stack Frame

DataBuffer EQU $-$$+256

;We'll use the area between here and the end of the 64k Segment to store
;  the data as we read it from physical memory.
